(* Content-type: application/vnd.wolfram.cdf.text *)

(*** Wolfram CDF File ***)
(* http://www.wolfram.com/cdf *)

(* CreatedBy='Mathematica 9.0' *)

(*************************************************************************)
(*                                                                       *)
(*  The Mathematica License under which this file was created prohibits  *)
(*  restricting third parties in receipt of this file from republishing  *)
(*  or redistributing it by any means, including but not limited to      *)
(*  rights management or terms of use, without the express consent of    *)
(*  Wolfram Research, Inc. For additional information concerning CDF     *)
(*  licensing and redistribution see:                                    *)
(*                                                                       *)
(*        www.wolfram.com/cdf/adopting-cdf/licensing-options.html        *)
(*                                                                       *)
(*************************************************************************)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[      1063,         20]
NotebookDataLength[     32784,        787]
NotebookOptionsPosition[     32821,        765]
NotebookOutlinePosition[     33282,        786]
CellTagsIndexPosition[     33239,        783]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["MarkovPlotter", "Title"],

Cell[TextData[{
 "This is a CDF version that is not fully functional due to the dynamic \
content. For full functionality open the MarkovPlotter.nb file in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "."
}], "Subtitle"],

Cell[CellGroupData[{

Cell[BoxData["markovPlotter"], "Input"],

Cell[BoxData[
 DynamicModuleBox[{$CellContext`maxTrajectoryLength$$ = 
  100, $CellContext`initialDistribution$$ = {0.25, 0.25, 0.25, 
  0.25}, $CellContext`transitionMatrix$$ = {{0.25, 0.25, 0.25, 0.25}, {0.25, 
  0.25, 0.25, 0.25}, {0.25, 0.25, 0.25, 0.25}, {0.25, 0.25, 0.25, 
  0.25}}, $CellContext`addingNumber$$ = 4, $CellContext`autoOpacity$$ = True}, 
  TabViewBox[{{1,"\<\"Plot\"\>"->
   DynamicModuleBox[{$CellContext`list$$ = {{1, 1, 3, 4, 4, 3, 4, 4, 1, 
    2}}, $CellContext`trajectoryLength$$ = 
    10, $CellContext`add$$ = $CellContext`addingNumber$$, \
$CellContext`opacity$$ = 
    1, $CellContext`maxlen$$ = $CellContext`maxTrajectoryLength$$}, 
    TagBox[GridBox[{
       {
        DynamicBox[ToBoxes[
          Panel[
           Show[
            
            ListLinePlot[$CellContext`list$$, Background -> White, 
             PlotRange -> {{0, $CellContext`trajectoryLength$$ + 1}, {0, 
                Length[$CellContext`initialDistribution$$]}}, PlotStyle -> 
             Directive[Blue, 
               Opacity[$CellContext`opacity$$]], 
             AxesLabel -> {"Step", "State"}, AxesOrigin -> {0, 0}]], 
           ButtonBar[{"Generate new trajectory" :> ($CellContext`list$$ = {
                 $CellContext`generateTrajectory[$CellContext`\
trajectoryLength$$, $CellContext`initialDistribution$$, \
$CellContext`transitionMatrix$$]}; Null), 
             "Add new trajectories" :> ($CellContext`list$$ = 
               Join[$CellContext`list$$, 
                 Table[
                  $CellContext`generateTrajectory[$CellContext`\
trajectoryLength$$, $CellContext`initialDistribution$$, \
$CellContext`transitionMatrix$$], {$CellContext`add$$}]]; 
              If[$CellContext`autoOpacity$$ == True, $CellContext`opacity$$ = 
                N[(1/Length[$CellContext`list$$])^(1/2), 3]])}, ImageSize -> 
            Full, Appearance -> Automatic], ImageSize -> Automatic], 
          StandardForm],
         ImageSizeCache->{380., {125., 159.}}]},
       {
        TagBox[GridBox[{
           {
            TemplateBox[{"\"Length: \"",InterpretationBox[
               StyleBox[
                GridBox[{{
                   SliderBox[
                    Dynamic[
                    
                    BoxForm`RemapVariable[$CellContext`trajectoryLength$$, {
                    1, $CellContext`maxTrajectoryLength$$}], 
                    BoxForm`RemapValue[#, $CellContext`trajectoryLength$$, {
                    1, $CellContext`maxTrajectoryLength$$}]& ], {0, 1}, 
                    Appearance -> Automatic, DefaultBaseStyle -> 
                    "LabeledSlider"], 
                   InputFieldBox[
                    Dynamic[$CellContext`trajectoryLength$$], Appearance -> 
                    "Frameless", ContinuousAction -> True, DefaultBaseStyle -> 
                    "LabeledSlider", FieldSize -> {{5, 10}, {1, 2}}, 
                    ImageMargins -> 0]}}, AutoDelete -> False, 
                 BaselinePosition -> {{1, 1}, Axis}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}], Deployed -> True, 
                StripOnInput -> False, FontFamily :> 
                CurrentValue["ControlsFontFamily"]], 
               LabeledSlider[
                Dynamic[
                 
                 BoxForm`RemapVariable[$CellContext`trajectoryLength$$, {
                  1, $CellContext`maxTrajectoryLength$$}], 
                 BoxForm`RemapValue[#, $CellContext`trajectoryLength$$, {
                  1, $CellContext`maxTrajectoryLength$$}]& ], {0, 1}]]},
             "RowDefault"]},
           {
            TemplateBox[{"\"Opacity:\"",InterpretationBox[
               StyleBox[
                GridBox[{{
                   SliderBox[
                    Dynamic[$CellContext`opacity$$], {0, 1}, Appearance -> 
                    Automatic, DefaultBaseStyle -> "LabeledSlider"], 
                   InputFieldBox[
                    Dynamic[$CellContext`opacity$$], Appearance -> 
                    "Frameless", ContinuousAction -> True, DefaultBaseStyle -> 
                    "LabeledSlider", FieldSize -> {{5, 10}, {1, 2}}, 
                    ImageMargins -> 0]}}, AutoDelete -> False, 
                 BaselinePosition -> {{1, 1}, Axis}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}], Deployed -> True, 
                StripOnInput -> False, FontFamily :> 
                CurrentValue["ControlsFontFamily"]], 
               LabeledSlider[
                Dynamic[$CellContext`opacity$$], {0, 1}]]},
             "RowDefault"]}
          },
          DefaultBaseStyle->"Column",
          GridBoxAlignment->{"Columns" -> {{Left}}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Column"]}
      },
      DefaultBaseStyle->"Column",
      GridBoxAlignment->{"Columns" -> {{Left}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Column"],
    DynamicModuleValues:>{},
    Initialization:>($CellContext`list$$ = {
        $CellContext`generateTrajectory[$CellContext`trajectoryLength$$, \
$CellContext`initialDistribution$$, $CellContext`transitionMatrix$$]}; 
     Null)]}, {2,"\<\"Configuration\"\>"->
   DynamicModuleBox[{$CellContext`showMatrix$$ = 
    True, $CellContext`showInitial$$ = True}, 
    TagBox[GridBox[{
       {
        TemplateBox[{InterpretationBox[
           GridBox[{{
              ButtonBox[
              "\"New transition matrix\"", Appearance -> {"FramedPalette"}, 
               ButtonFunction :> ($CellContext`transitionMatrix$$ = Evaluate[
                  Input["Specify new transition matrix:"]]), Evaluator -> 
               Automatic, ImageSize -> Automatic, Method -> "Queued"]}, {
              ButtonBox[
              "\"New initial distribution\"", Appearance -> {"FramedPalette"},
                ButtonFunction :> ($CellContext`initialDistribution$$ = 
                Evaluate[
                  Input["Specify new vector of initial probabilities:"]]), 
               Evaluator -> Automatic, ImageSize -> Automatic, Method -> 
               "Queued"]}}, DefaultBaseStyle -> "Column", 
            GridBoxAlignment -> {"Columns" -> {{Left}}}, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            GridBoxSpacings -> {"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], 
           
           ButtonBar[{
            "New transition matrix" :> ($CellContext`transitionMatrix$$ = 
              Evaluate[
                Input["Specify new transition matrix:"]]), 
             "New initial distribution" :> \
($CellContext`initialDistribution$$ = Evaluate[
                Input["Specify new vector of initial probabilities:"]])}, 
            Method -> "Queued", ImageSize -> Automatic, 
            Appearance -> {"Vertical"}]],TagBox[
           GridBox[{{"\"Show transition matrix:\"", 
              CheckboxBox[
               Dynamic[$CellContext`showMatrix$$]]}, {
             "\"Show initial distribution vector:\"", 
              CheckboxBox[
               Dynamic[$CellContext`showInitial$$]]}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"]},
         "RowDefault"]},
       {
        TemplateBox[{"\"Automatically adjust opacity:\"",CheckboxBox[
           Dynamic[$CellContext`autoOpacity$$]]},
         "RowDefault"]},
       {
        TemplateBox[{
         "\"Number of trajectories to add in each step:\"",PopupMenuBox[
           Dynamic[$CellContext`addingNumber$$], {
           2 -> "2", 4 -> "4", 6 -> "6", 8 -> "8", 10 -> "10", 12 -> "12", 14 -> 
            "14", 16 -> "16", 18 -> "18", 20 -> "20"}, "4"]},
         "RowDefault"]},
       {
        TemplateBox[{"\"Maximal length:\"",InputFieldBox[
           Dynamic[$CellContext`maxTrajectoryLength$$]]},
         "RowDefault"]},
       {
        TemplateBox[{DynamicBox[
           ToBoxes[
            If[$CellContext`showMatrix$$, 
             Dynamic[
              MatrixForm[$CellContext`transitionMatrix$$]], ""], 
            StandardForm], ImageSizeCache -> {197., {26., 33.}}],DynamicBox[
           ToBoxes[
            If[$CellContext`showInitial$$, 
             Dynamic[
              MatrixForm[$CellContext`initialDistribution$$]], ""], 
            StandardForm], ImageSizeCache -> {62., {26., 33.}}]},
         "RowDefault"]}
      },
      DefaultBaseStyle->"Column",
      GridBoxAlignment->{"Columns" -> {{Left}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Column"],
    DynamicModuleValues:>{}]}, {3,"\<\"Help\"\>"->
   PanelBox[
    PaneBox["\<\"The MarkovPlotter program generates the trajectories of a \
homogeneous Markov chain with given transition matrix and initial state \
probability distribution. The transition matrix is of form \
\\!\\(\\*SubscriptBox[\\(p\\), \\(ij\\)]\\), where i and j are the row and \
column numbers respectively, and \\!\\(\\*SubscriptBox[\\(p\\), \\(ij\\)]\\) \
is the probability of going from the state i to the state j. The states are \
represented as natural numbers {1, 2, ..., n}. \\n The 'Plot' section: \\n \
This is the main window, containing the trajectory plot. The 'Length' slider \
controls the length of the trajectory, i.e. the number of steps generated; \
this is always a natural number, even if the value of the slider is not. The \
'Opacity' slider controls the opacity of the plot. Note that a new trajectory \
has to be generated after the length has been increased. The 'Generate new \
trajectory' button generates a trajectory, while 'Add new trajectories' adds \
a given number of trajectories to the plot; This helps to see the 'average' \
trajectory.\\n The 'Configuration' tab:\\n In this window, the user can \
specify the transition matrix and the initial distribution vector; Both are \
displayed in the window. Pressing a button opens a new window in which they \
can be specified using Mathematica commands, i.e. a uniform initial \
distribution for a 4-state Markov chain can be written both as {0.25, 0.25, \
0.25, 0.25} or Table[0.25, {4}]. For large number of states, the display of \
matrix and vector can be turned off. If the 'Automatically adjust opacity' \
checkbox is checked, the opacity of the plot diminishes automaticaly each \
time new trajectories are added to the plot.\"\>",
     ImageSize->{400, 200},
     ImageSizeAction->"Scrollable",
     ScrollPosition->{0., 0.},
     Scrollbars->{False, True}]]}}, 1,
   Alignment->Automatic,
   ImageSize->All],
  DynamicModuleValues:>{},
  Initialization:>({$CellContext`generateTrajectory[
       Pattern[$CellContext`length, 
        Blank[]], 
       Pattern[$CellContext`startprob, 
        Blank[]], 
       Pattern[$CellContext`mat, 
        Blank[]]] := Module[{$CellContext`retlist = {
          RandomChoice[$CellContext`startprob -> Range[
             Length[$CellContext`mat]]]}}, 
       For[$CellContext`i = 
         1, $CellContext`i < $CellContext`length, $CellContext`i = \
$CellContext`i + 1, $CellContext`retlist = Append[$CellContext`retlist, 
           $CellContext`nextStep[
            Part[$CellContext`retlist, $CellContext`i], $CellContext`mat]]]; 
       Return[$CellContext`retlist]], $CellContext`i = 
     10, $CellContext`nextStep[
       Pattern[$CellContext`state, 
        Blank[]], 
       Pattern[$CellContext`mat, 
        Blank[]]] := RandomChoice[Part[$CellContext`mat, $CellContext`state, 
         Span[1, All]] -> Range[
         Length[$CellContext`mat]]], 
     Attributes[BoxForm`RemapVariable] = {HoldAllComplete}, 
     BoxForm`RemapVariable[
       Pattern[BoxForm`var, 
        Blank[]], {{
         Pattern[BoxForm`xmin, 
          Blank[]], 
         Pattern[BoxForm`ymin, 
          Blank[]]}, {
         Pattern[BoxForm`xmax, 
          Blank[]], 
         Pattern[BoxForm`ymax, 
          Blank[]]}}] := {
       If[BoxForm`xmax - BoxForm`xmin == 0, BoxForm`xmin, 
        Cancel[
         Rationalize[(Part[BoxForm`var, 1] - BoxForm`xmin)/(BoxForm`xmax - 
          BoxForm`xmin), 0]]], 
       If[BoxForm`ymax - BoxForm`ymin == 0, BoxForm`ymin, 
        Cancel[
         Rationalize[(Part[BoxForm`var, 2] - BoxForm`ymin)/(BoxForm`ymax - 
          BoxForm`ymin), 0]]]}, BoxForm`RemapVariable[
       Pattern[BoxForm`var, 
        Blank[]], {
        Pattern[BoxForm`min, {
          Blank[], 
          Blank[]}], 
        Pattern[BoxForm`max, {
          Blank[], 
          Blank[]}], 
        Pattern[BoxForm`step, {
          Blank[], 
          Blank[]}]}] := Cancel[
       Rationalize[(BoxForm`var - BoxForm`min)/BoxForm`step, 0]], 
     BoxForm`RemapVariable[
       Pattern[BoxForm`var, 
        Blank[]], {
        Pattern[BoxForm`min, 
         Blank[]], 
        Pattern[BoxForm`max, 
         Blank[]]}] := 
     If[BoxForm`max - BoxForm`min == 0 BoxForm`min, BoxForm`min, 
       Cancel[
        Rationalize[(BoxForm`var - BoxForm`min)/(BoxForm`max - BoxForm`min), 
         0]]], BoxForm`RemapVariable[
       Pattern[BoxForm`var, 
        Blank[]], {
        Pattern[BoxForm`min, 
         Blank[]], 
        Pattern[BoxForm`max, 
         Blank[]], 
        Pattern[BoxForm`step, 
         Blank[]]}] := Cancel[
       Rationalize[(BoxForm`var - BoxForm`min)/BoxForm`step, 0]], 
     Attributes[BoxForm`RemapValue] = {HoldAllComplete}, BoxForm`RemapValue[
       Pattern[BoxForm`val, 
        Blank[]], 
       Pattern[BoxForm`var, 
        Blank[]], {
        Pattern[BoxForm`min, 
         Blank[]], 
        Pattern[BoxForm`max, 
         Blank[]]}] := (
      BoxForm`var = (1 - BoxForm`val) BoxForm`min + BoxForm`val BoxForm`max), 
     BoxForm`RemapValue[
       Pattern[BoxForm`val, 
        Blank[]], 
       Pattern[BoxForm`var, 
        Blank[]], {
        Pattern[BoxForm`min, 
         Blank[]], 
        Pattern[BoxForm`max, 
         Blank[]], 
        Pattern[BoxForm`step, 
         Blank[]]}] := (BoxForm`var = 
      BoxForm`min + BoxForm`step BoxForm`val), $CellContext`showMatrix = 
     False}; {$CellContext`addingNumber$$ = 4, $CellContext`autoOpacity$$ = 
     True, $CellContext`maxTrajectoryLength$$ = 
     100, $CellContext`initialDistribution$$ = 
     Table[0.25, {4}], $CellContext`transitionMatrix$$ = 
     ConstantArray[0.25, {4, 4}]})]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "Subtitle"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nextStep", "[", 
   RowBox[{"state_", ",", " ", "mat_"}], "]"}], " ", ":=", " ", 
  RowBox[{"RandomChoice", "[", 
   RowBox[{
    RowBox[{"mat", "[", 
     RowBox[{"[", " ", 
      RowBox[{"state", ",", " ", ";;"}], "]"}], "]"}], "\[Rule]", " ", 
    RowBox[{"Range", "[", 
     RowBox[{"Length", "[", "mat", "]"}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"generateTrajectory", "[", 
   RowBox[{"length_", ",", "startprob_", ",", "  ", "mat_"}], "]"}], " ", ":=",
   " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"retlist", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{"startprob", " ", "\[Rule]", " ", 
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", "mat", "]"}], "]"}]}], "]"}], "}"}]}], "}"}],
     ",", " ", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", " ", "=", " ", "1"}], ",", 
       RowBox[{"i", " ", "<", " ", "length"}], " ", ",", 
       RowBox[{"i", " ", "=", 
        RowBox[{"i", " ", "+", "1"}]}], ",", " ", 
       RowBox[{"retlist", " ", "=", " ", 
        RowBox[{"Append", "[", 
         RowBox[{"retlist", ",", " ", 
          RowBox[{"nextStep", "[", 
           RowBox[{
            RowBox[{"retlist", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", " ", "mat"}], "]"}]}], " ", 
         "]"}]}]}], " ", "]"}], ";", " ", 
     RowBox[{"Return", "[", "retlist", "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"plotter", "[", 
   RowBox[{
   "maxTrajectoryLength_", " ", ",", " ", "initialDistribution_", ",", " ", 
    "transitionMatrix_", ",", " ", "addingNumber_", ",", " ", 
    "autoOpacity_"}], "]"}], " ", ":=", " ", 
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"list", ",", " ", 
      RowBox[{"trajectoryLength", " ", "=", " ", "10"}], ",", " ", 
      RowBox[{"add", " ", "=", " ", "addingNumber"}], ",", " ", 
      RowBox[{"opacity", " ", "=", " ", "1"}], ",", " ", 
      RowBox[{"maxlen", " ", "=", " ", "maxTrajectoryLength"}]}], "}"}], ",", 
    " ", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Dynamic", "[", 
        RowBox[{"Panel", "[", 
         RowBox[{
          RowBox[{"Show", "[", 
           RowBox[{"ListLinePlot", "[", 
            RowBox[{"list", ",", " ", 
             RowBox[{"Background", "\[Rule]", "White"}], ",", "  ", 
             RowBox[{"PlotRange", "\[Rule]", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", " ", 
                  RowBox[{"trajectoryLength", " ", "+", " ", "1"}]}], "}"}], 
                ",", " ", 
                RowBox[{"{", 
                 RowBox[{"0", ",", " ", 
                  RowBox[{"Length", "[", "initialDistribution", "]"}]}], 
                 "}"}]}], "}"}]}], ",", " ", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"Blue", ",", " ", 
                RowBox[{"Opacity", "[", "opacity", "]"}]}], "]"}]}], ",", 
             RowBox[{"AxesLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Step\>\"", ",", " ", "\"\<State\>\""}], "}"}]}], 
             ",", " ", 
             RowBox[{"AxesOrigin", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", " ", "0"}], "}"}]}]}], "]"}], "]"}], ",", 
          " ", 
          RowBox[{"ButtonBar", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<Generate new trajectory\>\"", " ", ":>", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"list", " ", "=", " ", 
                  RowBox[{"{", 
                   RowBox[{"generateTrajectory", "[", 
                    RowBox[{
                    "trajectoryLength", ",", " ", "initialDistribution", ",", 
                    " ", "transitionMatrix"}], "]"}], "}"}]}], ";"}], ")"}]}],
               ",", " ", 
              RowBox[{
              "\"\<Add new trajectories\>\"", " ", "\[RuleDelayed]", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"list", " ", "=", " ", 
                  RowBox[{"Join", "[", 
                   RowBox[{"list", ",", " ", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"generateTrajectory", "[", 
                    RowBox[{
                    "trajectoryLength", ",", " ", "initialDistribution", ",", 
                    " ", "transitionMatrix"}], "]"}], ",", 
                    RowBox[{"{", "add", "}"}]}], "]"}]}], "]"}]}], ";", " ", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"autoOpacity", " ", "==", " ", "True"}], ",", " ", 
                   
                   RowBox[{"opacity", " ", "=", " ", 
                    RowBox[{"N", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "/", 
                    RowBox[{"Length", "[", "list", "]"}]}], ")"}], "^", 
                    RowBox[{"(", 
                    RowBox[{"1", "/", "2"}], ")"}]}], ",", " ", "3"}], 
                    "]"}]}]}], "]"}]}], ")"}]}]}], "}"}], ",", " ", 
            RowBox[{"ImageSize", "\[Rule]", "Full"}], ",", " ", 
            RowBox[{"Appearance", "\[Rule]", "Automatic"}]}], "]"}], ",", " ", 
          RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
       " ", 
       RowBox[{"Column", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", "\"\<Length: \>\"", "]"}], ",", 
             RowBox[{"Slider", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "trajectoryLength", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "maxTrajectoryLength"}], "}"}], ",", " ", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], 
              "]"}]}], "}"}], "]"}], ",", 
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", "\"\<Opacity:\>\"", "]"}], " ", ",", " ", 
             "\[IndentingNewLine]", 
             RowBox[{"Slider", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "opacity", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{"0", ",", " ", "1"}], "}"}], ",", " ", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], "}"}], "]"}]}], 
      "}"}], "]"}], ",", " ", 
    RowBox[{"Initialization", " ", "\[RuleDelayed]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"list", " ", "=", " ", 
        RowBox[{"{", 
         RowBox[{"generateTrajectory", "[", 
          RowBox[{
          "trajectoryLength", ",", " ", "initialDistribution", ",", " ", 
           "transitionMatrix"}], "]"}], "}"}]}], ";"}], ")"}]}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"config", " ", ":=", " ", 
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"showMatrix", " ", "=", " ", "True"}], ",", " ", 
      RowBox[{"showInitial", " ", "=", " ", "True"}]}], "}"}], ",", 
    RowBox[{"Column", "[", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Row", "[", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ButtonBar", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
              "\"\<New transition matrix\>\"", "\[RuleDelayed]", " ", 
               RowBox[{"(", 
                RowBox[{"transitionMatrix", "=", " ", 
                 RowBox[{"Evaluate", "[", 
                  RowBox[{
                  "Input", "[", "\"\<Specify new transition matrix:\>\"", 
                   "]"}], "]"}]}], ")"}]}], ",", " ", 
              RowBox[{
              "\"\<New initial distribution\>\"", " ", "\[RuleDelayed]", " ", 
               
               RowBox[{"(", 
                RowBox[{"initialDistribution", " ", "=", " ", 
                 RowBox[{"Evaluate", "[", 
                  RowBox[{
                  "Input", "[", 
                   "\"\<Specify new vector of initial probabilities:\>\"", 
                   "]"}], "]"}]}], ")"}]}]}], "}"}], ",", " ", 
            RowBox[{"Method", " ", "\[Rule]", " ", "\"\<Queued\>\""}], ",", 
            " ", 
            RowBox[{"ImageSize", " ", "\[Rule]", " ", "Automatic"}], ",", " ", 
            RowBox[{"Appearance", "\[Rule]", "\"\<Vertical\>\""}]}], "]"}], 
          ",", 
          RowBox[{"Grid", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Style", "[", "\"\<Show transition matrix:\>\"", "]"}],
                ",", " ", 
               RowBox[{"Checkbox", "[", 
                RowBox[{"Dynamic", "[", "showMatrix", "]"}], "]"}]}], "}"}], 
             ",", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
               "Style", "[", "\"\<Show initial distribution vector:\>\"", 
                "]"}], ",", " ", 
               RowBox[{"Checkbox", "[", 
                RowBox[{"Dynamic", "[", "showInitial", "]"}], "]"}]}], 
              "}"}]}], "}"}], "]"}]}], "}"}], "]"}], ",", " ", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
          "Style", "[", "\"\<Automatically adjust opacity:\>\"", "]"}], ",", 
          " ", 
          RowBox[{"Checkbox", "[", 
           RowBox[{"Dynamic", "[", "autoOpacity", "]"}], "]"}]}], "}"}], 
        "]"}], "\[IndentingNewLine]", ",", " ", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
          "Style", "[", "\"\<Number of trajectories to add in each step:\>\"",
            "]"}], ",", " ", 
          RowBox[{"PopupMenu", "[", 
           RowBox[{
            RowBox[{"Dynamic", "[", "addingNumber", "]"}], ",", " ", 
            RowBox[{"Range", "[", 
             RowBox[{"2", ",", " ", "20", ",", " ", "2"}], "]"}], ",", " ", 
            "4"}], "]"}]}], "}"}], "]"}], ",", " ", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Style", "[", "\"\<Maximal length:\>\"", "]"}], ",", " ", 
          RowBox[{"InputField", "[", 
           RowBox[{"Dynamic", "[", "maxTrajectoryLength", "]"}], "]"}]}], 
         "}"}], "]"}], ",", " ", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Dynamic", "[", 
           RowBox[{"If", "[", 
            RowBox[{"showMatrix", ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"MatrixForm", "[", "transitionMatrix", "]"}], "]"}], 
             ",", "\"\<\>\""}], "]"}], "]"}], ",", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"If", "[", 
            RowBox[{"showInitial", ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"MatrixForm", "[", "initialDistribution", "]"}], "]"}], 
             ",", "\"\<\>\""}], "]"}], "]"}]}], "}"}], "]"}]}], "}"}], 
     "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"help", " ", "=", " ", 
   RowBox[{"Panel", "[", 
    RowBox[{"Pane", "[", 
     RowBox[{
      RowBox[{
      "Style", "[", 
       "\"\<The MarkovPlotter program generates the trajectories of a \
homogeneous Markov chain with given transition matrix and initial state \
probability distribution. The transition matrix is of form \
\!\(\*SubscriptBox[\(p\), \(ij\)]\), where i and j are the row and column \
numbers respectively, and \!\(\*SubscriptBox[\(p\), \(ij\)]\) is the \
probability of going from the state i to the state j. The states are \
represented as natural numbers {1, 2, ..., n}. \\n The 'Plot' section: \\n \
This is the main window, containing the trajectory plot. The 'Length' slider \
controls the length of the trajectory, i.e. the number of steps generated; \
this is always a natural number, even if the value of the slider is not. The \
'Opacity' slider controls the opacity of the plot. Note that a new trajectory \
has to be generated after the length has been increased. The 'Generate new \
trajectory' button generates a trajectory, while 'Add new trajectories' adds \
a given number of trajectories to the plot; This helps to see the 'average' \
trajectory.\\n The 'Configuration' tab:\\n In this window, the user can \
specify the transition matrix and the initial distribution vector; Both are \
displayed in the window. Pressing a button opens a new window in which they \
can be specified using Mathematica commands, i.e. a uniform initial \
distribution for a 4-state Markov chain can be written both as {0.25, 0.25, \
0.25, 0.25} or Table[0.25, {4}]. For large number of states, the display of \
matrix and vector can be turned off. If the 'Automatically adjust opacity' \
checkbox is checked, the opacity of the plot diminishes automaticaly each \
time new trajectories are added to the plot.\>\"", "]"}], ",", " ", 
      RowBox[{"Scrollbars", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"False", ",", " ", "True"}], "}"}]}], ",", " ", 
      RowBox[{"ImageSizeAction", "\[Rule]", "\"\<Scrollable\>\""}], " ", ",", 
      " ", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"400", ",", " ", "200"}], "}"}]}]}], "]"}], "]"}]}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"markovPlotter", " ", "=", " ", 
   RowBox[{"DynamicModule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "maxTrajectoryLength", ",", " ", "initialDistribution", ",", " ", 
       "transitionMatrix", ",", " ", "addingNumber", ",", " ", 
       "autoOpacity"}], "}"}], ",", " ", 
     RowBox[{"TabView", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<Plot\>\"", " ", "\[Rule]", " ", 
          RowBox[{"plotter", "[", 
           RowBox[{
           "maxTrajectoryLength", ",", " ", "initialDistribution", ",", " ", 
            "transitionMatrix", ",", " ", "addingNumber", ",", " ", 
            "autoOpacity"}], "]"}]}], ",", " ", 
         RowBox[{"\"\<Configuration\>\"", " ", "\[Rule]", " ", "config"}], 
         ",", " ", 
         RowBox[{"\"\<Help\>\"", " ", "\[Rule]", " ", "help"}]}], " ", "}"}], 
       ",", "  ", 
       RowBox[{"ImageSize", "\[Rule]", "All"}], ",", " ", 
       RowBox[{"Alignment", "\[Rule]", "Automatic"}]}], "]"}], ",", " ", 
     RowBox[{"Initialization", "  ", "\[RuleDelayed]", "  ", 
      RowBox[{"(", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"addingNumber", " ", "=", " ", "4"}], ",", " ", 
         RowBox[{"autoOpacity", " ", "=", " ", "True"}], ",", " ", 
         RowBox[{"maxTrajectoryLength", " ", "=", " ", "100"}], ",", " ", 
         RowBox[{"initialDistribution", " ", "=", " ", 
          RowBox[{"Table", "[", 
           RowBox[{"0.25", ",", " ", 
            RowBox[{"{", "4", "}"}]}], "]"}]}], ",", " ", 
         RowBox[{"transitionMatrix", " ", "=", " ", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"0.25", ",", " ", 
            RowBox[{"{", 
             RowBox[{"4", ",", " ", "4"}], "}"}]}], "]"}]}]}], "}"}], ")"}]}],
      ",", " ", 
     RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}]], "Input"]
}, Closed]]
}, Open  ]]
},
WindowSize->{740, 623},
Visible->True,
ScrollingOptions->{"VerticalScrollRange"->Fit},
ShowCellBracket->False,
ShowSelection->True,
Deployed->True,
CellContext->Notebook,
TrackCellChangeTimes->False,
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[1485, 35, 30, 0, 92, "Title"],
Cell[1518, 37, 228, 6, 108, "Subtitle"],
Cell[CellGroupData[{
Cell[1771, 47, 39, 0, 32, "Input"],
Cell[1813, 49, 15468, 339, 399, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17318, 393, 20, 0, 50, "Subtitle"],
Cell[17341, 395, 378, 10, 49, "Input"],
Cell[17722, 407, 1120, 30, 121, "Input"],
Cell[18845, 439, 5625, 131, 649, "Input"],
Cell[24473, 572, 4165, 102, 561, "Input"],
Cell[28641, 676, 2254, 39, 859, "Input"],
Cell[30898, 717, 1895, 44, 297, "Input"]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

(* NotebookSignature ywpItHa1FY6CUB10KgYTX6ro *)
