(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    459143,       7933]
NotebookOptionsPosition[    458776,       7916]
NotebookOutlinePosition[    459119,       7931]
CellTagsIndexPosition[    459076,       7928]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "We\:017amy powierzchni\:0119 utworzon\:0105 ze stycznych do krzywej \
\[Rho](u), gdzie u jest parametrem naturalnym tej krzywej. \nPowierzchnia ta \
jest zadana jako r(u,v) = \[Rho](u) + v \[Rho]'(u).\nPoliczmy pierwsz\:0105 \
form\:0119 kwadratow\:0105 tej powierzchni.\n",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "u"], TraditionalForm]]],
 "= \[Rho]'(u) + v \[Rho]''(u)\n",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "u"], TraditionalForm]]],
 "= \[Rho]'(u) \nZatem \nE = (\[Rho]'(u) + v ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{
     RowBox[{
      RowBox[{"\[Rho]", "''"}], 
      RowBox[{"(", "u", ")"}]}], ")"}], "2"], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[Rho]", "'"}], 
      RowBox[{"(", "u", ")"}]}], ")"}], "2"], TraditionalForm]]],
 "+ 2\[Rho]'(u)v\[Rho]'' (u) + ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["v", "2"], TraditionalForm]]],
 "(",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{
     RowBox[{
      RowBox[{"\[Rho]", "''"}], 
      RowBox[{"(", "u", ")"}]}], ")"}], "2"], TraditionalForm]]],
 " \nUwzgl\:0119dnijmy, \:017ce ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox["d\[Rho]", "du"], "=", 
    StyleBox["t",
     FontFamily->"Times New Roman",
     FontWeight->"Bold",
     FontSlant->"Plain"]}], TraditionalForm]]],
 " oraz ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox["d", "2"], "\[Rho]"}], 
     SuperscriptBox["du", "2"]], "=", 
    RowBox[{"\[Kappa]", " ", 
     StyleBox["n",
      FontFamily->"Times New Roman",
      FontWeight->"Bold",
      FontSlant->"Plain"]}]}], TraditionalForm]]],
 ",\ngdzie ",
 StyleBox["t",
  FontFamily->"Times New Roman",
  FontWeight->"Bold"],
 ", ",
 StyleBox["n",
  FontFamily->"Times New Roman",
  FontWeight->"Bold"],
 " to wektory tr\[OAcute]j\:015bcianu Freneta, za\:015b \[Kappa] =\[Kappa](u) \
 jest krzywizn\:0105 krzywej  \[Rho](u). Zauwa\:017cmy dodatkowo, \:017ce \
\[Kappa] =\[Kappa](u) = ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{"|", 
     RowBox[{
      RowBox[{"\[Rho]", "'"}], "\[Cross]", 
      RowBox[{"\[Rho]", "''"}]}], " ", "|"}], 
    RowBox[{"|", 
     RowBox[{"\[Rho]", "'"}], 
     SuperscriptBox["|", "3"]}]], TraditionalForm]]],
 "=| \[Rho]'\[Cross]\[Rho]'' |.  \nOtrzymujemy \nE = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    StyleBox["t",
     FontFamily->"Times New Roman",
     FontWeight->"Bold",
     FontSlant->"Plain"], "2"], TraditionalForm]]],
 " + \[Kappa] ",
 StyleBox["t n",
  FontFamily->"Times New Roman",
  FontWeight->"Bold"],
 " + ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"\[Kappa]", " ", 
      StyleBox["n",
       FontFamily->"Times New Roman",
       FontWeight->"Bold",
       FontSlant->"Plain"]}], ")"}], "2"], TraditionalForm]]],
 " = 1 + ",
 StyleBox["0",
  FontFamily->"Times New Roman",
  FontWeight->"Bold"],
 " + ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Kappa]", "2"], TraditionalForm]]],
 " = 1 + ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[Kappa]", "2"], TraditionalForm]]],
 ".\nPodobnie obliczamy\nF = \[Rho]'(u)  (\[Rho]'(u) + v \[Rho]''(u)) = 1\nG \
= ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[Rho]", "'"}], 
      RowBox[{"(", "u", ")"}]}], ")"}], "2"], TraditionalForm]]],
 " = 1\nWsp\[OAcute]\[LSlash]czynniki pierwszej formy kwadratowej powierzchni \
r(u,v) to: E = ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", " ", "+", 
    RowBox[{
     SuperscriptBox["v", "2"], 
     SuperscriptBox["\[Kappa]", "2"]}]}], TraditionalForm]]],
 ", F = 1, G=1, zatem \nW = ",
 Cell[BoxData[
  FormBox[
   SqrtBox[
    RowBox[{"EG", " ", "-", " ", 
     SuperscriptBox["F", "2"]}]], TraditionalForm]]],
 " = |v\[Kappa]|\nPoniewa\:017c ca\[LSlash]ka wycinka takiej powierzchni, dla \
u,v nale\:017c\:0105cych do D, to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Integral]", 
    RowBox[{
     SubscriptBox["\[Integral]", "D"], 
     RowBox[{"W", 
      RowBox[{"\[DifferentialD]", "u"}]}]}]}], TraditionalForm]]],
 "\[DifferentialD]v = ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"\[Integral]", 
    SubscriptBox["\[Integral]", "D"]}], " ", "|", "v\[Kappa]", "|"}]]],
 " \[DifferentialD]u\[DifferentialD]v\nW przypadku, gdy D jest \
prostok\:0105tem danym nier\[OAcute]wno\:015bciami a \[LessEqual] u \
\[LessEqual] b, c \[LessEqual] v \[LessEqual] d, otrzymujemy ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Integral]", 
    RowBox[{
     SubscriptBox["\[Integral]", "D"], 
     RowBox[{"W", 
      RowBox[{"\[DifferentialD]", "u"}]}]}]}], TraditionalForm]]],
 "\[DifferentialD]v = ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubsuperscriptBox["\[Integral]", "c", "d"], 
    SubsuperscriptBox["\[Integral]", "a", "b"]}], "|", "v\[Kappa]", "|"}]]],
 " \[DifferentialD]u\[DifferentialD]v = ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubsuperscriptBox["\[Integral]", "a", "b"], 
    RowBox[{"\[Kappa]", 
     RowBox[{"\[DifferentialD]", "u"}], 
     SubsuperscriptBox["\[Integral]", "c", "d"]}]}], "|", "v", "|"}]]],
 "\[DifferentialD]v"
}], "Text",
 CellChangeTimes->{{3.597852214362516*^9, 3.597852216619645*^9}, 
   3.5981197950621643`*^9, 3.599200273353887*^9, {3.5992012855401573`*^9, 
   3.599201327656858*^9}, {3.599201361965474*^9, 3.599201589099217*^9}, {
   3.5992016311211853`*^9, 3.599201692571589*^9}, {3.6051629296330457`*^9, 
   3.605162972453495*^9}, {3.6051631180628233`*^9, 3.6051632426569495`*^9}, {
   3.6051634085734396`*^9, 3.6051635104802685`*^9}, {3.6051635649103813`*^9, 
   3.605163868107723*^9}, {3.6051639282081614`*^9, 3.6051640655670176`*^9}, {
   3.6051708243215065`*^9, 3.6051708419715157`*^9}, {3.60517093575288*^9, 
   3.6051710725807056`*^9}, {3.605171118225317*^9, 3.605171173218462*^9}, {
   3.605178283078946*^9, 3.605178380555522*^9}, {3.6052035755247817`*^9, 
   3.6052035772938833`*^9}},
 FontSize->18,
 FontColor->GrayLevel[0]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]", "[", "u_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"List", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"Cos", "[", 
              FractionBox["u", "5"], "]"}]}], ",", 
            RowBox[{"4", " ", 
             RowBox[{"Sin", "[", 
              FractionBox["u", "5"], "]"}]}], ",", 
            FractionBox[
             RowBox[{"3", " ", "u"}], "5"]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"u", "-", 
             RowBox[{"Log", "[", 
              RowBox[{"1", "+", "u"}], "]"}]}], ",", 
            RowBox[{
             SqrtBox["2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SqrtBox["u"]}], "-", 
               RowBox[{"2", " ", 
                RowBox[{"ArcTan", "[", 
                 SqrtBox["u"], "]"}]}]}], ")"}]}], ",", 
            RowBox[{"Log", "[", 
             RowBox[{"1", "+", "u"}], "]"}]}], "}"}]}], "}"}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "[", 
      RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Kappa]", "[", "u_", "]"}], ":=", 
     RowBox[{"Simplify", "[", 
      SqrtBox[
       RowBox[{
        RowBox[{"Cross", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Rho]", "'"}], "[", "u", "]"}], ",", 
          RowBox[{
           RowBox[{"\[Rho]", "''"}], "[", "u", "]"}]}], " ", "]"}], ".", 
        RowBox[{"Cross", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Rho]", "'"}], "[", "u", "]"}], ",", 
          RowBox[{
           RowBox[{"\[Rho]", "''"}], "[", "u", "]"}]}], " ", "]"}]}]], 
      "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"listaA1", "=", " ", 
     RowBox[{"List", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "10"}], "Pi"}], ",", "0"}], "}"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"listaA2", " ", "=", " ", 
     RowBox[{"List", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"10", "Pi"}], ",", "10"}], "}"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"listaU1", "=", " ", 
     RowBox[{"List", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "10"}], ",", "0"}], "}"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"listaU2", " ", "=", " ", 
     RowBox[{"List", "[", 
      RowBox[{"{", 
       RowBox[{"10", ",", "10"}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"a1", "=", 
     RowBox[{
      RowBox[{"Flatten", "[", "listaA1", "]"}], "[", 
      RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"a2", "=", 
     RowBox[{
      RowBox[{"Flatten", "[", "listaA2", "]"}], "[", 
      RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"uStart", "=", 
     RowBox[{
      RowBox[{"Flatten", "[", "listaU1", "]"}], "[", 
      RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"uEnd", "=", 
     RowBox[{
      RowBox[{"Flatten", "[", "listaU2", "]"}], "[", 
      RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"g1", " ", "=", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ParametricPlot3D", "[", 
        RowBox[{
         RowBox[{"\[Rho]", "[", "u", "]"}], " ", ",", 
         RowBox[{"{", 
          RowBox[{"u", ",", "a1", ",", "a2"}], "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Thick", ",", "Red"}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"styczna", "\[Equal]", "True"}], ",", 
         RowBox[{"ParametricPlot3D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Rho]", "[", "u0", "]"}], " ", "+", 
            RowBox[{"v", "*", 
             RowBox[{
              RowBox[{"\[Rho]", "'"}], "[", "u0", "]"}]}]}], ",", 
           RowBox[{"{", 
            RowBox[{"v", ",", 
             RowBox[{"-", "40"}], ",", "40"}], "}"}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Thick", ",", 
              RowBox[{"Darker", "[", "Green", "]"}]}], "}"}]}]}], "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"styczna", "  ", "\[Equal]", "True"}], ",", 
         RowBox[{"Graphics3D", "[", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"PointSize", "[", ".01", "]"}], ",", 
            RowBox[{"Point", "[", 
             RowBox[{"\[Rho]", "[", "u0", "]"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"ParametricPlot3D", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Rho]", "[", "u", "]"}], " ", "+", 
          RowBox[{"v", "*", 
           RowBox[{
            RowBox[{"\[Rho]", "'"}], "[", "u", "]"}]}]}], "  ", ",", 
         RowBox[{"{", 
          RowBox[{"u", ",", "a1", ",", "a2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"v", ",", 
           RowBox[{"-", "40"}], ",", "40"}], "}"}], ",", 
         RowBox[{"Mesh", "\[Rule]", "Automatic"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Opacity", "[", "0.5", "]"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], "]"}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"ParametricPlot3D", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Rho]", "[", "u", "]"}], " ", "+", 
          RowBox[{"v", "*", 
           RowBox[{
            RowBox[{"\[Rho]", "'"}], "[", "u", "]"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"u", ",", "u1", ",", "u2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"v", ",", "v1", ",", "v2"}], "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Thick", ",", 
            RowBox[{"Hue", "[", 
             RowBox[{"19", "/", "25"}], "]"}]}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"PlotLabel", "\[Rule]", 
        RowBox[{"Style", "[", " ", 
         RowBox[{"\"\<r(u,v)\>\"", ",", "Large", ",", "Bold"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", "\[IndentingNewLine]", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<x\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<y\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<z\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "13"}], ",", "13"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "13"}], ",", "13"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "6"}], "Pi"}], ",", 
            RowBox[{"6", "Pi"}]}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"g2", " ", "=", " ", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Plot3D", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Kappa]", "[", "u", "]"}], "*", 
          RowBox[{"Abs", "[", "v", "]"}]}], "  ", ",", 
         RowBox[{"{", 
          RowBox[{"u", ",", "u1", ",", "u2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"v", ",", "v1", ",", "v2"}], "}"}], ",", 
         RowBox[{"ColorFunction", "->", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Blend", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"White", ",", 
                RowBox[{"Lighter", "[", 
                 RowBox[{"Hue", "[", 
                  RowBox[{"37", "/", "50"}], "]"}], "]"}]}], "}"}], ",", 
              "#3"}], "]"}], "&"}], ")"}]}], ",", 
         RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<u\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<v\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<|v|\[Kappa](u)\>\"", ",", "Large", ",", "Bold", ",", 
             "Black"}], "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"g3", "=", " ", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"\[Kappa]", "[", "u", "]"}], " ", ",", 
         RowBox[{"{", 
          RowBox[{"u", ",", "u1", ",", "u2"}], "}"}], ",", 
         RowBox[{"PlotStyle", "->", 
          RowBox[{"Hue", "[", 
           RowBox[{"37", "/", "50"}], "]"}]}], ",", 
         RowBox[{"AxesOrigin", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<u\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<\[Kappa](u)\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"g4", "=", " ", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"Abs", "[", "v", " ", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"v", ",", "v1", ",", "v2"}], "}"}], ",", 
         RowBox[{"PlotStyle", "->", 
          RowBox[{"Hue", "[", 
           RowBox[{"37", "/", "50"}], "]"}]}], ",", 
         RowBox[{"AxesOrigin", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<v\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<|v|\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
            "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"g5", " ", "=", "  ", 
     RowBox[{"Row", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<\[Kappa](u) \>\"", ",", "\"\<=\>\"", ",", 
        RowBox[{"TraditionalForm", "[", 
         RowBox[{"Simplify", "[", 
          RowBox[{"\[Kappa]", "[", "u", "]"}], "]"}], "]"}], ",", " ", 
        "\"\< \[DoubleRightArrow] \!\(\*SubsuperscriptBox[\(\[Integral]\), \
\(u1\), \(u2\)]\)\[Kappa](u)\[DifferentialD]u = \>\"", ",", 
        RowBox[{"TraditionalForm", "[", 
         RowBox[{
          SubsuperscriptBox["\[Integral]", "u1", "u2"], 
          RowBox[{
           RowBox[{"\[Kappa]", "[", "u", "]"}], 
           RowBox[{"\[DifferentialD]", "u"}]}]}], "]"}]}], "}"}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"g6", " ", "=", " ", 
     RowBox[{"Row", "[", 
      RowBox[{"{", " ", 
       RowBox[{
       "\"\< \!\(\*SubsuperscriptBox[\(\[Integral]\), \(v1\), \(v2\)]\)|v|\
\[DifferentialD]v = \>\"", ",", 
        RowBox[{"TraditionalForm", "[", 
         RowBox[{
          SubsuperscriptBox["\[Integral]", "v1", "v2"], 
          RowBox[{
           RowBox[{"Abs", "[", "v", "]"}], 
           RowBox[{"\[DifferentialD]", "v"}]}]}], "]"}]}], "}"}], "]"}]}], 
    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"g7", " ", "=", 
     RowBox[{"Column", "[", 
      RowBox[{"{", "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Rozwa\:017cmy krzyw\:0105 \[Rho](u) \>\"", ",", "\"\<=\>\"", 
           ",", 
           RowBox[{"TraditionalForm", "[", 
            RowBox[{"\[Rho]", "[", "u", "]"}], "]"}], ",", " ", 
           "\"\<, zaznaczon\:0105 na czerwono.\>\""}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Row", "[", 
         RowBox[{
         "{", "\"\<Powierzchnia utworzona przez styczne do tej krzywej \
to\>\"", "}"}], "]"}], ",", "\[IndentingNewLine]", " ", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
          "\"\<r(u,v) = \[Rho](u) + v\[CenterDot]\[Rho]'(u) = \>\"", ",", 
           RowBox[{"TraditionalForm", "[", 
            RowBox[{"Simplify", "[", 
             RowBox[{
              RowBox[{"\[Rho]", "[", "u", "]"}], " ", "+", 
              RowBox[{"v", "*", 
               RowBox[{
                RowBox[{"\[Rho]", "'"}], "[", "u", "]"}]}]}], "]"}], "]"}], 
           ",", "\"\<.\>\""}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Row", "[", 
         RowBox[{
         "{", "\"\<Rozwa\:017cmy p\[LSlash]at wyznaczony przez \
\!\(\*SubscriptBox[\(u\), \(1\)]\)\[LessEqual] u \[LessEqual] \
\!\(\*SubscriptBox[\(u\), \(2\)]\), \!\(\*SubscriptBox[\(v\), \(1\)]\)\
\[LessEqual] v \[LessEqual] \!\(\*SubscriptBox[\(v\), \(2\)]\) i zaznaczmy go \
na fioletowo na rysunku po lewej. \>\"", "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Pole p\[LSlash]ata to \!\(\*SubsuperscriptBox[\(\[Integral]\), \
SubscriptBox[\(v\), \(1\)], SubscriptBox[\(v\), \
\(2\)]]\)\!\(\*SubsuperscriptBox[\(\[Integral]\), SubscriptBox[\(u\), \(1\)], \
SubscriptBox[\(u\), \(2\)]]\)|v \[Kappa](u)|du dv = \
\!\(\*SubsuperscriptBox[\(\[Integral]\), SubscriptBox[\(v\), \(1\)], \
SubscriptBox[\(v\), \(2\)]]\)|v|dv\[CenterDot]\!\(\*SubsuperscriptBox[\(\
\[Integral]\), SubscriptBox[\(u\), \(1\)], SubscriptBox[\(u\), \(2\)]]\)\
\[Kappa](u) du \>\"", ",", "\"\<=\>\"", ",", 
           RowBox[{"TraditionalForm", "[", 
            RowBox[{
             SubsuperscriptBox["\[Integral]", "v1", "v2"], 
             RowBox[{
              RowBox[{"Abs", "[", "v", "]"}], 
              RowBox[{"\[DifferentialD]", "v"}]}]}], "]"}], ",", 
           "\"\<\[CenterDot]\>\"", ",", 
           RowBox[{"TraditionalForm", "[", 
            RowBox[{
             SubsuperscriptBox["\[Integral]", "u1", "u2"], 
             RowBox[{
              RowBox[{"\[Kappa]", "[", "u", "]"}], 
              RowBox[{"\[DifferentialD]", "u"}]}]}], "]"}], ",", " ", 
           "\"\<=\>\"", ",", 
           RowBox[{"TraditionalForm", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               SubsuperscriptBox["\[Integral]", "v1", "v2"], 
               RowBox[{
                RowBox[{"Abs", "[", "v", "]"}], 
                RowBox[{"\[DifferentialD]", "v"}]}]}], ")"}], "*", 
             RowBox[{
              SubsuperscriptBox["\[Integral]", "u1", "u2"], 
              RowBox[{
               RowBox[{"\[Kappa]", "[", "u", "]"}], 
               RowBox[{"\[DifferentialD]", "u"}]}]}]}], "]"}], ",", 
           "\"\<.\>\""}], "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], 
      "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{"g1", ",", "\"\<    \>\"", ",", 
         RowBox[{"Column", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Text", "[", 
             RowBox[{"Style", "[", 
              RowBox[{"g7", ",", 
               RowBox[{"FontSize", "\[Rule]", "25"}], ",", 
               RowBox[{"Darker", "[", 
                RowBox[{"Hue", "[", 
                 RowBox[{"19", "/", "25"}], "]"}], "]"}]}], "]"}], "]"}], 
            ",", "\"\<    \>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"Row", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Framed", "@", "g2"}], ",", "\"\<    \>\"", ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Column", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Framed", "@", "g3"}], ",", 
                  RowBox[{"Text", "[", 
                   RowBox[{"Style", "[", 
                    RowBox[{"g5", ",", 
                    RowBox[{"FontSize", "\[Rule]", "20"}], ",", 
                    RowBox[{"Darker", "[", 
                    RowBox[{"Hue", "[", 
                    RowBox[{"19", "/", "25"}], "]"}], "]"}]}], "]"}], "]"}]}],
                  "}"}], "]"}], ",", "\"\<    \>\"", ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Column", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Framed", "@", "g4"}], ",", 
                  RowBox[{"Text", "[", 
                   RowBox[{"Style", "[", 
                    RowBox[{"g6", ",", 
                    RowBox[{"FontSize", "\[Rule]", "20"}], ",", 
                    RowBox[{"Darker", "[", 
                    RowBox[{"Hue", "[", 
                    RowBox[{"19", "/", "25"}], "]"}], "]"}]}], "]"}], "]"}]}],
                  "}"}], "]"}]}], "}"}], "]"}]}], "}"}], "]"}]}], "}"}], 
       "]"}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "styczna", ",", "False", ",", 
       "\"\<styczna w \[Rho](\!\(\*SubscriptBox[\(u\), \(0\)]\))\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u0", ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "1"}], ",", "uStart", ",", 
         RowBox[{"uStart", "+", "0.1"}]}], "]"}], ",", 
       "\"\<\!\(\*SubscriptBox[\(u\), \(0\)]\)\>\""}], "}"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "1"}], ",", "uStart", ",", 
       RowBox[{"uStart", "+", "0.1"}]}], "]"}], ",", "uEnd"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "i", ",", "2", ",", " ", "\"\<Wyb\[OAcute]r krzywej \[Rho](u)\>\""}], 
      "}"}], ",", 
     RowBox[{"Range", "[", "2", "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v1", ",", 
       RowBox[{"-", "10"}], ",", 
       "\"\<\!\(\*SubscriptBox[\(v\), \(1\)]\)\>\""}], "}"}], ",", 
     RowBox[{"-", "20"}], ",", 
     RowBox[{"-", "0.1"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "v2", ",", "10", ",", "\"\<\!\(\*SubscriptBox[\(v\), \(2\)]\)\>\""}], 
      "}"}], ",", "0.1", ",", "20"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u1", ",", 
       FractionBox["uStart", "2"], ",", 
       "\"\<\!\(\*SubscriptBox[\(u\), \(1\)]\)\>\""}], "}"}], ",", "uStart", 
     ",", 
     FractionBox[
      RowBox[{"uStart", "+", "uEnd"}], "2"]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u2", ",", 
       FractionBox["uEnd", "2"], ",", 
       "\"\<\!\(\*SubscriptBox[\(u\), \(2\)]\)\>\""}], "}"}], ",", 
     FractionBox[
      RowBox[{"uStart", "+", "uEnd"}], "2"], ",", "uEnd"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"SynchronousUpdating", "\[Rule]", "True"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.6051739211456347`*^9, 3.605173951165352*^9}, {
   3.605174001384224*^9, 3.6051740022042713`*^9}, {3.605174042306565*^9, 
   3.6051741130286098`*^9}, {3.6051741493876896`*^9, 3.605174300075308*^9}, {
   3.6051743374224443`*^9, 3.6051743578466125`*^9}, {3.605174536368823*^9, 
   3.605174595101183*^9}, {3.6051747280027847`*^9, 3.6051747380053563`*^9}, {
   3.6051748206220818`*^9, 3.6051748207970915`*^9}, {3.6051749060829697`*^9, 
   3.6051749320534554`*^9}, {3.6051749703616467`*^9, 
   3.6051749921538925`*^9}, {3.6051774780148993`*^9, 3.605177490839633*^9}, {
   3.605177539902439*^9, 3.6051776025130205`*^9}, {3.6051781076009097`*^9, 
   3.605178163854127*^9}, {3.6051782141250024`*^9, 3.6051782703212166`*^9}, {
   3.6051784449942074`*^9, 3.6051786175220757`*^9}, {3.605178664248748*^9, 
   3.6051786939864492`*^9}, {3.605178779127319*^9, 3.6051788329383965`*^9}, {
   3.6051789096527843`*^9, 3.605178954664359*^9}, {3.6051790381531343`*^9, 
   3.605179098274573*^9}, {3.6051791287503157`*^9, 3.6051791298063765`*^9}, {
   3.6051792145392227`*^9, 3.605179308089574*^9}, {3.6051793444066505`*^9, 
   3.605179385980029*^9}, {3.6051795740327845`*^9, 3.6051796194843845`*^9}, {
   3.6051796922505465`*^9, 3.6051797908561864`*^9}, {3.6051798249371357`*^9, 
   3.605179970089438*^9}, {3.6051800271957045`*^9, 3.605180145274458*^9}, {
   3.605182094837967*^9, 3.605182139882543*^9}, {3.6051824294401045`*^9, 
   3.605182433102314*^9}, {3.6051830762551003`*^9, 3.6051830769231386`*^9}, {
   3.605186696405161*^9, 3.6051867087568674`*^9}, {3.6051884891397*^9, 
   3.6051885220745835`*^9}, {3.6051886257845154`*^9, 3.60518862971474*^9}, {
   3.6051886700470467`*^9, 3.605188863924136*^9}, {3.605188946268846*^9, 
   3.6051889713492804`*^9}, {3.6051890199520607`*^9, 3.605189101677735*^9}, {
   3.6051891887017126`*^9, 3.6051892539864464`*^9}, {3.6051893037102904`*^9, 
   3.6051894148326464`*^9}, {3.6051894539108815`*^9, 
   3.6051896561634493`*^9}, {3.605189786331895*^9, 3.6051897994726467`*^9}, {
   3.605195764890849*^9, 3.6051959946159887`*^9}, {3.6051960305700445`*^9, 
   3.6051961086335096`*^9}, {3.6051961406713424`*^9, 3.605196147138712*^9}, {
   3.6051961942564073`*^9, 3.605196262650319*^9}, {3.6051963180004845`*^9, 
   3.605196450497063*^9}, {3.60519653942615*^9, 3.605196548720681*^9}, {
   3.6051965857177973`*^9, 3.605196693529964*^9}, {3.6051967924676228`*^9, 
   3.6051968623326187`*^9}, {3.6051968957165284`*^9, 3.605197099587189*^9}, {
   3.6051971474949293`*^9, 3.6051973365307417`*^9}, 3.605197491807623*^9, {
   3.605198304983134*^9, 3.605198610214592*^9}, {3.605198880038025*^9, 
   3.6051988892745533`*^9}, {3.6051989387783847`*^9, 3.605198941263527*^9}, {
   3.605204430527685*^9, 3.605204474865221*^9}, {3.605204547204359*^9, 
   3.605204550143527*^9}, 3.605204584267479*^9, {3.6052049776129766`*^9, 
   3.6052050498241067`*^9}, {3.6052051008170233`*^9, 
   3.6052051409783206`*^9}, {3.605205172162104*^9, 3.605205236177766*^9}, {
   3.6052053266099377`*^9, 3.6052053426258545`*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`i$$ = 2, $CellContext`styczna$$ = 
    False, $CellContext`u0$$ = 
    If[$CellContext`i$$ == 1, $CellContext`uStart, $CellContext`uStart + 
     0.1], $CellContext`u1$$ = 0, $CellContext`u2$$ = 
    5, $CellContext`v1$$ = -10, $CellContext`v2$$ = 10, Typeset`show$$ = True,
     Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`styczna$$], False, 
       "styczna w \[Rho](\!\(\*SubscriptBox[\(u\), \(0\)]\))"}, {
      True, False}}, {{
       Hold[$CellContext`u0$$], 
       If[$CellContext`i$$ == 1, $CellContext`uStart, $CellContext`uStart + 
        0.1], "\!\(\*SubscriptBox[\(u\), \(0\)]\)"}, 
      Dynamic[
       If[$CellContext`i$$ == 1, $CellContext`uStart, $CellContext`uStart + 
        0.1]], 10}, {{
       Hold[$CellContext`i$$], 2, "Wyb\[OAcute]r krzywej \[Rho](u)"}, {1, 
      2}}, {{
       Hold[$CellContext`v1$$], -10, 
       "\!\(\*SubscriptBox[\(v\), \(1\)]\)"}, -20, -0.1}, {{
       Hold[$CellContext`v2$$], 10, "\!\(\*SubscriptBox[\(v\), \(2\)]\)"}, 
      0.1, 20}, {{
       Hold[$CellContext`u1$$], 0, "\!\(\*SubscriptBox[\(u\), \(1\)]\)"}, 0, 
      5}, {{
       Hold[$CellContext`u2$$], 5, "\!\(\*SubscriptBox[\(u\), \(2\)]\)"}, 5, 
      10}}, Typeset`size$$ = {1655., {357.5, 362.5}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = 
    False, $CellContext`styczna$219007$$ = False, $CellContext`u0$219008$$ = 
    0, $CellContext`i$219009$$ = False, $CellContext`v1$219010$$ = 
    0, $CellContext`v2$219011$$ = 0, $CellContext`u1$219012$$ = 
    0, $CellContext`u2$219013$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`i$$ = 2, $CellContext`styczna$$ = 
        False, $CellContext`u0$$ = 
        If[$CellContext`i$$ == 1, $CellContext`uStart, $CellContext`uStart + 
          0.1], $CellContext`u1$$ = 0, $CellContext`u2$$ = 
        5, $CellContext`v1$$ = -10, $CellContext`v2$$ = 10}, 
      "ControllerVariables" :> {
        Hold[$CellContext`styczna$$, $CellContext`styczna$219007$$, False], 
        Hold[$CellContext`u0$$, $CellContext`u0$219008$$, 0], 
        Hold[$CellContext`i$$, $CellContext`i$219009$$, False], 
        Hold[$CellContext`v1$$, $CellContext`v1$219010$$, 0], 
        Hold[$CellContext`v2$$, $CellContext`v2$219011$$, 0], 
        Hold[$CellContext`u1$$, $CellContext`u1$219012$$, 0], 
        Hold[$CellContext`u2$$, $CellContext`u2$219013$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> ($CellContext`\[Rho][
          Pattern[$CellContext`u$, 
           Blank[]]] := Part[
          
          Part[{{{4 Cos[$CellContext`u$/5], 4 Sin[$CellContext`u$/5], 
              3 $CellContext`u$/5}, {$CellContext`u$ - Log[
              1 + $CellContext`u$], 
              2^Rational[1, 2] (2 $CellContext`u$^Rational[1, 2] - 2 
               ArcTan[$CellContext`u$^Rational[1, 2]]), 
              Log[1 + $CellContext`u$]}}}, 
           1], $CellContext`i$$]; $CellContext`\[Kappa][
          Pattern[$CellContext`u, 
           Blank[]]] := Simplify[Dot[
            Cross[
             Derivative[1][$CellContext`\[Rho]][$CellContext`u], 
             Derivative[2][$CellContext`\[Rho]][$CellContext`u]], 
            Cross[
             Derivative[1][$CellContext`\[Rho]][$CellContext`u], 
             Derivative[2][$CellContext`\[Rho]][$CellContext`u]]]^
          Rational[1, 2]]; $CellContext`listaA1 = {{(-10) Pi, 
           0}}; $CellContext`listaA2 = {{
          10 Pi, 10}}; $CellContext`listaU1 = {{-10, 
         0}}; $CellContext`listaU2 = {{10, 10}}; $CellContext`a1 = Part[
          Flatten[$CellContext`listaA1], $CellContext`i$$]; $CellContext`a2 = 
        Part[
          
          Flatten[$CellContext`listaA2], $CellContext`i$$]; \
$CellContext`uStart = Part[
          Flatten[$CellContext`listaU1], $CellContext`i$$]; $CellContext`uEnd = 
        Part[
          Flatten[$CellContext`listaU2], $CellContext`i$$]; $CellContext`g1 = 
        Show[
          ParametricPlot3D[
           $CellContext`\[Rho][$CellContext`u], {$CellContext`u, \
$CellContext`a1, $CellContext`a2}, PlotStyle -> {Thick, Red}], 
          If[$CellContext`styczna$$ == True, 
           
           ParametricPlot3D[$CellContext`\[Rho][$CellContext`u0$$] + \
$CellContext`v 
             Derivative[
              1][$CellContext`\[Rho]][$CellContext`u0$$], {$CellContext`v, \
-40, 40}, PlotStyle -> {Thick, 
              Darker[Green]}], {}], 
          If[$CellContext`styczna$$ == True, 
           Graphics3D[{Black, 
             PointSize[0.01], 
             Point[
              $CellContext`\[Rho][$CellContext`u0$$]]}], {}], 
          
          ParametricPlot3D[$CellContext`\[Rho][$CellContext`u] + \
$CellContext`v 
            Derivative[
             1][$CellContext`\[Rho]][$CellContext`u], {$CellContext`u, \
$CellContext`a1, $CellContext`a2}, {$CellContext`v, -40, 40}, Mesh -> 
           Automatic, PlotStyle -> {
             Opacity[0.5]}, PerformanceGoal -> "Quality"], 
          
          ParametricPlot3D[$CellContext`\[Rho][$CellContext`u] + \
$CellContext`v 
            Derivative[
             1][$CellContext`\[Rho]][$CellContext`u], {$CellContext`u, \
$CellContext`u1$$, $CellContext`u2$$}, {$CellContext`v, $CellContext`v1$$, \
$CellContext`v2$$}, PlotStyle -> {Thick, 
             Hue[19/25]}], PlotLabel -> Style["r(u,v)", Large, Bold], 
          ImageSize -> Large, AxesLabel -> {
            Text[
             Style["x", Large, Bold, Black]], 
            Text[
             Style["y", Large, Bold, Black]], 
            Text[
             Style["z", Large, Bold, Black]]}, 
          PlotRange -> {{-13, 13}, {-13, 
            13}, {(-6) Pi, 6 Pi}}]; $CellContext`g2 = Show[
          Plot3D[$CellContext`\[Kappa][$CellContext`u] 
           Abs[$CellContext`v], {$CellContext`u, $CellContext`u1$$, \
$CellContext`u2$$}, {$CellContext`v, $CellContext`v1$$, $CellContext`v2$$}, 
           ColorFunction -> (Blend[{White, 
              Lighter[
               Hue[37/50]]}, #3]& ), PerformanceGoal -> "Quality"], AxesLabel -> {
            Text[
             Style["u", Large, Bold, Black]], 
            Text[
             Style["v", Large, Bold, Black]], 
            Text[
             Style["|v|\[Kappa](u)", Large, Bold, Black]]}, PlotRange -> All, 
          ImageSize -> Medium]; $CellContext`g3 = Show[
          Plot[
           $CellContext`\[Kappa][$CellContext`u], {$CellContext`u, \
$CellContext`u1$$, $CellContext`u2$$}, PlotStyle -> Hue[37/50], 
           AxesOrigin -> {0, 0}], AxesLabel -> {
            Text[
             Style["u", Large, Bold, Black]], 
            Text[
             Style["\[Kappa](u)", Large, Bold, Black]]}, PlotRange -> All, 
          ImageSize -> Small]; $CellContext`g4 = Show[
          Plot[
           
           Abs[$CellContext`v], {$CellContext`v, $CellContext`v1$$, \
$CellContext`v2$$}, PlotStyle -> Hue[37/50], AxesOrigin -> {0, 0}], AxesLabel -> {
            Text[
             Style["v", Large, Bold, Black]], 
            Text[
             Style["|v|", Large, Bold, Black]]}, PlotRange -> All, ImageSize -> 
          Small]; $CellContext`g5 = Row[{"\[Kappa](u) ", "=", 
           TraditionalForm[
            Simplify[
             $CellContext`\[Kappa][$CellContext`u]]], 
           " \[DoubleRightArrow] \!\(\*SubsuperscriptBox[\(\[Integral]\), \
\(u1\), \(u2\)]\)\[Kappa](u)\[DifferentialD]u = ", 
           TraditionalForm[
            Integrate[
             $CellContext`\[Kappa][$CellContext`u], {$CellContext`u, \
$CellContext`u1$$, $CellContext`u2$$}]]}]; $CellContext`g6 = 
        Row[{" \!\(\*SubsuperscriptBox[\(\[Integral]\), \(v1\), \(v2\)]\)|v|\
\[DifferentialD]v = ", 
           TraditionalForm[
            Integrate[
             
             Abs[$CellContext`v], {$CellContext`v, $CellContext`v1$$, \
$CellContext`v2$$}]]}]; $CellContext`g7 = Column[{
           Row[{"Rozwa\:017cmy krzyw\:0105 \[Rho](u) ", "=", 
             TraditionalForm[
              $CellContext`\[Rho][$CellContext`u]], 
             ", zaznaczon\:0105 na czerwono."}], 
           Row[{"Powierzchnia utworzona przez styczne do tej krzywej to"}], 
           Row[{"r(u,v) = \[Rho](u) + v\[CenterDot]\[Rho]'(u) = ", 
             TraditionalForm[
              
              Simplify[$CellContext`\[Rho][$CellContext`u] + $CellContext`v 
                Derivative[1][$CellContext`\[Rho]][$CellContext`u]]], "."}], 
           
           Row[{"Rozwa\:017cmy p\[LSlash]at wyznaczony przez \
\!\(\*SubscriptBox[\(u\), \(1\)]\)\[LessEqual] u \[LessEqual] \
\!\(\*SubscriptBox[\(u\), \(2\)]\), \!\(\*SubscriptBox[\(v\), \(1\)]\)\
\[LessEqual] v \[LessEqual] \!\(\*SubscriptBox[\(v\), \(2\)]\) i zaznaczmy go \
na fioletowo na rysunku po lewej. "}], 
           
           Row[{"Pole p\[LSlash]ata to \
\!\(\*SubsuperscriptBox[\(\[Integral]\), SubscriptBox[\(v\), \(1\)], \
SubscriptBox[\(v\), \(2\)]]\)\!\(\*SubsuperscriptBox[\(\[Integral]\), \
SubscriptBox[\(u\), \(1\)], SubscriptBox[\(u\), \(2\)]]\)|v \[Kappa](u)|du dv \
= \!\(\*SubsuperscriptBox[\(\[Integral]\), SubscriptBox[\(v\), \(1\)], \
SubscriptBox[\(v\), \(2\)]]\)|v|dv\[CenterDot]\!\(\*SubsuperscriptBox[\(\
\[Integral]\), SubscriptBox[\(u\), \(1\)], SubscriptBox[\(u\), \(2\)]]\)\
\[Kappa](u) du ", "=", 
             TraditionalForm[
              Integrate[
               
               Abs[$CellContext`v], {$CellContext`v, $CellContext`v1$$, \
$CellContext`v2$$}]], "\[CenterDot]", 
             TraditionalForm[
              Integrate[
               $CellContext`\[Kappa][$CellContext`u], {$CellContext`u, \
$CellContext`u1$$, $CellContext`u2$$}]], "=", 
             TraditionalForm[Integrate[
                
                Abs[$CellContext`v], {$CellContext`v, $CellContext`v1$$, \
$CellContext`v2$$}] Integrate[
                $CellContext`\[Kappa][$CellContext`u], {$CellContext`u, \
$CellContext`u1$$, $CellContext`u2$$}]], "."}]}]; Column[{
          Row[{$CellContext`g1, "    ", 
            Column[{
              Text[
               Style[$CellContext`g7, FontSize -> 25, 
                Darker[
                 Hue[19/25]]]], "    ", 
              Row[{
                Framed[$CellContext`g2], "    ", 
                Column[{
                  Framed[$CellContext`g3], 
                  Text[
                   Style[$CellContext`g5, FontSize -> 20, 
                    Darker[
                    Hue[19/25]]]]}], "    ", 
                Column[{
                  Framed[$CellContext`g4], 
                  Text[
                   Style[$CellContext`g6, FontSize -> 20, 
                    Darker[
                    Hue[19/25]]]]}]}]}]}]}]), 
      "Specifications" :> {{{$CellContext`styczna$$, False, 
          "styczna w \[Rho](\!\(\*SubscriptBox[\(u\), \(0\)]\))"}, {
         True, False}}, {{$CellContext`u0$$, 
          
          If[$CellContext`i$$ == 1, $CellContext`uStart, $CellContext`uStart + 
           0.1], "\!\(\*SubscriptBox[\(u\), \(0\)]\)"}, 
         Dynamic[
          
          If[$CellContext`i$$ == 1, $CellContext`uStart, $CellContext`uStart + 
           0.1]], 10}, {{$CellContext`i$$, 2, 
          "Wyb\[OAcute]r krzywej \[Rho](u)"}, {1, 
         2}}, {{$CellContext`v1$$, -10, 
          "\!\(\*SubscriptBox[\(v\), \(1\)]\)"}, -20, -0.1}, \
{{$CellContext`v2$$, 10, "\!\(\*SubscriptBox[\(v\), \(2\)]\)"}, 0.1, 
         20}, {{$CellContext`u1$$, 0, "\!\(\*SubscriptBox[\(u\), \(1\)]\)"}, 
         0, 5}, {{$CellContext`u2$$, 5, "\!\(\*SubscriptBox[\(u\), \(2\)]\)"},
          5, 10}}, "Options" :> {SynchronousUpdating -> True}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{1706., {480., 485.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({$CellContext`\[Rho][
         Pattern[$CellContext`u$, 
          Blank[]]] := Part[
         Part[{{{
            4 Cos[$CellContext`u$/5], 4 
             Sin[$CellContext`u$/5], (3 $CellContext`u$)/5}, {$CellContext`u$ - 
             Log[1 + $CellContext`u$], 
             Sqrt[2] (2 Sqrt[$CellContext`u$] - 2 ArcTan[
                Sqrt[$CellContext`u$]]), 
             Log[1 + $CellContext`u$]}}}, 1], FE`i$$43], 
       Attributes[$CellContext`u$] = {Temporary}, FE`i$$43 = 
       2, $CellContext`\[Kappa][
         Pattern[$CellContext`u, 
          Blank[]]] := Simplify[
         Sqrt[
          Dot[
           Cross[
            Derivative[1][$CellContext`\[Rho]][$CellContext`u], 
            Derivative[2][$CellContext`\[Rho]][$CellContext`u]], 
           Cross[
            Derivative[1][$CellContext`\[Rho]][$CellContext`u], 
            Derivative[2][$CellContext`\[Rho]][$CellContext`u]]]]], 
       Attributes[Derivative] = {
        NHoldAll, 
         ReadProtected}, $CellContext`listaA1 = {{(-10) Pi, 
          0}}, $CellContext`listaA2 = {{
         10 Pi, 10}}, $CellContext`listaU1 = {{-10, 
        0}}, $CellContext`listaU2 = {{10, 10}}, $CellContext`a1 = 
       0, $CellContext`a2 = 10, $CellContext`uStart = 0, $CellContext`uEnd = 
       10, $CellContext`g1 = Graphics3D[{{{{}, {}, {
             Thickness[Large], 
             RGBColor[1, 0, 0], 
             Line[CompressedData["
1:eJwV0nk81IkfBvCZ+SLjvr6RY8q1oSJFJZvPR2lZOUpRu45VrlrVIHeOCaEo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              "]]}}}, 
          GraphicsComplex[CompressedData["
1:eJx0u3kwlW/8Pn5w7Pu+b8e+7/vyvIiikCQhKtmjKJGkyBZFWUqliCxJidCm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           "], {{{
              EdgeForm[], 
              Opacity[0.5], 
              GraphicsGroup[{
                Polygon[CompressedData["
1:eJw1m3cAVtMfxt9777nnVn4iKbIqlcgeIRKVTchqKCpFO0Iqo4jIyAotMyMS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                 "]], 
                Polygon[CompressedData["
1:eJwtmwf8V9Mfxu+95577U2Z7yEhLVEhbNDQ0tagkpWE0tFQqVEoI2SE7REhk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                 "]], 
                Polygon[CompressedData["
1:eJwt13nATWUeB/Cby/u2kSWkZF8qZCdL2RMKWbLv+xKh7JWdImTLmrKkDU0J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                 "]], 
                
                Polygon[{{1412, 1411, 928, 615, 616, 
                 929}}]}]}, {}, {}, {}, {}}, {{}, {}, {}, {
              
              Line[{525, 738, 1704, 526, 752, 1716, 552, 767, 1727, 567, 782, 
               1736, 582, 1819, 797, 597, 1826, 812, 612, 1836, 229, 487, 278,
                1448, 488, 243, 1756, 634, 837, 1768, 649, 852, 1779, 664, 
               867, 1788, 679, 1856, 882, 694, 1863, 897, 709, 1873, 912, 
               724}], 
              
              Line[{527, 739, 1705, 528, 753, 1717, 553, 768, 1728, 568, 783, 
               1737, 583, 798, 1744, 598, 1827, 813, 613, 1837, 925, 966, 926,
                1102, 1081, 968, 1893, 1045, 1103, 941, 987, 942, 1757, 635, 
               838, 1769, 650, 853, 1780, 665, 868, 1789, 680, 883, 1796, 695,
                1864, 898, 710, 1874, 913, 725}], 
              
              Line[{529, 740, 1706, 530, 754, 1718, 554, 769, 1729, 569, 784, 
               1738, 584, 799, 1745, 599, 814, 1750, 614, 1838, 927, 967, 436,
                970, 1894, 386, 988, 943, 1758, 636, 839, 1770, 651, 854, 
               1781, 666, 869, 1790, 681, 884, 1797, 696, 899, 1802, 711, 
               1875, 914, 726}], 
              
              Line[{531, 741, 1707, 533, 755, 1719, 555, 770, 1730, 570, 785, 
               1739, 585, 800, 1746, 600, 815, 1751, 615, 928, 1883, 969, 
               1083, 1082, 972, 1896, 1046, 1047, 989, 944, 1759, 637, 840, 
               1771, 652, 855, 1782, 667, 870, 1791, 682, 885, 1798, 697, 900,
                1803, 712, 915, 1806, 727}], 
              
              Line[{535, 743, 1708, 536, 1809, 757, 557, 1811, 772, 572, 1815,
                787, 587, 1821, 802, 602, 1829, 817, 617, 1839, 930, 973, 
               1032, 826, 628, 1921, 1086, 1087, 991, 831, 1760, 639, 1846, 
               842, 654, 1848, 857, 669, 1852, 872, 684, 1858, 887, 699, 1866,
                902, 714, 1877, 917, 729}], 
              
              Line[{537, 744, 1709, 538, 758, 1720, 558, 1812, 773, 573, 1816,
                788, 588, 1822, 803, 603, 1830, 818, 618, 1840, 931, 974, 
               1033, 1104, 1034, 629, 1922, 1088, 1105, 945, 992, 832, 1761, 
               640, 843, 1772, 655, 1849, 858, 670, 1853, 873, 685, 1859, 888,
                700, 1867, 903, 715, 1878, 918, 730}], 
              
              Line[{539, 745, 1710, 540, 759, 1721, 559, 774, 1731, 574, 1817,
                789, 589, 1823, 804, 604, 1831, 819, 619, 1841, 932, 975, 
               1035, 1106, 1036, 630, 1923, 1089, 1107, 946, 993, 833, 1762, 
               641, 844, 1773, 656, 859, 1783, 671, 1854, 874, 686, 1860, 889,
                701, 1868, 904, 716, 1879, 919, 731}], 
              Line[{541, 746, 1711, 542, 760, 1722, 560, 775, 1732, 575, 790, 
               1740, 590, 1824, 805, 605, 1832, 820, 620, 1842, 933, 976, 934,
                1108, 1090, 978, 1897, 1048, 1109, 947, 994, 948, 1763, 642, 
               845, 1774, 657, 860, 1784, 672, 875, 1792, 687, 1861, 890, 702,
                1869, 905, 717, 1880, 920, 732}], 
              
              Line[{543, 747, 1712, 544, 761, 1723, 561, 776, 1733, 576, 791, 
               1741, 591, 806, 1747, 606, 1833, 821, 621, 1843, 935, 977, 936,
                1110, 1091, 980, 1898, 1049, 1111, 949, 995, 950, 1764, 643, 
               846, 1775, 658, 861, 1785, 673, 876, 1793, 688, 891, 1799, 703,
                1870, 906, 718, 1881, 921, 733}], 
              
              Line[{545, 748, 1713, 546, 762, 1724, 562, 777, 1734, 577, 792, 
               1742, 592, 807, 1748, 607, 822, 1752, 622, 1844, 937, 979, 
               1093, 1092, 982, 1899, 1050, 1051, 996, 951, 1765, 644, 847, 
               1776, 659, 862, 1786, 674, 877, 1794, 689, 892, 1800, 704, 907,
                1804, 719, 1882, 922, 734}], 
              
              Line[{547, 956, 1886, 957, 548, 763, 1725, 563, 778, 1735, 578, 
               793, 1743, 593, 808, 1749, 608, 823, 1753, 623, 938, 1884, 981,
                1095, 1094, 983, 1900, 1052, 1053, 997, 1901, 952, 645, 848, 
               1777, 660, 863, 1787, 675, 878, 1795, 690, 893, 1801, 705, 908,
                1805, 720, 1004, 1907, 1005, 1006}], 
              Line[CompressedData["
1:eJwVy7kuxAEUhfE7QyIhdpUCg8Ew9iESHQ2lqZRjqf0VGOuUOqU38AbegCfQ
6TyBiH1ffoqT79zv5GZWk+JGKiLW5CodcVIVUaiO+MRJ3KmJmMALW4Vr0T9w
HLdtY3huS7hm/R2P+FF9RM5sJa5JT/g3fVjPy6ltyX3AN7pf9SEclGPbnHvf
1uB+0XM4IGVbmZ/l6t3XOI1TUuE37TNc2n2JbbjOt+KKLcel9Gfsxy1bHxZt
7VzoT3jIZ/VembfVcb9S4h+xh++Wgu1L9vgf/kEyfJdk+VvZtX3z99LJd0gt
f/P/y93JIrcgy/IHIAYsyw==
               "]], 
              
              Line[{722, 910, 1003, 1871, 707, 895, 1906, 1002, 692, 880, 
               1905, 1001, 677, 865, 1904, 1000, 662, 850, 1902, 999, 647, 
               1766, 835, 998, 632, 1754, 828, 985, 939, 1099, 1079, 1919, 
               625, 1028, 1098, 1027, 964, 923, 1834, 610, 810, 1891, 962, 
               595, 795, 1890, 961, 580, 780, 1889, 960, 565, 765, 1887, 959, 
               550, 1714, 750, 958, 523, 1702, 736, 953, 954}], 
              
              Line[{723, 911, 1872, 708, 896, 1862, 693, 881, 1855, 678, 866, 
               1850, 663, 1778, 851, 648, 1767, 836, 633, 1755, 829, 986, 940,
                1101, 1080, 1920, 626, 1030, 1100, 1029, 965, 924, 1835, 611, 
               811, 1825, 596, 796, 1818, 581, 781, 1813, 566, 1726, 766, 551,
                1715, 751, 524, 1703, 737, 955, 1008}], 
              
              Line[{728, 916, 1876, 713, 901, 1865, 698, 886, 1857, 683, 871, 
               1851, 668, 856, 1847, 653, 841, 1845, 638, 830, 1885, 990, 
               1085, 1084, 627, 825, 1031, 971, 1895, 929, 616, 816, 1828, 
               601, 801, 1820, 586, 786, 1814, 571, 771, 1810, 556, 756, 1808,
                534, 742, 1807, 532}]}, {
              
              Line[{1113, 1542, 1543, 1496, 1510, 735, 1489, 1428, 1702, 1309,
                1114, 1429, 1703, 1310, 1115, 1704, 1311, 1116, 1705, 1312, 
               1117, 1706, 1313, 1118, 1707, 1598, 1807, 1119, 1708, 1314, 
               1120, 1709, 1315, 1121, 1710, 1316, 1122, 1711, 1317, 1123, 
               1712, 1318, 1124, 1713, 1319, 1125, 1886, 1430, 1320, 1431}], 
              
              Line[{1126, 1551, 1552, 1497, 1511, 1599, 1912, 1490, 1432, 
               1714, 1321, 1127, 1715, 1322, 1128, 1716, 1323, 1129, 1717, 
               1324, 1130, 1718, 1325, 1131, 1719, 1600, 1808, 1132, 1601, 
               1809, 1133, 1720, 1326, 1134, 1721, 1327, 1135, 1722, 1328, 
               1136, 1723, 1329, 1137, 1724, 1330, 1138, 1725, 1331, 1139}], 
              
              Line[{1140, 1553, 1433, 1498, 1512, 1513, 1913, 1491, 1434, 
               1602, 1887, 1141, 1726, 1332, 1142, 1727, 1333, 1143, 1728, 
               1334, 1144, 1729, 1335, 1145, 1730, 1603, 1810, 1146, 1604, 
               1811, 1147, 1605, 1812, 1148, 1731, 1336, 1149, 1732, 1337, 
               1150, 1733, 1338, 1151, 1734, 1339, 1152, 1735, 1340, 1153}], 
              
              Line[{1154, 1554, 1435, 1499, 1514, 1888, 1686, 1492, 1436, 
               1606, 1889, 1155, 1607, 1813, 1156, 1736, 1341, 1157, 1737, 
               1342, 1158, 1738, 1343, 1159, 1739, 1608, 1814, 1160, 1609, 
               1815, 1161, 1610, 1816, 1162, 1611, 1817, 1163, 1740, 1344, 
               1164, 1741, 1345, 1165, 1742, 1346, 1166, 1743, 1347, 1167}], 
              
              Line[{1181, 1352, 1749, 1180, 1351, 1748, 1179, 1350, 1747, 
               1178, 1824, 1618, 1177, 1823, 1617, 1176, 1822, 1616, 1175, 
               1821, 1615, 1174, 1820, 1614, 1746, 1173, 1349, 1745, 1172, 
               1348, 1744, 1171, 1819, 1613, 1170, 1818, 1612, 1169, 1890, 
               1440, 1439, 1168, 1694, 1916, 1438, 1500, 1437, 1582, 1555}], 
              
              Line[{1195, 1355, 1753, 1194, 1354, 1752, 1193, 1833, 1627, 
               1192, 1832, 1626, 1191, 1831, 1625, 1190, 1830, 1624, 1189, 
               1829, 1623, 1188, 1828, 1622, 1751, 1187, 1353, 1750, 1186, 
               1827, 1621, 1185, 1826, 1620, 1184, 1825, 1619, 1183, 1891, 
               1444, 1443, 1182, 1908, 1544, 1442, 1501, 1441, 1583, 1556}], 
              
              Line[{1209, 1420, 1419, 1884, 1208, 1418, 1844, 1678, 1207, 
               1417, 1843, 1677, 1206, 1416, 1842, 1676, 1205, 1675, 1841, 
               1415, 1204, 1674, 1840, 1414, 1203, 1673, 1839, 1413, 1202, 
               1895, 1412, 1411, 1883, 1201, 1410, 1838, 1672, 1200, 1409, 
               1837, 1671, 1199, 1408, 1836, 1407, 1198, 1670, 1835, 1406, 
               1197, 1669, 1834, 1405, 1196, 1892, 1520, 1521, 1502, 1404, 
               1584}], 
              
              Line[{1211, 1590, 1591, 1503, 1515, 1911, 1356, 1459, 1421, 
               1754, 1357, 1460, 1422, 1755, 1358, 1461, 1423, 1756, 1359, 
               1462, 1679, 1757, 1360, 1463, 1680, 1758, 1361, 1464, 1681, 
               1759, 1628, 1885, 1465, 1424, 1760, 1362, 1466, 1425, 1761, 
               1363, 1467, 1426, 1762, 1364, 1468, 1682, 1763, 1365, 1469, 
               1683, 1764, 1366, 1470, 1684, 1765, 1367, 1471, 1901, 1427, 
               1368, 1585}], 
              Line[CompressedData["
1:eJwNyjVOBFAURuE7MEBHh+ugPTTIsAmWQMIEC+wA3QSaYIN7SXBfD+7wFSfn
3f+8VM9I93AiIjJ4SEa05Ee04igvIo+HCiIW+F5r4mYcakke1Ob5TmvgRhxo
czyg5fKtVsf12NdmuV/L4RstxVPuLO/pCQ5ca7U8qa3yrvaHX1xpK7YJrYZ3
bD/4xqWWRrV92/2FPv9m3Bf2Sq7Clv0TGe2Dz7VyewU23dPcq717n2ml7jJs
uN/wilN7iW3cv2Vet73gGSdasW1MW+I12xMecawt2ka1du5EB7JamrvQhiIU
4h8JaTeC
               "]], 
              
              Line[{1225, 1576, 1577, 1504, 1516, 1629, 1914, 1493, 1472, 
               1766, 1369, 1226, 1767, 1370, 1227, 1768, 1371, 1228, 1769, 
               1372, 1229, 1770, 1373, 1230, 1771, 1630, 1845, 1231, 1631, 
               1846, 1232, 1772, 1374, 1233, 1773, 1375, 1234, 1774, 1376, 
               1235, 1775, 1377, 1236, 1776, 1378, 1237, 1777, 1379, 1238}], 
              
              Line[{1239, 1578, 1473, 1505, 1517, 1518, 1915, 1494, 1474, 
               1632, 1902, 1240, 1778, 1380, 1241, 1779, 1381, 1242, 1780, 
               1382, 1243, 1781, 1383, 1244, 1782, 1633, 1847, 1245, 1634, 
               1848, 1246, 1635, 1849, 1247, 1783, 1384, 1248, 1784, 1385, 
               1249, 1785, 1386, 1250, 1786, 1387, 1251, 1787, 1388, 1252}], 
              
              Line[{1253, 1579, 1475, 1506, 1519, 1903, 1687, 1495, 1476, 
               1636, 1904, 1254, 1637, 1850, 1255, 1788, 1389, 1256, 1789, 
               1390, 1257, 1790, 1391, 1258, 1791, 1638, 1851, 1259, 1639, 
               1852, 1260, 1640, 1853, 1261, 1641, 1854, 1262, 1792, 1392, 
               1263, 1793, 1393, 1264, 1794, 1394, 1265, 1795, 1395, 1266}], 
              
              Line[{1280, 1400, 1801, 1279, 1399, 1800, 1278, 1398, 1799, 
               1277, 1861, 1648, 1276, 1860, 1647, 1275, 1859, 1646, 1274, 
               1858, 1645, 1273, 1857, 1644, 1798, 1272, 1397, 1797, 1271, 
               1396, 1796, 1270, 1856, 1643, 1269, 1855, 1642, 1268, 1905, 
               1480, 1479, 1267, 1695, 1917, 1478, 1507, 1477, 1588, 1580}], 
              
              Line[{1294, 1403, 1805, 1293, 1402, 1804, 1292, 1870, 1657, 
               1291, 1869, 1656, 1290, 1868, 1655, 1289, 1867, 1654, 1288, 
               1866, 1653, 1287, 1865, 1652, 1803, 1286, 1401, 1802, 1285, 
               1864, 1651, 1284, 1863, 1650, 1283, 1862, 1649, 1282, 1906, 
               1484, 1483, 1281, 1909, 1545, 1482, 1508, 1481, 1589, 1581}], 
              
              Line[{1308, 1488, 1487, 1907, 1307, 1882, 1668, 1306, 1881, 
               1667, 1305, 1880, 1666, 1304, 1879, 1665, 1303, 1878, 1664, 
               1302, 1877, 1663, 1301, 1876, 1662, 1806, 1300, 1875, 1661, 
               1299, 1874, 1660, 1298, 1873, 1659, 1297, 1872, 1658, 1296, 
               1685, 1871, 1485, 1295, 1910, 1548, 1549, 1509, 1547, 1546, 
               1486}]}}}, VertexNormals -> CompressedData["
1:eJx8nHk0V9/3/9EsQ0iGTKUiUWbJcFJRlFKoKEoRDUoDypAkIkUlqTQnSUWT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            "]], 
          GraphicsComplex[CompressedData["
1:eJx0W3k0lVH7veaZe83zPCUkmSo5R1QqJENCIVOEDCGVRChNhgyJkkRF5kKI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           "], {{{
              EdgeForm[], 
              Thickness[Large], 
              Hue[19/25], 
              GraphicsGroup[{
                Polygon[CompressedData["
1:eJxFm3f8V1P8x+84935CVLSkKSEtJTRQymwZFSlCw2iZWclMRnZCZlb23jMz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                 "]], 
                Polygon[CompressedData["
1:eJwtmwf8V9Mbx+/9nnvuVyglVGjRlEpWoVQ0iLR3aWuhVBRCqJCZPSNlZVUy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                 "]], 
                Polygon[CompressedData["
1:eJwt13mgVeMaB+DT2adzFGkkFKESjVSaKaU5TZrnWVE0Is1pQPM8Jw03IY0S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                 "]], 
                
                Polygon[{{1406, 1405, 923, 610, 611, 
                 924}}]}]}, {}, {}, {}, {}}, {{}, {}, {}, {
              
              Line[{520, 733, 1696, 521, 747, 1708, 547, 762, 1719, 562, 777, 
               1728, 577, 1811, 792, 592, 1818, 807, 607, 1828, 229, 482, 278,
                1442, 483, 243, 1748, 629, 832, 1760, 644, 847, 1771, 659, 
               862, 1780, 674, 1848, 877, 689, 1855, 892, 704, 1865, 907, 
               719}], 
              
              Line[{522, 734, 1697, 523, 748, 1709, 548, 763, 1720, 563, 778, 
               1729, 578, 793, 1736, 593, 1819, 808, 608, 1829, 920, 961, 921,
                1096, 1073, 963, 1885, 1037, 1097, 936, 982, 937, 1749, 630, 
               833, 1761, 645, 848, 1772, 660, 863, 1781, 675, 878, 1788, 690,
                1856, 893, 705, 1866, 908, 720}], 
              
              Line[{524, 735, 1698, 525, 749, 1710, 549, 764, 1721, 564, 779, 
               1730, 579, 794, 1737, 594, 809, 1742, 609, 1830, 922, 962, 431,
                965, 1886, 381, 983, 938, 1750, 631, 834, 1762, 646, 849, 
               1773, 661, 864, 1782, 676, 879, 1789, 691, 894, 1794, 706, 
               1867, 909, 721}], 
              
              Line[{526, 736, 1699, 528, 750, 1711, 550, 765, 1722, 565, 780, 
               1731, 580, 795, 1738, 595, 810, 1743, 610, 923, 1875, 964, 
               1075, 1074, 967, 1888, 1038, 1039, 984, 939, 1751, 632, 835, 
               1763, 647, 850, 1774, 662, 865, 1783, 677, 880, 1790, 692, 895,
                1795, 707, 910, 1798, 722}], 
              Line[{530, 738, 1700, 531, 1801, 752, 552, 1803, 767, 567, 1807,
                782, 582, 1813, 797, 597, 1821, 812, 612, 1831, 925, 968, 
               1027, 821, 623, 1913, 1078, 1079, 986, 826, 1752, 634, 1838, 
               837, 649, 1840, 852, 664, 1844, 867, 679, 1850, 882, 694, 1858,
                897, 709, 1869, 912, 724}], 
              
              Line[{532, 739, 1701, 533, 753, 1712, 553, 1804, 768, 568, 1808,
                783, 583, 1814, 798, 598, 1822, 813, 613, 1832, 926, 969, 
               1028, 1098, 1029, 624, 1914, 1080, 1099, 940, 987, 827, 1753, 
               635, 838, 1764, 650, 1841, 853, 665, 1845, 868, 680, 1851, 883,
                695, 1859, 898, 710, 1870, 913, 725}], 
              
              Line[{534, 740, 1702, 535, 754, 1713, 554, 769, 1723, 569, 1809,
                784, 584, 1815, 799, 599, 1823, 814, 614, 1833, 927, 970, 
               1030, 1100, 1031, 625, 1915, 1081, 1101, 941, 988, 828, 1754, 
               636, 839, 1765, 651, 854, 1775, 666, 1846, 869, 681, 1852, 884,
                696, 1860, 899, 711, 1871, 914, 726}], 
              
              Line[{536, 741, 1703, 537, 755, 1714, 555, 770, 1724, 570, 785, 
               1732, 585, 1816, 800, 600, 1824, 815, 615, 1834, 928, 971, 929,
                1102, 1082, 973, 1889, 1040, 1103, 942, 989, 943, 1755, 637, 
               840, 1766, 652, 855, 1776, 667, 870, 1784, 682, 1853, 885, 697,
                1861, 900, 712, 1872, 915, 727}], 
              
              Line[{538, 742, 1704, 539, 756, 1715, 556, 771, 1725, 571, 786, 
               1733, 586, 801, 1739, 601, 1825, 816, 616, 1835, 930, 972, 931,
                1104, 1083, 975, 1890, 1041, 1105, 944, 990, 945, 1756, 638, 
               841, 1767, 653, 856, 1777, 668, 871, 1785, 683, 886, 1791, 698,
                1862, 901, 713, 1873, 916, 728}], 
              
              Line[{540, 743, 1705, 541, 757, 1716, 557, 772, 1726, 572, 787, 
               1734, 587, 802, 1740, 602, 817, 1744, 617, 1836, 932, 974, 
               1085, 1084, 977, 1891, 1042, 1043, 991, 946, 1757, 639, 842, 
               1768, 654, 857, 1778, 669, 872, 1786, 684, 887, 1792, 699, 902,
                1796, 714, 1874, 917, 729}], 
              
              Line[{542, 951, 1878, 952, 543, 758, 1717, 558, 773, 1727, 573, 
               788, 1735, 588, 803, 1741, 603, 818, 1745, 618, 933, 1876, 976,
                1087, 1086, 978, 1892, 1044, 1045, 992, 1893, 947, 640, 843, 
               1769, 655, 858, 1779, 670, 873, 1787, 685, 888, 1793, 700, 903,
                1797, 715, 1000, 1899, 1001, 1002}], 
              Line[CompressedData["
1:eJwVz7kuxGEYhfHXvrb2dRjGrpDoiKWlmUpCNY3EMmNPlDqlO3AH7oAr0Ol0
OonYl7Emfv/iyTnvc77mS+UK2XxJRORwWRpxXBYxVB5RlIMyXxUxIM9th1y9
/iEzctPWL89sa1yd/i73+D49jVPbMlerr/Jveq/egxPbgnuHr3G/6inZjSPb
lHvbVu1+0W+St/w+N6nP81dyTI7igF+3T3B/uMAIv8IPJ2lLc3P6s+ySG7ZO
uWhr4H7xhF2+g2/HtK2S+8ES/yjb+FaM24rY4r/5B7Twzck/+FsUbF/8PZr4
RlTw1/jk7jDLzSCLfyfJLak=
               "]], 
              
              Line[{717, 905, 999, 1863, 702, 890, 1898, 998, 687, 875, 1897, 
               997, 672, 860, 1896, 996, 657, 845, 1894, 995, 642, 1758, 830, 
               994, 627, 1746, 823, 980, 934, 1093, 1071, 1911, 620, 1023, 
               1092, 1022, 959, 918, 1826, 605, 805, 1883, 957, 590, 790, 
               1882, 956, 575, 775, 1881, 955, 560, 760, 1879, 954, 545, 1706,
                745, 953, 518, 1694, 731, 948, 949}], 
              
              Line[{718, 906, 1864, 703, 891, 1854, 688, 876, 1847, 673, 861, 
               1842, 658, 1770, 846, 643, 1759, 831, 628, 1747, 824, 981, 935,
                1095, 1072, 1912, 621, 1025, 1094, 1024, 960, 919, 1827, 606, 
               806, 1817, 591, 791, 1810, 576, 776, 1805, 561, 1718, 761, 546,
                1707, 746, 519, 1695, 732, 950, 1004}], 
              
              Line[{723, 911, 1868, 708, 896, 1857, 693, 881, 1849, 678, 866, 
               1843, 663, 851, 1839, 648, 836, 1837, 633, 825, 1877, 985, 
               1077, 1076, 622, 820, 1026, 966, 1887, 924, 611, 811, 1820, 
               596, 796, 1812, 581, 781, 1806, 566, 766, 1802, 551, 751, 1800,
                529, 737, 1799, 527}]}, {
              
              Line[{1107, 1532, 1533, 1491, 1503, 730, 1484, 1422, 1694, 1303,
                1108, 1423, 1695, 1304, 1109, 1696, 1305, 1110, 1697, 1306, 
               1111, 1698, 1307, 1112, 1699, 1590, 1799, 1113, 1700, 1308, 
               1114, 1701, 1309, 1115, 1702, 1310, 1116, 1703, 1311, 1117, 
               1704, 1312, 1118, 1705, 1313, 1119, 1878, 1424, 1314, 1425}], 
              Line[{1120, 1545, 1546, 1492, 1504, 1591, 1903, 1485, 1426, 
               1706, 1315, 1121, 1707, 1316, 1122, 1708, 1317, 1123, 1709, 
               1318, 1124, 1710, 1319, 1125, 1711, 1592, 1800, 1126, 1593, 
               1801, 1127, 1712, 1320, 1128, 1713, 1321, 1129, 1714, 1322, 
               1130, 1715, 1323, 1131, 1716, 1324, 1132, 1717, 1325, 1133}], 
              
              Line[{1134, 1547, 1427, 1493, 1505, 1506, 1904, 1486, 1428, 
               1594, 1879, 1135, 1718, 1326, 1136, 1719, 1327, 1137, 1720, 
               1328, 1138, 1721, 1329, 1139, 1722, 1595, 1802, 1140, 1596, 
               1803, 1141, 1597, 1804, 1142, 1723, 1330, 1143, 1724, 1331, 
               1144, 1725, 1332, 1145, 1726, 1333, 1146, 1727, 1334, 1147}], 
              
              Line[{1148, 1429, 1494, 1507, 1880, 1678, 1487, 1430, 1598, 
               1881, 1149, 1599, 1805, 1150, 1728, 1335, 1151, 1729, 1336, 
               1152, 1730, 1337, 1153, 1731, 1600, 1806, 1154, 1601, 1807, 
               1155, 1602, 1808, 1156, 1603, 1809, 1157, 1732, 1338, 1158, 
               1733, 1339, 1159, 1734, 1340, 1160, 1735, 1341, 1161}], 
              
              Line[{1175, 1346, 1741, 1174, 1345, 1740, 1173, 1344, 1739, 
               1172, 1816, 1610, 1171, 1815, 1609, 1170, 1814, 1608, 1169, 
               1813, 1607, 1168, 1812, 1606, 1738, 1167, 1343, 1737, 1166, 
               1342, 1736, 1165, 1811, 1605, 1164, 1810, 1604, 1163, 1882, 
               1434, 1433, 1162, 1686, 1907, 1432, 1495, 1431, 1574, 1548}], 
              
              Line[{1189, 1349, 1745, 1188, 1348, 1744, 1187, 1825, 1619, 
               1186, 1824, 1618, 1185, 1823, 1617, 1184, 1822, 1616, 1183, 
               1821, 1615, 1182, 1820, 1614, 1743, 1181, 1347, 1742, 1180, 
               1819, 1613, 1179, 1818, 1612, 1178, 1817, 1611, 1177, 1883, 
               1438, 1437, 1176, 1900, 1534, 1436, 1496, 1435, 1575, 1549}], 
              
              Line[{1203, 1414, 1413, 1876, 1202, 1412, 1836, 1670, 1201, 
               1411, 1835, 1669, 1200, 1410, 1834, 1668, 1199, 1667, 1833, 
               1409, 1198, 1666, 1832, 1408, 1197, 1665, 1831, 1407, 1196, 
               1887, 1406, 1405, 1875, 1195, 1404, 1830, 1664, 1194, 1403, 
               1829, 1663, 1193, 1402, 1828, 1401, 1192, 1662, 1827, 1400, 
               1191, 1661, 1826, 1399, 1190, 1884, 1542, 1543, 1540, 1398, 
               1576}], 
              
              Line[{1205, 1582, 1583, 1541, 1573, 1909, 1350, 1453, 1415, 
               1746, 1351, 1454, 1416, 1747, 1352, 1455, 1417, 1748, 1353, 
               1456, 1671, 1749, 1354, 1457, 1672, 1750, 1355, 1458, 1673, 
               1751, 1620, 1877, 1459, 1418, 1752, 1356, 1460, 1419, 1753, 
               1357, 1461, 1420, 1754, 1358, 1462, 1674, 1755, 1359, 1463, 
               1675, 1756, 1360, 1464, 1676, 1757, 1361, 1465, 1893, 1421, 
               1362, 1577}], 
              Line[CompressedData["
1:eJwNyjVOAFAUBdFHglW4Oy006EboIVgooUM3gSZocKckuK8Gd6fhFJP738yv
bO9p6k6IiC5cJUZUJUdUYycp4g+dKRET7kut3FZgm/9FhzbuvtBKbRm2+DHb
rv14n2vF7hJsukdtm/btfaYVuYfcc3aD+8InTrVCblCbtevcB95xos1wA1qB
XePe8IpjrQH5/Kr7Ba3+jbiP+FybhxX+GS3akz3UsvkcLLuHbbP26H2gZbqz
sOR+wD32+Qyu379pu8jd4RZ7WjrXp03ZBe4G19jVJrlerdbWow7zWoNtRA3S
kIp/HoY6cQ==
               "]], 
              
              Line[{1219, 1466, 1497, 1508, 1621, 1905, 1488, 1467, 1758, 
               1363, 1220, 1759, 1364, 1221, 1760, 1365, 1222, 1761, 1366, 
               1223, 1762, 1367, 1224, 1763, 1622, 1837, 1225, 1623, 1838, 
               1226, 1764, 1368, 1227, 1765, 1369, 1228, 1766, 1370, 1229, 
               1767, 1371, 1230, 1768, 1372, 1231, 1769, 1373, 1232}], 
              
              Line[{1233, 1569, 1468, 1498, 1509, 1510, 1906, 1489, 1469, 
               1624, 1894, 1234, 1770, 1374, 1235, 1771, 1375, 1236, 1772, 
               1376, 1237, 1773, 1377, 1238, 1774, 1625, 1839, 1239, 1626, 
               1840, 1240, 1627, 1841, 1241, 1775, 1378, 1242, 1776, 1379, 
               1243, 1777, 1380, 1244, 1778, 1381, 1245, 1779, 1382, 1246}], 
              
              Line[{1247, 1570, 1470, 1499, 1511, 1895, 1679, 1490, 1471, 
               1628, 1896, 1248, 1629, 1842, 1249, 1780, 1383, 1250, 1781, 
               1384, 1251, 1782, 1385, 1252, 1783, 1630, 1843, 1253, 1631, 
               1844, 1254, 1632, 1845, 1255, 1633, 1846, 1256, 1784, 1386, 
               1257, 1785, 1387, 1258, 1786, 1388, 1259, 1787, 1389, 1260}], 
              
              Line[{1274, 1394, 1793, 1273, 1393, 1792, 1272, 1392, 1791, 
               1271, 1853, 1640, 1270, 1852, 1639, 1269, 1851, 1638, 1268, 
               1850, 1637, 1267, 1849, 1636, 1790, 1266, 1391, 1789, 1265, 
               1390, 1788, 1264, 1848, 1635, 1263, 1847, 1634, 1262, 1897, 
               1475, 1474, 1261, 1687, 1908, 1473, 1500, 1472, 1580, 1571}], 
              
              Line[{1288, 1397, 1797, 1287, 1396, 1796, 1286, 1862, 1649, 
               1285, 1861, 1648, 1284, 1860, 1647, 1283, 1859, 1646, 1282, 
               1858, 1645, 1281, 1857, 1644, 1795, 1280, 1395, 1794, 1279, 
               1856, 1643, 1278, 1855, 1642, 1277, 1854, 1641, 1276, 1898, 
               1479, 1478, 1275, 1901, 1535, 1477, 1501, 1476, 1581, 1572}], 
              
              Line[{1302, 1483, 1482, 1899, 1301, 1874, 1660, 1300, 1873, 
               1659, 1299, 1872, 1658, 1298, 1871, 1657, 1297, 1870, 1656, 
               1296, 1869, 1655, 1295, 1868, 1654, 1798, 1294, 1867, 1653, 
               1293, 1866, 1652, 1292, 1865, 1651, 1291, 1864, 1650, 1290, 
               1677, 1863, 1480, 1289, 1902, 1538, 1539, 1502, 1537, 1536, 
               1481}]}}}, VertexNormals -> CompressedData["
1:eJx8nHk0lt33/yUaSEmSIUpp0kCGkOFESCgSRaiEBkWkgTQQoiQJSYYmQ1GK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            "]]}, {
         PlotLabel -> Style["r(u,v)", Large, Bold], ImageSize -> Large, 
          AxesLabel -> {
            Text[
             Style["x", Large, Bold, 
              GrayLevel[0]]], 
            Text[
             Style["y", Large, Bold, 
              GrayLevel[0]]], 
            Text[
             Style["z", Large, Bold, 
              GrayLevel[0]]]}, 
          PlotRange -> {{-13, 13}, {-13, 13}, {(-6) Pi, 6 Pi}}, Axes -> True, 
          Method -> {}, 
          PlotRange -> {{0., 7.6021045416728725`}, {0., 5.367672107525205}, {
           0., 2.3978952542454945`}}, PlotRangePadding -> {
            Scaled[0.02], 
            Scaled[0.02], 
            Scaled[0.02]}}], $CellContext`g2 = Graphics3D[
         GraphicsComplex[CompressedData["
1:eJytvXVUVU30/08JGCiCrZjY3XX1HFss7O4u7MDE1sdEbB9b7FYExatcEBEQ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          "], {{{
             EdgeForm[], 
             GraphicsGroup[{
               Polygon[CompressedData["
1:eJwtmgcYT9Ufxn/33nPvKRShCA1JKWlraomsUFJRIRpGg0IDRUUSsksTGaWF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                "]], 
               Polygon[CompressedData["
1:eJwtmnn8VlMXxe9zzz33ZyokIUKTKXMRokKUiErIUBJlfFUSKWlQoUmlEmUo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                "]], 
               Polygon[CompressedData["
1:eJwt1wm4VtMaAODf+c9/TkSU6arkCt1b0YBQuSUuURSlkVtkLhWpNE+n02me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                "]], 
               
               Polygon[{{1590, 1116, 656, 657, 1117, 1591}, {1644, 813, 621, 
                529, 528, 1443}, {1683, 908, 733, 469, 468, 1274}, {1384, 871,
                 1104, 1740, 1232, 1233}, {1492, 62, 824, 1137, 533, 1608}, {
                1707, 953, 778, 473, 472, 1320}, {1344, 801, 1136, 524, 18, 
                1151}}]}]}, {}, {
             EdgeForm[], 
             GrayLevel[0.82], 
             GraphicsGroup[{
               Polygon[CompressedData["
1:eJwtlUtsTlEQx8+99/vuV1ZYqBJaiXiloaWVoEVaysLKszQeIR6haiPxjASJ
NLoTSVPUQlAW7GiJZ4Mo8Uiw8aiIZ4JgQT3i8ftnJvn++c+dM2fOnDkz8w1d
sXFOQxxCaAIJuB+FMBZ+DR/IhLAFjtMQRsB7wHCwEjSC0aA4Mft6nJzJhpBF
9wJuA1t971TWCpGnwTfRD0OuRj8DbGVvF+f0oOsH3kdm04z+I/oS9rQhl8JN
icnPkA8in0P+gFyA/Vnk7/CArOnH4bs1F0IRdmuRGyK7g+JvAyfAI+wmsX8X
8mQ44TzlYh58J7J8PIXr+R7Hwip4HyhEvx6fvzMW537k3px7ArkFeQA4HNm5
yovy8xxnw5FXo/8dWdyKsxQfg8A3dBvgStCKvABuTyze6ch14AryYvhIZLLO
uAqugRv4mst542PL7W10l0HfYKzvS6CctU64DO5yvWyUk07Py0h8PEY3Cl6G
3UvFAC8F75Br4OLU4hiYWj2oFj6z5wd52IA8FP1mr5UvwWpCtXEafgUXobsH
d/P9T/UGv/HaUw1+icz+O7jIWl2wGL5GJv+Fe6V2ls7U++4FD4PlTW+bl9h+
+fkEHrh/naPanAUqg+3T/prIanKK3gmeCSbq3V1uxLab/Cep7dNdtrFnO5jN
96/Y3mEGNvWRxXad71OJ6bX+D90O8Mf3bfP4erK2RzV8jLpdg48qzhkMjqIf
Ard4nLpjo+eWX6jC73KEn54T9Wmev8tmt8mkFqPers1zrtwfZ3F3ZHercf+q
Oa2r98fA5bH17ITY3nKlv7ViPIRcAc/3ulX93sravfO8RlSnfYL5bvE+HJG1
nKgOL/B9PjJfRanl7wg56EisDnsl1seqmSXEUObxKK6jXl+KZ6CfN8R7UH26
M2Nz6S36JejyUztnGlyQWu33T6yeOyKTlQ/lZZh/y6Y6tju2RzYfFmL/JLI3
WpixWaE8KGb1ULXywNpo9tWm9r7q9eac5emC31f9qP4dn1oPtXtu9e7K2Sb2
VMQ2Jytjy89J7698j1/3OO8+Nb/qcjYrNZdW5GxWai7V4iuLQQM81ueq5mtN
xvpfc0b3lE/NGc2GLp8bmj+aI4vgjaAYu7XwuozViuabzm/1GEpy9t+gOak8
KB+bcpbPDp9vJam9aWlqc1Y5vAv/BwYIxrI=
                "], VertexColors -> None], 
               Polygon[CompressedData["
1:eJxFlElIVlEUx+97331P3VWLUqNUiIIyp2yAFCSHgrKgub7MMjQph42LJoJy
U9sIpEEXUX21qGXaopGKggiCllqLXBraooyK6vfnXGjx553pnnvuOf/zyjr6
t/fFzrl24EEuz7mFCK2Rc5OJcwPIM9hvoC9KnSsG0+hj6OXITSCL/hW9HbkG
PEV+ia2Q87Wpyc+wrUYeIX+zN9uy4H+OLxeZXoQ+jHwNLECuIr6NAkuJv8i5
49hKnNnkW8v3FrEXsK1D3kmM3qMcu5BXEX87sjt0fzV4jPwIVKVWo2q5m3Fu
KM/e/Bf9mLdeDIBGbzmUayJj/grQw0XD+Pd5y6ncWfRO9Bp829BjcBJfPfGX
vd1RzfdB6M9HsCmymBzyVuIrYvMXoP/GfhokYAb0cnYisvloTuqJevMZPcvZ
m+Q/gu0NegP6L75dYB6YBU34lvK9A1qQW4jZwvlp9IOpzSAXfJrVfN6721s/
NZsObOPUlwv1KUaxyleKfz2+c3oP/rrY7lO+D+ijGbtH9+lNeltnanPT/DYi
XwJDznqoXtZ749tomKfmK3k5yHjjm3qlnh1G3o9trrN5ZJH7wHiY915v/ifI
I6CRM4tTk+c447d0cV13Fof5nYhs5pqPOKNcyrk5NU6I210+cAV9CXotuXcg
v49svprXRJiJZqMaxe9uzpUTuyK2HA18S/AfAhuCTfm1U4pVz/XeqxmbxZrY
7tMOaBf+RLaPZ1RzuE+7dNT/58Zb8Sm2fhRkbDbi9xhynbf4h2CPN25fj6xn
6mc+MS2RcUjzFOfFv9KM7YJqVK0ryd8f+FmJvzxj+6qevYvsjHqp94hLlbFx
/4r21RnH9L4D6N8C17WP4uJYmI+40Z1afapT95elxkXV94Pc9xLbPc3gU2Jv
1vw0A/VCfu3WKfGJs2e9cUE5C1PjlN6iN4lrbeBL2Mf7ie2HeDQS/oeqUf+O
qchq105ORtYD9aILvT62/WhO7X/TGjiif8FPfL3IPZH9k/KJGdS/EbxOTH/h
LKYA+XtisbIVIU9xx/nIOPEqsf+N8ihmNrGeqDeD4fw/I2uwZw==
                "], VertexColors -> None], 
               
               Polygon[{{1602, 474, 460, 1123, 1956}, {1689, 922, 747, 181, 
                1290}, {1682, 907, 732, 166, 1275}, {1908, 1126, 555, 554, 
                1736}, {1503, 328, 465, 486, 1454}, {1643, 812, 620, 46, 
                1162}, {1569, 365, 762, 1093, 1568}, {1640, 800, 605, 31, 
                1560}, {1246, 385, 570, 569, 1607}, {989, 47, 464, 492, 
                1130}, {1615, 561, 167, 907, 1883}, {1225, 287, 575, 574, 
                1605}, {1606, 487, 509, 380, 1540}, {1526, 181, 747, 1073, 
                1527}, {1604, 481, 488, 274, 1468}}, VertexColors -> None], 
               
               Polygon[{{1603, 563, 1132, 1125, 151, 1478}, {1624, 553, 213, 
                952, 1091, 1736}, {1602, 1127, 1084, 3, 459, 1623}}, 
                VertexColors -> None]}]}, {}, {}}, {{
             GrayLevel[0], 
             
             Line[{392, 1, 375, 240, 1140, 16, 1150, 31, 1162, 46, 376, 1172, 
              61, 1539, 378, 76, 1540, 380, 91, 1468, 274, 358, 550, 507, 503,
               488, 481, 1631, 497, 510, 511, 509, 487, 1630, 495, 508, 496, 
              502, 493, 1629, 486, 465, 477, 1133, 501, 1628, 492, 464, 485, 
              463, 484, 1627, 483, 462, 1611, 476, 1134, 517, 460, 474, 1623, 
              459, 475, 461, 3, 1111, 441, 2, 1027, 298, 392}, VertexColors -> 
              None], 
             Line[CompressedData["
1:eJwt0r0vXWEcwPHH6+VyX7xVURQtMdg6WgyNCI2XUsEil6UGWl38ARI1SwwS
iUU6WC1mg73U+/uGpENL0pp8TmL4+jy/59zjnHvuacjMDExnhRB+6H12CLmc
9CdmXaBCjeSHEGeRivXF8QRH7SeZUr91miUqVZnKNWC/gl+d84KVeqlB+1Ws
Vo1eqVZD9utYr9dqUKM+2W/iG71Vi3668Sn32+VYh/nR/E83ulaP/T/Mcixb
QbfmD/b/Msd8zzv91qT9c35zr7ucMO/xly6UMe+zj/nOnfW5S/OBcs3j9g+t
jxTP8VmXLOIBi3nIBI+YZErH1mmesISnLOUZy3jOcl6wgpfR13DdVtdY0ZV5
gZ16l+eZmJu5zUpusoDr/O+8Zd5xgWc81Zz1Dj9zi6PcYDdX2c4ltvE767jm
fz5w0XVTnGebxjyHpHmECQ5H7wyHoveHHxlnf/RusTd6z9jDbsWi35MeZehk
3vN7+QTA0UML
              "], VertexColors -> None], 
             
             Line[{1225, 121, 385, 1246, 136, 386, 1260, 151, 1275, 166, 1290,
               181, 1305, 196, 1480, 295, 409, 211, 390, 326, 776, 212, 777, 
              213, 552, 553, 1624, 554, 555, 556, 1135, 557, 1633, 558, 1614, 
              559, 560, 561, 1615, 562, 1132, 563, 1619, 564, 565, 566, 567, 
              568, 1637, 569, 570, 571, 572, 573, 1638, 574, 575, 576, 578, 
              505, 352, 287, 1225}, VertexColors -> None]}, {
             
             Line[{1160, 1354, 1761, 1159, 1353, 1760, 1158, 1352, 1759, 1157,
               1351, 1758, 1156, 1350, 1757, 1155, 1349, 1756, 1154, 1839, 
              1642, 1153, 1838, 1641, 1755, 1152, 1348, 1754, 1722, 1487, 
              1347, 1753, 1721, 1486, 1346, 1752, 1442, 1485, 1345, 1751, 
              1441, 1151, 1344, 1958, 1626}, VertexColors -> None], 
             
             Line[{1171, 1363, 1770, 1170, 1362, 1769, 1169, 1361, 1768, 1168,
               1360, 1767, 1167, 1359, 1766, 1166, 1843, 1647, 1165, 1842, 
              1646, 1164, 1841, 1645, 1765, 1163, 1358, 1446, 1933, 1491, 
              1357, 1764, 1723, 1490, 1356, 1763, 1445, 1489, 1355, 1762, 
              1444, 1488, 1921, 1644, 1443, 1617}, VertexColors -> None], 
             
             Line[{1181, 1370, 1776, 1180, 1369, 1775, 1179, 1368, 1774, 1178,
               1367, 1773, 1177, 1847, 1653, 1176, 1846, 1652, 1175, 1845, 
              1651, 1174, 1844, 1650, 1772, 1173, 1366, 1452, 1935, 1496, 
              1365, 1451, 1934, 1495, 1364, 1771, 1450, 1494, 1923, 1649, 
              1449, 1493, 1922, 1648, 1448, 1492, 1608, 1618}, VertexColors -> 
              None], 
             
             Line[{1195, 1373, 1780, 1194, 1372, 1779, 1193, 1371, 1778, 1192,
               1853, 1658, 1191, 1852, 1657, 1190, 1851, 1656, 1189, 1850, 
              1655, 1188, 1849, 1654, 1777, 1187, 1464, 1463, 1925, 1186, 
              1462, 1461, 1924, 1185, 1460, 1848, 1459, 1184, 1938, 1458, 
              1457, 1183, 1937, 1456, 1455, 1182, 1936, 1620}, VertexColors -> 
              None], 
             
             Line[{1209, 1376, 1783, 1208, 1375, 1782, 1207, 1860, 1662, 1206,
               1859, 1661, 1205, 1858, 1660, 1204, 1857, 1659, 1203, 1955, 
              1596, 1595, 1202, 1953, 1591, 1590, 1954, 1201, 1374, 1781, 
              1200, 1466, 1856, 1724, 1199, 1430, 1855, 1429, 1198, 1718, 
              1854, 1428, 1197, 1927, 1427, 1426, 1196, 1926, 1465, 1504, 
              1621}, VertexColors -> None], 
             
             Line[{1223, 1377, 1784, 1222, 1870, 1667, 1221, 1869, 1666, 1220,
               1868, 1665, 1219, 1867, 1664, 1218, 1866, 1663, 1217, 1739, 
              1865, 1597, 1599, 1598, 1216, 1952, 1593, 1594, 1592, 1474, 
              1928, 1215, 1473, 1864, 1727, 1214, 1471, 1863, 1725, 1213, 
              1433, 1862, 1432, 1212, 1563, 1564, 1861, 1535, 1431, 1211, 
              1534, 1946, 1733, 1531, 1533, 1532, 1210, 1947, 1510, 1511, 
              1505, 1622}, VertexColors -> None], 
             Line[CompressedData["
1:eJwVzktKAmAUhuETqIFYlKTT6B6EuY5GltkGWkCtous0ahS0kCiiGqjZhZDo
toDupdm8x8HL957/fAf+keXV8kpPRCzhOSF7I7ZTEY+8wrf4PV/km/yOl/kG
b/IFvs5v+Txf4ze8IUvmgixiFtfdW8zwp2TElJzGgV5dXtkNyTxy3T/oTMhJ
jOPSfkBmMYgH+5rccT8mR9HQych+9OFEJyWHkcSF/Z+3NN93dy6Pzd9o4wt1
nU/ZwZ7Omc4R/0AL76jqnHrftf81v+EQr/jBC+bs/wEpnjII
              "], VertexColors -> None], 
             
             Line[{1259, 1401, 1807, 1258, 1400, 1806, 1257, 1399, 1805, 1256,
               1398, 1804, 1255, 1397, 1803, 1254, 1396, 1802, 1253, 1879, 
              1677, 1252, 1878, 1676, 1801, 1251, 1395, 1800, 1250, 1394, 
              1799, 1249, 1393, 1798, 1437, 1248, 1392, 1797, 1436, 1247, 
              1391, 1796, 1477, 1500, 1930, 1675, 1507, 1613}, VertexColors -> 
              None], 
             
             Line[{1273, 1410, 1817, 1272, 1409, 1816, 1271, 1408, 1815, 1270,
               1407, 1814, 1269, 1406, 1813, 1268, 1882, 1681, 1267, 1881, 
              1680, 1266, 1880, 1679, 1812, 1265, 1405, 1811, 1264, 1404, 
              1810, 1263, 1403, 1809, 1262, 1402, 1808, 1261, 1931, 1678, 
              1479, 1501, 1960, 1636}, VertexColors -> None], 
             
             Line[{1288, 1417, 1825, 1287, 1416, 1824, 1286, 1415, 1823, 1285,
               1414, 1822, 1284, 1889, 1688, 1283, 1888, 1687, 1282, 1887, 
              1686, 1281, 1886, 1685, 1821, 1280, 1413, 1820, 1279, 1412, 
              1819, 1278, 1411, 1818, 1277, 1885, 1684, 1276, 1884, 1683, 
              1274, 1635}, VertexColors -> None], 
             
             Line[{1303, 1422, 1831, 1302, 1421, 1830, 1301, 1420, 1829, 1300,
               1898, 1697, 1299, 1897, 1696, 1298, 1896, 1695, 1297, 1895, 
              1694, 1296, 1894, 1693, 1828, 1295, 1419, 1827, 1294, 1418, 
              1826, 1293, 1893, 1692, 1292, 1892, 1691, 1291, 1891, 1690, 
              1634}, VertexColors -> None], 
             
             Line[{1318, 1425, 1835, 1317, 1424, 1834, 1316, 1907, 1706, 1315,
               1906, 1705, 1314, 1905, 1704, 1313, 1904, 1703, 1312, 1903, 
              1702, 1311, 1902, 1701, 1833, 1310, 1423, 1832, 1309, 1901, 
              1700, 1308, 1900, 1699, 1307, 1899, 1698, 1306, 1961, 1610, 
              1616}, VertexColors -> None], 
             
             Line[{1332, 1482, 1481, 1932, 1331, 1919, 1717, 1330, 1918, 1716,
               1329, 1917, 1715, 1328, 1916, 1714, 1327, 1915, 1713, 1326, 
              1914, 1712, 1325, 1913, 1711, 1836, 1324, 1912, 1710, 1323, 
              1911, 1709, 1322, 1910, 1708, 1321, 1909, 1707, 1320, 1632}, 
              VertexColors -> None], 
             
             Line[{1440, 1343, 1439, 1920, 1149, 1342, 1750, 1148, 1341, 1749,
               1147, 1340, 1748, 1146, 1339, 1747, 1145, 1338, 1746, 1144, 
              1337, 1745, 1143, 1837, 1639, 1744, 1142, 1336, 1743, 1720, 
              1484, 1335, 1742, 1719, 1483, 1334, 1741, 1438, 1141, 1333, 
              1957, 1601, 1625}, VertexColors -> None], 
             
             Line[{1612, 1506, 1509, 1940, 1378, 1543, 1536, 1537, 1529, 1734,
               1944, 1379, 1475, 1434, 1530, 1735, 1945, 1380, 1476, 1435, 
              1785, 1381, 1547, 1726, 1786, 1382, 1551, 1728, 1787, 1383, 
              1555, 1729, 1788, 1668, 1929, 1578, 1577, 1789, 1384, 1233, 
              1790, 1385, 1235, 1791, 1386, 1237, 1792, 1387, 1239, 1793, 
              1388, 1241, 1794, 1389, 1243, 1795, 1390, 1245}, VertexColors -> 
              None]}, {
             
             Line[{581, 241, 1741, 582, 247, 1752, 608, 252, 1763, 623, 258, 
              1771, 638, 1848, 264, 653, 1855, 228, 668, 1862, 232, 280, 1472,
               236, 1785, 691, 238, 1798, 706, 895, 1809, 720, 910, 1818, 735,
               1893, 925, 750, 1900, 939, 764, 1910, 954, 779}, VertexColors -> 
              None], 
             
             Line[{583, 972, 1028, 973, 1742, 584, 979, 1031, 980, 1753, 609, 
              985, 1035, 986, 1764, 624, 992, 1039, 1934, 993, 639, 998, 1924,
               1044, 999, 654, 1856, 1006, 1046, 1007, 669, 1863, 1011, 1047, 
              1012, 1076, 1048, 1939, 1095, 1013, 1079, 1014, 1786, 692, 881, 
              1799, 707, 896, 1810, 721, 911, 1819, 736, 926, 1826, 751, 1901,
               940, 765, 1911, 955, 780}, VertexColors -> None], 
             
             Line[{585, 974, 1029, 975, 1743, 586, 981, 1032, 982, 1754, 610, 
              987, 1036, 1933, 988, 625, 994, 1040, 1935, 995, 640, 1000, 
              1925, 1045, 1001, 655, 851, 1781, 670, 1864, 1015, 1080, 427, 
              429, 1574, 428, 1081, 1016, 1787, 693, 882, 1800, 708, 897, 
              1811, 722, 912, 1820, 737, 927, 1827, 752, 941, 1832, 766, 1912,
               956, 781}, VertexColors -> None], 
             
             Line[{587, 792, 1744, 589, 803, 1755, 611, 815, 1765, 626, 827, 
              1772, 641, 839, 1777, 656, 1116, 1954, 1118, 1119, 1017, 1928, 
              1082, 1097, 1096, 1100, 1951, 1098, 1099, 1083, 1018, 1788, 694,
               883, 1801, 709, 898, 1812, 723, 913, 1821, 738, 928, 1828, 753,
               942, 1833, 767, 957, 1836, 782}, VertexColors -> None], 
             
             Line[{591, 794, 1745, 592, 1839, 805, 613, 1842, 817, 628, 1845, 
              829, 643, 1850, 841, 658, 1122, 1955, 853, 672, 1865, 1101, 862,
               681, 1871, 1104, 871, 1789, 696, 1879, 885, 711, 1881, 900, 
              725, 1887, 915, 740, 1895, 930, 755, 1903, 944, 769, 1914, 959, 
              784}, VertexColors -> None], 
             
             Line[{593, 795, 1746, 594, 806, 1756, 614, 1843, 818, 629, 1846, 
              830, 644, 1851, 842, 659, 1857, 854, 673, 1866, 863, 682, 1872, 
              872, 1790, 697, 886, 1802, 712, 1882, 901, 726, 1888, 916, 741, 
              1896, 931, 756, 1904, 945, 770, 1915, 960, 785}, VertexColors -> 
              None], 
             
             Line[{595, 796, 1747, 596, 807, 1757, 615, 819, 1766, 630, 1847, 
              831, 645, 1852, 843, 660, 1858, 855, 674, 1867, 864, 683, 1873, 
              873, 1791, 698, 887, 1803, 713, 902, 1813, 727, 1889, 917, 742, 
              1897, 932, 757, 1905, 946, 771, 1916, 961, 786}, VertexColors -> 
              None], 
             
             Line[{597, 797, 1748, 598, 808, 1758, 616, 820, 1767, 631, 832, 
              1773, 646, 1853, 844, 661, 1859, 856, 675, 1868, 865, 684, 1874,
               874, 1792, 699, 888, 1804, 714, 903, 1814, 728, 918, 1822, 743,
               1898, 933, 758, 1906, 947, 772, 1917, 962, 787}, VertexColors -> 
              None], 
             
             Line[{599, 798, 1749, 600, 809, 1759, 617, 821, 1768, 632, 833, 
              1774, 647, 845, 1778, 662, 1860, 857, 676, 1869, 866, 685, 1875,
               875, 1793, 700, 889, 1805, 715, 904, 1815, 729, 919, 1823, 744,
               934, 1829, 759, 1907, 948, 773, 1918, 963, 788}, VertexColors -> 
              None], 
             
             Line[{601, 799, 1750, 602, 810, 1760, 618, 822, 1769, 633, 834, 
              1775, 648, 846, 1779, 663, 858, 1782, 677, 1870, 867, 686, 1876,
               876, 1794, 701, 890, 1806, 716, 905, 1816, 730, 920, 1824, 745,
               935, 1830, 760, 949, 1834, 774, 1919, 964, 789}, VertexColors -> 
              None], 
             
             Line[{603, 976, 1920, 977, 604, 811, 1761, 619, 823, 1770, 634, 
              835, 1776, 649, 847, 1780, 664, 859, 1783, 678, 868, 1784, 687, 
              1877, 877, 1795, 702, 891, 1807, 717, 906, 1817, 731, 921, 1825,
               746, 936, 1831, 761, 950, 1835, 775, 1024, 1932, 1025, 1026}, 
              VertexColors -> None], 
             
             Line[{778, 953, 1909, 763, 938, 1899, 749, 924, 1892, 734, 909, 
              1885, 719, 1808, 894, 705, 1797, 880, 971, 690, 1945, 1089, 
              1088, 1021, 970, 1071, 1948, 1078, 1070, 1069, 1010, 968, 1861, 
              1090, 667, 850, 1005, 966, 1854, 652, 838, 1043, 1938, 997, 637,
               826, 1923, 1038, 991, 622, 1762, 814, 1034, 984, 607, 1751, 
              802, 1030, 978, 580, 1957, 791, 1124}, VertexColors -> None], 
             
             Line[{783, 958, 1913, 768, 943, 1902, 754, 929, 1894, 739, 914, 
              1886, 724, 899, 1880, 710, 884, 1878, 695, 870, 1929, 1105, 
              1107, 1106, 680, 861, 1103, 1102, 1121, 1952, 1120, 671, 852, 
              1953, 1117, 657, 840, 1849, 642, 828, 1844, 627, 816, 1841, 612,
               804, 1838, 590, 793, 1837, 588}, VertexColors -> None], 
             
             Line[{1136, 801, 1958, 606, 983, 1033, 1921, 813, 621, 990, 1037,
               1922, 825, 636, 996, 1937, 1042, 837, 651, 965, 1927, 1004, 
              849, 666, 1946, 1074, 967, 1009, 1055, 1056, 1068, 1942, 1062, 
              969, 1020, 1086, 1087, 1944, 689, 1022, 879, 1796, 704, 1023, 
              1931, 893, 718, 1884, 908, 733, 1891, 923, 748, 1131, 1961, 
              1138}, VertexColors -> None], 
             
             Line[{1137, 824, 635, 1129, 1936, 1041, 1052, 836, 650, 1002, 
              1926, 1003, 1053, 848, 665, 1058, 1947, 1077, 1059, 1008, 1054, 
              1063, 860, 679, 1941, 1060, 1072, 1061, 1019, 1057, 1075, 869, 
              1940, 688, 1064, 1065, 1049, 1930, 878, 703, 1066, 1067, 1050, 
              1960, 892, 1139}, VertexColors -> None]}, {}, {}}}, 
          VertexColors -> CompressedData["
1:eJztfXlcTl3Xf3PGaJAkTYokmSnFMjSjjClUokEZKqRUSEhRaZKIokGGJmkS
GSpFKGmQRKk0XFfXOQnNw+8873Pc+zznfs+n2/Pcz+993s9798/5+N7n3tfe
37322mutvfY6cjsdNljzcHFx3RLk4uIlnqMOVS+PH9sIm//rrwK4/uuvHX4V
r0vaq8yl2wz3RXNXe+6t+w1f4c8K8w9ohW67Qpnzxxp/ww0EengreljgM0Xi
jLZg82/4tTery9bhbOgvqb8andOC3rc2liiPbIOcPQ0CY7taf8PX72wfESvH
Ab0pVuzYOtZvuNjSs7brvDmATx3JsyeU/Rt+Zlq396sKDrzW4vu6Vb7tN9zx
qNH+zxMw0Ovwt3sRivBQnqrGgwYYjKwrsrzdgXDjo7HH1Q9jUFqL7SpfzvkN
Hy8ddVY+AoMeXeukHC/OP81nk+ONH654I7zJbAwqd6/6DVdVMlPg8m6BuTFq
ZQo36n/D1XIXqc1xY8HKRUsnG09t+g1f/tCWN/guG3K+31DeYYT4lNIuk+8/
2Qb2fU13phQiPq3cFeP3SnKgzbOZP7cM8Wl/teOS31kOTJrUItIXgfjkmMxa
8K6OAzcrBENFFiF+BORSDnYrYJByk/f2g2SE75DXevVlGwY/LJsXlgojfo6H
hkb98MHgcMTkJr2dCN+/Z/c+tyQMzs+6uVkvjkORk10RU4oxqPTOn1748Z/n
+fGIHS7nC5ugclVr8Qfh2t9w9+trpbmetcLNeclbX9QiuVXt8nr/1poNfjz3
xKc8R3K78EAlj5FdG3x7ubDY7SLi8+L9rQfiJTjwfhr7fvgbxOexoO8L+cMI
PsPYfC4piM+TVd+Vnb9xgCW2d8n6LYi3Z4fecJlrYGB5RmBa9juEn568e4fC
IQyCx/DuklqKeFhXqKbMuo5BdOlynvcBCLeftn6rSyEG9cZ77ZtLEe5tqrLt
QRMGa9wtdR+OxH7D55xUSpDgxiH12dTrb9Swf5rn8GuTeuKiWqC9ufP01zIk
ty8kl0lw8bFBNlexft8kxKeiSomb8/o2qCxWEmnci/hUVtLmGUOsd6WYfKcL
tYhPUdX6pxsSOaC7AS8UrUZ8hsfn5V8VJtb1HZxXxR/xdkW064HZdgwejG+3
jBdBPEQGHnzdeAEDSXX+LMsjCOcTl127Lg8DZ0ceqaNFCF++d5YP1oyB4YrL
xXWjET+bs8ZO6OHHwVAkBzu9AuFRuu16/dI4jHohqT5nP8KfLOQ8FF2AQwDf
ScnqkOF5bjs+9yW/dBM0PU+pMEur+Q0/oFbm9tCFBR2zjij8kEZ6QDxUVYRr
VRuEr79iJ7IR8SllOVlKgpAbuYjIsXeEEW+yn+5xv6jigLnbxgkp0xFvAdF2
woPEeNKPfqsIaEB4ak7wxkX+xPp98o3nsx3iJ92wZ43OMwz8xhzyHXiN8MMJ
4pf3tGNQzuI1GDkZjffk+Cp1DxEcTMq5Kz5uocihsHxTxywcelO+XW7xQTgY
FJW4aeHw4PXYgwp3EZ65MG3R0i04FIqXK8e+Rfi6lruvhWxx2LOqPqQBG57n
jiHZeaZ2rXCds0RXRhPpgTVv/PrfGrVB18G+3G47iv4cKzOGi9D74z+LfM3w
Q3yKhNnmZCthsMdWbOSBDMTbhFB5bu9ADELX12cVOSB+Rk78uuNWJQZTb3U1
jOQg/FWZZX3xCBxiK7q4w3RQ/4t9+z6qquJgPqI7ZaMvwo2e37fpMMDB/wpP
TcpDhPOMDpx20xIHDTXugGVfEC6bIa7VdRCHeNm1tu2E/P7ElWu8z/Z74TDd
17wrVxbhJVNdFY6dx+G0lb+UxGKE110+/GnkZRx0vVaM5ejjw/LcfXz8pYS0
Nig5fDVmnDRa19N26xxrnY5B3/2jlv1pFHnzHifA9RSDM46+rtsKKLy9vGdu
JoZD+vyzfOrbKPNrEMS1Sg+HIiWn7V8yEX7qnGvKpj04BJX3fT3VifCm1jlO
tqdweMvq41o9FfW/OX9g/8SLOMzm86i6pYXw6Y3b5x+JI8ZryL3fxBzhJ/j1
RMtTcJhyhUs36gDCx28bHd13H4eNgTfmd3shfML+VdrHnuIQqpXsbhmI8BZh
TZHHhTisTNUR8otAuONaDZzvNQ4KT695d8YifHv3EPGHw7aOvz9/4kNDf//3
4NB/jw/RcPp//6P4/5Unkzz3kfJcTpPn6aQ8D9Lk+R4pz740eR5FynMmTZ5H
k/L8kibPp0l5Dv4X5VlpGHmWZpDnTb8oz6v+oDwz8fyd1M83aPp5Lamfe2n6
2ZrUz8I0/SxK6ue9NP0sTurnCzT9PIrUzwp/kn4O+JP0sxJNP78ZRj/r/UH9
jJH2BkazNw6R9kYnzd6QIO2NyzR7Ywppb8gz2BsWDPZGxi/aG/40e8Pln7Q3
+mj2xvJh7I3n/6K9wYRfJu3nDpr9XETaz/I0+3kaaT9X0eznmaT9rMxgP+v9
ov38kMF+nsxgPx/+RfvZ6Bft5/N/0H5mwp+Q/mANzR/0IP3B2zR/cDbpD/rT
/MFFpD/4neYPhpP+YDWDPyjJ4A+yaf5gAekP7mTwB0P+RX/wzL/ZH/wZ3yhn
iG/Mo8U31Mn4hhZDfOMRQ3xjDy2+YT1MfEPyT4pvdP6HxDf+itf9Hf/VeJ2v
fO71pQ5tYHWn+ppINOp/88esuZa5HFjpF3c+cQj10+bLPs/puzFYvCx/edp0
1I6fmPTzjes58G5fjMurhej9qh3shY9LMHjZoFeXUofej/4ePP7lcmK/eP95
9vnbaH25rClRHuuKg+3jsAmaY9F+HUS2X0drv5psv5jWfgzZ/j5a+65k+3a0
9lvI8WrRxmtLjledNt5flUPhem+VOxKtoJMVLzE2oQHpVbE809pHLJjH4Qro
v4rW+9SAxPd1pWw4y04/JeyL5O32jGWOc2MxOBcSEsQKRv0xceEWvZaGgW2z
2J6VKQjv9VqXcZ/Q11Fb0oSmb/r8Gy6v31IZqMSCw+punNCgL7/hOwfskt74
s+GavxHmPQ797qjCLaonD7eB4vqnb4WSkZxcsdX5krX2C5jzyT5zePX+Nzzj
kvKFqbqt8Dy2PWnEEBrv/BT9E4fV2HAje02ulAtaX2FN43lzt7eBkGqkofAJ
1P7XIe6TipM58DTjleyYCtawPLPjHI4sSWqGsCWDcpUKaLyOKXyH/J+xoP2r
ihHrFuJZa+Kdmdv12qBSQ+Zi7Hb0u0UlmVvuzeSAR3FbUkQH+t0qtYR3hY85
YCZVtX9kH3vY/ixpDB/7UIgF/Qf2Wh7ahXhWKfy0oYuwGyeBHf5yE/rdzcfG
VK4w4YBAztc9KitR+4NZ5gmxvcT+uF9j3DQrtN4fORmr2FsR6/pEw0MBOTTv
t5duNen71gwB+iwb6+uIhx+Pw7/wjGOD2ry9zhNnIf7Vr9gt/aTBgZ4wzWC3
ceh3RxtMHOkpR6xfpeIFvrfQ786L5ucOe4HB1nFnHVIq0O/2gc8a460Y2Dwo
LhUch/Cffng/zY9m4k1kwdTH30VxGKh5NOfYVrR+mfx60zxBXs8dhJ+VpfVw
VsPv36f77zbnEjafCSfs2OSqkiW6w/v7P99/QXvfr+F2RVIiDvPW9ppw70O4
P4nPp+HbG0xq9jwk/L7a5sYNZ36PK9LwQZLPPTQ+mXgTI3nj+viPvG0l+dGm
8ZNEyslFmpycI/eF3bR9gel3NUk55zr4j3L+q3qSSb958B9b70j4k14umkNT
dw3PQ058YLM5HwumrPO62rEO9UfbMuXkvc2EH+FbW7XhTvOw7ZdbbZbzVGyF
NtY38a5cpMfSamp8uNtZsFuqO/z+D6RPlkyUOek4tg1Mduz32PcN6c+Ecs2s
y/eaActPz3BQpejhT9qTPa1YYOVmHxnRj/p5W3iGcuwHNtxt2RfqeRm1M+e1
v9esZ20QsHhAxkcD6aWWx/cnbndthAwwPLLvbSWyk/d2qt891wpfR6ltPngE
2TmOWxZN8IxhQ83Iz4rLF6H2r+k4v9QpbIP+tIbzuoDaVzzZf4LlwYF8Ib+8
6JNIP2Bw61hyXjOMujVy0vTVaFwWfCkPCnex4fu67G+H8xHPOW+mjfOsb4ON
l7YkNjqg9i+6P93bmsoBnROm54QaUfuS6ntOxC8g9NsXSduclxR/OWWskF8k
BoFrS7wrfNB8nfpimqx6FofqSdpeV2b9+fG6blJ/LqPpz68kD0I0Hpjkk2m/
ZnpfbYOrrJH2F3i7f3LOriS0z06eoRkYH82C1A86ePgeJIeyJP6AhmuS7dTT
2mH6XbeWb9GJlU1w4MzKqve6yE/EOmLkRrey4LubyEODVtS+5cDGa7v7MFBN
5fW7qYr0TP2TL4Ff3HDIsm94uU4EzcvM7r46dcJ+vSg+OrbnHJIHJRIPouFi
c3CPGx0cUNy9VKluM5KHBj9reWEjHPi2pBuNyUe/21w9w1MzDIcmgY+N8qvQ
704m25lHa8ea7P9CWv+byPZH0NpvJMf1gDauFvJ3W2i/OyCjNW0mIZepZs0t
J8+gdn7ui70M8eo/Gsdmmsev5Hz10ubrGDm/nrT5ZWonnTtF53QUBvmOJwOD
z/5+fx/4g/1h6j+InLj57SYOtfM2+QRYIXw5iX+m4SPHSRlUPsFBPtH41MLz
lPUu+3eeM2k8/1l+JRMPqU8r9xyL4kBEYdATy6dIj+m0KsqFncDgfWqehfRm
9H4K+f5F2vsJN+bYzudwYDy/LK6wBsln/Mq7qSmOGCgvv72rYxFqR4tsv5LW
fjLZjhitnT+Lhz8LP9B+x3F5zheIFrYJfrr1w2+4cPFRj3MZOFTcqPMq90Dz
K0Li72j4gMWrAyfOcEB2Ukb2ubDh7fNfxQ2634JLMAYTZ5TfXHkQ8Szw/MWe
uuc4jL7i9iTw6vDyn2bwxvBzPAYpE3PGeF4aXv8zvd9LjncybbxM6+s0uT/W
0PbHUeQ6UqCvI1p7P//NH6fnKReLg3WoWlLHNoTf3DTrmVEJDo80dh0QuoVw
AfJ9G4b3H9PeZ3rmamua3E7HQZ814LrSHb1fW+y5ua2K8C8unDVSy0Z43jDv
D9DeZ3r+qjz8u9fLLVIPqNL0wONFJ3uqezG4Ft4ffmcW0nuPSPwqDWdqn2ne
j5DrNJu2Tv/d4xUk19cY2vpi6qfzKtOzgeU4NJS5vXVI/T3eSMOZnnabatvD
anA4eKrfKv8Jet+eAWd6uo66OXFeIbG/x74xDLyM3v92KDxrfi4Odj+OesYF
IVzHQa0yvZaQTxPfQeMC/Hft9P1iO4O0dv7d88X0/Hhi3gurehzmuO1NkXv5
/68/v4qL3R51YdVCHPZdzUzqvoDWS1bB3ax3roQ+eVTyIk4I9f/t2lteclE4
dI260se3EeG2Mt06YZtxwDGntpQS1A4utm62VQAOP/SvX5VdiN6/ePriNtV4
HAL2awtbW/7n8vMX/hf+F/4X/hf+F/4X/hf+F/4X/n8BPxBTdcB/VjM465nX
CgHKJxGOvFNXYN8C7x/lp59xRvk8837oq0p4tsL9tiUuOVbo/CWut8TiuTgL
DBNPe5c5oXOfPhm7xu8YC1I+8n1+/w3FaeuyXnfNX8wGhaKiVzWH0LmDS+TK
cypNbNjd2XnWKBGd4yyaytFYwd8Ghxp42CWNw+erfDlnNr8orA0kx0xfnNry
+3tSbFoeUYr8x1EGwhwQFyzHnPIQPqMnPMLHgwOiAnpfv3mheNSuggYjxX0c
0K638Dhii/AxtyP9tV5y4FTT43t+41B8sh9T7RvI5MARCZsuWQ56v39Cbd+e
0Rj4qz9bIeWF3u8rjemt/MGBs5P1ZwVvo+Qby/XKOCzHYMPpHw4FdQg3S87d
Gj4DA6eXsQUDmQifudbrwcu9GJzu6p04OJsSX5U7t9p6MwZ9tRvrFwggfMnZ
kWXGwRj0Px58OoIS/7GolVwg6I5BjnauwW59hItVTS/bn4pBZhZ7tknC8PEi
7xs1Jie7GoEVofb9XDjKH1vok1b7I64FdmoeGbe4Fsnb5jUt7nYXWHBZ8q7a
t41IftZr89jJFbJBVOiURp0zkgehU5nSihfaIEF+qn7uFzTvod9fK29U4sDT
BatPhrYNf58rumSTSmHz3+LVD785r0R8pvmbvtxF8JzHkmFHUXge0Dzf/94c
g2tbFfwmTqTk6Tmt0xY8h4Ekfj211xrhPawVUkPJGFyeut5uMB7hc7+d2apH
+NX9Ubeu19Qi/OGn1fyCLAwu5V96Gzlu+HjXnqwGUTuVZsiPFX/OtxSt6869
gWvMpYl1OicULI6jdeoS4/0i+zYb3PWm9yqtQnzG20dw1ka1gfMy3rAmyvqK
s1NJnaLFgXZDI8GF0oi3VWbL5Gvuc8DWzKHkcPvv81F1afmok2+Mz+HfiMFY
vjmdXdxovGZOYiP/ds7Bgx+Xv2eB8IFdMKBLyNs995OVIhR5k396wz6qAoPP
JoY/VNkIf+7DfXTeNwySjOKzB2UQb9O3C9Srj8Fh4PimEylrEL7ri8PiKDkc
3N7oOn85gPCCZcF8XoGNsKROtfCO0rvf8HVFrGJDy1YI7hsfljcL6cP76/fe
LwhjwxKFZIczMojPS70KE8c8aYPth68+MJ+H5HDg/IIDbi4cqNrv1d52BPGm
YXRdW/wbBxa4uz+LN0a8dTxLmmS9muDNO2Sy6fff51c70/KrQz1erdV6hMFI
3tjuI08pcf7NJTrRXzBY+a3WtEAQjXfwLD6Qzo9DwZV6WSFKHu/78QPnF8vi
cCu3d/EuR4SHTXv60XoRDrnuA6OHLiJ8yrNTdjP1cRi0GNpx6j5FbttC7Bab
4rC95sdElUrKvZ7yjETjHS0gem0cp2En0gMLa776LiD4tNww2spLGvHpvkhv
2uxxHJgmURSV/Bjx+WB9npVZBQeWxooeDZVD/GxMf915wwiDJVHcq7/1Ifzt
AvH3QtEYuMbHn5Q8T8nrU5URxmoIeUvKtNXo/v19gRjafQGhjT6fvGbgIMAj
0dfnifBktbOnnq7C4UQXBL1PpuTz3I0anErw8D5nxZ6RFB6CdmxML7HHwUkl
3u3iD4Rb5Xsuu3QEh3fxG82GxqF4mpgq71cpb4JnuL3cZBrC73ZkRpQE4rC0
JSb7gDrCV9h/MJ45pw1GvDnT6TQXrWt2qNCPew0cePFEUHi2BuLn2rodlx2D
CDmR/xG3zwnx8PGmZWoSoZek3/ouKxqP+nm72sa9bDoOV0s843qOItxO8txe
wfU4PCwrW+FfOPw9l1YTkShWKA7XNj/zLVyO8C1S2rl113F40hf1vG0L5Ry5
ymgoKAEHzqdr6Xx7EK6XcqvaNh0HtbCNOS/dED5v5/KoVw9xYJfdShqi5CmN
unjCVSgPhyGZzbIqIZS8rJ4Pr22f4yD9fb3Z/SuUvCaG8+L/7U8tUk6EaHLC
IeXkFU1OrpNyok2Tk0+knMgyyEkkTU7sSTnJocnJ+ovnR7jsx2Hruw/3pvQP
Lz9nZmg5PCXkh4/bb+AoRX5MSPl5SpMfrvf/vfzok/KjziA/bQzywyX738uP
DE1+vEm9J0HTe4tJvWdF03sepN5Toum9h6TeA5re20TqPU2a3isj9d4RBr2X
xqD36Pekfuo9QQa958Wg96r/JL03RNN7qQx6bwO5X4fR9utscr/WpO3Xl8n9
2py2Xw+S+/V72n6tSe7XC2n79TdyvxZi2K/p96EukPv1qF/crwtp+3X1MPt1
3r+4XzPZn/tI+7OQZn92k/bnOpr96Uranx40+/MmaX8eZrA/v9LsTy3S/tzN
YH/S70MNZ3/y0uzPwWHsz/p/k/3JxLMP6U+10/ypRaQ/tYvmTxmT/tQVmj+1
gfSnxBj8qcRf9Kfo96GY/Kl00p/K/xf9qd5h/KmBf9GfOkTGSVxocZL5ZDwk
mxYP6SfjHqm0uMfP+IY9Lb7xM14xmSFeQb/39DMuIUaLSzDFHwYY4gw/4wkb
afEEpriBBkN84FfjAEx4yqN+fsX0LyByy9v89VJK3hRDPIop7sQUX/rVOBJT
XIgp/sMU52GK5zDFbZjiM0y8eY6az3PaowlsaqoFP/B/+g3v4S9cmybWBpI2
DWdtuIaPg1mLP/adQIxr30nb9WaUcWlPNrcbdZcD55s/zcisQ/g5tpzDkVYO
NGfw7zmqjfp/UCFyxnsJDHaUOYuKX6bUzbB5wTWS2J/uC69Se/8Z4UVS/d7O
uzCwn5/7ab3M8OMVuLTMald1I6TuCTt7Zg7Se5eLjNa91G0BS6F718ctRnJy
c/9i7aU32uBJgOA7Pb7h4z+f2twkN1VxwN7rw8baaaif2KBE/AxCXxSzl1kW
+SD8nMhbh2ZNDHrfWaW7ViNc+dB3QydiXEpL5Y0NKONq4PW11DyFweull3zf
myL8yWk3IdtrBA+i+x4p+iHcZv/yhcVZGARfm2hxP3N4fiT55jgkdzaBFMt7
94xslAfbewRP35rRClPacvquP0P6asu7eM2CxRywyZw5deaI4eM2JnmL7gSv
wsD2hJGxZRPCL9aXNertI+yc9sjwj3Mo9+nUvRw3BxL7bE/e0EHKffz6PIND
I5MwaL9RHH4sFuF3r+vlOvztfqsdXv2ecr81E+u+YPIRgz3fJkb2UOzSsc5W
tjbtGBxKeMbNRbkn3p2U3aXs1AgdjiMEH2WhewSqDnJufSKtsCpNI+bLdXQP
YuuM85NZCmyofvF884JNSG8ILJdYYPSCA2PqjBzGjhk+3lJ6qUOjlBjXLs88
kwbK/VAoCJDf/RKDtd8HS9qrEO6/Y55TXgPhH0lONXDgQ/2/LHr90vVuQq+O
d/+QOgPhx2HE1JhROHRe0Fap1kd44haXKQaSOOwtyz362hrhae4+lwYJP2tz
1sFYnWMIX3TorD2vbAskSiRNEmhHef4rq0VO685mw5Fv84MzbBAP2VWqJ46E
tEFYfFlyQT3SJxk3fWZWbSXsohGHHuDjho+TGDgmvRpH9HPH8cXbrCn9bLml
v+MM4Uf4dZsL8p1AuP+Zeqe5i3GYr+EVan+J4g/u6nqkTvgXx92mSzcnIXzt
x8KTlWtxGJ0bcbT6KcJjnvyI1SD8vX339pldp9z33+6V8DLMAodF+XK6/p8R
flB968cPxWyo7343O/Ek2i+2aPMFhqzmQPI8lRNnZlLud/gUN43g+dt++mmk
qROSk6/C3QnqhDxvSlXSPUKR559+ayndb93Wr5BJ+DWfjh25umc65d6oP1/k
DcLPfNX/aNnEGQgPSAo+EHUWB93tnz9Zq1Lyye+tbSz1x0GnsWzH5AUIl3I/
0zgyiPBDsa/F1RT/6NKMQyqzCH95X4jEUmdAOK/vmwHVizhIvClpLaPUG0kZ
nLEu7SgO4u+5dTZNHD6PMZKHdfrVVxyWzUgTjW1CuLrT4w/PvhDzxS1zWLmU
Mq6KlQfHfiL8/aPLZ1jmIfwJT+xI+yochAw9Y4zuI5wloau9tByHBZJ6sh/u
IjwwuOOeNNHu/oN5UvoJCL99/vvswmIcej4c9ZO8iXBRTYGlB8vaIEOnPIZv
M+t381VGm681xkqTpGNw2KUifHjqVoRL3zndJPkQh4xezw253gh34h3rd4r4
3RDLHX4x8Qj3SeQvHajBQVmvbJLHU0r8Sr/H9HwLDln3LQMUKhHuxnc+Hyf4
DEoI4m2g8Jlk13z1Wg8OihLlbyK/I3yXUfID7jGtEJ0/rcTxAtJ7e49MN/Kx
aIO749h3+b3Rui6029Cil8oB189cLXg9kvP9xlcj2uoxYC2beRPnQetl9dJb
4TUzcfj8fMMx1dMID0hL7+Ql1lf6pj7RM3UIf03qhziafihduLP9hxoOiae6
LwdfQbhzYdHNPjMcDnfKTk7+hHDHmu3nxN1x8FzOvfIm5d5KqVnyHetgYl4+
TXunq0nh7Y56z7Y4HGL9Ry9VoNTJORUxfulgGsHnq6ap4yhxHsFdeXtG5OKg
NWaaqgklH/XG/bMiszS/EPuG2bln/uj+kYnQIi3NVSzCj+vIXfAU2aUJLGHl
Et02ODYo8/LmNsTzisVTxPwIP1PykcnQHCPEs8RcvolPRmHgI5SwttWTcg61
ZQF/owcGV69Me/JgDdIntau1h9xeE/uvyrvC2BqE32OIM5hY3LDIJN5POX0q
fDylXsHrhnF7aoYwWNzxpCFiEYXn9ISzNwl9tE8muiuBEq+bJGTq/VoXh4hD
bqGilLpGCWPdwpV24nDeMp09tYkiD/OC08e44hDYpqGlQbm3vmN7lLojocd2
crmeE6boMSY7xyE8irN0qBlEdWfXeqaj/YvFvyjHpoQFQaP4IzwfIP9Lpu5Y
wRKDNlALrF/aZ4H4zx29JzhkHgcUP6l8qx9E633KgcdO7NccMHXs5dYXQ/zP
aSgX7NDAYDfvPffcKoRfYogz1Pqwil13Evuj9/iwgCmIZwWuzbNyrmPQzdmR
4EOp7+EQ0O+7pBwD08GViXdbEL7zEY/lwgEMykcVr6+di/j85JC9+Ic0Du4L
LS5PpdRXCX8hqjpZg+B/TJDV3+zKn/j9ze6CVRtwOPH9RUtR0fD+71nv8Hkm
RV/Ap85O/pQv8sumy21dN2jcCrHiLHuTyRT/16fOtXUBG0x27vV45ojsh71N
pWNtt7ZBbmJieI0H4t/bz+BThzQHJmgVr6r8gPj3dLMab3ebA7nVAbPrytG6
YIoz2KSqLlvSxYHMM1dCxpgj/t2lLuNXCXs1q5XL2Zlir+63XeP7yhMDnY8N
OzM2Uu6b70/QuEr4s2Ouy427Q/Fnx7/trXz6AQObkSP1p3Yi/PqOCzdmDGIQ
oNJ0KmQ+4lPYaEsFTMYhqmWyzinb4Xm21jzWcOFTM2TJlyyZ447kuXruypnh
Miw4vKAz+/wJpE/En6r5LiH8/x1HVZdV9iKe8RsVBr0ObfB2YvTpXTGI51Lh
7xJ1EhyQSrVvGKDUsWGqr9L24UBi3zkOZPsoBZ2NRDyXqdXePfaF8HO/XFu6
cxmFz+VXfMxnYTD/4SmJB48o8U9pY3H+3RhoLXZ+dZhSd2LlAo3DAeEYbPiY
2iV/DOF3usRl1Ai7LWCNRtxjSl01e735MfGEnfyoZl/MUr7h+WTCo7dEH55l
0wRhZrsnjM/4+BueVR3zUWdUK1wQ8OwxDUb74+OIKD6h2yzoX5PcUOKK9InJ
0x2Z3E/ZEMB2Lmy3R/ah/K2TclvOtIGzr87Fya8R/0xxhoP8mVI5shzI8U0L
GEGp76S8WeGQxRkOLPm8XMCIch9q36S2M+3vOSAboVj8eAbiWaNkqH3vFAw8
Xj/3XRmN8ENh7hO2bcZg6d3tN+Qp8YT0gPCLOoQf6r838Bmb4ofak/ZAEs0e
KCDtAWeaPfDzHt9M2v2dlAmj+cum4MCn7mA1ZS+arwaGe6YHeM9urz2Ew3SB
yTUBgpT7raRdvZlmVx/sGNNadIAFu/wOzJMTR/Nyd8gi6F4isV6GjL5uOI7w
xQZlWLU1G3z4mk/PpNR9mht3dv99Yh6nOia9U9uL5tG+pcg9k/BDHo8xwU0p
9xAHqqeottwh9lnBmMaUawjXTShbP7q7GU7aVxy/cROt33DVj4Etemx43nX2
vlso+t0KjTnqpScJf9N+t2vCAMLjntaGjyL2mw75tGOLh1B/oqQuSrQS69ov
wP2NFmVdq6ptVI0d1QSSsXxFig6ozlv8toOZl21aYble3Xu1xUg/P7RPVBOQ
aQPVXTHLy0VQO70uXJ8x0zZYXuk5xE/Rz6LqbSuX5LbB1hUnXFYtQvIpFBqT
K0Ho7R8Jei/WVQ9fz2RljJZ6+7QWWBnUW7arH/EjMFp0inIFsb4U2fNfPkPz
9fnG0bqpP9ogpPhB4awg1L502hufMXM4ELfikrdFL8JPpHS32TlyIM/C0NFo
H5JPj9Epe/VeccD85YTc7cKU+kKkneZKs9NsslO97q9qgyzeTn8zSj0TgYa1
PitecqBbvdzwDCW+uqr92hxlAQxGJ94de98V4fh0/ouXpDFQOTbZblsswlle
D8Vd3TAobK3P3q2H5GcHaZ9fodnnO2X0eVbosUAo6+VX5SLUzx21F3D/CmIe
r5+7VGCCeGh3DWxWquaA1T3cVUGZEo+SkZ5jQdgb5nFtFXX+6Hd3qzhV6dZg
4ChRFCrShXDZ9H13JkhgwNuyqi8rHLXjbHCm9/1XDKzqTvpcnEKpm6c0Z22W
Hg5yQb1vM7Io9RK3Ye88XHDIH89vtmQMWtcZMx7U3UvBoTVuxnNrSl3KTBJn
0/Cf7TyjtfNSXJrdTeiTwez0rQcp+uQViQ/RcLfrju6XjxP+/ruM/VmSCHcn
8cU0fCrJwwgaDy4kD7Y0HtaTPEyl8WBKxg1SaXEDLTLe4kGLtzDpGSa9xJSn
x7QeRY4sWgqBLGjT/iycbYDWXVpXkmpRCBuMs4tU50ki/eP0QHg9W6YFDmjm
j/+Ao/W7KF3gy3YbNmy42xMu+gL1X97hQVXPijZ4VHVx+rL1aB0pRD4tvuVJ
6KtC7UvxYihe/cb+boZbQCuoSpbY76PUMdv2tdLPTbMNMqVEZPfponYCmwq9
ZrS3gVKXlayBD5J/tZH33v+40gJ58hEPFEpQHHiO5HqpUQMsYHW9zx8ag/rp
OSt+QbgIYRf5KMcXPKOc85qVq5hGciBwwrxJxo/RfMX6KpjuJeyAOePj36h3
IfthzaHYxhX3WdBtGXL7RwjiM/BF+4lLe9rgZkWjdHAE6n+snUtNOmHfe31b
qSqrheRqb0Vdpc8aDHrmDwnv7ET4izjdU2WPMGg235Z+JBfNL+fzRJWvoTis
LTqoWUbJc2B62pD6RIymT26S41pCGxeT/CwILQ5UXdsMOw9f4Dnrgs7FnEwj
eQX7WRBm/Fhi7mjEc5L0/sO1tzEoWtSqWhWJ+v+ZtAcyafYAU52NCVK54no3
OMDd2pbt+RrNy3gybpNCi9sIk+/3t/zj+6lk/GoSLX6VSvbzDa2fTPUxkoXW
NOiL4dB+xnmJOKXe72EyfthCix86k/xcofGjTsZj79HisYtJnm1pPDPdi3ck
7SgFmh0l47u8/Eg5Dg6TlLV0KfeFZUnckYankuPqpI2LSR5uMNRzEFNpvPVR
kwM1F3ckr6TUj+VtbFzo2IgDv+HSHc+L0e8Kk+9X0t5nGi9Gyr8hTf7183uU
W27i8NLxEq+b1e/xVzR8xr5V97dm4nDctjtE59jvcU8a/qt+B9M995skPouG
3yXtZwGa/cwTuMlfjdADDxV39FtR8kO4STybhv+77xH8nEcB2jwuvO3guhrD
QX3lsXk76xAu/to/VvYFDmaLB/bzRv7+/SUM75vT3md6ribjsTtp8Vime+VM
OFO8mul9upzS37envf+fdh/kV/FX7l0cIwyDRTfiw7QnIvlkyhNTEr1q98YM
hxcFyp8tKfHb9dXeB9L3E+u6uH26/x/I6/vJ524anwuSl2SNUMOBx6tyiHV5
eH3FlG/w7+YtmowbG9LixkzvC5Ln3Rm08+7/NHn4s3C+STKKsuaEn1iqv7Ld
HNlv/sb1WTaE/z/gPM0Ai0N21PXw1Rd6RnFAZ1DAZmYW2vcFjd+ecTjKgahL
XWsDT6F95MCP8K3eFRxwGiq8/pGSJ5khN6lTZDIGCx42BI+LRHiu/+nlihsJ
eVqwXXMODyV+xbN0tyJhh484FTRh8yZK/IqTbHQgHoN3vE7v7ocPr4dfRH+t
9F3fBJWyN4dM9yK7y7XGNdLjGzHeyfad6gFoXN0vl4vIuHCgOFD5mT4l/zBH
P01A4z0HOiecS3FXQv0vSYxf+1ABg2/V3ivWUeoef5FaYm26A4PL8/MW5E+i
7NeRD0TsAjHIcFYed5FyXo9zR7MrMzEQVDJ5MZSOcC7zBzJ3qjD4OP2bQVQ7
5dzfuKvZ9DsGfT9erhSS/+fjdVY7x50KdubA4NPE6NOH0XgNhxae12rggPFU
Q4XdS9C4DiwNOy2wEIO1wdKitq8QPssmY3nHQQycM7Q/52pSxiuxrTwqjujf
nehK1wuUvIukr40JrzHYn9n9eYBynnKVW9DBh9B7Aq+kj96m6D3j4gK8YSQO
DaudH53SQ3jRgZiwH7I49K8Z8stwGp6HdS1xdjcJP3zQ9qthKSWOHTdv5hh7
Iwxq051OelPyeJXmuvK9JeYrVijVeYMj6udZ6WfzlfIw6AriO7GQUr99lajH
qiYW4bfKe7nOEqbUA3k0PbN9FGE39hSkWRlQzuu593aoKxJ2muOXOZuPIPzO
srePpTQI/92ha6495XxhxHkj7aC1OAzEzHtnTjl/x41eCmtvbYamLUfHtgYg
O9aq1JWdr8SGRSNYx8W3IXs49GnLuGvZbWBduFsqRQnJf8/3ixLOxDzlFLLu
OCcjedi+8+jnZMIPFx19SySbEv/U3K9p9Ijo99DYhX1SuoiHfmtZ3/MPCB70
LtTHPqTkqytsPXm1jZDbs9pVS8Uo+QmVZdPMCbvfbV+e7E3KdwcOCl1NVZmD
w+tLlpL1fpT5LTHzXaCHw4clF868pJyLdXOVOrO34cAnltA4VI1wruSP5zfv
xQELORJn1I1wnTt931T+Ft/otZYTFEb73ffamtGqmizAzm80j0hDftyqRX1X
qp61wRH+K7fvayLesmZGjHpSygHsVLuI7GTEz7qYbOuYXRgcq/5aGEPJUwpZ
MbjcmbAndwoWWJZS7Eml728XlPcRfN5zjd89G/Vz46UJAunTccCrs1bkUc4H
QyU0eewIHjYIvl8ygxIP0T5fPynUklgXel5PJCnfy4ge+UjuoDMO84VXPAwb
gca7vTZkm+tpHII9dm2dp4jwOK5FPVeCiX0/60D4bco5r7FMq0XAVRy+Z/ZJ
LFxHOectjI9+foPgc/2lPck7EN7rgPFPlOZAV+GM5LWUeKZcxFHDtp2Evc1j
WLFdGvFQc2Etf10LBi4rXUcGjkX9v7n+Y2rpXByA091Qeh7hL2SPX1tigcNd
3oaUFso5uJibnSSL8EO5tj7cmEbxQ2+9GnWyOgQH13011z4vQ7jBGOkTC2Jx
uHVy71Wx7QiP0f06pigFh2MKK3b4U+JmpXy1gfezcbjsI2u++hQlTwB/Meth
7t/q/8yddSkY4Ru5IjwMCXube7v6ms0Ue/sOmS/RS8uXyG3YuN6qjLDfbr5K
35KC8J/3Yf5oneTh6kP+u79/xITTn0z8Mz2Z5oXpyTRfTE+meWR6Ms0v05Np
3pmeTPLANO8/9ZXb/5C+av9fqq8Yz5GH2U9t/o/tp/gf3E9ZZN3pR7S604z3
2cl61N8Y6lF/pNWjvs5Qj3oaQz3qP9sO7KbZgVr/Q3bgr9r/NwUP+VzFmiFl
rLfym4soLrqGc1Jyhx8LNq0xnf1mFYq364dvOCbRwwaN6JqDk0oQ/3iMu7xi
TRs4izgcOmdFyX9g8C+MGPyLg//L/QsmvIj0Q6tofqjSyVKZ5c6t8DKgVG3H
eiTnX1tnz2Ups8HtfMUWtjnSM1n5vbkWGm0wTXyD4iFt5KcfIf3Zwf8hfzbz
/7M/y1rqoHg4rRE2TNO6LXoL1Q1gim9c1hjb+GA7C7I9ijVyMGTPn/hyZNfl
y2x4N2lh5fZpSJ7/t8dDDJesVn9UiEFvZHi39VuEG0gb7VepagbfIBmhHAe0
3mcXGfwolmNBfuXF6pOnET+awYMmXw6x4cOBo6sEG5Acmr/zXee8pQ0OZEpG
X3ZB/NiQ91z20+65SGY/K25/zoEr5t8+WY1G4/WxmnlgKqEfJUz4Lqz3o8hb
9OUY+dUYrBs02Ff/DeFXv+6ZFOJG4E2+neGU8/2N5sZXeq5j8OmkysXvlHy/
BpvLgdGEfuY1UOMZ/xLhI8i4XzYt7qcpYsSqKWiBac/uLuiehPIEZlxbWDW3
kAU8keI87xOQPny1+FrV+T42FCWs/ORZhuRn/XLTdReI/YhL07igjLIf4eQ9
lze0ey619qYT1hP7TtUyLdyUsu/kXA17mOiFgfWZuQnCW1D/bb+87gxOwCB+
0uqPn68jXHu3Tpt+CQZbeMc71FLu5S0/6irlRNgJt2q1AjBRtL76yXsrsrR7
K3PG3YGMY2xIe7wqLOA7mvf+zo9e5f5tYPzSdktqFZp3t9HZb1OAAzFmF0YZ
iqN59yfvpwjR7qf07lt13+shBj7+K6ZteYTwbx8HPA4S/puQm5D46UGEz4w4
5KA8iIGG+SV2KCUPcGaDVrgI4deJOxmzhXYg/Of3eqoYvtdzlOF7Pea07/X8
vCeSRbsnsvxD350F4jicFiy/5mWOcIGuOsUIVRzOhT4fM+EsxY6auP4c/yoc
lngfa/Kl3KcwZLhPUel+btwVwh7VvXH1rQXlOyzxk6/+0HfEYaJMznGLIYQz
3YO4TN472E+7d6CGKb2rJfyTRA2RzPMbhvdDf+btp9POf3dXuEusXYPBhIGQ
nV0/kNzeN39xnPMRg1C+PB/eXtQf6zvZ6/Vn4RBj/Pr5fUq9/Z2SVRM2Ef7e
2VGr72d/QPgZuWfqbHccsg88GK0ghvrDdA71n+an/8z/T6Hl+934wY6cE82B
24u2L59XQNmXc1jSToT98XZDm4IoTqkn8Nm7yv0uBlMMXq2+cRvxWTT1/fNx
34j1MlI89wnlHjRTPv/qFXl2VwheHi3lFjjNi/rZPbLBRfUkIc9D6jJScghv
7LNd9zAQh29nHXXWUe6zWHbeVhmMwMG3ZvMh+7UIj+62nekSh4NOsdfrTZT8
f6b8/KynUuK4MQe2L2R5lQDiYfKqiTfzOjmgVfbgjZoZ4kFuwHC0kwUGM8aO
Xa0ogXj4mT+/l5Y/X2u4+pPxChzu5UlU+tyh3NvqsHHXN8ah3C8Oa3+DcPkF
UztjbXG4w+2TieMIv7ZMM0DtMA4VDvK6XSMp5/4Mee+xWnPGiczmwLSou3Ct
G60XSYGXn8fmcWCjzXXsMxca18/88zJa/nlu48WBH5NwiLOs0lpMuc+F65n5
PZiLw67VYsa3KXGwh+lvjtzUJvrvf0ce7iGcKT88bdnaNU1TOHBOrCyh8z3q
J1M+9vMFpviKXgyS7vcaXVZB7XeaKWIFoji8mC69Q4XyPSmmfOmfecj+tDzk
tYuXsEMI/T97mdvQI4r+h6CvdqvbWOD9atR3CRztv0z5tJLv5CdKjuSAtOe6
GWVpaFw2R3QKRH9wIPY8O3zhVsT/Q3LdldLWnfa59/Vy+4l9+an4BMt5lPsF
rmCUR/gRy/NfRYlKoPH+1G/RNP32q+387P8UWv+tGfp/I8y26fbtFji8O7Qx
shnZvUx5bkz2YY12VZiCXjPke4i5n92PzhEMf1x2e97ZCuMyxBSS1Sj3btby
a3clNUJ9u8jkgxeQHb5/2zRVrSmtELQwtXFlGrKjqooEmk1msuFU/8pRdy2Q
XTH04q18lBQHPtwd5Zz0bvh8Vxb5/b7Q/5Dv9zHhyqOHPAJEWmGHQyHvVMp9
WL0jzUr9SoQ/cn128KZgxOexhg9XWt6w4e2SRE3jM8ieZMqbLeCdYP1VhAMq
O7ezrQso/sjiQFuX9Rzw/75dbMwi1P+febY9tDxbHZ60p7M6OPDc6WngCMp3
jt69Svx8YgUGop5DInfrKXXSlkYolmzDoMVzet5NynddX0cu1b6d1AJhESJb
cjEkhwqTxbiFEjFwmbMoNCeaEtci48I9fzCOzVQPiimObclgVzDFt5nsDab8
VXny/CKH4fzClXZ+sYzUY140PcY03mmk/GylyQ/T+0zrnckP+lW/+M+KV/yM
OyX/m+JOP+ON2bR448+4Yscf/M4dU1yR6Tt3f9a5yQ/y/LGddv7IdM77q3qp
Q9dOM+5KE/RzuWpfdKXUtYhZELnBkA3AZV6qGInmsZfEl9Pw72Q7PNz/2A5j
fs74K1mORWxQ6Lmp/8Id8cyUXxpLvq9Ee9+0++98GXf8I299JI9dND6Z9AzT
90aH0zN/VP8w4T+/3/bjD/aHqZ2f/aB/D+5X9eSflV/k3rotMoDNgRsBx30W
6qP9QkqF22wX4b8c1XwZ4kbxX5je3xQiy9W+jgPfcsz1JSnfcZ6ddrLVhLAX
NzVVbckTQO/bkH6oKM0P/fm7HrTf3Ui2/5XW/hyy/S209v8sfoaTE7oe6CPP
zbtp5+Z/1u8ynacz9edXcaZzefr/98+2z3S+z9T+r+L/7ny8LDJOEkKLk/zM
Q37wL+YbM/H2Z7XDhP9Z/P8qPjq1WFLyAg7bJzltkloxfL7Hr877cE+mftKf
/2l5oefrBtw6+XHQi9mif4JS57B9WYbGSBkcfO9vMdGl3H//7B/x9KEvDp4F
F8aXqqDx1kzmHMkPwuFL7+rB6RoI1z6beLX/HA7XGtN3VsxB+OWehNB5s3Ew
qF/gMvUcaj+i/EhwPTF/8X1phl4JCN8gYnPr4hUcMmQ5vh6GqJ3Hi62aioh5
T0mQHWmyEuGrXh/UfnEZhxXbD75buXr4+WU6V/pPm68m0r5NoNm3QNpDTs3/
KIdMdb3+08b1F/4XTsXH6NxWGUnYc8WsJonBwOHtH5tlKl+91nNgv8PtJFlK
3EODm3vU/BwOsHGDffs6h4/nfFqoobxAvgl0XMrC1uShe98mhjXWK9I4ENkz
6/mhJtROqXyGb78wBo93CkEFpT5J6OhT7b0mGPi+ZPtEjEH7OEbGry7T4lcH
yPhVBy1+1eCcfVZrCgYWvk7WvddR+9PdP404sAcD1oe7BaGzUPsj6wTuWN3A
4PlAz+aqMIQHvok7Oaccg/veJwuiKPVP+NMLLPz8MEiWdva+uxvhS0e5nQl5
gcG+bQv5EioQbuRxvdKmCwN/L7vnntORfmbPzjesl8ThQ7PXqo82CI8MSDYb
tRiHzvGfXipQ6oxZ1W08yL0GhyrTJXWhjxB+ZcvHUnsrQo9J5R5WYVHO12r3
8+e4EPo8wL4rgXJPeUqjJZ/pGRyib1kn+Cn9z+dzarX0nttNvNfc3NmzRnN4
e+B/6llGxuuu0+J12SeaNzvK4bCjojsniFIvt/zzc56cVTj0cfWcKqXUnTYg
45mPaPHM+TJhrk9vYpC5ePOW8RFIfiI9uU5f+oRBp0tcxqI+hLsc9ysLFcSh
xTlqjrXW8HkgWoGK9RXmzbDohq3a+IsoHhJ1y0f/Uw4LxrganZx7Ba0j0Thx
9usZGBwP/brXLIvyveyWfMGiQxhcanGap7WMUq/GYZH/hUQMyqMfXkuOoawL
y4hvH99jEDeLd35ex/D2+ZJV+1afNmyE4Je3o7iWov0alx1bGD+2Fbp5Hzrv
DEfxPUdOpmyyEhsMsqsv4FtRvGWbqF3ihVgOZLBfD7oWIf3TPkn8nKEABl82
mHf3UOokjAl/XjHwt+8yHHXdE9BPqQ+sdT5W0xeD3bsVsgp3ov57mozkKsrA
oKncNFgmDeFX1kVFz1zcDMujraM11iGe77QWKqzpaIXAe2/PJsxB835IqT8m
15UNkkPJHzitqP+j7f0fS0zigPlS1phdpUifHxH7LjQ9hAPVGfYjTO6gcUV2
r0x8jXFAkr8skNsI9b/Swudq/kIM0kv4z2S/puRPTrF4IEbYqW1yDy/qU85Z
rmSfF0yMwGDiqcV9aScRHq8GNXZLvsCruHARtzPovlhpedJb4fgWGONRJDXv
M1oXD0YllyqcZYFKSNaIcqDkgSyz+qh/nw3THIWOKJkNX69mZZV5yMbJHHAV
u7jTvALxYBEUJ8p/lgOHlrwaPzIC8XAt1fuTcy0H/HfFR0XMR+MNGcMXMmEq
Bg1fv1uaJSDcNtL4fKYpBlmlu7a1jaXEe4PCJkd6Y8DNV7lZ0hzhP8+jb9HO
o9MrL3FtP8eCwalY5tAKNN6sOT1ZccR4HVOVT7yijFfPrTOv9AgbxPVO8Lxl
o3lnqq/CVBdF/soiC6UjGOzSMNIU1kH9lOtzqrFdiMODt2Yu6mHYsPielHc/
rlri0OgUsk3ly/A4U5z/Zxytj+bf/WqcbRaP1vmJI4j54pUWUfZA86VC4vU0
/FfjAL/qjzPlUTA97ee852jatMIVmTCLoEUofq42webggvcsuBLyXIPnNZKT
8utN/R1lbNC5t2Fuvh+Sk81X975YcKoNErxtKrwKh88fu7XzmPv0RxwYZVuC
yXUj/ESqgfxkLgyMd502at6HeNslvyvadxEGleEVJpIlCPfPyps92gqDwBcO
0maylLpDXXcjvM9iEHDz0FcxSv1zBQunClVbQg8cNCiQckB64KHB7hkD5iwY
cXuCaH4H0nu3WmX1V1xmw6rrTvdzFNF4rzHIv/PENmMlXg58mVH0eOFtpAd+
1kMuoeWJCR620VfTw2BeUmx8Ikap83xA3kDTBQM58Z2nolei/j96ms93LBKD
pMIlhx/6IDyjuIod/5h43+kC1488hC9qqH7R+QGDGU4zK09Qzv1/1jeWpuWJ
8XFMQgQ3s0HKfNUbmduU8wJyXa+gresLQXsaJ3txQPr1rNstfmge/RjyxObl
ff6KZWKwNwRLVs6g2M9Fz963V2Hw+hl/8eSvlPp+cUMaL75jkKaeMa6Ckkcq
uVfnkzdhL27cGN2rvvb3eWLvaOfC6aPZTuO4CblyDAqNcEA8M+WDSZcXJO0S
xaEt742iuynlXrbHND/WDBz0eN5Jp1Pq7g5+v9shvhSHowsnyXTEILzitP0Q
jycG50V/HDPcQDmvZ8gT+7xhbc1oC8LeLuqadYESX60/OkUwfh8O8RMDV93u
/efzxAoFfCcvJuzaNz0Cu3euHz4PKl/46DoBIRwOjF2b1mRE6efWVi3Lv8Vl
Arf4WyVS4jzh5TO5bHAwK9Qy5OIMr4eZ9FX2LuvygSQcNNwD/bc4INxNs7Gq
PhMHhfS6ePXjCA9PXm6y9jEO6V4Hy138EP6mc1DZ/xkOn7kX3rx2EeG6M94n
fyrCYd/i2naZ6wiXcgllO5TgUDnF94PuLYTvYchL4U3q6We5c0BA/5Jb9Qkk
/0ER4QdypTHQ+Mo2j6XUswrOlY06T+glQ5HakYoUvbSu/qvEYAkGOmbnVOQ+
I/zpaO4vEjw4nL+vNvPykuHzwX64Pr/7jOBLz/6p0cFBhM+1OJFy+RgO9vzN
N3EJNK5rnIHNkudwyOW1X7diNsIDNqRa5FzAoXr/o89Aib8x5hmS+WAetHyw
iUq1YgmLOaDcZre/XxDxUz317v53JYRdFFEckDkR8eNaZq84sBiD1tGluXdL
Kd9LCjqxRfEkBlvEK5Y3U/JmHRjyxF4I5Y5oIdajtM/Wo7ZxCHds7PeMX4dD
DH9U9+cCyjplyM/caJ2Ta7Qfh5OmEcHv+ij6gSFPbOrpFctkJnAgQuGRqEER
0v9R+Q1z+6M44Jctbroyl7LfTeQpmsuHgfRBJ+MFzmi8lgz5Yz/zVE/R8lSn
xFk9dpuJw72PHnnHTyHcoWZ90mOCB1MXhf0yFB6Y8scK07cv6xPkgKrddvxt
Kuq/5VUvzWWnOdBUMnbviWBKHSGGvDKr4qUOpp0YyE7YnhaliH733MamS7PH
4jD7QqK+reHweWUrp/ImGwhwIFHl9oniZNQfpnyz+CK301E1GPDfW6SYTKnP
xmS3M+X/M92z8IjbOmLxSw6087ADDo0b/jyR6d598IJObxNivznotf/VOcr3
LKSOw+huSwzeTbK4cVMK9Z/pHtPNvCB+tzOE383dMTKG8v0dgyFrh4I04n3d
42zvlN/7ubE0P9fm6gabBYR/ZXanZkiNUteX6Z7aow2zTkUQdrbrCWfdbMr3
lZj8fcwn7bDNVEKf71xpI3IY4feK1eYfWYLD2TVXFHSiEP6rerWhL7FQjvCD
bnbrbdA0o/A2lLp4F7GvtMc8dl5VhdqPSnndg+3F4W3YiUuWPQh/7fvm1ToP
HLb75Ox7T8kXqm2Znajui0Nqpe1g00yEM9nzP/dNpz+4b15m2DeZ9se3x99H
zE3Eobu0NltuL8KNqpo8XDJwsHv55FWKB8KbtHbbKD3CQTX/U8beswh3+H6x
8ko+oR/Y849/u4Dw12JLwsSJ/TFT3y8yO+o/N97F9GS6r7rgqBePqA4O0/la
LQYo+bRMci6NNZ382kysl1PW8k2j0fu6urFas0YT9tVzrso3lHt/jPdMB8cG
rHJugZCqkoIVPsjvEJ1w6KFOFws8a77NTOeh1DVlWO8jLFbzv/El7Hz++sbi
XaifkoVH68yzCD18uS6wg2JXP/YPEZQl7IMK1s58s97h/U03mWUxO9ybYMSF
1e8LuFH+jxtUGj660Qpe2YV+T28hfyFi3KjXZhvYUDf5wzbzONR/Jr3XUZLs
nTQTg6jT5vGZDxDeprPFI9AaA7O9T1aLTUX9FLJxO3UxFINlGVODhFwQrse7
p9CMmC/ukoQRayjzVW+n9nmhcQucCo/gvF6HeJaAC2WeW1ngE1925CkL+Xfl
F6fNmHeJ8GdNrgW/n4r8Oyb9X7NcbIT/aw5ICXywuyaK+v+4YI5ErggGm5dd
E1h0nvLdomWW3ONWYxB/otHsMeXek6pe2SzvIxjMDjn3OIsSDzleEJxofg2D
R981n4v7DT9f+qGXDybyN4MQ59OVNBx9vyZ0v2x1zM5WmDP/1UWFOWi+NPXd
tQbesaCIJ8Svsgj59S3J6+UuEn59n+OiGbIUv55pfyy46+q7h/DrLnlvUfHd
Q9HPOqPSvj3mwNrxnk+3UPJsE8T1jnkT/tf4tXHKjo6U7xz5a4QmEfae2Rb7
w4oUew/LVj7VR/j1EnWOuqPkEQ+uY9anG57DQCuscJWbDcXfJ/Mkx9LyJGVL
uyMTHjRBpEmT5+5mJM/qZN3LfFrdy7lk3cs2Wt1LpjzbpMGORUELMRA19c8x
p8Qtd4K/0l7nVsifcK86iZJXyeRHuDPUWWXKc9hFtl9Aa3/Din1icIwFSybl
Lbqg3DQsP0Y56fJyhL037m3lobV3KfXkyTqfU2h1PofIOp9BtDqfcZd02rjH
NQFrX8D9nGM1v+uPOq0/tmT+czYt/5kp3iVM5hOm0vIJfzWOx3ifl127cZ4y
Bh5cptnj7w8fr3tBvu9Oe5+pn0zxw189P6W3N5ycMNWZ2WbfsuULFw6xM3d3
H1JD+MXOrUWK2jh4cBfmb04dfl9zdbwefbajCeyHJr/bfgfpn1/NT7hByk8b
TX6Y6rn9P662qEA=
           "], VertexNormals -> CompressedData["
1:eJzsvHk0lm/bNqxooJRUClEJqSRJktSOUlFkKhTNqRRRRCRDkkLKXBkyz/M8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           "]], {AxesLabel -> {
            Text[
             Style["u", Large, Bold, 
              GrayLevel[0]]], 
            Text[
             Style["v", Large, Bold, 
              GrayLevel[0]]], 
            Text[
             Style["|v|\[Kappa](u)", Large, Bold, 
              GrayLevel[0]]]}, PlotRange -> All, ImageSize -> Medium, Axes -> 
          True, BoxRatios -> {1, 1, 0.4}, Lighting -> "Neutral", 
          Method -> {"RotationControl" -> "Globe"}, 
          PlotRange -> {{0, 5}, {-10, 10}, {0., 4.516805571219527}}, 
          PlotRangePadding -> {
            Scaled[0.02], 
            Scaled[0.02], 
            Scaled[0.02]}}], $CellContext`g3 = Graphics[{{{}, {}, {
            Hue[0.67, 0.6, 0.6], 
            Hue[37/50], 
            Line[CompressedData["
1:eJwVkGk81fkDhe1FiH7zV8TNUilkqZBJnW9EqaaFpEgK7SHGlkhKobpGJUlT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             "]]}}}, {AxesLabel -> {
            Text[
             Style["u", Large, Bold, 
              GrayLevel[0]]], 
            Text[
             Style["\[Kappa](u)", Large, Bold, 
              GrayLevel[0]]]}, PlotRange -> All, ImageSize -> Small, 
          AspectRatio -> GoldenRatio^(-1), Axes -> True, 
          AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, Method -> {}, 
          PlotRange -> {{0, 5}, {0., 0.8916249006017011}}, PlotRangeClipping -> 
          True, PlotRangePadding -> {
            Scaled[0.02], 
            Scaled[0.02]}}], $CellContext`g4 = Graphics[{{{}, {}, {
            Hue[0.67, 0.6, 0.6], 
            Hue[37/50], 
            Line[CompressedData["
1:eJxF1fs313ccwPGvb7RvUXLNV3L7mrOUdHLSSHu/MWETRpicpbl0nLLwldL5
oplr5my5z+0cvq7fI5k5LnNq7/fmVhhdSd9GUQodc09OZts5L+/PD8/z+BOe
RoHhniF8Ho93+b/+N+7V8fn1dREF8YREe0n+XkRB7LZj9G3LOxEFsaF1xFr4
goiC+I/0LMGzCREFsWD/kD79U0RBnHPh9OffFokoiGsVoip4h0UUxEohTgeF
XxlTEGs87gyTZhpREHu2Fwbt6TGkIJb8fTTs2rgBBXHrpcKz9e76FMRuWd6G
/xToURA7ldxyc36jS0Fc1X15MMpfSEF8KilHa6BmJwVx/OlNN5Q1tCmIeeYG
xCFZk4L4yfcFqbWP1CmI9baGyhbt1SiIzx0yU5LrqVIQBx0eqWlvV6YgNoux
WT9fIaAgLvvLq+OynRIF8asELVsnHT4FcVvuR46vfdYIiA5MDi9alCwTEH3a
Jt+y5jNLQBQhq19R0xgnIDqw/Xyi/bMxAqI58b7tUXVjBERiW5noodMYAVH0
gNQtL/Y5AdHC1F6XQ32jBESbE1dKj4mHCYhSXaObq1WGCYgE2vO9gurHBERb
ZdPLPfIhAiLVgRFXd8dBAiKdXZ0rvjoPCIh8zojK7sfeISBKj4xKy2q6TUB0
K7Y93HOmm4DIJDvok/sBXQRE86Rcfs++nYBI39J5n1StjYAo2eX1qlFiKwHR
m4C0O2WLzQREbRm3z5QNNRIQ1fVl2tsdqSUgkry7N4r1awiIXEzV47BCJQFR
77pJ+JUfSgiIQv0qZfEn8gmIFBs/fBGnm0lAhIWuR1dpMgHR7E8FwXMFYgKi
WH5O57GP/Zj7C4O6Na2uMEeEDTPKqhlML8vHN1PscpjNw77fpUoKmdvotKjj
ZCkz8sy5yY6cKqbUeq9rZ4OM+VBl+kZn/3Vmsd8hm6CkBiaP17Qe9FsLs7tv
ON3S6zYzNOZJt//eO0yBiVwxaVMP8zPJ0/iHjb3Mvj2j4mjNAWaog7hOPnWf
GVZ6KXf39WGmjfnvv3jkjzP5F7WeBgtnmR+oeCQEziwzE58NOojL15g/F6V4
xM8r4A3DpcE7XvgoMU+dLdydmiBgXv3iorVlsTJTUTN34srqduZQb/Jskqoa
01sSaFXYrs4MU5427j+pyTSo7crbPKXFlLQ6eKkW7WRGVIU1W1kImSr8w4H7
X+oyHb85kWuWrcfU+XV3uKOJPjNLnJZ5YMiA6Znibl7SbMg080/yrogzYg5O
bJFmexsz+wNf2qkbiJjPFatXco05F6tC64WmnMLpaT0jc87gqPm3Fkc4VxPX
6477cppWCnWv/shp7SS/q5LN6TpZnHotjzPS3HApv4TzZpPp3apaTs8uy5SO
bs6Q0CVb517OmK0tC739nCVuNl8/eMT5ehDbjo1zrsbwF0JecW7b1SGbnOI8
GOC0c26O01FhS/+FJc4vy3uSVlY4zzpmHIl9z7nx3Q3/BQVWjYY=
             "]]}}}, {AxesLabel -> {
            Text[
             Style["v", Large, Bold, 
              GrayLevel[0]]], 
            Text[
             Style["|v|", Large, Bold, 
              GrayLevel[0]]]}, PlotRange -> All, ImageSize -> Small, 
          AspectRatio -> GoldenRatio^(-1), Axes -> True, 
          AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, Method -> {}, 
          PlotRange -> {{-10, 10}, {0., 9.999999591836735}}, 
          PlotRangeClipping -> True, PlotRangePadding -> {
            Scaled[0.02], 
            Scaled[0.02]}}], $CellContext`g5 = Row[{"\[Kappa](u) ", "=", 
          TraditionalForm[
          Sqrt[1/($CellContext`u (1 + $CellContext`u)^2)]/Sqrt[2]], 
          " \[DoubleRightArrow] \!\(\*SubsuperscriptBox[\(\[Integral]\), \(u1\
\), \(u2\)]\)\[Kappa](u)\[DifferentialD]u = ", 
          TraditionalForm[Sqrt[2] ArcTan[
             Sqrt[5]]]}], $CellContext`g6 = 
       Row[{" \!\(\*SubsuperscriptBox[\(\[Integral]\), \(v1\), \(v2\)]\)|v|\
\[DifferentialD]v = ", 
          TraditionalForm[100]}], $CellContext`g7 = Column[{
          Row[{"Rozwa\:017cmy krzyw\:0105 \[Rho](u) ", "=", 
            
            TraditionalForm[{$CellContext`u - Log[1 + $CellContext`u], 
              Sqrt[2] (2 Sqrt[$CellContext`u] - 2 ArcTan[
                 Sqrt[$CellContext`u]]), 
              Log[1 + $CellContext`u]}], ", zaznaczon\:0105 na czerwono."}], 
          Row[{"Powierzchnia utworzona przez styczne do tej krzywej to"}], 
          Row[{"r(u,v) = \[Rho](u) + v\[CenterDot]\[Rho]'(u) = ", 
            
            TraditionalForm[{($CellContext`u (
                 1 + $CellContext`u + $CellContext`v))/(1 + $CellContext`u) - 
              Log[1 + $CellContext`u], (
               Sqrt[2] (
                Sqrt[$CellContext`u] (2 + 2 $CellContext`u + $CellContext`v) - 
                2 (1 + $CellContext`u) ArcTan[
                  Sqrt[$CellContext`u]]))/(
              1 + $CellContext`u), $CellContext`v/(1 + $CellContext`u) + 
              Log[1 + $CellContext`u]}], "."}], 
          
          Row[{"Rozwa\:017cmy p\[LSlash]at wyznaczony przez \
\!\(\*SubscriptBox[\(u\), \(1\)]\)\[LessEqual] u \[LessEqual] \
\!\(\*SubscriptBox[\(u\), \(2\)]\), \!\(\*SubscriptBox[\(v\), \(1\)]\)\
\[LessEqual] v \[LessEqual] \!\(\*SubscriptBox[\(v\), \(2\)]\) i zaznaczmy go \
na fioletowo na rysunku po lewej. "}], 
          
          Row[{"Pole p\[LSlash]ata to \
\!\(\*SubsuperscriptBox[\(\[Integral]\), SubscriptBox[\(v\), \(1\)], \
SubscriptBox[\(v\), \(2\)]]\)\!\(\*SubsuperscriptBox[\(\[Integral]\), \
SubscriptBox[\(u\), \(1\)], SubscriptBox[\(u\), \(2\)]]\)|v \[Kappa](u)|du dv \
= \!\(\*SubsuperscriptBox[\(\[Integral]\), SubscriptBox[\(v\), \(1\)], \
SubscriptBox[\(v\), \(2\)]]\)|v|dv\[CenterDot]\!\(\*SubsuperscriptBox[\(\
\[Integral]\), SubscriptBox[\(u\), \(1\)], SubscriptBox[\(u\), \(2\)]]\)\
\[Kappa](u) du ", "=", 100, "\[CenterDot]", Sqrt[2] ArcTan[
              Sqrt[5]], "=", 
            TraditionalForm[100 Sqrt[2] ArcTan[
               Sqrt[5]]], "."}]}]}; Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.6052044975585194`*^9, {3.6052046260288672`*^9, 3.605204644915948*^9}, 
   3.605205084567094*^9, 3.60520528311145*^9, 3.6052053530504503`*^9}]
}, Open  ]]
},
WindowSize->{1867, 885},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 6015, 192, 505, "Text"],
Cell[CellGroupData[{
Cell[6597, 216, 24396, 573, 1620, "Input"],
Cell[30996, 791, 427764, 7122, 1014, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
