(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    755829,      14379]
NotebookOptionsPosition[    746125,      14083]
NotebookOutlinePosition[    747819,      14131]
CellTagsIndexPosition[    747738,      14126]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[TextData[StyleBox["Wycena opcji i parametr\[OAcute]w greckich za pomoc\
\:0105 modelu dwumianowego skalibrowanego do rynku",
 FontSize->56]], "Title",
 CellChangeTimes->{
  3.559948400406288*^9, {3.599754276407556*^9, 3.5997542978677835`*^9}}],

Cell[TextData[StyleBox["Agnieszka Segiet\nMiko\[LSlash]aj Stelmach\nJakub \
\:015awi\:0119cicki\nWydzia\[LSlash] Matematyki, Informatyki i Mechaniki UW",
 FontSize->36]], "Subtitle",
 CellChangeTimes->{{3.599754368583828*^9, 3.5997543851097736`*^9}, {
  3.5997544161075463`*^9, 3.5997544320394573`*^9}, {3.5997545923156247`*^9, 
  3.599754594888772*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Autorzy:", "Section",
 CellChangeTimes->{{3.59975825066951*^9, 3.599758254305718*^9}}],

Cell[CellGroupData[{

Cell["\<\
Agnieszka Segiet - kalibracja do modelu Blacka-Sholesa, wycena opcji \
europejskich i ameryka\:0144skich, prezentacja\
\>", "Item",
 CellChangeTimes->{{3.5997582742328577`*^9, 3.599758344295865*^9}}],

Cell["\<\
Miko\[LSlash]aj Stelmach - opis problemu, kalibracja do danych rynkowych, \
wycena opcji zale\:017cnych od trajektorii\
\>", "Item",
 CellChangeTimes->{{3.5997583602517776`*^9, 3.599758409456592*^9}, {
  3.5997584409873953`*^9, 3.5997584980466595`*^9}}],

Cell["\<\
Jakub \:015awi\:0119cicki - wyznaczanie parametr\[OAcute]w greckich, \
rysowanie drzew dwumianowych, scalenie stworzonych funkcji w modu\[LSlash] \
Manipulate\
\>", "Item",
 CellChangeTimes->{{3.599758500127778*^9, 3.5997585928830833`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Kontakt:", "Section",
 CellChangeTimes->{{3.5997580166611257`*^9, 3.5997580191412673`*^9}}],

Cell[CellGroupData[{

Cell["as290688@students.mimuw.edu.pl", "Item",
 CellChangeTimes->{{3.5997580476548986`*^9, 3.599758057529463*^9}, 
   3.5997581143967156`*^9}],

Cell["ms250936@students.mimuw.edu.pl", "Item",
 CellChangeTimes->{3.5997581066392717`*^9}],

Cell["js292355@students.mimuw.edu.pl", "Item",
 CellChangeTimes->{{3.5997580771775866`*^9, 3.599758084907029*^9}, 
   3.5997581227291927`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Projekt zosta\[LSlash] wykonany przez \
autor\[OAcute]w. Autorzy zgadzaj\:0105 si\:0119 na zamieszczenie projektu na \
stornie internetowej kursu w Moodle. ",
 FontSize->18]], "Text",
 CellChangeTimes->{{3.600015530033068*^9, 3.600015595790682*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Opis problemu", "Section",
 CellChangeTimes->{{3.599758664169161*^9, 3.599758669696477*^9}}],

Cell[TextData[{
 StyleBox["Wst\:0119p. ",
  FontWeight->"Bold"],
 "Model dwumianowy jest najpopularniejszym obok Blacka-Scholesa modelem rynku \
finansowego u\:017cywanym do wyceny instrument\[OAcute]w pochodnych (np. \
opcji). W podstawowej, najbardziej uproszczonej wersji tego modelu mamy dwa \
aktywa:\n\[Bullet] aktywo bezryzykowne (obligacja, rachunek bankowy) ze sta\
\[LSlash]\:0105 stop\:0105 oprocentowania. Jest to zmienna deterministyczna - \
w dowolnym momencie w przysz\[LSlash]o\:015bci mo\:017cemy \
powiedzie\[CAcute], jaka b\:0119dzie jej warto\:015b\[CAcute].\n\[Bullet] \
aktywo obarczone ryzykiem (akcja) - jest to proces stochastyczny.\nModel \
dwumianowy jest modelem z czasem dyskretnym, tj. takim, w kt\[OAcute]rym \
znamy ceny instrument\[OAcute]w finansowych jedynie w sko\:0144czonej ilo\
\:015bci moment\[OAcute]w czasowych."
}], "Text",
 CellChangeTimes->{{3.5986350055226564`*^9, 3.5986350309351006`*^9}, {
  3.598635090230805*^9, 3.598635097157217*^9}, {3.598635168371342*^9, 
  3.598635255996696*^9}, {3.5986366228625703`*^9, 3.5986366445428104`*^9}, {
  3.598636807567135*^9, 3.598637059930569*^9}, {3.5989785940265017`*^9, 
  3.598978601776512*^9}},
 TextJustification->1.],

Cell[TextData[{
 StyleBox["Formalne wyprowadzenie.",
  FontWeight->"Bold"],
 " Za\[LSlash]\[OAcute]\:017cmy, \:017ce mamy sko\:0144czony \
przedzia\[LSlash] czasowy [0; ",
 StyleBox["T",
  FontSlant->"Italic"],
 "], na kt\[OAcute]rym chcemy modelowa\[CAcute] ceny aktywa. \
Przedzia\[LSlash] ten dzielimy na ",
 StyleBox["N",
  FontSlant->"Italic"],
 " okres\[OAcute]w o r\[OAcute]wnej d\[LSlash]ugo\:015bci ",
 StyleBox["dt",
  FontSlant->"Italic"],
 " = ",
 Cell[BoxData[
  FormBox[
   FractionBox["T", "N"], TraditionalForm]]],
 "ka\:017cdy. Proces cen rachunku bankowego opisany jest w \
nast\:0119puj\:0105cy spos\[OAcute]b:\n\[Bullet] ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["B", "0"], TraditionalForm]]],
 " = 1, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["B", 
    RowBox[{"n", " ", 
     StyleBox["dt",
      FontSlant->"Italic"]}]], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["B", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"n", " ", "-", " ", "1"}], ")"}], " ", 
     StyleBox["dt",
      FontSlant->"Italic"]}]], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"r", " ", 
     StyleBox["dt",
      FontSlant->"Italic"]}]], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["e", 
    RowBox[{"r", " ", "n", " ", 
     StyleBox["dt",
      FontSlant->"Italic"]}]], TraditionalForm]]],
 " dla ",
 StyleBox["n",
  FontSlant->"Italic"],
 " = 1, 2, ..., ",
 StyleBox["N",
  FontSlant->"Italic"],
 ".\nZ kolei w przypadku akcji zak\[LSlash]adamy, \:017ce w ka\:017cdym \
okresie s\:0105 dwie mo\:017cliwo\:015bci: jej cena ",
 StyleBox["S",
  FontSlant->"Italic"],
 " zwi\:0119kszy si\:0119 ",
 StyleBox["u",
  FontSlant->"Italic"],
 " razy (z prawdopodobie\:0144stwem ",
 StyleBox["p",
  FontSlant->"Italic"],
 ") lub ",
 StyleBox["d",
  FontSlant->"Italic"],
 " razy (z prawdopodobie\:0144stwem ",
 StyleBox["1 - p",
  FontSlant->"Italic"],
 "). Naj\[LSlash]atwiej jej dynamik\:0119 przedstawi\[CAcute] obrazowo na \
tzw. drzewie dwumianowym:"
}], "Text",
 CellChangeTimes->{{3.5986370694301124`*^9, 3.5986373834910755`*^9}, {
   3.598637473065199*^9, 3.598637532371591*^9}, {3.59863756591851*^9, 
   3.598637657771764*^9}, {3.598637842381323*^9, 3.5986378910461063`*^9}, {
   3.598637930637371*^9, 3.598638035474367*^9}, {3.598640510305045*^9, 
   3.5986405308350735`*^9}, 3.599844016395491*^9},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"(*", " ", 
   RowBox[{"Najpierw", " ", "wykres", " ", "samego", " ", "drzewa"}], " ", 
   "*)"}], 
  RowBox[{
   RowBox[{"TreePlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\)\>\"", "\[Rule]", 
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) d\>\""}], ",", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\)\>\"", "\[Rule]", 
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) u\>\""}], ",", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) d\>\"", "\[Rule]", 
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) \!\(\*SuperscriptBox[\(d\), \
\(2\)]\)\>\""}], ",", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) d\>\"", "\[Rule]", 
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) u d\>\""}], ",", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) u\>\"", "\[Rule]", " ", 
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) u d\>\""}], ",", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) u\>\"", "\[Rule]", " ", 
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) \!\(\*SuperscriptBox[\(u\), \
\(2\)]\)\>\""}]}], "}"}], ",", 
     RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", 
     RowBox[{"VertexCoordinateRules", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\)\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) u\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}], ",", 
        RowBox[{"\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) d\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) \!\(\*SuperscriptBox[\(u\), \
\(2\)]\)\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2"}], "}"}]}], ",", 
        RowBox[{"\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) u d\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}]}], ",", 
        RowBox[{
        "\"\<\!\(\*SubscriptBox[\(S\), \(0\)]\) \!\(\*SuperscriptBox[\(d\), \
\(2\)]\)\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", 
           RowBox[{"-", "2"}]}], "}"}]}]}], "}"}]}]}], "]"}], ",", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Potem", " ", "naniesienie", " ", "prawdopodobie\:0144stw", " ", "i", " ",
      "wyp\[LSlash]at", " ", "z", " ", "opcji", " ", "na", " ", "wykres"}], 
    " ", "*)"}], 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Text", "[", 
       RowBox[{"\"\<p\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.8"}], "}"}]}], "]"}], ",", 
      RowBox[{"Text", "[", 
       RowBox[{"\"\<1 - p\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"0.5", ",", 
          RowBox[{"-", "0.8"}]}], "}"}]}], "]"}], ",", "Red", ",", 
      RowBox[{"Text", "[", 
       RowBox[{
       "\"\<(\!\(\*SubscriptBox[\(S\), \(0\)]\) \!\(\*SuperscriptBox[\(u\), \
\(2\)]\) - K\!\(\*SuperscriptBox[\()\), \(+\)]\)\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"2.75", ",", "2"}], "}"}]}], "]"}], ",", 
      RowBox[{"Text", "[", 
       RowBox[{
       "\"\<(\!\(\*SubscriptBox[\(S\), \(0\)]\) u d - \
K\!\(\*SuperscriptBox[\()\), \(+\)]\)\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"2.75", ",", "0"}], "}"}]}], "]"}], ",", 
      RowBox[{"Text", "[", 
       RowBox[{
       "\"\<(\!\(\*SubscriptBox[\(S\), \(0\)]\) \!\(\*SuperscriptBox[\(d\), \
\(2\)]\) - K\!\(\*SuperscriptBox[\()\), \(+\)]\)\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"2.75", ",", 
          RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"(*", " ", 
    RowBox[{"Na", " ", "koniec", " ", "dodanie", " ", "podpisu"}], " ", 
    "*)"}], 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"Style", "[", 
     RowBox[{
     "\"\<na czerwono zaznaczona wyp\[LSlash]ata z opcji call o cenie \
wykonania K\>\"", ",", "Red"}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.598546669724182*^9, 3.598546721074119*^9}, {
  3.5985485352068815`*^9, 3.5985486492334037`*^9}, {3.5985486830353365`*^9, 
  3.5985488547051563`*^9}, {3.5985489944541492`*^9, 3.598548994767167*^9}, {
  3.598549155269347*^9, 3.59854919431158*^9}, {3.598549245499508*^9, 
  3.5985494308631105`*^9}, {3.5985495478628025`*^9, 3.598549548733852*^9}, {
  3.5985501721145077`*^9, 3.598550271755206*^9}, {3.5986349886122265`*^9, 
  3.5986350006086473`*^9}, {3.5986381204202256`*^9, 3.598638203404972*^9}, {
  3.59864103677982*^9, 3.5986410776598773`*^9}, {3.598641152209982*^9, 
  3.598641156899988*^9}, {3.5986412323000937`*^9, 3.5986412641901383`*^9}, {
  3.598641329180229*^9, 3.59864132963023*^9}, {3.598642594493001*^9, 
  3.5986426643830986`*^9}, {3.598962349493351*^9, 3.5989623642733717`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   TagBox[
    GraphicsComplexBox[{{0., 0.}, {1., -1.}, {1., 1.}, {2., -2.}, {2., 0.}, {
     2., 2.}}, {
      {RGBColor[0.5, 0., 0.], 
       LineBox[{{1, 2}, {1, 3}, {2, 4}, {2, 5}, {3, 5}, {3, 6}}]}, {InsetBox[
        FrameBox["\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\)\"\>",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 1], InsetBox[
        FrameBox["\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) d\"\>",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 2], InsetBox[
        FrameBox["\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) u\"\>",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 3], InsetBox[
        FrameBox["\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) \
\\!\\(\\*SuperscriptBox[\\(d\\), \\(2\\)]\\)\"\>",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 4], InsetBox[
        FrameBox["\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) u d\"\>",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 5], InsetBox[
        FrameBox["\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) \
\\!\\(\\*SuperscriptBox[\\(u\\), \\(2\\)]\\)\"\>",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 6]}}],
    Annotation[#, 
     VertexCoordinateRules -> {{0., 0.}, {1., -1.}, {1., 1.}, {2., -2.}, {2., 
      0.}, {2., 2.}}]& ], {InsetBox["\<\"p\"\>", {0.5, 0.8}], 
    InsetBox["\<\"1 - p\"\>", {0.5, -0.8}], 
    {RGBColor[1, 0, 0], 
     InsetBox["\<\"(\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) \
\\!\\(\\*SuperscriptBox[\\(u\\), \\(2\\)]\\) - \
K\\!\\(\\*SuperscriptBox[\\()\\), \\(+\\)]\\)\"\>", {2.75, 2}], 
     InsetBox["\<\"(\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) u d - \
K\\!\\(\\*SuperscriptBox[\\()\\), \\(+\\)]\\)\"\>", {2.75, 0}], 
     InsetBox["\<\"(\\!\\(\\*SubscriptBox[\\(S\\), \\(0\\)]\\) \
\\!\\(\\*SuperscriptBox[\\(d\\), \\(2\\)]\\) - \
K\\!\\(\\*SuperscriptBox[\\()\\), \\(+\\)]\\)\"\>", {2.75, -2}]}}},
  AspectRatio->1.4142135623730951`,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"na czerwono zaznaczona wyp\[LSlash]ata z opcji call o cenie wykonania \
K\"", 
     RGBColor[1, 0, 0], StripOnInput -> False], TraditionalForm],
  FrameTicks->None,
  ImageSize->Medium,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{
  3.5985491113748364`*^9, 3.5985491958276668`*^9, 3.598549254191005*^9, {
   3.598549309439165*^9, 3.5985493268971634`*^9}, {3.598549357340905*^9, 
   3.5985493972751894`*^9}, 3.598549431116125*^9, 3.5985495492968845`*^9, {
   3.598550229768805*^9, 3.598550272223233*^9}, {3.5986349902190294`*^9, 
   3.5986350011234484`*^9}, 3.598638124376452*^9, 3.598638156776305*^9, 
   3.5986382038629985`*^9, 3.598641079139879*^9, {3.598641153809984*^9, 
   3.598641157519989*^9}, {3.598641233490095*^9, 3.5986412647201395`*^9}, 
   3.598641330140231*^9, {3.5989623555733595`*^9, 3.5989623648133726`*^9}, 
   3.5998418606331453`*^9, {3.599844029155509*^9, 3.599844053155543*^9}},
 TextAlignment->Center]
}, {2}]],

Cell[TextData[{
 "Parametrami do ustalenia w naszym modelu s\:0105 wi\:0119c ",
 StyleBox["N",
  FontSlant->"Italic"],
 ", ",
 StyleBox["r",
  FontSlant->"Italic"],
 ", ",
 StyleBox["u",
  FontSlant->"Italic"],
 ", ",
 StyleBox["d",
  FontSlant->"Italic"],
 ", ",
 StyleBox["p",
  FontSlant->"Italic"],
 ". Nie mog\:0105 jednak one przyjmowa\[CAcute] dowolnych warto\:015bci, gdy\
\:017c mo\:017ce to prowadzi\[CAcute] do arbitra\:017cu."
}], "Text",
 CellChangeTimes->{{3.5986385231073933`*^9, 3.5986385948392873`*^9}},
 TextJustification->1.],

Cell[TextData[{
 StyleBox["Arbitra\:017c.",
  FontWeight->"Bold"],
 " W pewnym uproszczeniu, arbitra\:017cem nazywamy sytuacj\:0119, w kt\
\[OAcute]rej na pewno nie mo\:017cemy straci\[CAcute], a czasem mo\:017cemy \
zyska\[CAcute], nie anga\:017cuj\:0105c w\[LSlash]asnych \
\:015brodk\[OAcute]w. Poni\:017cej przedstawiony jest przypadek \
jednookresowego modelu dwumianowego, kt\[OAcute]ry prowadzi do arbitra\:017cu:"
}], "Text",
 CellChangeTimes->{{3.5986382733419724`*^9, 3.5986382789612937`*^9}, {
  3.598638325434952*^9, 3.5986383392897444`*^9}, {3.598638390021646*^9, 
  3.598638414956917*^9}, {3.5986384554169736`*^9, 3.598638462776984*^9}, {
  3.5986386142993145`*^9, 3.5986386694893913`*^9}, {3.5986388071095843`*^9, 
  3.598638836369625*^9}, {3.598639901154192*^9, 3.5986399015141926`*^9}},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"wykres", " ", "zbudowany", " ", "jak", " ", "poprzedni"}], " ", 
   "*)"}], 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"TreePlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", "1.1"}], ",", 
        RowBox[{"1", "\[Rule]", "1.2"}]}], "}"}], ",", 
      RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "Tiny"}], ",", 
      RowBox[{"VertexCoordinateRules", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], ",", 
         RowBox[{"1.2", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"3", ",", "1"}], "}"}]}], ",", 
         RowBox[{"1.1", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"3", ",", 
            RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]}]}], "]"}], ",", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Text", "[", 
        RowBox[{"0.5", ",", 
         RowBox[{"{", 
          RowBox[{"1.25", ",", "0.8"}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{"0.5", ",", 
         RowBox[{"{", 
          RowBox[{"1.25", ",", 
           RowBox[{"-", "0.8"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Dodatkowo", " ", "na", " ", "koniec", " ", "dodane", " ", 
         "parametry", " ", "modelu"}], " ", "*)"}], 
       RowBox[{"Text", "[", 
        RowBox[{"\"\<N = 1\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"5.5", ",", "1"}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{"\"\<r = 0.05\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"6.25", ",", "0.5"}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{"\"\<u = 1.2\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", "0"}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{"\"\<d = 1.1\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", 
           RowBox[{"-", "0.5"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{"\"\<p = 0.5\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5986389026997185`*^9, 3.5986389708398137`*^9}, {
  3.5986390342299023`*^9, 3.598639087730977*^9}, {3.598639212278369*^9, 
  3.5986393510183835`*^9}, {3.5986426830231247`*^9, 3.598642711033164*^9}, {
  3.5989624006834226`*^9, 3.59896248446354*^9}, {3.5989788040767956`*^9, 
  3.598978835316839*^9}}],

Cell[BoxData[
 GraphicsBox[{
   TagBox[GraphicsComplexBox[{{0., 0.}, {3., -1.}, {3., 1.}}, {
      {RGBColor[0.5, 0., 0.], LineBox[{{1, 2}, {1, 3}}]}, {InsetBox[
        FrameBox["1",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 1], InsetBox[
        FrameBox["1.1`",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 2], InsetBox[
        FrameBox["1.2`",
         Background->RGBColor[1, 1, 0.8],
         FrameStyle->RGBColor[0.94, 0.85, 0.36],
         StripOnInput->False], 3]}}],
    Annotation[#, 
     VertexCoordinateRules -> {{0., 0.}, {3., -1.}, {3., 1.}}]& ], {
    InsetBox["0.5`", {1.25, 0.8}], InsetBox["0.5`", {1.25, -0.8}], 
    InsetBox["\<\"N = 1\"\>", {5.5, 1}], 
    InsetBox["\<\"r = 0.05\"\>", {6.25, 0.5}], 
    InsetBox["\<\"u = 1.2\"\>", {6, 0}], 
    InsetBox["\<\"d = 1.1\"\>", {6, -0.5}], 
    InsetBox["\<\"p = 0.5\"\>", {6, -1}]}},
  AspectRatio->0.816496580927726,
  FrameTicks->None,
  ImageSize->Tiny,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{{3.598638967549809*^9, 3.598638971299814*^9}, {
   3.598639061740941*^9, 3.598639088350978*^9}, {3.598639226649191*^9, 
   3.598639351358384*^9}, {3.5989624019134245`*^9, 3.5989624847535405`*^9}, {
   3.5989788186068163`*^9, 3.59897883591684*^9}, 3.5998418639931498`*^9, 
   3.5998440695355654`*^9}]
}, {2}]],

Cell[TextData[{
 "Strategia arbitra\:017cowa przedstawia si\:0119 nast\:0119puj\:0105co: na \
pocz\:0105tku zapo\:017cyczamy si\:0119 w banku na kwot\:0119 1 i kupujemy za \
t\:0119 kwot\:0119 jedn\:0105 akcj\:0119. Po jednym okresie akcja w \
najgorszym wypadku warta jest 1,1, za\:015b do banku oddajemy tylko ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"0", ",", "05"}]], TraditionalForm]]],
 "\[TildeTilde] 1,05, czyli zawsze zanotujemy zysk bez anga\:017cowania \
\:015brodk\[OAcute]w."
}], "Text",
 CellChangeTimes->{{3.59863936969841*^9, 3.5986394408885098`*^9}, {
  3.5986397800940228`*^9, 3.598639865644142*^9}, {3.599844204985755*^9, 
  3.599844211855765*^9}},
 TextJustification->1.],

Cell[TextData[{
 StyleBox["Wycena.",
  FontWeight->"Bold"],
 " Klasyczne twierdzenia dotycz\:0105ce rynk\[OAcute]w instrument\[OAcute]w \
pochodnych opieraj\:0105 si\:0119 na tzw. bezarbitra\:017cowej metodzie \
wyceny."
}], "Text",
 CellChangeTimes->{{3.598639874374154*^9, 3.598639908174202*^9}},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[TextData[{
 "Twierdzenie. Model dwumianowy jest bezarbitra\:017cowy wtedy i tylko wtedy, \
gdy ",
 StyleBox["d",
  FontSlant->"Italic"],
 " < ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"r", " ", 
     StyleBox["dt",
      FontSlant->"Italic"]}]], TraditionalForm]]],
 " < ",
 StyleBox["u",
  FontSlant->"Italic"],
 "."
}], "ItemNumbered",
 CellChangeTimes->{{3.5986400577444115`*^9, 3.5986400591244135`*^9}, {
   3.5986401138244896`*^9, 3.5986401519645433`*^9}, 3.598640183584587*^9, {
   3.5986403714848504`*^9, 3.5986404142549105`*^9}},
 TextJustification->1.],

Cell[TextData[{
 "Twierdzenie. Je\:015bli model dwumianowy jest bezarbitra\:017cowy, to \
istnieje prawdopodobie\:0144stwo ",
 StyleBox["p",
  FontSlant->"Italic"],
 ", przy kt\[OAcute]rym proces zdyskontowany ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    SubscriptBox["S", 
     RowBox[{"n", " ", 
      StyleBox["dt",
       FontSlant->"Italic"]}]], 
    SubscriptBox["B", 
     RowBox[{"n", " ", 
      StyleBox["dt",
       FontSlant->"Italic"]}]]], TraditionalForm]]],
 ", ",
 StyleBox["n",
  FontSlant->"Italic"],
 " = 0, 1, ..., ",
 StyleBox["N ",
  FontSlant->"Italic"],
 "jest martynga\[LSlash]em."
}], "ItemNumbered",
 CellChangeTimes->{{3.5986404724249916`*^9, 3.598640489245015*^9}, {
  3.5986405532851048`*^9, 3.5986405650261216`*^9}, {3.5986406047361774`*^9, 
  3.598640712056327*^9}, {3.598640749126379*^9, 3.5986407491363792`*^9}, {
  3.598978900986931*^9, 3.5989789051869373`*^9}},
 TextJustification->1.],

Cell[TextData[{
 "Dla instrumentu pochodnego daj\:0105cego wyp\[LSlash]at\:0119 ",
 Cell[BoxData[
  FormBox[
   RowBox[{"f", "(", 
    SubscriptBox["S", "T"], ")"}], TraditionalForm]]],
 " (np. ",
 StyleBox["f ",
  FontSlant->"Italic"],
 "(",
 StyleBox["x",
  FontSlant->"Italic"],
 ") = (",
 StyleBox["x",
  FontSlant->"Italic"],
 " - ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"K", ")"}], "+"], TraditionalForm]]],
 " dla opcji call) sprawiedliwa cena wynosi ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "r"}], " ", "T"}]], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"k", "=", "0"}], "N"], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   RowBox[{"(", GridBox[{
      {"N"},
      {"k"}
     }], ")"}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["p", "k"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", "p"}], ")"}], 
     RowBox[{"N", " ", "-", " ", "k"}]], "f"}], TraditionalForm]]],
 "(",
 Cell[BoxData[
  FormBox[
   SubscriptBox["S", "0"], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["u", "k"], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["d", 
    RowBox[{"N", " ", "-", " ", "k"}]], TraditionalForm]]],
 "), gdzie ",
 StyleBox["p",
  FontSlant->"Italic"],
 " pochodzi z Twierdzenia 2."
}], "ItemNumbered",
 CellChangeTimes->{{3.5986413805503016`*^9, 3.5986414506203995`*^9}, {
  3.598641481880443*^9, 3.5986416176806335`*^9}, {3.5986416512806807`*^9, 
  3.5986416684907045`*^9}, {3.59864198661115*^9, 3.598642048621237*^9}},
 TextJustification->1.]
}, Open  ]],

Cell[TextData[{
 "Oznacza to, \:017ce wybieraj\:0105c odpowiednio ",
 StyleBox["N",
  FontSlant->"Italic"],
 ", ",
 StyleBox["u",
  FontSlant->"Italic"],
 " i ",
 StyleBox["d",
  FontSlant->"Italic"],
 " tak, by spe\[LSlash]nione by\[LSlash]y nier\[OAcute]wno\:015bci z \
Twierdzenia 1, mo\:017cemy obliczy\[CAcute] ",
 StyleBox["p",
  FontSlant->"Italic"],
 " tak, by otrzyma\[CAcute] bezarbitra\:017cowy model rynku. Dalsze rozwa\
\:017cania na temat wyboru ",
 StyleBox["N",
  FontSlant->"Italic"],
 ", ",
 StyleBox["u",
  FontSlant->"Italic"],
 " i ",
 StyleBox["d",
  FontSlant->"Italic"],
 " przedstawione b\:0119d\:0105 w nast\:0119pnych cz\:0119\:015bciach \
prezentacji."
}], "Text",
 CellChangeTimes->{{3.5986420600112524`*^9, 3.5986421315823526`*^9}, {
  3.598642206572458*^9, 3.598642253752524*^9}, {3.599845510678583*^9, 
  3.5998455165385914`*^9}},
 TextJustification->1.]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["\<\
Inicjalizacja warto\:015bci pocz\:0105tkowych\
\>", "Section",
 CellChangeTimes->{{3.5997587847270565`*^9, 3.5997587983688364`*^9}}],

Cell["\<\
Na pocz\:0105tku przyjmijmy sp\[OAcute]\[LSlash]k\:0119, kt\[OAcute]r\:0105 b\
\:0119dziemy bada\[CAcute] oraz ilo\:015b\[CAcute] dni, za jakie \
b\:0119dziemy sprawdza\[CAcute] jej zmienno\:015b\[CAcute]:\
\>", "Text",
 CellChangeTimes->{{3.598971073379565*^9, 3.5989711129696198`*^9}, {
  3.599759443644234*^9, 3.5997594734269376`*^9}, {3.5998419678932953`*^9, 
  3.5998419699232984`*^9}},
 TextJustification->1.],

Cell[BoxData[
 RowBox[{
  RowBox[{"Firm", "=", 
   RowBox[{"ToString", "[", 
    RowBox[{
    "Input", "[", "\"\<Podaj ticker sp\[OAcute]\[LSlash]ki\>\"", "]"}], 
    "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DaysN", "=", 
   RowBox[{
   "Input", "[", "\"\<Podaj liczb\:0119 dni (od 2 do 350)\>\"", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.599759489606863*^9, 3.599759498505372*^9}, {
  3.5997595595888658`*^9, 3.5997595658192225`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Kalibracja do danych rynkowych", "Section",
 CellChangeTimes->{{3.5997588456785426`*^9, 3.5997588594763317`*^9}}],

Cell["\<\
Kalibracja modelu dwumianowego odb\:0119dzie si\:0119 w dw\[OAcute]ch \
krokach. Z samych danych rynkowych wyliczone zostan\:0105 pocz\:0105tkowo \
parametry modelu Blacka-Scholesa, podczas gdy potem z nich zostan\:0105 \
wyliczone parametry modelu dwumianowego, daj\:0105c ko\:0144cowy rezultat.\
\>", "Text",
 CellChangeTimes->{{3.598966835673048*^9, 3.598966866963092*^9}, {
   3.598966913884157*^9, 3.598967030944321*^9}, {3.5998420295333815`*^9, 
   3.5998420992434797`*^9}, {3.5998421535135555`*^9, 
   3.5998421941636124`*^9}, {3.599842545635104*^9, 3.599842546455106*^9}, {
   3.5998426448452435`*^9, 3.5998426650552716`*^9}, 3.599845868429084*^9},
 TextJustification->1.],

Cell[CellGroupData[{

Cell["\<\
Przypomnijmy, \:017ce w modelu Blacka-Scholesa cena dana jest za pomoc\:0105 \
stochastycznego r\[OAcute]wnania r\[OAcute]\:017cniczkowego:\
\>", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.598967125382763*^9, 3.598967258239679*^9}, {
  3.598967333099784*^9, 3.598967390599864*^9}},
 TextJustification->1.],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"d", 
    FormBox[
     SubscriptBox["S", "t"],
     TraditionalForm]}], "=", 
   RowBox[{
    RowBox[{"r", 
     FormBox[
      SubscriptBox["S", "t"],
      TraditionalForm], "dt"}], "+", 
    RowBox[{"\[Sigma]", 
     FormBox[
      RowBox[{" ", 
       SubscriptBox["S", "t"]}],
      TraditionalForm], "d", 
     FormBox[
      SubscriptBox["W", "t"],
      TraditionalForm]}]}]}], ","}]], "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.598967335439787*^9, 3.598967390599864*^9}},
 TextAlignment->Center],

Cell[TextData[{
 "gdzie ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["S", "t"], TraditionalForm]]],
 " to cena akcji, ",
 StyleBox["r",
  FontSlant->"Italic"],
 " - wolna od ryzyka stopa procentowa, \[Sigma] - tzw. zmienno\:015b\[CAcute] \
instrumentu finansowego, za\:015b ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "t"], TraditionalForm]]],
 " to standardowy proces Wienera. St\:0105d, aby otrzyma\[CAcute] wyniki \
numeryczne w modelu dwumianowym, nale\:017cy ustali\[CAcute] (znale\:017a\
\[CAcute]) warto\:015bci ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["S", "0"], TraditionalForm]]],
 ", ",
 StyleBox["r",
  FontSlant->"Italic"],
 " oraz \[Sigma]."
}], "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.598967364779828*^9, 3.598967390599864*^9}, {
  3.598970835382193*^9, 3.598970931822328*^9}, {3.5989709935673733`*^9, 
  3.5989710705095606`*^9}, {3.599842742975381*^9, 3.5998427471053867`*^9}},
 TextJustification->1.]
}, Open  ]],

Cell[TextData[{
 StyleBox["Cena pocz\:0105tkowa akcji.",
  FontWeight->"Bold"],
 " Ten parametr jest naj\[LSlash]atwiejszy do ustalenia - jest on obserwowany \
bezpo\:015brednio na rynku. Dla naszej sp\[OAcute]\[LSlash]ki:"
}], "Text",
 CellChangeTimes->{{3.598971073379565*^9, 3.5989711129696198`*^9}, {
  3.5998457029988527`*^9, 3.5998457087788606`*^9}},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S0", "=", 
  RowBox[{"FinancialData", "[", "Firm", "]"}]}]], "Input",
 CellChangeTimes->{{3.598971129489643*^9, 3.5989711358596525`*^9}, {
  3.5997594255031967`*^9, 3.599759426190236*^9}}],

Cell[BoxData["500.75`"], "Output",
 CellChangeTimes->{
  3.6000301032565565`*^9, {3.6000301667846823`*^9, 3.6000302097481728`*^9}, 
   3.600070891196789*^9, 3.600073238283659*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["Wolna od ryzyka stopa procentowa.",
  FontWeight->"Bold"],
 " Wolna od ryzyka stopa procentowa jest wyidealizowanym konceptem \
finansowym. W\:015br\[OAcute]d ekonomist\[OAcute]w nie ma zgody co to tego, w \
jaki spos\[OAcute]b mo\:017ce by\[CAcute] ona wyliczana. Jednym z \
najprostszych jest wyliczenie tej stopy z obligacji emitowanych przez dane pa\
\:0144stwo."
}], "Text",
 CellChangeTimes->{{3.5989711757297077`*^9, 3.59897119847974*^9}, {
  3.5989713260629916`*^9, 3.598971337023007*^9}, {3.5989714549352107`*^9, 
  3.5989715041652794`*^9}},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WolframAlpha", "[", 
  "\"\<United States treasury bill 3-month on January 9,2014\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.598623652202972*^9, 3.5986236539428787`*^9}, {
  3.598623751526848*^9, 3.598623752534627*^9}, {3.5986238618795767`*^9, 
  3.5986238644711447`*^9}, {3.5986240879272957`*^9, 3.598624117862949*^9}, {
  3.598624201543518*^9, 3.598624206583167*^9}, {3.598624255591765*^9, 
  3.598624258551297*^9}, {3.5986243528877983`*^9, 3.598624353087852*^9}}],

Cell[BoxData[
 NamespaceBox["WolframAlphaQueryResults",
  DynamicModuleBox[{Typeset`q$$ = 
   "United States treasury bill 3-month on January 9,2014", Typeset`opts$$ = {
   AppearanceElements -> {
     "Warnings", "Assumptions", "Brand", "Pods", "PodMenus", "Unsuccessful", 
      "Sources"}}, Typeset`elements$$ = {
   "Warnings", "Assumptions", "Brand", "Pods", "PodMenus", "Unsuccessful", 
    "Sources"}, Typeset`pod1$$ = XMLElement[
   "pod", {"title" -> "Input interpretation", "scanner" -> "Identity", "id" -> 
     "Input", "position" -> "100", "error" -> "false", "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            TagBox[
             FormBox[
              TagBox[
               GridBox[{{
                  PaneBox[
                   StyleBox[
                    TagBox[
                    GridBox[{{
                    StyleBox[
                    TagBox[
                    TagBox["\"United States\"", 
                    $CellContext`TagBoxWrapper[
                    "Entity" -> {$CellContext`EconomicData, "UnitedStates"}]],
                     Identity], {
                    LineIndent -> 0, LineSpacing -> {0.9, 0, 1.5}}], 
                    "\"treasury security\""}}, 
                    GridBoxBackground -> {"Columns" -> {
                    GrayLevel[0.949], None}, "Rows" -> {{None}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    ColumnsEqual -> False, RowsEqual -> False, 
                    GridBoxDividers -> {"Columns" -> {
                    GrayLevel[0.84], 
                    GrayLevel[0.84], 
                    GrayLevel[0.84]}, "Rows" -> {{
                    GrayLevel[0.84]}}, 
                    "RowsIndexed" -> {
                    1 -> GrayLevel[0.84], -1 -> GrayLevel[0.84]}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {2, 2, 2}, "Rows" -> {{1}}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Baseline}}}, 
                    AllowScriptLevelChange -> False, BaselinePosition -> 1], 
                    $CellContext`TagBoxWrapper["Separator" -> " | "]], 
                    LineSpacing -> {1, 0, 1.5}, LineIndent -> 0], 
                   BaselinePosition -> Center], 
                  PaneBox[
                   StyleBox[
                    TagBox[
                    GridBox[{{
                    FormBox[
                    TagBox["\"Thursday, January 9, 2014\"", Identity], 
                    TraditionalForm]}, {"\"constant maturity\""}, {
                    "\"daily\""}, {"\"3\[Hyphen]month\""}, {"\"bill\""}}, 
                    GridBoxBackground -> {
                    "Columns" -> {None}, "Rows" -> {{None}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    ColumnsEqual -> False, RowsEqual -> False, 
                    GridBoxDividers -> {"Columns" -> {
                    GrayLevel[0.84], 
                    GrayLevel[0.84]}, "Rows" -> {{
                    GrayLevel[0.84]}}, 
                    "RowsIndexed" -> {
                    1 -> GrayLevel[0.84], -1 -> GrayLevel[0.84]}}, 
                    GridBoxSpacings -> {"Columns" -> {2, 2}, "Rows" -> {{1}}},
                     GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Baseline}}}, 
                    AllowScriptLevelChange -> False, BaselinePosition -> 
                    Automatic], 
                    $CellContext`TagBoxWrapper["Separator" -> " | "]], 
                    LineSpacing -> {1, 0, 1.5}, LineIndent -> 0], 
                   BaselinePosition -> Center]}}, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                ColumnsEqual -> False, RowsEqual -> False, 
                GridBoxSpacings -> {"Columns" -> {{
                    AbsoluteThickness[-1]}}, "Rows" -> {{0}}}, 
                AllowScriptLevelChange -> False], 
               $CellContext`TagBoxWrapper["Separator" -> " | "]], 
              TraditionalForm], 
             PolynomialForm[#, TraditionalOrder -> False]& ], 
            TraditionalForm]], "Output"]}], 
       XMLElement[
       "dataformats", {}, {"plaintext,computabledata,formatteddata"}]}]}], 
   Typeset`pod2$$ = XMLElement[
   "pod", {"title" -> "Result", "scanner" -> "Data", "id" -> "Result", 
     "position" -> "200", "error" -> "false", "numsubpods" -> "1", "primary" -> 
     "true"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            StyleBox[
             TemplateBox[{
               StyleBox[
                TagBox[
                 TagBox[
                  TagBox[
                   RowBox[{
                    TagBox["0.04", 
                    $CellContext`TagBoxWrapper["StringBoxes" -> "0.04"]], 
                    "\[NoBreak]", 
                    StyleBox[
                    "\"%\"", FontFamily -> "Helvetica", FontSize -> 
                    Smaller]}], Identity], #& , SyntaxForm -> Dot], "Unit", 
                 SyntaxForm -> Dot], 
                LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 0, 
                ZeroWidthTimes -> False], "\"  \"", 
               StyleBox[
                RowBox[{"\"(\"", "\[NoBreak]", 
                  FormBox[
                   TagBox["\"January 9, 2014\"", Identity], TraditionalForm], 
                  "\[NoBreak]", "\")\""}], {
                FontFamily -> "Verdana", FontSize -> 10, 
                 GrayLevel[0.5], LinebreakAdjustments -> {1, 100, 1, 0, 100}, 
                 LineIndent -> 0}, StripOnInput -> False]}, "RowDefault"], 
             LineIndent -> 0], TraditionalForm]], "Output"]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,computabledata,formatteddata,numberdata,quantitydata"}]}]}]\
, Typeset`pod3$$ = XMLElement[
   "pod", {"title" -> "History", "scanner" -> "Data", "id" -> 
     "History:Treasury:EconomicData", "position" -> "300", "error" -> "false",
      "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["cell", {"compressed" -> True, "string" -> False}, {
         Cell[
          BoxData[
           FormBox[
            TemplateBox[{
              GraphicsBox[
               GraphicsComplexBox[CompressedData["
1:eJxMfHk8Vd33v6nM03W5ZtecqIgiDWetQiKShETRpCghiZJUUikVmZIpMiRE
JEolNIuSilKpO99MITL2u8/z9Xz8zj9e+7XP2Wefu896D2vtQ3PbfuedAnx8
fJ8pfHz//K2JszFRtqXhI+nSRwcf6EPLQFlJqwcNB54l5r7XnguBsU626vtp
GH3WRln4ChXSXXSTZE/Q0BXmHf7mQQXn9Quq8xJpaL33qEYLkwqXowJGmwpp
qPAm7eyZu9qw9ceP7qv3aXhqsKlA74oWVIWen5psoWE3dWGp/ZQ2pC73Z/LR
aeiV8as/qk8XZpkfi7o5TMOmnJQd0W6aMLntuQVHjI5jkbddHzKoEPXYJrdZ
jY6rOZK/6vvU4ILzGM3FmI6GzMp9j1TVQV+BtjLAio5WuKuogl8F7CT4XRa4
0ZFhK+tuY6AIf8xcTp70p6OA/bqipB55MLnUeSbsGB1tvx8ml66mwG+1NJBP
oOPdM2anzl2igNXX8wrW+XQMSJkd8vmGPKi/rcxUraHj9rHfN9X2UODksKz1
6dd0/MQXtmIpTRkOOF5/nPCdjjYBTooakhrQ2+7fbz3Eu98jwWOqVZowlLR7
+XkRBn7MDVwu9pEK0afSlh1WYeD7+A6jomQNyCrgJ4nOZyDfvwcVrCcyZhmu
ZCB932Rj4nMNCD25/+aQCwNpc+zdxk6qw8LlofvX72Fgl5Pvl6UhShBucFt0
3VEGbv9QK/RqowLY22q7Dl1k4OFU4bLtO+Wh8MqLOqPrDCw6up9zWF4aLqnl
fZG4y8DzhY66Al2SINB2503cC975T28d8mwWhb+149+vfWFgyeIdwwkWonC6
PTTPq5+B+Ubbpmw2CEOanv7pYiEmkkj2oRPuImBRIKGSS2Gi+ee50jY/RcDH
Q/+U5VwmLjharLfNSxLk4ZDkzhVMnJA/KBDDlgUX94nV5uuZqCqgIXbAiwLq
uVXZ6TuZuPtO5Ne8MAocoOa35IQz0TOPHPPKUQGc37wsczrPRKMrAZtHx+Sh
9rZOWXw2EyUdD0rbVJOh/FmFz+EKJpavt+Y+NuStr3QYR/ApE6vVT/1cz+tf
djboIvUTE689P+V0tIcMrYuyWfRuJop458y+eoYMg2ShLcv4Wfhwea9zmLQ8
ZOllFJnJs1AgVedEwlUyfPDzv9Gmz8JH7gmqWkvJkPI94KnwMhZ6O9mxqitl
gBZbkPTDkYVKV7u2li4lwb1d8iedtrOwe/0/MyCB6sFqm62HWLhsdJSW6koG
0apLtfKxvPa3/R/KbyvAcYNMp62ZLPzcpi22ahMFolu6kp3KWVhclny6a7YS
kArdK340sHDV6cY9DsFkMKyY1SvczsIThnTiNkUSWvpZn9q4LLR95T76MkAA
Jr3/Msz+srC2N6n7dNQ4USW49tkiOTZ6/vUaU5kaJ8baX3t81WXjjvgyRQ/H
ceJFV7SEsiUb/w2H7wOEtkpQ4ORaNoZabCc9KfxFiJxJKDq+lXf9xfrfczz7
iDB9jsCVA2yMUd8r/MK9lzgwGiLpHsPG1x3Ht9zZ2EeMTi5aXJTGxuv/vO65
fwixRUay10vYqKjf3NCUyQ95mW71K+rYuE61/lKr+Wx4ZVkdv7eNjV6D26L1
lCUgQtRRbiWLjRyW554fP6WhWkypomicjeyP1WaJt0hwbIWSQaU0B90MNNOK
vcnw9rrj+p1aHGRFM8ddFpChdHlNyo3FHHSI3uf62IwMCqKbLiWt4WCgoAWp
blIORIXnb9Xy5OD2WIGDnQvEIcbcYu3KQA7KuUglRg8MExfSDv0UPclBgz6f
s6zUSULTuLtwRwoHp5JoaSnHPhHEn6Rl3jc5mByxMnvj4EuCPRByQvAhB9Ou
/HO8IFSpZ5lLWjn4btvc4OZNt4nPx1onKAzeeP/+gLWELmk9J3mEg9sYF634
+SuJsQ9CQ4XiXBwiy54KC6gjPJp7yrapc1Ho8gLP7AONhNUf8fO3FnIxwuxO
/n3DQqLGZavSdWsuHvlnuQ4nEjU0VsQSdy6KMxJGQqg3CKu8vCmfvVz8prfE
b/XeKsLjSurChce40/OrIcYf1UUnXeaiRVqW1vH6CkJfSb3kSgEXuW+2upgH
5hNfr5edtr43M/7q4JpMiRYufuW4c0SOXCes6o7sD11Pw1mXL3rl2cyF7Id8
R/7soKH9kw52S4YhxPTd600Jo+Ei71459loqjDgX5W8+R8O5e7cF1fZRYYDd
7F6TScPkPVGtCkpaEF4+54DZbRqu/uY3tM9EC2KL7/5uekLDYtR9evyPFuh/
OhL8t4OGf2yDt06F6YCj5UFT1x7e9fNXeVcv1QX+17meL/noaGKRzRBTp8KK
BOHezWQ6rlzOXFz4XA2EY7MbZPXpmCco07bPUw08KgMu+1jSp+NTDSxkg181
O9Ax9RPDR8xQCa5lF/lv8qHjpeZLFlox8pC4TXF25EE6HoibWCfjpQBybvfp
T8/QcejSIfX2QxRQjbxsOC+djvVvq1saepSg/GP2p7JbdJwXdVbXvoICb7bT
fq1voGOfcNbn29KKcERrs2DcRzpat1NjfG+qQZmcyKZuLh2D+Pa88hqkQpA5
V2HPFB0rHpmuLP2sCbVx/MsFSQwMOTV3wDCTCgkKjgWPdRhYSws5J7FdAwbe
togrWzCwznJqao0yFb4+imm/aM/A7IFFn4z4NcClK1hSeysDn54Yr709Sw1c
TROXOR1gYE3lk12beinwo5p761oMA8X+JSgKjAWGnpNJY+Dp/g2bUjtIkL7Z
vCW9hIFDl6u46WUy8CJsnptDHQMPkWVX6awVg6jn7h0p7xjIT1KstvUXgQa7
moa/TAY2rlcw7ZQXgUt/HRVOjTHQ4fWNPT7WosBhKr3Vl2Kib66+HbJEoIlP
+U0vlYlXmkK61G6JwVKHdS/WmfHwWmfjtqEfMmDWVDO3eTUPz9sCzq0kyFBz
dNPQns1MfHAlU2LDEAWe+8yvztrPxK55Mq4jNQqwLcyibvQEE5lHbrprd8nD
6ceHjIOSmXipPinX/hgZFi/vFpldxES1WU/6+6vIEPQzSfdRLROvBvW1lrXw
+ptClpHeMLGov/oUXiPD6W9n7p+gMVHadvHf1bz+bbqtOTIjTBwjmUccv0SG
FxlO0RbiLOwvqMrP+kuGe7ZCRdHqLGxb6Y3Xqbzx9HrMe01YuDhjXR/3uxws
Xyw+/6A1Cz8ppX7wsSNBc9iW80qbWHhgc+eP9GRZ+NnDpLvt443X4CL9ZEIO
EpKuH78XxeODjvH1XmoK8GR/SoxlIgsPhUoq9BIUOBHxaPBjAQsnJA7VNGkr
wav7qnlX7vH4Qmk5e1meIky+Dd0R8J2FB98VXDXfIwHMwgNdQr9Z+G3XmiVT
i/4SHrfzXBeJsjFqoIeWYjlJuPdKyMaq8vhg98SCAyvHiR+eN0wnFrCx5Wi8
/Pz4QWJ48vDDc6vYeHBhTPxGnQEi+e3xOMKVjeRMnTJ32R6i7uMD17g97Gn+
7SVCZRac+RMx06468l7z+KX/+GGIOKFUrq1/nY1P/WLWvTo+SVR3CxdtfMnG
/MLR/QN/hUFH66Tzxy9sJB1vWqDcIQHKsabbQ3+xsWr2QnjHlYV0HaWAW7M4
KGq6YVuSjxwU/jJ9IKHEwRgyo9//nBzAr5Mhp404eLm5RNYthrd+2qKJGsBB
I06CfFCMHMicaRj57MzDd52S5kBfGbDVqNi4cBcHRdqqslY3iYAY56NKfjgH
V269uYhSPUa4M0zszOM4qLi46miY8DhhTH4cvO0aB1WHFhzce6qOSDx46lt5
JQfDl738W7TmCXFC9Fil+nMOmv57NBATLSW/Cj9zUChi8JOXSRHB90L2gFsv
ZxpvG4lLQ0W9WfxcvHk5YNGdZw1EkXN46yx5Lh54+aVwilpPrKNFqJ+dw8Ws
aKkHX96WEZH5d1oNlnGx+ebZZ4zy28SSdO1XvY4z+B3Z+PSBwzYevmf+1eJ3
rCHWaWQpvjw4wwdFxcWft5/logs4RdasvE/E7+1LTcng4irVnwoHXe4SAlt9
0/rK/hvvOpEgvkjuRuN/198gpvR8nJ6vpeFEh5oC3WkeVLe7JzK20vDlqdN+
EZJzYLz2lMrnAzz/sKAlad1GDXj5jpVRFUPDklmZNq2PNEBL7diZW1do2OV3
7W5tJRVmX7Gviiqh4WurV7CqQwtCVjsEVdbR0DjYXzUpVAsC5kRXT7XR8JVM
iqHrNx0YXNp//iabhtp7n98ZWKYHgifie++N0zAuue1FIZkKmWO+l3OkeX7C
nLTXypwKjXkHTAO16Kj1UZZEUlODkJOVSzcvouMaX3Pb7HZVKLs897T6Gjq6
ZeuIiu9XhNAP77daedLxPd9SLd84Cjy1r2qMCqRjZVyRvleaAuQMvqrSiKbj
5eOF175fVQCRZoXFmil0LBg2V2uXU4KxT8l/xoroaGZtz+0SpcAh5bW25g/p
OKu71+3RHwocO79YJ7aVjpqZnzT8VVSBZOIaRzDp6LP8qfmjWCoYi9w86TbK
4wvdg3Yim7SgXXbRg9WSDMyyiux+70AFccehX2pUBprW7Vm1sV8DnteyL8ia
Mnh87D66VpIKpC2k/V9sZvwFwySoU9yDgdcW5ebPuaUGVhazPjgFMDAu313h
VbYizA9q9vxz/L/zKZDT2RQokMT4n57OOcz3nF7IwPucQZKYhTQY2e9RLrnP
wG2CubmqS6QAHYXfJzQz8ITs2PqV+2fB95OfWp1+MPCft4dcKgwS3T+8gn4z
MP2u/9Pv2qJQH0M18hNlolvb6Pm1XGEQcLn821aVicfn7Ar9ZCUCzRuW6lsv
YGJsxYIGD2dZ0IlRTFdaxUR2xqw37BISzP45N9PJlYncJDtXzi2efzgRbJTp
x0RBltqSwyIU8Fvbt9oxkon8rb4+2R3y0G17rd87nonUMx0vZQzIMHroTKd9
HhPVH0abXttHhviO6w2q1UwkzE21jJ+SoXLfMEn8FXPav8nBNrOjeW+/MnGN
7ZooWx15SJu35MnYL+a0vpOHLZvmBlnOZmGU1y6KsKk8FN91KupUYuHLZfYp
FhvIEGNbHPjdiIUD33Kex68iA1d8+eGHwMJ9kvxD621I0M4vKDu1gYXbz1/g
W0kmgfPcKVOX3SzcUPKAK5dBArdT8+kSETx+CaDpuY2SgUVK1JxzkYVDfNsX
bPGlgMC7+TkquTw/EckfNlCiCIVPptR+32GhuMLhz6w8JUhcucLgficLo8N2
Wz02koRPTSVfuvtYGFGoXPHtIj8Un3VWXyTExkUOnpnNSyYI4XCj7m8UNr7k
z7xjUjZO9KYtXd0zl43RWcLSiiljhHffMUbrCjauOvvH3urrAOEZOhqZuZ6N
8ySdAx8n9xP0BYVRp3ewcde/Ry8xonL+iW0YG+X/fSF6iUTLvJS959iIgg9I
/LK/iIfnBot3Z/Hu97Z8oM9znCh9smCx3RM2vl8+YR2zSBjCStUGNDvYmBgk
6HeYIQ6vXsBSz2426gRZrn56QQaKKFdkSvg4GP1ndavrRjkgp+od8CZz8G+0
dvNOGTKI2HO2hepz8FMnc/USjhycMf6etGMpB5fQDi/xfisHl22lGi0cOVh8
zYvMNyUGcy4Hesz14eA5nVnzAvSFwVZGxGwohIOf3TPS2/yHiMFHbWnUMxzk
/zdeJog5OR/itqdzMNLxq82OoUSCWyUpJVrGwbbV0csd7r0kFk2Fq8g2cND5
34B6TkiEqez99YGDYek5gv3WBUSAzsDduxwOrrJ8tHfx+kbCQ3DK/+oEB4MX
HXKUDm8kWsnEdjcZ7jR/1hFt7ndYB7W5+K5kVNZS+iHh0+J9a6/5DP6Hh2Hw
GruZtqqLW8YqLy4G50SPvJGqIuy25YgrBHHxYXjo9sqgGkIgV0vYPpr7P79i
o9B+ITmVi6lE14WerdUEubY+16p4Bv8t2oMdDj3iTuNDJhG7KfmCjisNlecu
Xb5vmRGcuV7oI+5Hw6Tc7RTbP7ogq9X/2OUoDXPSMrbkBlJBp3XvLb5LNFyl
d1vUb6km1FeqGzTk0vCa2msP21Et6H4xy5hdRcOQ1+Mxd2y0IFtW6zDjJQ2H
ne7ohvhoQ9e5A0Z832holiBDKmzRgSKLsQ6+ARoe7KQL367Ugr+Uqpcds+gY
26tzaF+DJnwzKLCVV6KjInf8le8SNbALeL2hwpCOHctrzte/VANgzPnpS/Dw
XOOLGbFRDR5fqJE+5kzHxWJ7WRaLlKHJ79ihgF10VB358uB1PU9PhB9efeQw
T/8bJ0d12PH8+70iUkAcHRPylD27yihgPF9Gc8k1OuazbSdjU1Rgd1tR7a5K
Ol6M02vVUFCEuSWHr+59TkedhdYRJwSU4VD1sR8XO+kox1+cIcNVg3XDNTpX
+nj8Me+DYYCcJtzeZVB0WJCBqSuqqCUrNCFbtLn2oQIDlyx4IrG4XAMUvxV4
7jRg4I5ej8mdIRqgyqo6o7Wcge5L2U8vbKBCkeY4rnRi4BX9m2abFDSg4ULI
CssdDJw1Oh6Y3KAMu+dr564LY+CBY+f9Z+tRIJlPWND+HAMpzT1B86XkYf0s
ar56FgPvVknsa+TKQPKygA8utxnIIeUFKRZIwq78X5d7Ghmo90gx4skfUahb
WfQlvZ2BK8OTOtQNxSFPNrWy9Od//CIC8nL3m1P/MnBib6BYq5soyKyWC2WQ
mKgbt6SkI10UkkuyixJ1majdIztpLCoJhTbb/T2WMBGvqKsI+JHAirS55sRa
Jv6lnrx/zUUe9sqcsTvpzcSLexZLkB9QQB25q66FMDEhSnrbjZ0K4HH9uEXe
aSauLtkVv/aVPGhZOgYev8pEqS4He/lROQgRcFpUV8rrt+uyrZwkw/rJmNM+
j5loOLSBsSed5z/mDu5Ues/Ec5qns91KyFAcm/jWlM3EWe4npL84kGGumn+U
3gQTf+Y+PiPP8ytmP0JTFsvw+OCST2BbARmed9y9YaTNQvpgmufNuWRgCs7/
O7aYhcecbXwt55PgknfHd0M7FoYaLLFK2igLjX01wou2sDCmXP2vXTQJostb
kjYHs/C1GDuMs04OmvOUNXafYmHjWM7+KLY85Dal/Vx7hYUSAps9yExFENRz
sk4s5uH/iQlZcpQi9JZbGq14xMKVGVXH1x6nwC6fW1maTBZaxq+PlvIXh4Ho
JTTVMRa+H/KmtEaPEyKf/1xYJMXGG9cdm4bfjBM3tvcsMtNko+xV8619UWPE
B3UKVXwRT5/LzRrakzxInJcITbGyZWNYhucWBneAaDESS+/yYOOsccVV7p29
RPqxd0aXA/7hE/XedRt7iSGhVrvC42y8IKdrx7+sl2ivnVWclMTGBWefUYrT
hgmbgoA0RiHPj+iZe8Rp8UO9XJeaTwsbna1GtcfDROFNEvv2+R9sLPhyulHm
hjTssdM7d2mYjSsSM5b83keCCyZXXpWLcdD4wfjfF6JkWGaPwjVqPP3u7Koe
4U+GQynqMakm/+RvRBXWPuD1K5gkfLLi4GhYc4OKqBycfxZmeMyNg0XR1kLG
ZFnwvfnbydKfxwc/UGBekAA0PS4QdI/k4NV/8XCSqBW7OOqQwEHxcCLB7VcX
YRFz080nn4NHnwyw5h97R6wwmyzzqOFg/qNFj3LPPCZayNEORq85ODvs7KtN
B+4T3fpwyLuLM42npUTCPpP5IwMz/uAJwy3o+mwuOliHaf10qCdOXKrASiXu
dD7jMfFyn9XG9HkzeJ9+VGyYCVz0vB6rv84ujhh9NEsnccN//dHEd7PFX918
uXhZdHN4bUUF4dJ5VTfy8Az+O1ctLou4wMXDUfzmcruKic762bmpOdz/za+f
XyI+7c4MH3SvGGn/9IJ3/bM5xs/DywnPT+8gyI6G+7yFSpbdmQuNDCFNTy8a
DnbQWL/nzYUq7Z/lEUE0pM/L2E8eoYJpYozSjmiefhf0Kwk6QQVLc7fsuSk0
NKScixF7SoUmiS8f9W7ScMTNIWSvsTZwyYoL5jyk4aGokMC1uVqQsO7M5shW
GhrtdOgtEtaBp7UlS1yZNJy/b1P4ktu6EO15xtx0lIbNX09STDhUaJ6vyLSW
pOO1i/OOeJZTIcfUy1+DSkfb2r755rfVgN//o3T7QjoGjfi/EEpSg+622Tuf
2tDx38dXVwbvoJ8dNZvoaDT6ZId5BQW2wiwdgQA6Ri8ZuLWCrMD75ds0mo7T
8YDi8m9LtSgwddB96dVEOh4hKY/bDStAVme8cHYhHbcafPajBCrCy4NRgzfu
01F0EXtxcTYFjuP1SpE3dPzNhbGtB1Sgnjiqz6Hx+Oa+Qsa5KXW4GCh+r3mY
jsNz/lkwTWC+c5zkiDHwVO3FtJEIKjzfs5rSpMbAq/XFr4fFNMBs4UGnOGMG
ki7wBzR+0wCjee6W0VYMLJ6zkST7RANKPfpXRbkxcL2mziZKqRrcv/dA660/
j19I+2Q0bRTBxQEqco8xsLNgY9IBOQqEksK2H0lgoFSIpdgZDhl0xXY2nsln
4Fuj76lF8dKwxUx4wrOGgVrrhURepEmBVvxXZ5kmBs4X6XtsVSsMgVR/j9Fv
DFwjdmErYSgCdj+Kj7MGGKiS7mdx/ZIwlH7I3SQuzMSzNaWxdYQIZEyuExlW
YuKpJxKmUj9EQNHN5MMjIyZ2nGTp8F2VBlXaM5dHwMSpXGcX59skKLkmN9iw
gYmRS1KUvw4qwPOExF1qu3n995/fL6RSIKDq5bk/R5joFzyl5BbCWw+Jqjft
F5goPXlKRLNCHjySXJ/25jBR1SxL6PZaMlxzKk54dYeJ8UWla5zekCF4hXnk
6edMlBs4bjZaRIaWLYeUwzuZmC2Z9tokRB6qyvd+2N/HxAf03udFwvIwxzzF
974gCzX+fX/kQa8vtOgMhYWRyOmm8vREaYe45Oa5LNR6EMP6cIAMdcMbqdtX
8PD93Jod+6RJsMVm44bA9Sz8UB41IRxLgpjnZze37mShR/L9X2k1JLA8ekC+
KpyF86f016tnkyFsB6kv8zwLc8pFXa/rU2Bl5K7wB9ks7GnEEd/DPH5/uf9T
TgXPX2jM89HdqARdY9fO+Xzi+QEB8jjZXQLavtp1evewsKBesPF6KT+4/J4j
cIefjXXKSREPb40TW1bUdsTKszEwM32wf3KcGKoRertzDhsPqB0PurF9lCDv
FggPXTZTX6izvTPisI6H3xIRshGbfxHDmzOShLaxMUIxeVwMeonqa5b0/oPs
afzpJoSU45x/nGEjn4vXjQHjX0RnY2KQaAYbPadWyT86OEbMvb0qorGejUH/
yOFAYcgZ4uKzD2wUaM81yl4uAdf3rNZv4bCRLkczm3dRGkxkefw6xcaO8kdf
k7pJYPdTw1GMxMFDFie8Tu4mQ/eIyqcenf/wVw5UzF8rCC/hoNfrOJ8iVTK0
FZrOZdlz8JXpis1mYXKg6NDimb+Fg8P3HQ2a54gCS5sKV4M5GFF19rx97RAB
8/RWJZ3iTPvfEUJnj48K/QoPz43P/zY/lEUkflyfV1nyX32gibgQNuIYW8eZ
zsc+I8hrnW8ktXGm8b2c0HHe9smXxUFvV+EvBZsaiLrYgrlKYxw0nDjYuaa0
gWD+vmbIJzXDBymX16/tpnKRGxlqn81XTbRur1KTWsRFre8fe1g62QT3qkbc
Q4//+KCSeCaoM6s2gIuHjHxvDFIqifmZX9IfHudi55X8yA9n7hJU/yZRhWTu
/+aT6Rc4p+/GDP6fexjv97WWi14R/ZubVM4SLAnRY6830FCuXnfXSOFcSCx3
6T3uy2tnWi3bKWQATWc2ug8fpvH8x8GoRTy8upAgblgaR8OSrm3dSxKp8Kl5
GFZco2GwUHkjda8W3F6esv5CJQ2D/lh3ZEtqgfy3bvNNz2l4w3zJIVV+bRCq
ONRyrPOf8eRlDAJ0IKLmbszNPhrmu0wk6sbpQNRAsZyzIB0rezc7XZXUBKkt
blerFXh63aLEzCtdDeZMVJ3bZkDHHYMR109MqcLrJvtH9GV03Cf1WUG3URUm
WpJ69JzouPuVjPATPyWompX0i7adPv388jC+70X+xCEeXsd0ScpqKECTSMUR
5XN0HLogZ5q/SRH0PqzXq8ik47J/F1gZJD7kvRK/TUey3ge2/ygFjorcsvn2
hI5iOjfMT0orQ/i+nmCpT3Q86+F0OcdCHfhmfX+4soeOJRNvrCI6qEBqOdv1
i4+np5eNDBk90YTSV6wJbzIDndeOx7BOUuH92NhxOX0e/moqWt8/rgGnPVfZ
ZVoy8AubyacpS4XGfpDkODBQVGHM4FeGOpy/O5hX6sPAeZVvU4/bqMK3ss99
LQcZeNrSL9SboQC1nWGbhs8wcJlhmsjkaQXQW/oqNSWdgQcvV+fr/pEFpabW
1j+3GGhTcld3MkkGUi9ePJhRz8B/Xy+yGGSfOr5Z+QMDdyv8KtMrFQWz0jnL
3DgMFGnaUWbgKgLOoqcGpCZ5fqA4W6LroQhMJCfnxsgw8UXO8U+PJUTBxM3r
AWoz8XWT0UfRGzy9umaT8vvFzGk8lYVl+8WC59jx8Pmdc1dxChlIzwKzhr2Y
uHhJViT7GAUOrJeIpAYzcfOmIoc7vPlvkfKKWHeKicb1BKWZLg9tk9ucRlOZ
/4v/9xrqGtuLmXj9zayxVXLy4BNywVXmERP3ywQcOh3Cw9dx07dJrUyMKhkz
2V5HBuU7F2w+M2bqzzbXMuOvjjKxa2DbXxlzMkw9osXdlWRh2g8H18JLZEDZ
rzfaqSy0JocxLWvJIJUUdzXEjIXOV598nHdADnbZD5x+s5qnzwtf71dplIU1
ZhJ2BZtZ6JS3r3HyEAmq121+0LGfhYzTeuSaXXJQlrHVSfYkC6HEqPVsrjyY
qSvVNCSzMHB5bNDrFzz8f3tadXERC/ds+MWxQSXorLrJ/lnLQlOls4rdbRS4
rSQn8JzGwvqhBdcED4lDd/KH75dGWLjzTyanzXScKLdpCb4jzsaN/GGCuwPH
CT6Do9rf1Nko9yPjpY3xGNG5vOvGyYVs/AB+HsL1gwSe+jOXbc3Gf+F5+QCx
8O8T8iV3NpLbSneaJvQQpTefo8xeNp4wCyzqiesl7sRG7XE6xjv/kc3LW0O9
xOr0nl3il9l4S7Fv1ZHDQ8SOLumtMfls7El4fGvWx7/Ecr6h7Z+b2BhsaPzH
tkMExj7fEVjYxcZ72ZQj0u+kYCXX6JDgEI+vBMVDSIYkkDfsSDcW4aBQAFnn
xi05CM60/LFNhYMjO2vJ263J4Gm1flJ6AQe/x7QIrL/J43NVNbmjKzn4bVIn
XEeC57f0M+PnbeTginHD5+uVpMF9p8uGqt0cXBkSJNJzSQD83z+S/nuEgw2/
/xFkk4RYWNe1+os8vKYMPK3O6ifMHBYzvudyMPKPhOjwyTqC44K2s+9ysIJb
mbvF7ykx5yL/8byXnP/h99B4aKXQV87/8HXN1WtOBf0cJEn03Jlf2kjM3cdv
rCXERZkj/SCc0UAkBymIeVFm8P98YVcNyXBGr0uSvHecWcFFy0Gv1275GYRS
aeIhXM9FZvBDgVTnc0RZxNTr1h0zfNB6VE1DJ2zGD0SW/7LuPzdTP6iijKsp
ZnMxLmfBh8srKojwshp56wouukbuTi11SiMIXYVhfMbFhqY25atnbhPXDvRu
1VhHwwcuLBcrznwoflUsvH8bDa+tj38uGGkA4Eo9tSSUhjUaxKU7XergLbdG
S/QsDQtMGK3aTCqICRYEmqXTsM1RcUFRkyaA7r3ET7doeHORvdcrXS34G36i
Ahpo6PF5q4t/lhbY8UfJH/vI45P35ZZ6qTpAvb+wi+8njefnnvz+uk8XThSk
5a2c4vmNXSILVegaEPD0LvyVpfP0m/KXn60awKTEjtfp0JFK+hafoKUGrKvx
vl/N6RgvZypZWa4KIc6ON0Lt6Tj2pzvijZkSnF9ax2jeQkdOe3n7lKACzHPz
3fk3mMcnYkpXHrxVAI+8BocDMbzx6zWLzX4rAEnvvXHBFTo2GixfVXlVEVw7
rnI2ltDxuqO3yjtLRdB5RMlorKOjDn9WofZHRTj68fll8fd0bHuZULayRxV8
tBYMJrHpmKrbfDv4IhXeZNk5dI3T8etHWHRwuxa8XKdyNE+agfd2/HrPVqOC
48JrTfu1GFi9TjxtW6QGeK32fJ20iIGLXw96Ku2hwp8LTbmL1zDQcYd10pi/
BqiKDoSkeDKm87VqIJLkOdshmoFFWqNTTH4KNOdrRp5NYWDt97rE5eflQOPn
1Vdwk4EaJe8VpDbJwJjPK4vJBwy0LMKVKmJS4C1u7Cb/loGU3z20P8+EwZm1
xr6QzsC9Gkvf2XOEofm3ouX4CGNaz4nCh8UZU8/FmdP5YxHwLfrw46o6Ez99
TfvJx/ML0U7WYS9NmGhVENvEJy8LRgZ7aAesmdjp9Vdo70058DZbueaLO3P6
faaAerDTgPo+JlIFk/Wakyiw64ec0PUoJorZxKx+8VAeLE+dl+FcZqLbXMOe
gYdkSPW4N1BYwEThR/1C1NNkOL4tY2jfPSYeztHaJLxEHn6n3ym48JqJiTXv
k6R5+nFI9KTx3O9MJJTqViyykYfIG7MqTw0x8ZvQlwdPR8mQeOTB4RoRHt6e
ic0jn5YH06i5RcaqLAxa2FEfspgMW+6ubfNdwEJB5sI4e3kykDV12pRWsVB7
+eygS82ysOFBWfM5V9a0npQF9fPBEh/8WLhLIF9T6owchMRxbm+P5I0X3C6c
P0gG18fyLuXxLPyXHk9RoF5/5GV4HgufDz/UlPmgCPfq4nxWV7NwrYapFD1A
CWxjPz0lf2OhT/yBwNhBCei6J/MtbICFdicVltmYTBKC6hGWd2azkSqgqklK
myTKKtKnzJTZGCl0xuNh+jjBPhL8IGQeGzXj7gfZDg0TN0Mn1y9A9nT9c5AY
zV0+u28DGw+f/lTEmeQSrYIV/mK+7Gm87CEWJ3/Jzz4809bd/KBzOI49nS8f
IrKdndnPrrHxbPBsh5X244Rph0p/yzM2LntR0lyQJAyOu51yIj6z8X7CHHfZ
izx9YGC5jtPLxsWU4KfLD8mCtvomYr4gB3df6JPPXisHX63mpVYpcFDh1ICD
zxs50Mms+jllwMHsO2YKLoFk+G3wm1y//L/8ixw4s9lesU4cvLd6t/ZVlgxY
dMi6l27nYI7R7LJqT1G4MdGn73CIg3HnS3Ztth4i8p1PDtyM5eB5XcJdnzFO
GH2256NlcpBZ9ileS+oSQSS/CPW6PYP3nScnWClP/uOPJ4TQdfp8hw4OnppV
e6K+K5m4O3w8Sbibgx9MHm/NbWskfh9xKVH7O1NffmjamVZK4v6vTVJXOvlX
l4vHNKkxkkfuEv2W4vhqCReXXKBZfD6ZQjhIXCx5vpWLOvaL1lx3qSSa6qik
wANctCpLETT2riE+FPgGfYzh4rsdmctjuuuIvY9pcpSrM3xwTlJeI610hl8Y
vzYYy9TP1IuN8rUzj7jTMPza9aDDj+ZCRMpEW+JeGrqcjOuTktQG1/uxhhXH
aLjx9QHPL35UuC/bbLohgYZ7jO1Tq39pQlGajaxtPq/9ekNHsIk26LmGSK2s
oU3rCS0wtHKrDXpNQ6vIj0Kf7HWgdsf+s1HfaThLt2AsDnWh/e6yea5DtH/y
ARczNLUgcvmj4z4idHydVmy544gmlP0e/h2kQsfQlZz5rFJV2NtFUxGaT5+O
LzWonJxF+Yl0vONYmbhtRBViHL6YfHSh4/7fe1IOmCjBj5Y9k39203GDmlJZ
eoE8vIw2ZI9G0NE67Y7QRlcFWLY358bji3Q0zYaCic0UsIxpVnmUS8cVEq90
dp1Rg4bWWyWPq+h4qz+kIdKOAh/W2/SPvqRjhNQCDdcjynBQkOQs+42OTfkf
Zb4qqUMmKyG27xcdFe9tzSb5aMKGqecHBGcz8PZ8V/9Wb01IWF0ZoarEwFc9
fforKFTwbHAxv2vIwJiKVuG0Bg0oC5r7LJ9gYNSla5beXA245Hwn9KozA3el
SLzTuq0OYzt/f3iyi4Fv78RdXHNFCfpv+rm2HGZM870CBOokFWfF8fA+r+YE
n6gCRLSEVORdY+BRU8tlxYXSIFci+qmskoHd8aufqJ2RArMHG24vf8ZAmYbW
l0/MRaHrb+tWjc8MfDSc1/5kmRgoHBSeN7uXga01Sdpe6cLQrvqrSEuAiWWc
iF+xb0VAZ+SirZU88398MCFIT2Hp/7Of558AkYAtq/bVflvKxJvDicleKiRY
e+cm3xdHJur5mJ25z+PfJ5uyfktvZ2LArfNTD0op8Nz4uajWISY2tX17+HGf
Arha5g+NneXxSc3FraRNCrA/dMkl0Uzm9H5Hnn9gHLdXK2di21mR4vfO8oAx
x6pvNzAx6ZP5RYu7ZBjbdHss/SMT7xbfIfiTyUB4p3me5/L8hohopPt6np6/
Yr6/fIqJZ4ji8xEbyeAnJHbtDomFJl65Wt/ayLAuJ/5GlC4Lu5uilVLjyPAw
uHnb8SUsvH0r3IXxUBruHaxbenotC/dTnbU2TMgCcdP3Sb03C0fXLKv6FEMC
JzmrgC8hLNSbCF9dv0EOukve9zw8zcLCj5xbQnSevjiiqv7hKgu/2Aj6CmYp
QONhxYCBUl7/2aL02DJF4Ct5sf/SYxbK58bYzwuVB+Ub9suPsFmYsDjV1lxL
DP4Ep9MLJ1jT+ZsxYut+rZt3ZNh4+qzVikyXCcI508v2rDYb7Y3Y9zwSxog3
fx2SE8zZ03wzSLRfHhS8Zjej//d6OGqbeLHx3AbzmrScXiJ2w1eKQhAb07wW
6lcp9hBmx7SN+KLZKLqdT7/vTQ+x+4vaL41UNnYY+jDjKH+IOQGv31vdZGNe
V1i8Wyk/2Og3fWS+5el9r09uiRHikL9OZTuLzp7On8jApSKNLLVRNv48aODn
eIsEsy02jS2U5CDHXzfthysZZv9ZbSRN5eDOTu+eHG8yJHB/SmmacbDRiv9d
nAMZbkhby1qs5mC18ZTy8/dyYOe74cmbTZx/6h/KXSPSEPor2fHhPg7Orzsv
oCHAD/NKL46URf2H55NEQMby9R2JHNxfW/6LMjZALHtEfdlVyEHj9/GMvcQ7
4rJcjdKt+xycuyPbcVHAMyI0bbZyRctMvoe+QdSy9gcHizs8gs9m1hCdxGPx
1b9n6gHeW0pv64lykWMywLFWaSQCbjmFi6ty/9cvbFrYr2vMxduBwbKZrCJi
LqfytPWqmfx/x9vQN8yNM/UCUs++3s49XLTz3vpTPLiS+GipbNQewcW6cxLm
kaH3CL37R5RF47l42jha+1PJZUIggDRHKW8m/+O7YYtE/10uvrmddf9vejaR
5t5+/0DTTL5IzEyyxnoNDc/5T3b5TcwBu24PX4onDd9E3jc9lzoX5D6qHXUI
pOEhjalUMy1N2D208aPlSRrauOjX5b+lgo3VKiN2Em36faRC2dM89ugNGp6i
17ToLdSG60cmJX/U0vCs7ai68oAW6GwXm7fiLQ01yxYueOCoAwuOSlwyZNCw
2qNz76CfLjS+EPTsG6Hhv+F+UROYtoEXKRL0/9MbvPvFj60XHlGnT+tfdXj+
lR2ebELH4z77Db/R1SD299CGNGv6ND4pw/sVw8kh7jw9/y9/U6D4XvG7+r10
jLq4q3zlYgWQ2uPukhNFR4PtBaEDPLwfWzO63P0yHY3v9WheVqNAsJf0xeCC
//iHAiG5ymu236PjgucZ948spICA6ueJZ808vio4cm62hAooP7s09OAHfXr9
1OHh9aUbY3/TkfvTFG2KNKGncrPafVGevveUrBC6Q4X8kX6DXFUGdh16arml
Xh24e5ea2C9gTPM5FarJ41luqxjIreZQNn/XAFLfrUOWrgx84PWxn31ZDYbH
ldbE+/H0evM5AdECRdi1NHxLeCQD+U/VB67SoYB3yetO83jGtF6TB+b6lHqP
PAaarr2+TtpZGkbmfOg2q2aguUn6m/0BkpCw8KVsy0sGLreZsv9WKgzVAaaZ
r78yUN0rwXnKTRR2f4m/nPOLgXmmqqvu8fTd9cid/Z9nMXFtgRURHCcCfs6l
8U2KTBT/N95Foda9eN5RQyai/06qf6oUpMZrmCQQTDyVFHVqcTMJ+CZPZxx1
ZqLDguFG9yMUGEzLE/yyi4n0VatU+PkoEOhfXfL6MBPXVDxOTtiqAGEBdXWJ
cUysS9Dx/fRBHsSvL19ad43HJ3Os06MjyWAgYTyWU8lE30929f1e8tCa/7HC
+hkTq9rDO0jVPHwJGWpb+5mJJlHKcfus5aHxwOytc3uZOHydtDT1Jo8f8l//
OCLA0/vz399UMJCHH2KxRVsUWLj1eGCOPo9/VuYs/UwxYOEP/tr7JB5/GO3d
dmDRchb+DgrzbTIgQfbuyBADJxbC4bea13j4lp2ybn/8DhbOvr3U7RqHBIaj
8qWxYSyMePzS/140GSDu7UaPcyxUDQgeCjClwI8NAjsvZLEwc0+R7L2dFJB0
KKwOv83CVp2s3R4iSjD747tasw4WKupoJFrLSEKr75XPyt0sDKtQ/3RfTBDm
GJKHQvj+y9dPEGKa0U7eZDaGnfZQWiU1QRxaw5HX0mej77/+bYwIuN6w0nYp
G5/+7VYOyx8gBkzkKnUd2fi66Z+jn/j7i0Jt8GYjv5iNbunsPiKVHj/YGMJG
0uJlsj8/dRO1ovzGGafZuOIXQ/VQZB/h58N413GVjXtYK64obB0ldhc6ZB1/
zMb4/p9x+T9mQ1XKW86V92yc2/alM2i+BFyqscs4w2bz9KzXu4xAaRiSDLf7
OfHf/UlAT0xf+k2Ggxd6l5yuceL5Mcc7STe0ObgvuNPPTpIMOyxXubWbc3CL
tOaNRQY8f+Bu4/XQjoMjuPTH5nw5kCma8trhxUGzf/W3OFTNM3oaEMTBVJ3a
ph+tNIJFc0xZF83BtBKmQ8eWUSKnSW/b9VSe3ld2sShWfkFwWYOBscUcbH4b
8Lvw8wvi/qIqts0jDtrfU/xYk/iMUKzqeeb7jscHgzYmakU3CL49aT8JJud/
+4GCHSdE2/9wkC+xOOzEnAdE4K53F9skuPiEduFRdlY98acsK7JAg4t9ec5n
mAvqCPH539u+ms7gd+sjwVkRm7hI3X2JdruomIhpo/Nf3Med5tO7RKPKfd+w
qBn9fyHJ5tn7xJl80Q985tdYOKP/K000R+Pvz/BN8q6VI9ecaRiZX8HZ1GIA
ytVFZst30XC4VkZfcutcMFh2RvtZOG06n0uF+oFP7OjzNDRp/5sUc4gKzM8/
msazaPjKLWslpVALkke2bvOpoOGQ37azuxo04Y11q4LcM9r/6bdOXv/T0Wzi
M48P9JmpNbE6wAhX+BLVS0PVn4cbC0Z1oG7rHAspATrqrsqp1G2ngl7YLatY
eTp6rrLQWNqiCooNN/Ut59BxtuDPJ6+9VCERvAxyl9Ixa1B6eEhQDdL6T3aO
OdLRzMXFeU6CEhi9yyrN3EbH4d/8+4/y4t2WHej6IJSOeh0r/ZKFFKB/gXlZ
/1k6nkp8+nqbBwU0iwbmBGbQUSCtkzsYrQxfXbU3fC2jYxHV65DuLwroLV6T
ntpIx5CFBSkfRhRhbLXO/dftdLy5YavGHnV1cD8/dI7STcdMsfRw0jcqrBS8
d6TkL28+sc3z9vZrwp3iIdWFcgz8/dzzc8IOKlSeuZ7I1WXgfOs3DS/va8Cy
FFFDzyUMbJFdQTHVpcL6dlpw7VoGXvc/XGOmpQ799hUdu715eJ4nvtxfQQ2U
B8wVLoUw0FuEnfj4LgVaXpYLNZ1m4KbJ4vimEQWQ+UAluVxlTPtPEnySm/X2
ZSkD3xx6l9tYJAPG0Vt2HXzMQNeStOBn9mIgo79PuaON5wfkjn2tJEQhYqL/
mCGb52d2+fudPy8CQUJ+Qi/HGbgxvrhz3mIRGFjhbukmzUSmmfbgx2YRmLp5
30ZRi4nmv9si9YXEIdm+LShhEROpb5PojWMyUK22zXHclon6LUv7y2XIsEuL
sabMk4n3x37dM/hBgcxNaipdgUzc9fZY9v0LCuDdYJepE82c1hfyULp1H9xJ
YSKtStn99JgcxMyflWh2k4kDAUYj+xvJwFlAesh6wMTsd3qPvpjLw8ftbbNd
3jJRw1inUTqNDE4vxflv0Zm449JwQkUhGVy2Wyi7/mFiGLN6rVAAGejzlUXD
JFgoML9KdCiMDFNGv26UarCm/Q0Zcrwe7DExZeEOr4nRG/vkoLVu6lOODQu5
h3srswZl4bzrIn9vDxaKmDlG0XVJ0Kqu+TY1gIXOduZD1VNycE1JgMM4zvrf
80zYtGscS2Kh9F19vbkLePifry0ifIOF5m4oq6KuBC5L6E/r77NQ920QYblB
Edp/W5le/cGajncJ4GjofrcbZk3H8wQRE3Fvx0ExNvZURG+aeDJBFItbp1Wq
sfHxFseRYx7jxNbXjb2ECRv19YSdXRsGifTHNUM1VmxcsKfurvrHAWIHW/ut
rxsbicejw9SebuIurmpq9mPj90sKJd3NvUTy649hOpFsbLe091mQ1UtMnfOx
ehrPxq6myV2j3weJwQjvx6557Gn9NkUcHp6MSX3FxuOXLz7J7hUG6WPpRULf
2CiulbjqKp8UzLc07qkdYGOiSuvmf/xiu374rP7ZHPwQW/djSakcSNrebTFX
5iB32/WCO51y0JzGrX41j4MOs08s604ggyL18gZH5KBluWJ/t6Ec9H0saxRy
4aBCn4wr6YAUONWfdAnx5aCkgV3hs75ZYPntVVLrYQ6qN10Ga49Jony+6HDE
BQ5WUfaHZhF/iNtl44Y5ORz8tfaSsVnuQ2LFTppc552Z/aEb19Ypb3sxkx/6
s5P07kMnB6WaL5v2O90idG53+Bzrm/EDX4xdpb8LcHG+yH6H2J2NBPXH6gAT
BS42fFm4aHNnPdH7ZH73awMuMo6Il58bKyJsOmNVNi3nYq6p6scz9dmEga6n
pqLTDF6nZP+wvrR9Bv8vOX5VGQmdyf+TF7TIFMVycd1I6OE31yoJnZUHP3/M
5OIfkXf2wxtuEw9Py7gr357ZH7o7NS/695MZvnB6rd8+6EBDYqPv0MLBebCw
VcBxrg8NLY5+SNp+wgAyRTc4iR2kYQ/t24819lRIOqDY9e00DYNTcpcw7lJB
QebyxK80Gjq7OMgHrtAE7W8n8kpKaThitHd+UpUW3OvyTRh7TMM7aQHfOwy1
oJMswFrxgec//CoUH2fpQOyR+MUfODQcmzspJJqvC/VkhZdTEzT0qnwtuUib
CjFd0tw3MnSU+Hmx88tfDXj/NTIlVZuHv2GWX3TnqEGpdO7b9MV0JN/b1jOo
qQakA8tS7ezo0/GiCPyir3LOetHxqauFZR1XgSfTpOTrguh4u0nz81C5AkQ2
rT6x5hQdf6aRaZ5vFEFy7KDpjlQ6Plw69/MzfkWY46EUNKeYjqar+Q6de6kA
zd3lA0cf0ZHvcmvScCQFpsr/fn75jo7LD6gWbExWhXs3Vtb5sej/t16xVOBr
O8y+OkZH6TWXxDc1a8Fb4zkZoVIM9HuZ2LC7jgpGdXbfbDQZeND2DIdUyNP7
J7RKN5gxpv07FU6F7hcVs+X5Bb9wy7+yVIjKKC9cv5mB+cy2HOp8NVA5mVSu
dZKBVyJ3CpFEKVCNh0ask3l8oWu0f4SHb10Lm1+QihjYbVus1WgiA5dd0wze
1zJQvIrvQs8vSXhTrKLQ1sLA7zbwNuv3bEhbRLoYQZv5XqCnf9K+apiB1H8n
JApNX7ckXRH7bz++MJj9NdsbrMacri+LgIFzXctpYyb6ndticklJFgo/1j2y
sWJil5Hr5Ok3JKi4WDWY7MZEjxay8scICtge9rn41Z+J7VkxeknHKLA7hV8v
/BgTP33JvughrgByrGS+vAQmxslq+vQ8IYPtnmu+h/OZ/8NnUXVNT+saJuqq
bq9818DD91muX9Y2MfHV2/LrT+TIYKjB93Py28z3Aef9s5bBIHM6HyIP4dzB
3+HCLLxr+MpltJ4M/VeXF81WYWHpxQa9xbzfb+BYRI7OfBZmPz/VI+9DhmPJ
xvrdyEKLFY8Tmn/IQvK3jj6rjf98b+x+YuVvWbDYbEFN2sPCQVf51U5UOdgl
et7e4ihvPIUj5dw18qDObbu39xKPLwKu6ZtnUGDbZEKV3XUW6iWJviyJVQST
VU8J9bss5G+3sog/pwQBuyT+sL6wMPrLj4BXspLwZdXWrwt/sabrMXzQvsHX
6OAsNp45Z1HkemeC8Ezm0YESG3PcpF08vccJf3E3ARMjNrovfnrb4dAYMbvi
oQo/sDH/WJ7/bYlBYm7c1fqnzmxcGiHy7Nn9n8TnK/OGn+9kT+u/HkKhw6wq
JHzme4FOO5N75efZePCye4FBzACxoC/HLjWbjfSlEYzVEeNEYIuuXNxTNt7d
vuSj9tBs2C5ubrfuExuXrX3wXvaQOHwNX/4kp4eNkWXci8spssBUHi3o4efg
AP3Jm7V75CC898apc/Iz+3+Sh9YV3JvDQc2V597qGJNhxTz/jZeX/VePlYPg
1PFLPus4KLD7zIjDT1kwXoyb9m7j4Ht5WkHjOmEImz1RQg3l4Hem7+fRjEFi
rWixza6zHJyzsF5o7dNJomiF7OrcDA6upi3QEuhNJhLz/Veals/s/xHB+8dd
Gv+/tlSUg0Y7Bw9tebbCuaaYSJC8l/+Ny0G5U2akVwr1RCFx43znJAfbjx9w
tfzTSNhel/x7QpaLf8nPfeKFGogDS33v3NPhoonyrKultXeIObMW/7lqMYPP
ZsYHdGO2cFHZAGSG1j8gzsV/l1oVzMUlm8+kWFysIfbqWi+LPzWD/x0/vd5+
uMJF0oLtUiYCj4g3dH+f/SUzfkJqJ+1hQx0XvS7WDx5PryM+//VUcHKjoUrE
6NH2C4YgkOms4uRPw5v8w8e/yupCZcCD4ZORNORmX35fr6YJ/UEZvwziaTi6
8mSDTaomVBUszJiVR8PwoZG+awwtEJVZriFfTcOto1V7ZEALmEXLrho20bCO
9n31nnva4Bj2ywO6aLgwtW/Rk2c6gGFXTxoO0rBzqXPUmUea8LDIMl9NmI6R
AU89+Z5qwnPpdVmrlOloRf85pdSgCpsL2u9+NqKjne2NurmdanA4iHL8BtCx
X8ikPsREDXQCXlFvbqDjKspzodpVSuCWEXKvwpeOv72PLKy1lweFv60p947Q
kSolnbDbjgLel/W+plygo4mzgOl2Kwos8tivHpFDx1cEp7ZCTQWSN8xblHiH
xy9SRmpNWykQdazLuuLFf/kgZRj+Ypv25gsdHa9U0Dh/1GA4IN+tsf+f/2eh
7LxIQBNOLByVeiTEwKIb3tSCMk24Mudxeg+FgbbHMrMbUjTAcv3UmgtzGbhV
9qDhCbIG7CruL9ixgoGnl0ZL2f7QADVL986A9Qw8siFLL+6cOmwZqxSL2snA
r78vy0plKoNRz9OIi+GMab2lACdJzW4HzzPwVk1X5LtlCrDL76XRtmwGzr1q
NSToLg1tQ0vbT1QwMOLX4qfpq6XgdblWrvzT/+oJouB07aH61w4GPrzy8OW8
WDHY0tAS+KmbMZ0/E4ZhyofaL3xMfLZTczxwkygoZ63/Ribz9H1e8Eh9uCi8
cF+p+VCPibkH+fMTLSRB0Jotl2HJxA+Z6qtvxMrC8+2CX245MHHdc6uzyzLl
QfGOXPYLHya6C+VLnqyjwKBFR/73g0xcWHTaL9tCAdz7Liu8OcM7f17U8yuC
CmDbvirqSToTJVNf2T6QJ0PD4O663ltM9NXc5mRCI8MLFKTG1vP8yMcrPzJi
yeBR72y8+QMTDVdwn6bx9HzoQQrFm8NECl+zyShPj6tufjviP8lElyv7f4Iv
GdYdANVQ2f/0ORkkHl6/4arDwreBHnrrTpHBeemU8QoLFu7kuJJGOTKg+7Pp
wiZ7Fprt4Gx90C8LJ15fYh7ZysKz3P/H1JfHQxl9/0uyyzYMsm9ZikJS5DlH
CiWJqCQkJdlV2kslokUUidAilT1rixCRLW2oLCWzDyIhu998vr/6+Pjvvp7n
uTNm5r6Xc849t9P+908JONAjcO72QQaWvVh0U/CEJHRpH424HsHAIKdX0q9I
0tB+vyM8NomBcsn2Zq//kMHLvmhHdQ4D15vvFZeKl4Ej+tx23pUM1H3HHxr5
kgRw4VSAHYOBFiIWfmdIQjAyyaZ4TjKw7f/4d5IweiCScliUg+dL1h4eMJsi
ZsI0KtxUmaiCwVVLqycIxxiDDjtjJkaN3d9GXvCbMHhf9DbEZq4eNHVt9nd+
17n9wddZ2++1BM7lf0lVx01bzjHRUcxr8IbaT0L5bWxzewITbzl3rNpc/Yco
FVQ0kcpk4jax2LH7D+dBuELbxP33TPSuK/AedheEF0PzhJ5TmCjYdWDy4AdR
ODmhKvX5DxON+jYcpQZLQIPRuOeQEAvpXgP+7cYkuHv3tSxVkfXf/A8PXmjo
NGBhfcquoacRHD6WeLFFYD0LeT9b7VtzXBJ8yfvGHm5nYeA2Y4zKFoUAu9rN
J/04eD9r5ULX5oap0uRT4WdY2GSi/N3l6ywhtXXfg+vXWWivwpOS0/aJeK5K
F7v7kIUh+QcP7Zn4SDDVdtLCn3P4p8zE1VS/nri3raYwsJmF13mOPjepLiKY
L9O3X/3B+q9+LnUel1canssXS6jOj6PxsdH0cn+6gnINMaZ0ruu73Fw+eL/9
qOoPPTamH+MfDv+VSuwp/G4ubTEX/2dZmx9/uZWNt+7RrXZfjCMmxBz2Je1n
44r2JzVvt5YSCUIdWlkn5uI/ZSY7aFUxc/nfwMTLtC/35/A/W6fYrqZkblzd
6L1hceNcPiAnLKnu9kYK9q2fPfziuy6Yf89tv+NGwe5Vph8PTy2G7UFP6Vkh
FNS94Bn8UEcZZgxLd165QPmLD0qgp+NL8k+k4Dq14OoVscrAciC9ccym4I2F
GnL7VqqBfq6BfUAFBc97REdezlEFLjPe6PJPFLSfdLvrr68OrlN2lDAGBc1H
crnjjTTBckBY8sgEBffdMC+e5lOGElKl2aGFVHyfk3ygtU4JCv32v7NSoaKS
2ruEnXYKsPpPzQNZI871E53dMWwFsCuSCR2yomLioqDBRbmy0Hu/W37WhYqe
xl3G+xbKgETtrkMYSMW8gO4FjWukoVbOvnfkHBU9KnSy+XeTYf69UpNv8VR8
O/TBcZc/GZp2ksLePqYisTjQ5lAJGZSt6SmDZdS/epcMB576uJBoVLwp/fLL
FiVl8DDrUJQcoyLrhHVDL5cqfB/CLhlhGt5esdI45Y8SsDtSeEYUaXhdrfhX
gpQynP6TG/huOQ3VF/OkpL1TgrR1xS3562h4c0o26Y60MmyoXSZWu52GwVMe
x4NrFCDs2O4pMX8Oflec/sATIAPozsffHEZDpWA9UpoiGS4fUWWXX6fh9CKV
s/4lJPCqMqgtecjxD3HRj0bzF0INYSJ04TkNbTwLtzteXwgFA0PXt7zl4H2b
bE90LR9ofbwnrfGDhq2MAyI1dvygy3gTuGSY9je+yQ9P9XqqVvPTMbavinlX
lh/eP/p1WmkRHfm82S0fL/DDQaeS09x6dAwQP7Zx/gkxuGMUdLQP6Ui8WGSc
mScBLuvTrAWd6PijmqtAiCoNqdHn63f50NGkkmfq8Cky+M3r8lE7RcfRg0uN
ecekoDYzq1v+Gh1n17b/cflKgsyIwC0K6XTMNK2/cpiLBLLxWrrDJXRkqhDL
yLkkkGxLsK6vp2OE5KWG40tJkGgz4f6gi46/lRwyaXJS8Gjg46biQfrf/Rok
WFvn0TfBw8BjfUbrZntJ4PNpT2aBDANtjrnfftlKAjnxTvNUXQZS8s3Wr9pF
AqezNm+vEQwUNJFuW1YlDovUlxiUOjDQVP2gfZe/BPiNV1tJejNw/4FmnqaX
EmA978PJH8cZuKTm19O1MyTIN3W8SLnC+BtfIMO9Rw1X+u4ysHNLeESChgwo
Wa+caixioKdRVGNihCw8VwxyudrBQJ/1u96vfy8En52mOjN+MtCPYngrkjYP
wirWiI1wM/HNm/57ttRJomDnsGexNBMjkl3N0m9NEsE6ypcfa3PG9wODNAPG
iee6mJe+5h/eDxFX3beZhtoz8crOyI5CiSGiv0ZVaP0eJm7l3ZUV0tJPfHGj
tMgfYaKe0+/Xdg59hK2O7OHF0Uz8zL8EDZIGiU1alqKrUpk4/PuKhMCTCaLv
xaodfK+ZqHFGYFzSmw+ubOFJGv7MxF+zl6zOygvDU1nLJ1K9nPsrniXJdHPw
mrTqmN8sE/1sHi0RkZGEPLzvsUKShSK3a2ZNOP7r+N1zigaarP/u//5ouK1t
xWrW3+9PEorGlP+IbmJhmcG74NRcCVAeTNvJdGf91Uf8ICNHev7mIAvVao5o
U4NHiaTQ6Z/tESzkix3Lv1Y2SWQsuN2ilsxCik5ak7j5dYJ4k/f1Wy4Ld7DO
+JzwqSI8X5gUv301Fw8S6ymJrm5lYd7jpauzfe8SNqY69TFMFiYuGy11OF9N
iLxx2OgyOccHrheC3uiKzu0XNg6dL7dclY30LdM+q4oqiaRbl/atMZ7D//lH
TaXmubKRL+u+zvurTwl+wz38rMC5+E+iMtdHnvPs//RPM1qz+gVRCA62zjfn
8HzHdVm6bBYby9vfhL6jPCI8N3J36pTPzW9S+I53fCsFj2pcpd1frwMBrapX
NE5ScO9wwpWxQBXYYWDm//kqBU/uPvdlpYoKNL8SLA67R8Fh6o0vG3pU4d35
ZnhRTME009Uheg9UwOUo3460egrqvd3tHjutCiFpI9MVXRRsH3PKijmhDpLj
25e1DVLwQf7WEW2SGkfPLB+I56Hi/beMukc7VWB07ewvOpmKwzMLX9WcWQSr
VlQNROtQUeD76B/5JwrAu2O1k6Y5FQsdn22Jn5AHt7yHMw5bqGjImlpkri8H
aBJtpL2XitnbSgVF/aQg97fKH9NjVBxn5CUs+iQNj37oWVlepuLStVPxWWZk
0OV+ojaaRsVRdtC3FwNysNpJy3JVIRVvn/DbaxgsAy3tpF8ab6hoezbtXUyZ
LIzFlehs7qCiveXkhq5oBXh06u0v/59UbHufW3N9mQr0JO1YZ8xNw+Oifh/e
ZKjAQ3Z7Z4wUDXvtzZgVNsow6rcl0EyLhjvHg+1XcCvDR5VTPt2mHPylPs3X
k1OGlQKpD6U209DNIku6m08JtNSMQoY9aZiVcvgx9d0iSA88Uy96hIYvb2df
dc4kw+OfRK5yNA1TxDoufmyXArM7h5U6Ujh8ERDn/mWlOGwPv9Oi+YSGWoZT
37w1xGA2qTK8pnqu/n8ZNf72zs80jJZy5ZF+IAh97h5j59g0VDz46SDZgB+M
Ft7pdpyhIT3d3cT0Az/wDrQIl4jP1f94cc8a+qrTcdU+Qd8gljBssv5WRTah
44oHE7Uvz4hDZWVBvNNGOuafSdnXdJcEFb5Tw2budITV89a8uE0Ga5vJbo+D
dKxdLVfVYi0NrjsCXY5H0LFKOlu9O1EKJpO3e6xJ4rxewHY7njZJUBdfmRmb
Q0fVI8+2tb8jwdenggMmlXS0YPv2fnEmgcz168mfP9Fx6aXTvkLnSEBJE7/M
x6DjOnLCYRu2JJh85xH4MUFH14pcd15pDl9syZH4s5CBqwZqNCQ5+B8+0vCY
W5WBG3qbFVU5/HK8adfb0hUMfP3BuTKmRQImW2lGM9aMv+tZHHglKFo/XRkI
wj7T27IkIDUs/rFcMAN3eVy7nKkiCRUqL0vNwhm4eY/NmRW3pcBvZIcDfyID
ex/xJIcUycC9yd5le7MYf78PWdhrdFBQqpyB8beGw74+kIbLa368H6YysFS0
s7dsXBAGRC72tI0xsNJigNXcNEl0ilHDRoSZ6BG6eZXenUli6/ribAFlDn4W
+M+LSZwgduROer0xZKLIqYeXQrN+E3TrlbulrZhoIJ182V5uiOCS3r/96Q6O
Hv+SajuV9ZN4IGVXusWfo8e5bQM8L/wkWqy0XU6GMTHAsHaP7I9+4lr2sSj7
G8y/+nGEaF1bMVX88F//IC7gEmSDYjMTN2wSWnHirADQTN65uP/gjMlqEhe1
RME5SXvehhGOf5B+RbEMkAAHvVVGwQIsTE6ZVz2hTILPwy+Hr8iz0Jey50zJ
ARKw+0tx6zIWurx7XXvwOQkiZB9+zFrLwlX1A4Nr7CUg58glN2dnFlaIziyO
VxIDD34NhzEfFhKpFm0DDfPgdmNhlO4pFh4QZhN1NjPEnlelm/hjOX5h8LPw
sVd9RAkrKFXlAQs/vdBe5ClTRdywTDu57OlcfGfqgwWD2cjC471J6h8cnxKD
sR3xBt9ZWB6pbj3smU0EhPsQ736xcMrnXuo1i1fE0cfZ9nsWzNX7C8+jPbgo
w8Zc0htvAa4qQvdSXOS2JWxk53qOtPc85Hy+K3JKCTbyF+Wtj/eNIgRWvn17
wIGN78OIodggb6Juu5yz1L45vJfMcVXdcoyNDl8emlVdeUEwDUknjK/MxX9s
+sM8tt+dw3+jr56fAovm8r/SBRHeV+vYyNzHXXx7OosYki1mbLCnoPOJ49M/
JrRBs8b5VeEeCq7JPJMptkEHKPf6n+0/QkHe++e6jz5ShCWFx7wMoin4vOSr
7KCUCsyMPKeGplDQcvSwmFuvCrj6/jrP9+Q/+WPmY01zVbCUTGmJeE3BhkpH
jYtnVeFp//Taii8UbOpd1Om6Th1KJz5F6fZRcGdQKinUWQMsViudjZil4Le8
BYE93UrgnO1+c6kkFY8e850UFFaEUft4d5YGFQ8v71tt2qsAylph00qrqKjz
f/5HAdqWezznCB+MJBuGdUrJgnRAsRbJg4r1FQc6zS2koLuzotj8EBVNufks
hD3IYHyakE2JpKI+37CwG4sMZAcjPXYSFTuzV81EbpKF8O2KnudzqehwzHrv
LRsZOB57ykqoiooHM0co75bLwNRU7EbbNiomV/XZHVBSAP7kRZqvWFSEH8Df
dEEZ7vjKFahPU3HfisoXyzRUoTpg4a4WMRo60HYWRXkpQ1D6n2eJajS0lEw9
sb1ZCR4JJ/R9Nqah0KseYd91yuD7UNt8zwYacj3s1uvlUYKnhwywaxcNF2/r
B8ZaBRjJUNt55AINe/oKY+9xk4Eq1MTzNpGGnmJPA+T4JcHtvs/bgGwazm7x
EZk8Igae/lNWGhU0vJJOubfWQgQGfSwTnT/S8JGRpOYvAX4QvHWWr4VGw/mf
tU8Z9/JB3oShFozT8Ik3X239O37ovtrhPSZM/6/+T3I6uqNGiY6XRm6obg0W
hG67BmURQzomrT6x7sGAGOQfF+e7u56O4+8dhSJGJED469tUNRf6f+uxfvsQ
Tu4BnPk6vZYdtCaD11LNnuazdJza0ntZyVUKPNTOKS+Np2NX9InHXftIwNj4
6dTnR3RkZzc7L7pNgvEM2SsJL+i4TcpSZ9BIChKMpELeN9PRNnfXAc8CEpQP
Lwh17pnT90EMX93GEQ7/7HgH58Q5+kA4cnZMgIFx8wQLuu9JQagXOdNF4Z8e
J0HDT3nerGUM9E3cc+bjChI8yiKftbJk/NWf4iCWHJnzcRsD7x5itnYZiwPP
y+wxaT8GznNyHjpPSMJ5cSu5mDMcf5BfVGu6UwquJjr3j8Rx/ES2oNNsIhlU
HXZ+f5TB4Pif2C1WIzJgYe50PugZAxNFlD88c5YF1dxH8djNQNqISPisuTBQ
lld9L//NwIdinjP6PTOEHvOa9QgfE8n9yem2pBmC50NLpPsiJkrnVT7+dGiS
2Nt35ehTvbn6T/vVZhd3WTDROHLhyvKWX0Td8+82ZCcOvsNkQunpPqLe3+TH
xv0cPF8Zvkzl4k/C2THiZtOJuXh/gK/NrGkMEy0uiBXq9gwT4iXzIv7cY2LM
bEKxUOkkMdoj/lainvnfeOGqGp+Jx51MNNH20c9XFwbeduOv+oNMnP+KT3Oi
UBw8VJ61BfD8i+9Iwtrk/MwfZBYuq5k21MyQhAIrhWVrdVlY+36CknaRBNma
Z1oGzVk4X6/Y2GqXJCw3adMp3MLCwAX67MuzogAne5wHvVh476yCVGixALQP
Ue4eO8rCrQ/LdXnc/hCzyS6pvy6xcImLTK+M/CSReyTimeodFrLmH39XOPKI
YF9YnBVZyMKf2rfbCMEXRF7tGruO2jn9zrXaRuxEO+u/eNr53SZcv38u32vx
dPatG9dcvadRdaZxuyQbNVy+rTuUW0PkczXaWy5mo5tu2EzO4AuiNKg7amI1
G903mZ0YjM0l9jEzVwjtZuNjxdhUxbZiYuGgu1TKoTn8B53oDIWLbHwyZOXX
f+AFMZPg47zt9hz+rzcu73ydx8aWM1XPQpUeE2WnX991rZ7D/9O2bI2HOyj4
+CC/d2uTNoxey7j61Z+C1xzGhW06FWCcb7tHTxgF616GisQlK0HEk5nDJ69T
MG4nj1iqtwqkXnG5EP2Qgis/VDfcKlIDi9tZ0wHPKagcIZXDf0gVgrqCu0qb
KTiismCRhpY66GzpL63soeCg/kWxsRsaEPCnqy1shILT7AM5p3NUwPz92l0P
BKho5tLktOCaCiR2pNrekadiwPZfJk++ycMp2YEzS/SpSK1daFo/owA/o4az
l6yl/s3XLQLmkgGL+c5UPOZcJHz5ogz4c7uD+QEqzttDX+60VQpOC4abrDpN
xY2XImxCj0mDzDrFw73XqNhxMepG6CkyEAVLZbkfULFVr/Bdhrg0DG4x0Bwo
paJbZN7nDg4+LVHPToImKt67JZmaJCEHw1odAg7dVFzNImuObVSE9R5nXsr9
/pcPUAH1hsQvVnw0rAgYPmA9pQyX9j103ShHwy5VA20XRWU4vSJLvXvJv/5t
SjBh7EVnAg1NPj47E7hAGeb7SojXOdIw4P23qgWBipDwYcV9of2c+z/A3lO8
slB0YOEy0ZM0rKWd22dySBrcjF3nNVylod7E7Mu4O1IQZ6S0mnWPhl9PNotZ
OYmCw97PHd+KaXjLq9HEKFcEkuvCX+2t4+h/uRcGO78LQLMmwVo+QMOG5Q1V
sqp88ExF+Jb3fDpGfTq6eiCCH/Q2Nz85KP0PPznjvAsLxbXp+KqaWeAttBCe
45CX6hr6f/Xwe96t6oL2nOfvZ7+5SJeCkBmdjc5edBxznH9/gT8ZUrVK/TyP
0vHDdOAH+a3SsPXC048al+gY+nrNcBO3NCSQ9O9sSqNjULjEioVHSODZltS2
sYCOD8XdAg4ZS8Gzhkn7jtd0JC3/42VaToLkX+I1377QkU/f73n9t//0E1O4
97SXjvpusz9O3CEB1+cU+ugsHU8/oa48O83R9/GfNEYkGbjjcWB/Oef3ERdx
+nGmJkdv28q8/pRMAp3M1BuvVzPQ9JlODDNBFOy4iphFmxhY/5D6NVBZAqYu
mqcLeDLQPUHmjzBbAowtT7sohjJwfHqwLFmbBBPLDZ3YFxn4gpunJuaDNGxw
2FUql8JAXt5nNOFHZFB/cPKcSj4Dld7k1gbyyUKUTmzssyoG8nnML/vVS4Lh
JlnhRywG1vpNFF8Z44EJ1ibaz2kGOjvHjFu1jRPRq1Y+GxHn6Pe6ZOEtBlNE
xov4D4XqTPxQkz+wd2iCsA3y2dJmwkR+ruMvqlR/E6e3Gax+t5EzBpsGyflD
xOrgwX073Jio9Xoi/OniQeLsyz1XtoUwsfn/6i37iK1mTfJLLjDxbFTdV7ba
TyK//7Hk3lscf7D2z4lLr/4Qtz6cPHgom4lKoT/2lM/MA/7lVUXan5jYTcvh
XskQgthsoxck+j9/IArpLvLaXhNM9D6l+m39TQmwMH0We3AhCy+XKBy5ZEsC
P7tG89UqLBxaceM2mePflG84OO5dwULSTSGHDiMSeAi/e7/PmoU79YK3u9Ml
QacU4sZdWNhYnrrV6ogInL7hvYkrkIXFwb5GcmLjhFv6+eCusyycfH7NpE12
kqijk6YVE1ho907hQa8qkyjfufO8ciYLPVY+Xyo38p4wn0+2+1rGwkR9s9Nr
G+sImy6rsNH3LJRZLKKrtLCI6Gb5L2JTWP/FVy7tqImAURZ++1pk23HoFZGT
tOOTtyAbzS4NSWtOVBJUcyWplQpz+J8h5VJ+YDkH/5OW6iw9xtHbitHvD1nO
1fPUu+Rpim1jo4iuuY7XqxRCtz4qVMl3Ds9lDuzQX3CajeqlF8MTPZ4T19ak
bt4cN6fvb6xNPLAjYw7fVU/yNcg9Y2NpsFZPxOIEIohmvbTy7dz9Pd3aI3nW
FPyz2fdihIoWXB64IHh4JwVNsre1+d/SgaplpT3FgRTEqZaJdT4qcC59jXHG
OQrujU3U3+6sDE0bVg2tj6egdekl4/hKZbinJhi85zEFp6yK5/f4qQG3ftC0
eRkFwfvqNtlMVej3a5RKfU/B01eyfqnxqYNXl6lpApWCqiPUVeuea4BXGAZs
+kNBIerRG72BKjDkJO8VJkTFa567VFs+KwO/m22rpyIVX2rccg7/rABZib9y
R5ZRMdBp6EusmCJ8WeC3kWcdFTV3XZZ5/V4Orj04MfJhGxW/uFpnkyrJ8PFI
mK6aHxXHnedZtoE03DmZFCASRkVv3WeJ7/aRYazQpqIkjopCqzfsMHUnQ4dC
88eODCqWxu/Yb7eVDDbPGb8rnlHRMFDnxpVVZLCIGr2zuJmK25tX1+HqRVAb
LbdTq4fzfiO1sm3OKUJb+SdV5jBnfspHd56rKhCk4ZmjJkDDlsmjvF+/KEN8
+brChfI0VF7hXffZWQkso1NVMvVoaAEvdx/S5PDDxSaHVxY0/PJ/+pJz/VlM
7E0nGm44FtMUdkMBbshbu/7yoWF6tUc9PVUWggqkjKinaLjomGH7u3hpaDt+
VDbhGg1pdnYKfr5S8OZw/qvqdBqS43gtrnctBMv7a2h3Smno9civ4QyIwIb5
EKzXQMPOJc/I2S180BlPrlz5jYaOPb6djhz/PuYSLs/1i4aJBllurz7yQZpD
ranlAjquqRYliGx++HByV9tKGTrmb8gTGF0oAFe/+nzt0OHgfafdbC/HX7Tt
35g2aU7HVqnqfYm3JCBTpyqkfQsdHeMZu6TDycCvpPfRbB8dUxf45Cn6kGFo
XZ65yXE6qssNsHtWSsPetJqnQ5fp+GC+x5LNTCnw0n0yonWXjjdqdhfTa0nQ
z/qVs7CIjlpXnILLOPqfu+Nhc3otHe3MCaf+LBLcnTEoKGmn4/VXF2uvT5Gg
cavj/ch+OkYr3nKQOEaCsK79yp3zGDh5NtGmiOMPKxOvZ9ZLMfC1ohmfmDcJ
Lkc4WoRqMfCb6Ez4TjcS9GQwb6eaMXDtKYWzinfFoWpcYkHEZgaqzYgVjd6V
gKVnDMYH9zAwVsN0H5+nJKiv9J4YPsJAqw/brrfcJEG6ynKBp9EMlNyVLDQ7
Ig0F5u/bR1MZGMYX3/RiJxmsr75eTHvCwCKtzer1TTIgU+PnlPqF4x8iitkN
ASJgnw0dR3oZf/XgfJCoFehvmWUg9dPHksvkKcJDginUKMnEU7sNaq6JThEm
sTtNwjTn6v1vW6QvfrKaiQ/swjzOzgwR0ZoWcbGbmH/5fZDgWeO0V9WDicMH
ehy3Lxgg+CPWTOod4uh9LrsjsV79ROK8F6kTEUzsfXGTnhIwQBTkiSywSGai
bRj9mr/eOBFx/+Oy7komGsVXbOXV5QVgvV4zv5WJD6N8y++tFoaI3bbbaYx/
+xPEwFm4fmbD1L/8sgQUsFwKbMRYCMkf+ws4fi9x/OxBPjUWHpFc+ShfhQQC
Zqf/wMp//XlIwPvk3aj2BhauefLnYxBTEi5vT3CrdmVhe/Cm555BgpBqYBD1
JYiF3q+Sur11OPxH7HmVfZ6F/O6JincypgnP01EXeBJZyAHb1mrNTwRp8LXz
SBYLryq7yDaubiYcbsSveFA+p//lfE0/v//ImV/+iEjIvGyCI0qGs2gslBoU
HOm1Lids8zOOrRxj4SCZO6RgrJQoVux7ZS48Fw96XFFLXqDExluuz+41TVQT
WtdDl1kZsrEjelrDcOcjovbDSGX7djYe9P6se6MznaCZrQsb8+P4A8sBZpbh
MyKmXXtT65m5fO/rzPkZK26wcYFBSs9yoQIiPGdISP8RGyPpS31/HMogbHr3
V/b+z/kB/pLuhsIOFNRVvNsVm6MNu160fk7aS0HmutfkZ6U68CVeJUr/GOX/
+9ttytB5r8pq8BIFb0RvFDIJUQa/ni9xLmkUXCfbscNAQRUubn3NbiigYLxO
B9cRG1VYOm7JG1RLQf155gPb2lTB7f3zqLR2Crb6mzhNf1MHufZ1F3v7KSjy
Z3zUV1IDPKT3bfCb93e/1qAyGFzYKfubREXofxHFe14BrmlmjDxYTMX1zotC
GaXycGRirxu3KRX5Iz4HfdqiACyuyU9edlRcZVqZlmQlC/RVGiJTuzl+IPL4
j3FbKQh4YJmrEEpF0di4J4Ky0nBu7bGGnVFULJZYenMFR58pktZmNt+mov6G
EP3vHL9tTe5JsMqn4nJek9vOb8gwaSttNVJNRYfZtus/dWRgdTHhvvTLv/Nq
FIHH/vTQ2V4qR1+v/SiWrgwuCg42QrPU/1+PR1cBE4XJ7CQJGl4hHtdpb1CG
+5vHFZw1aHh6l9b6sVAluFnkt+iFyb9+/8ogY1usoWlLQ/XgpNLMAkVQlb7+
u8adhgd90xY/klGApxL7tAcPcvjA9NAYrYwMX9Cu3Thy7ryAC/cb7QqSaHhv
XW1ujJkEvFip+N4w9199jxicnKlx+1FJw0NPq8vvbxKEuj89x0xaaPhbwe2u
WTE/3FFrvRvPoP31V/zAdc71yuJJGi45yD8++IUffko8u1CxkI4S9+uD9HQF
YG/bgUvnVehY3G1b/fuFIOxvilX4ZURH2ScFiqFfxGB0+EqZlzUdp7XzZddz
9JyYvZKSiCv973ogQ2HXAxYRxMHviY+JwiQy/EhB/ZjzdIwN+77RtEsKkq6F
mEje/E996bWz0q4k+FZ81C4lk44hi7WcXPJIkCPSEuz4ko79KQaHlwlKAW9i
ukrhezq2MV/fPfSCBH1bN3yTodJRyaJ/fsEwCXZaXnAr/EPHF6I+EobpJHDe
V7z+ixADFa6axFgeJ0Hn84nHskoMpG9rV9ofxHkeW9/HGDAwyVfFXKxFEi5O
hvMIr+fgrR93myEhATmM+smyHQycqWkOvvZNHNx4eXaO+XP0/4ddxPVWSUja
5rjC/iwDDydkRPMQ0uDRsfJT5w3G38+XDAWxv04FPmJggUeArtYiWbh2nMtY
7wWHD7i6PuYFyACb0tXI08PAs7M9syPuwrDfq6n74QgDS8yS3nCgkwgi5+9q
FfgXf58iuKcfOSkpMHH3hsanpxdNEspSK8VTlzFxUECS8vDYb6LePemrqiUT
Xz6+2/RywxAx3emQ98mZibVkioxpSh9RdjlMXO8AE199blP/5v2T4A08H3b1
FBO5clKMrWZ/Eu3nFxWqxTKx64JM00zXCLG68eJQeToTV442+1StmSFu/Ton
86eBiRsU3LcqLuOHpPcxM/7fmFixRu+LVKQIqPcsfyQ7xPz7/YvDas36Z5t5
WbjaPTbt0BlJaL99eP09WRaO3vr1VSRPEvjWlyZoL2Xh19tWb8XOk+ClSvPv
EmBh7D11hfeJksC1bLVbkCML/RmTjw+zF0JT0CKnT/tYSFtUeOakkwCoUj9s
NzvOQsMyd3uD9VMET7SCcvsVFurX6PXo75gkgj3dNnPfY2H4HTTubCwmfPyL
xtf/T71/X2aad2UdCze8T1KxeV1FTMh59BCdLHSJMDnwpfU5Effy8IHe/zkv
oCSO6wxws5EafktqVPs1sTfJ406yFBtFsxRYbcQrIrXF6YKuNhsXubpQ1hk8
IDxR+cgrMzaeCR3tmvxwiXjSTYSe38zGp/7lobF3konogpZ5A55sTPlmI/PG
qpgYLDFP8gidiwd9718zyhvNRp5FuzVyruYRLtsMnq9MndP7Hr9Nx8OfzPmD
6S39GzfXsPHG3osfxCQKicXHLUlumyhoti2iRttsKRxuXfor0oOCSt+Owy0d
bbDd01cccoiCV9PvW7v4KEG+GhexMZKCP55sy3V9pAy3paOq7JMo2KnqYA8c
fUsyYywl51LQ67LeY9U+VSDfaD+77RUF5azUwrUjVeGBYvW71FYKWrbxeA3V
qUN5R+UPYFHwcdLKRkWqBng2Ona6TlHw+9qejElDZYjrf1G+SoyK3/5Eqtzh
UwZbi2N7edSoaOQakU5TVYDY+izeqRVUXNjrVvFQTwF2ny+MKbKh4l4H34uT
zWQoC7Sfx3ClcvRc2ZFDbmS4c7XHTzmY+t96SbHuqNtF4VTk2f0ubzPnfkGv
2qKqm1S0Yn50NJwnC7FyX4pis6ioLSF7pui7NNybfyalvZyKWvlvZz+nkMFc
aVGYzicqMvrCjr9pkYd9/k2arXQqzlt4Rp5xm4PnPyVKxsc5/GPtfA0+qsLW
u3pLv4vQsChEQ+JosDLIR6btL1Cm4XGVPfUzHUrgn3YhtcCQhmd2P9T05fCv
LRvKDlrR8NvjqKZH1UpQ4B1blevCGfP5Tz8+pwDqE8sjr5yj4eEbDvuzOe9v
qaiqUXo853pCPGWsgQSvnBl1Jx7TMEu2L1A4ThS6389TxbJ//Z4XwsVTsYcN
39Ewj7Arcv69AMpdR/PpPTQcHn4Tu16WH04GDLZIjtIwOS0+0k5EAN4UVHTP
E6TjV9O9FtdL+SBZm5rfJU9HccpRnikOX0x9PHWCrk9H+42fEgRlxYGe27c0
fy0duV2273cdkwDXl4N1v53pOJzXav37ERncZli7zH3pmJJYds5zLRlYwWMl
lNN0LDmsBmn9UsAlc3uMO46OxpW8NhbxJLgzSFKlPJir93872SP65OncOHyV
5lhWIx1D3azjQholofaxeZ33dzqqnZeM5VkhBddt+8JShujo6SUlbKQtBX0q
MYbtvAx8U7f48juyFDRrW2UGyzFQk7Zr2MieBGZeNwTOL2Xgk6M85MYDJDD6
UGLvhAy8P+14odNcAkqDAsLubv2nxyWgxmJR5vB+BtZvOU+ybJYAN6uum/dO
MtBEkVk8qiQF504bBTTEMLBmauaoSREZDJgeSwrvMzC6ce/DzjQZ8AvvyY0q
YWCZ2PUPe5Jk4ezWB9e2dDFww2fJKb5tIuB6kfdbzCADT7SfSGqd5IKqn64a
rTxM3NOauURj6xRREFm37LAM8+9+10liiWO9eowuE93ju3BIc5Iw3JLGdYBg
4kCZoqnRgt9E9dmGOwYOTOSni+orv+4nuqkHTLX2zsX7I453v/x2lIlL110j
JdL7iacWvVqil5kY/UC5U3bxLyJ0TeMJrjtMXH/w0GPt15NETENmem8NEys3
BT8QesULP111Up9+ZaLmz/pZrgXC0KJChM32MTFDsLaI/5sYWMvauG6ax/qb
n5CE9Wv3T42QWHh48d51Z0Yk4V2a/AUZLRY6yYbELlpMAopexsikKQu9bhU+
87onCecGw3Xe2rFw3x+vgpABEcimftnRuJuFFRm/cuZ95gMPIe7g6MMsTLO7
YO509xdxx6syqPoiCx/Qna2umU8SPoMHD8xPYf233r4i10wrNX/u/LDUtKTm
gmoW/pz0ej5/6xtCsPqt68XPLBQ0Mb76s/oxwSXrnLeRzcIwPaffQ6JVxNm7
jlOm03P9f664ai7vF2PjmPh3gR01lYT6hqt2MupsrD1fIml77TlheaDRked/
6v21LPb+oO6aw3f2OF7JDp4br6QWqvwMZ+OU7NJYWPOUEJu3KN/4Fhtn5Hee
1rV5QYTY3+Ru/5/zAO4r6kYoVLJR6+5aua0+eURB9jGH584UlIqmZUg168K6
u6fKcw5Q8Dxf1tqIS2rgWefs2neKgvJ0/d7ycGUQVL1gH3+NgrR2gQVxV1TA
LFdrj1c6Be3u+P42+aUKE353H54upeAZa8etJctVYa1bXvTFRgqGaQevC/dW
A/K5grV3vlOQOrVw09ZhdQj90qCXMETB8jXlDbyOHH+w++jTE7xUlDw64PFL
QhVa5CcPZsty8Nak6yPVTB4+Cn66YLWE4wdCKlbGvlWAXbrKJfzwr7+yPISc
tpCRcqTiDqeQ+1+/yIIEz4SMuDcV32lctrRjctZvWcaA3AkqLj7upcj+SYah
jP1j3FepWDI4sDk1iLP+Xlektd+l4lSRRNu2pEUwK9l3dLqIir4h5pYG98jg
lJAzKFpPxY8R1+/lp8qB8UYv82VdVHSMTOQbtFaEewbLyvUGqbjrOlv5q7AK
JNnGdsrz0FDKItybDSogf+vNEmcyDd3TaE68ykqgLeP4aVz7X38HJXhV75hY
vYaGW/f/qOZRVwZqjnbMF3saDii/29D6VhGuvb6h3uVFQ4naCsdz0XLQIDIS
M3CUhoMyrl2yFdJwOerA0u5LNPyxrsbuqLk0dK487FOZRsOnveyJ3Z0LoVjG
6XNvAQ3LF/rlPPwqAnJLopPP1tAwRJh6/mWhAPCHGJ1e85WG69Ll93QkC8I5
dmGcZR8NaecVL1+v4IOI+Lp1plwcPS3cNv68jB+kDhbonJKk/12vArDs/K+9
2pp01N/YZ+tfIAxtNQ8qJlfRkXHlnNuZGHHgNdXfKLuJjk1P+Av9LktBVc+m
w5q76WjNB8odHPzjf7n7MB6mY8SSDpVpZWn4Wh/9cPVFOiZ2aos/pUvBCgGb
o2q36XirJSLDfUAS5E90Ht+WN5fPvaJU82nkFR2Zt07t1TtDguhR1Y3PW+m4
VHXVMqcAEohzOQ/XM+n4w/PnzbWrSKBmpmhWP0VH9W5f4cpzJKjK7NjRJsZA
0ewjWcG1JGBvzH38So2B3CGip5p2keC2knTi7ZUM9K4zaPpPv/l2DcenVRsY
qDSiKWVWKQ733TSOfHFj4PPGLXGlyRLwp75PaCqEgYW9CjMarpLQ5l3/cfoC
A+MkrLPos1JgbmJqMnCLgSoF+1xaOfrByPTcO90cBjryPF5+wkMGCoIUX36s
YOD7aLr3JmMpcDwozfeUzsDWh6aZWZuE4BDEUSomGJj5rlWLFDdJKML8hNaF
TAzJFopzD5witoZEHa9XYWLD6m3yfPYTBOlz+nT2Cia+Z6k9bbP/TbgHxBd0
WDNxKGRFXmvFEGFs0vHy0M6582ASjRIYhoFMTHmwJfrLrX4ifI/mWvNzc/sB
pl5vXGOSwOETV1rC7S1/iJnt631OPWZi5tIJpaz4eXBfZudl7vdMNL1nR1S1
CsB6yxE3NQoT8/4vPyYKIffU3xv+4fCB3+GSS7slYImhDdlBiIU2EZadGUtJ
EDB67pqdIuuvvyaBed+WR6sNWNipFL4p+iQJbpJGfwWvYyGfvvzSQ7qScDJw
IFZyOwtb24sX3ef83tlTu+w7fFloPNVfJjc2D6hld+HnaRZSl75dNss/S+zP
O/5uMI6FPl764b4FFOJYi7XRvIcsvL2jTrmC+ERILlnSOPBsbn+vSUk6V/Pb
ufg/O2TI+083C4dXj543lMgn1D3jNS79nosP9Z3PmbeOb66+f82XJNENcmyc
3zs6zb2vipB1Vygz15vD+zCZw0mncS4+E8yj+k5rKxutL++hnyJfI36qWqqO
e7Px08kbh1qbi4mRg6YPSSfYeN+H7lvbWkpE/nnToBTDRmJzXZ+tZCaRkWPz
2uR/6v3tEroH9EvYqHjqVtrjNTnE9gt54mcb5vxB+NJSHr6NFKQ86LikuE4X
zvZ8PTWzi4KZTupHrvLpAF/DFltSCAWjQfGx3hOOnqWmPh8Lp2BP9JHvl8aU
oGjZ7vbGm5T/j2ccP9Ced3TzyyzO8yT2/M9GanB59wOisZyCpgkd4ebJqlC/
7k2I4icK3rc28/4yXx1iXU9f7aVz/EMT8wC5TwOoDzZotI5T8FqQ8EJ/B2Wo
UvET7xKhIuX8jOsemhLovPdMKVSmIscmhukdUwDFJ83tRw2pGGmq3iM8pgAp
r2P8Xa04+vuN8Vt9RTnIENx3wtWFo/8/XTpeJi4DJueXN90N+FcvJA3b9eIW
7D5HRX0Zh8dbJqWBS5j/uVk8FddNL/qxky4NxvKfqo0fU3H/pF9I52YZGHEr
tN5URsW26wq3Pl8ng/TJ35WnqVRUNjz38li2Ehx1PtgX9IeK/F3cfNeaVMBz
j7X/WSEaXuDWu15GVoav94aueCjSMEy25pGwAGdMkvDQW07D3xax3k7CyrDv
WUSk3DoafpWZ6cwVVIaT18R01LZz/ILcHbZCJOf/TYoRDfbj4PsKFcMbcjKw
oe1+l0kYhz9UdmcULCTDvHVvNRWu09CD1i2tVUwCS/rGGqWH//YPi4LE87T5
v57RUJTSYcC9biEcqNz/O7+JhvxH+bsE7/OB7XiESUw3DU/vdbnfnsQPz72e
j0X9puGfwhcyJyf5oJB77cL7fHR0JjWK7FjPD8af7lRHy9HRVbfKzkWFs97b
DursXkrH71O6f658FIVvQrfpTkjHoeKWBzrfJYDn0FcF7610ZD0O84gNlIbC
hcKJL/fTUQrujP/aQYb+jk8TV05y8J+HsrQnWBoKOvK/HI+hY1hm1u/bu6WA
eyFFKOI+h0/OXGy2/y4JXSHsb+4ldFxhcsF072MSWAh679GqpyP+UOpdcoqj
11tM1oh20VFBnHlz6wEpyHuvFCcxSMfauHfRvt9JUDI7qb2Th4E7j1nceKYu
Bda7/TMVZP718ySB18jvB1M6DOTyf2tdn0kCwbJ3o+PmDIwP5V1gMy4OZsWV
VZIODDzpvzSt2U8CxrszPoTs4+j/bVzRl4clAAnV+o3HGTgyEtxiz+EX0vsC
U7zCwI/O+qOey8kQcj1xvtNdBvrIBi56NUMGlyhH35VFDDSvXtj26LAsvBUW
+P2nfa7fg3PS/c75Pxn4lmrh+EKcGw64GAo4cTP/e94V/6btisrSTBTK3rHi
2pdJwiAkLpdPm4nbuMrSpFrHCUa9yg2RNUy8simRCP44RCzeGiHbs5mJh7fO
/y3w5hcxJOZh/8Bzjg+suWI6I0KZf/Gpj9BS/UQJj2JimrJd7nD4IHEj1A/u
pvzr9zBBCJWWs/dWM1Fp1t+eKccHMvf/9O/6zMR3v3X0b+8UhtxX6/xC2My/
+S1ReC8RtbRphvnXj3LwPGH35zQJFnakL/Z55kWCQtvNUzEaLGwwieOBB5IQ
uiIuNHUVC68zpnlHBUnw2j7z2glbFmrb3/ATfiQJt1NXulq5c/T3cqKyT0kA
uJTkTi0/yOEDXXczno4Rov+DuKxJBAs1N6dknOSdIPaWzvw5n8TC198zDj1W
qSAOvAursMllYddjgU0/ljcSY7Iy3EtesXDijrfkpaA3hMRNnqQlrSy8dr3a
SK4lnyhZX/thkjEX/6FrTT9/NsHC9FMhvZk2tcTdNVHj8QvZeIo2PvG5uZyg
h+sUXlVh45Gmq04Rz18SJTPKVQ9WsDH51dDqF+aRxGjU0g/uO9lo7H5oT3pG
EbE/uTrC4X/q/fd8DyjdfY6NfpofU6+bcfyBk6huSQIbq9je0Qt+5xJTM5aR
4ZlsbPzdL0Z9kUGM8my4H/5yjl/EPPos9mylYNP8D8V9JrqgoF82dOUEBa26
HCRLFqvAoR61JourFBxeXF2U3aQMW+u4Tny/S8FDRXsulripQmW3Qb16MQVF
y5dRggdV4KnuceupOgqqJT5/7iitBqaPS+hKXRTcVye4/dsOdbDecbEDBino
w9u0s+WrGnSbBs4bnk9FrVG5BYY/lYF7S1btZjIVt+rWd6jkLoL8xLKXo9pU
JAmssY6TVgC2xNroC2uo2BD5ItDynTzkVCiOltlz9PuU3Mm3VFmYShW9HuFF
xRHiy3mncCloyR+xu32UikmVR5dZREnD6pGg3XmXqOjxkizXw5AGLb95D7am
UXGF4K5ZuxNycF+KEXmvgIqWkqcJWwoZHv36kXyulorSlxt2ckXLggnXx+bc
diruc2i3vdenAFtx2/Yv/f/6SajARNEviRvzaBhtaiCw4KwK6Oz84TdGomFO
xUDXpnXKQDfMGHu4mIa3Fky3+UQrwRKiewdhSsPInJHQgQ4lmDkZ6HLGjoYH
rzoPre1RBJd+yctbPGm4sa3t8vI18mBxLaczMJSGYl6Hlj2SIkPB3s7zl6Jo
f/lbCp74K7uuSqFhwZHoYNJecTB59OxTTD4ND6mwDoUdFQNbKa1Ty6v/5ZMF
gFkkNPW8jYYGKRIs218CIBZpKdfP4uD9zeMYsY0fqi/F+TyZpiHfBYXSwDx+
mFe9YruiOB0zlbIG4YAANCzJPdqmRseGEc92RT9hUK5PDghdScfcGUt2+Xxx
mLn5bX7FBg7e7ktLO/aVBPtvGTfccqPj7hsqR+w5fsvt7fm8yhA6Vr7Mpqqo
SEOX4b5e6oV/9aRSwGzatT35Focvgl+kvMjj4EFiptdENh29TNP2F4hKQUpC
0730Cjqe9GCW6WuSwPrNnhLjT3P9/U/r2PsE0+fGROWWTeYTdLzaMzPdOy4J
ly9a229byEDx3t6fHQUk8Dzf8thfhYEHsreke7A4eJJ/2Eh6BQM79jWpVZMk
IV/Mz83bmoEeT6YCrHglQOv+kWcbXBm4unTUrPGQBOjuP2p4PIiBeXZjk6Oc
+5+6L+R5eJ6B97729C0tl4L3Uc8W7LvJwBDN5gMjtzh4T3+W8TaTgQHXZxbW
WsrCncMxx8JeMvBHJpfn4yApSNM97uNG5dz/fwkCIQhw0O8xHGPgsdxjmvO/
TBC1WV+POQkz0emV1qhl8CSRuVJ2/yElJkqIxw7olY4TcqP+kRqGTFzs8fyQ
67nfBIlBXn9mPRNfn3LZHzv7i7gleNNYfcfcft5Mj0tT+X5zeG/JatlNPzOn
9/3SDcdyrv87z2WEkI9jLFV8yMSV0je3t0dxgeKCwI8n3zLxYeFx2wZxAQiK
rsqt62aix+VrCpUOomBroVuWMcxEaOA54QQSULQkivmen4PHMXeWXxyVhHSb
k75ji+b296rdClcq0Geh15LaH8UcPtdZ1BNCWstCtfZZEfFWCSh/Rxp75cT6
r5/oLClz2ObDwrp9HSVvf3JB+PtntvEnOfywuzv0l+oMUSLfdGTvNRYGXBKK
ODVKIw4nf3p1Np2FQqSaWWP9l0S5bZBnculcvX/cMlUjq0YWfl1z7P1u1TJi
aL32g+RvnPlOLvh9NSqd6IxZYG36i4V6sS6e3udeE1uEtlVW8czld7c8m/48
RGbjH75bxq1V1UTnrWfKxbpslJoQ/9Wq/YQYzG7gVybYeOnH+tmKdXFE7FC+
atuWuXqgsgPCEof2slEsO+GkzLNiIkTq5Z3nR9m4bLtKxLhRKVE4dM7j+mU2
Fg4f7yIsSokwbnPi6R02xvfNNiv45BFtllcPtRfO+YtM32Y95ps5vd9Q+0Gt
eDMF5ZQPoq/ZEvCpO+slvoeCX39bmGsb60DcVITSh1AKihwMu1e3VAnW79ld
nRJFwbYL5e7DPCoQPpWf2XqbgqMbDR9k5quAXZ2TcHA+BZuP399L81WFe7Wi
rynVFFwWvcXrTaIqnP1TvkTpCwVVfdTv7+JVhz6X+SsSeik4QCraMemuAT2D
rtepM5T/nofr+UzIL0GCikvW5e86FqEIAUUxS500qH+vKwJPz0WDMyYcvc0g
m4ZvVAANi89PhG2p+DXj6uG3qrLwoWV1ZLA7FetC9kmo1EgBb9J1kbSDnPke
Dz3hGZGGutizhvyRVAyq+L42ZloaSGXhedZJVHwa5fZ6VYcM9Mt0PejLoeI2
mG5UOS0Dmx9tGPJ+RcW+ngwp23QZMDuQM5DVSsXZ//uThyK3B5d1WVQOnmQ9
0uH4lacXCs6cm6JignjW0gI7VVj/ndRvJkbDupU2zdcSlcDd13YtjxoNv3X1
H2hcoQTcOuOdxsY0lF7HrajjqwwGiyYHm2xoeKbxZ5DeciVgm0vsXL2Lhisy
zAQXkRVgRqFyWU84DVMshK5OcvzJjq+hqJtIQz31nCOOepJg/uZc0+cszvy2
s3tPRIhBLmMPxJb/698jAo9WP/9T/IGGa4OsIwzz+UGvcq+2OY3z+oMuCxZP
84H5Uc0nKWM0nI04ujRwvgB0eJoVegjT0TBI2FLsHT9whS1OXaZER1LkI3Fh
KQEoeBfZ5GtAR/Pt/hdsV4vDzy1rDguu51wvbyw7nSMJJbz8h8J20LGvI8VR
t5EM/D/fqFX40zFZUPQlsYcMND6Fg6vOcvhBUP4uy1UKNm2NlLl0g44ra4ce
pd4kAXxabwKP6EjR0n3Sep0EL8M7gPsFHTWLjogqbZWC2v20y/rNdBQIt0gy
aSPBjjOWjpU/6Fg/XzLD2VMKjtQ9DdQaoSO5/csnLg5/qFiqrtkhwECTkAvj
LhFSsHVIObNGnoHJsyKVK204+vyTkb/AMgbW1GnPpP2n/z89JTN/LQM3N1tU
qHH0vsESeXP9bQxMOhmmHHVWHGLTY86F+nL0PuWSzuARDl9tTtw3fnquf8TQ
kpI7jnEMPGd4pET3IBmGzLSdxDMYmBPmYnaASxZOnwke6njK+IuvsrDiNupl
fWegkVhnreOsMHiG+nxf9JuBlt47twntniZkzkegEx/zv+eZuFSZrG2Q+1ff
P0loGnElS+sxEf2Tvs77OEqc/iLvX4tM3L3nROyU2G/CI2+h1vmtTGQFRdq/
tuwnmp8e1szyZmKRN/XbRpefRO3w8jTjE0xsRxW9D9w/iQ175gfcuspEre/l
ZFreCLGdR6fU/R4H7zXTqyuDJgnStwS34Dom3lh+yNPsMx+8lt5lJ9nJRK8N
9dT34sIwddbkxuUBJpakdScPHBSHKiWBS83z/8V3JEFsMEDFlsxCq5NcXaYv
JaF3iCVyV4eFzyxmUu4fIIG91vNDO8xZuDRDNdXGVZKjh9xfK25hYVTA6QrN
reJQpnN822YvFmZ5mYWJNwtC1R+WF+UIC29vu76Hu2SUcPgTUGd3iYVX9aJv
HAufJPy1WZ3n0v6jz/MGZ4ScCNLVsWtDBSx0+VTmO6RdTazXUEheVTvHB9wD
CUrUryyUvCdyUcn1PrGhl3Y5uY+FRjmHU1y6agh5ucw15bMs1DiZ5GmTXk0c
O1G931KSjTyfKoz3sF8Tu0WHWHc15/R7S+thmufqufiMy8TtXz4ebCzSPWW1
Vq2E8N9eeZ330Fw/NiHW2KXjkWycGN/nx77xlFiRrbmi9H/6/TPvsk7p583l
d+1NhH1K/qffv9M4r6f4DgoG3VQIHN2sA6tufFi+0p+CHtaRDbJZyvBo96+a
DWEUtIubypdPVIY7u+ktjDgKFlbfUMIBFVC/Yb+RlUFB2Tek3J/FamA0Lhrx
5RkFl3zikltsoQrN16hNpGYKXokWkKM6q8Nvl9w7yj0cPiCuGkx5aMD9bSLn
eocpqLDd5NeBVhX4FnGWAytUTI3RXyVYoALpzA0qAvIcvC3uWxO0SgGGT7I2
Jepx8NlauHLdVwX4sHb6xyULKq5mLjknv1seVq7Zt9rfiYqj8VEujX9kQMuH
mprsQ8W2a6l59zjrPf3Ntmu3Tv2tv9knDZnbPWKcr1FRaP2Ct/+JL5jJn07y
SKdiTYZ//cZFi8BF4pfP9lIqrjm39yjdgAzzTI+tS2n8d36YHBgljOY8+U7F
gqOWCfFaijCkJqB+YYiKU+8yLJbfUAEz6rKMB7w0lKPRt5gOK8PCzzl9hbI0
bLA7ePjmTmXwn5rN2biEo6d3pimLTCmB09Y3bVZAQ8PX9X4P5ytDwzdK9XJH
2l/9owh1yVIv93vTUOnkdy6HCRlwuGS2NvAEDd1vaUqYeEuDd85Ym9FVDl5r
fWU3NkoBH3dDqNU9GhKBv/xF7ETBIGqw3aqYhqFdeqyVMguBadH37MMbGoJs
2IpPygIwtElN6PZPGrZUfIhyMOYD67QZlRpuOs7vFD5+uYwftNX0pzuk6Bg0
SVfbZi4A8V+NHE9q0bH7ZszJ0AvCcLkqT+ysGR31UkWp0/fEYeG3M3EHN9Px
SzlJ//8x9eXxUL3v+yj7zjB2Y0tUshWlOs8dWRKVooikIkukkCVEliwtKCWE
ogWRkC07pVQqKa2SObMi+05+8/7+6qM/n9cxc+Y141zL/dzPdZ+ZlkByq11J
ZUeocEUl5vCag0RU9gAzag6kQgs9KpT9tCT64PzwSFICFd5l5G6xVZFE57bp
pxVmsfzAqdpJ/RwCqnESSi5/RIX1kobjJqoSKOx+3XKzViqcLDime5alB9vV
+n5s/sTyH9micpJ0Asr7cOCscj8V/InKM5wmBMRdxdTcu0iFPWc/vDNMJaCp
Vz5HbMVp8Huzd3wyQQL5EuLyJVbQwFqqZkt3NwH5X6qYU95Ig4R3yljDRkG0
3GijmIIVDaYrNNbXrxBDCjLv9d1caCDOPrCudkoMtaxywcMCaIBEg1+uuS2O
xk5E39obR4NLy1/9SrgiiYqptZ5BmSy/QPWqN60lovHL26fjH9LgygbuQzNk
KdTqVcSm1kyDlETtwfUirN/vSWmeKIPFL6baPGsGuVGw1gRuuUD7g48zmH/X
6lJbUTpItXKttTo7j80/mLmgoEoH67fdbz1ezWBCVV/99A1Zeput4o6I9xhW
OCGmaGhJh2Tx2wIfOEax966K25460WFnYq767OgvLJbnVmfFSTp8/dq/d+3u
Aaz1e6Dqteil/d4LlCPnmtNY/kFqv1zb/CTWq3gn71vh3/oMB1JfbWYa10mH
1UAvV3bjR3K/1YXDKXRw/jBYH/dBGKVzKOCNM3Tw+Yr2DF8XQ3kbeE3fCzLA
n+PL8kfHCGhDbvzjPNKS3rfHFHVa9BnwtGGz4aQOAS0X4jv5xozxJ/9ZHG0U
bl/l6sCAU0cZRlpvhdDs1kUrZx8GyMXSDS/3zmOm+fH6ZpEM4Mlao9MWvYDJ
btVQD01lgJtl8wpP+wEsTLD+bkQ+A3Zv33dB17cTc+en65nULtXre43UX+99
y4ADKiM1ZvqlWF/WE8095L/7wfWYj77asq//5PvHzi8zbuNd6u/XmDIwu/VP
vr+dauS+59pL+TtC0Yqrv/+T779b8sqZM3ZM4A/ZWL65LA5T+HpGN9xziR+C
OquLfMKYoJQ3Jdd9rhI7MC+w7kEy87/fu4TcVoq93G9rUX2HCaVqSlYU/Xys
labrFVPFBF+vc7eMzHIxzuykcel/+v31zg+HfrUgw63DwRXMNg3EzVjbWu1I
hlOUwj1vWXxwNCyaSPElw+9jlqEzmiw9b+IT9CaKDIX2q+TuOZNQ42Yrt/hr
S/n+9R5wKKmADE+qA2WOTysjs+cJCjF1ZKBQ9RXC+5XRAXsLk553ZHixhuNy
rJ4qmpX7jjdSyKCU2B3je0kNqYo/s0ieJkNnlexQ6A4l9MWotaZYAIeVrQ6G
1+6RkMz1fRsSFXGoz4dTyWoKCFftNTHQZeHti5pEi2fyyIgS5qhtioOa6w9Z
3EMGyXzyNSTa49Bg/erESCwRxS58OnPYG4e1WgSi4KgECrWV3GgQiYN5hHvq
6WJJNP/jfu3MFRzgVP1hCRGWHr25y5L3Pg4yEmM/xqKIKPuCVRbXExx2q+pq
4j5E1FzcsN/9DQ4++yo7hNhkkc8y7kt7yDic8jtlHfJAAd1NyD2/ehIHMfuo
F17jSsjTxPaiDR8FSnc/9S3LJaFK7cwcA3kK/Px87tLYBkV0eecnNLCWAk27
LUbNfyui0RyNwUFjCmwXaE540qmIelXfOn23o8D52VlxDzV5tP9r/zodLwqw
USVKsw9KIafWb3FCZyl/9j8lUf8P5ZzPyRTYOhb4RUmC5Xe0wltG7lAgblP4
ssgYYVRQ7DP+vIoCzPgpc1VlIfTFZW/piZcUyKA6cVY85UZXzXaGHvnB4q9d
OVPWkzzos3M237ZRClybIUzvPsON8guW3/HjosJH/bYsXj4etHzl4g4XaSoo
lYxGbKjgQczuX5EKq6lwdfOQR22xEHKoGWteiahwAWMeafwhhuzeWD0n7aHC
nXN7Jw02EFGPpPy6sGMsv9BSUZyhTURDSU1yR85Q4U1voMDzE//lHTx5vv4S
9Q/eSKJSufaIfbepgLqlJVJzCchVy8fU4DEVSEelTHjVJdDtU9w3qG1L9R5P
xuOpvq9U8JFbJZedKYHqUqplXv+iwnPNVre8MgLK8NG9I7uMBpu+9E8e1JFA
y8MiCsYkaTDs9YO/JYaAputU/Ks1aDA0dH8Z5x4COq3zzeLVZhoIX7l7Pi9A
DJ3tZpBf7aJBeM75zPILYki85DhFx5UG0nWfk452iSHdJ60upGAWfs96FnyI
J6Bv0ydvzyfSoIVdVb5Ri4jEPPSH1HJoQAg1M7IwJ6JO/gsWQmU0kHl/wsrP
WBqN0TeqvvxMgy5nI8attwJoj8ro17oBGkQKm6rcLWdHW5IU5gjsdDC+cjZm
3HQeK19LSp0g0OGMHKy5t3weq2APHGtRp0OE7fiIJGEWAy6y0w8jFt4/UzXn
qx7F7DfjH6qt6aBW5pR3VGoEm7375csRl6V6z0pjar9DAB0uHTxdxWk0gPWK
mjVhcXSQd/uhcOHTEKYiXnf7ZCYd9CZo7kzfWcyi6LmgSjMdXtzlY9fj5Ear
TXtStT/S4QNJVf6ZrgBKF7XoW8WgA3WP7sAWLWGUIqxxLXGBDrIhN9/6fRdD
rP+IVn9Rlt73kt4ld5SA1HLplZaqDPCrP2V6miaOGg15Kk8YMmCRrFR8SoqA
cLa6FhvLv3k+4ujqnJsT50EG0Hmcn+zL50UdK1cs4zzFgNu7d+e2h45gV+M2
eo9Gs/T5w4kbMeMTGFmmdYvJDdb7R5940Xq0EWv4oZyoWPQX7zsw1e6PGfQG
Bssvxrn40dswSfacqt/vGWB6amMpsbQES3H63feeygD3bSreuVVN2I2B3elB
M0t5/6uKa5w8BZkgvG75tVnW2vx2EMWCxATNKC1led9G7Ndzy+DT+kv6v6dI
1ELegYXfBcS41c2F2Irj0VFqPkv4PeO445xs5JLe3xcRTw9IXfIH6GPGC/t8
JvyeDDjEIXoXIwV91jGsZULLuiDV55/isfpqtScGe8jwwDX27epOTRTS96vu
YAgZJLNDRUGCpf+3jsVLXyQDzxPTR4etSejQhwGumzlkOPJJ+mbCG2WUlz73
eaqMDDPb1ye1NCihUynO6hVtZBAWVLPlEFJBr2sNq358JcO+uMvi3/NUUYk0
TUdyiAx7Aw42OxSpIlI+U62EAwf9/B0Y5zIlJOO1zFdJEgcdIzPPhGvyKMf5
kX3HShyKM4PIW/rlUEns3nHjTTjsedW/1q9RDln2ClCSdv7t15RGJ4/L7IIj
OHSm3BU/ESmBlFfd/O0YiIOxlUvi5w8S6KDcRGpMAg635J1mFOWkkCq6fU80
CwebExyrpVfJoIBrR4UDHrHu5+HzFq1j6WvF0BGjpzhon6nKeO8jjWq+8BB9
PuOw6dqys4eG5dGD555qRQMsPmp54o3qSUiToVS8k40Czx2jiQEBSkh3068L
L8QpMLW74V1eEAm1Nu3kP7uCAnjz+ISFvyLqC767cWEDBax8MNdcHhJKOCrW
aGNFgZ5NoWudUhRQfeT7Bn4Xlt5/t45DvVkOhb7jXaYdQIGWzpG8e45E9GyP
xFqXOAqskgooXkyQRBk8pz9MZFBgZe71I9ZUUTQ71P/O5eHf+YwiCOed8uZt
pgBxk63exBdetN9uqib4AwXEHpNk+YVZ6w8CB5volP/Nb+yLDTxzfJ4Cvzp3
zceM8aApz6lfv4Sp8EFgvePrEF6UFinAUaRMhc4JubU1efyotV3ymd56Knyx
y6dFqIqiENP1vckW1P+dx6kdL/Df40SFFb+9m/26iCjuw9UdESep0P9e0Hxt
liT6Qd8jWBNNheksFRvRHxKoScvdfF8aFZzRvZgSlv/Xupf8+WUhFeoUaxW/
drLwwGYXX2g9FeQ1tMzSJAjo/trlA+PvlvD+MfZaZRuFCoazK+wexkggq3P9
H6anqTDQdERRYz8BnZwKf0kUpEFhRUxE6hUCImXT8o1Jf/PyCWh/8B2O93o0
2BItnSjDur9cbNCjDWY0GEwRXX94XBR5Ps35suwADRzLxF9FRIihbQZbzDac
oMGRh0qffhaIo/tfSzLPnKPBZ3zmvGA/AaWVBh1Xukb7w18svK+1TcnKp8HA
1zqZVarSSGq6bd++WhrUnDnu0moghZ5yP0jXIS/t73p+Dfs5OEmD0DfBkqIr
57HMn61eEvx0sCq6/fCr7DxmJ/Ozx0KBDgnTxmHsinNYVozNq586dHi87Z7W
8rtjmI/KZ+Hd25byPF+OjY/O7aPDW0fr81aDA1jpJOf5E1508MsovEOI/oWt
WL36ZE04HT5ezhU8cv8Xpnz13gf3FDrMkWLrzK0msAdahkm/7tBBW33j8ajC
RcxxLmhiw6u/57d4UPSafLuMH3TYk7Pytme7EDJM0dI9NEb/37yJ0xoau5O4
GRCNve2mxYgjNDa9/7UMA5zOr20iiRBQ6pD8V28tBljqJW89mcbyYwr7yyjA
gF7/IJuNu8VRz1n1VTf2MmC9UdRG72ZB1CU+sEfCnQEn5E3id06zI5svTzvd
z7Dej3IlUFtpATv4fvyl4mUGtLdsNW5kDGBjv9N4tuYyYNm9za2OxvUYwUlM
62QFA7LSkxxvV7Vh9YO9r5f9M993sqS1xfs7A0K6Dhp/3VSOVdzdbC8+vKT/
l78pzI5cxoTP/NInXh1vxb5qrN3UJskEo6cU01KsHttcyb3HV3MJvzUDJxqG
Ny/tv97yCHr1YBcTam+JtMXaJWB5l4bjdY4yobwzrMdxWxmmQw27eTFwCe8t
fA+tsvpnvu/g6qr5wGwmnNaf1TlgU4bJyVEqHpYy4ZGf8rLHqbexrh6nuoxn
TCC8SbAr53+MBZH4M+OtyRC7tl5zfIcWGuroLnjlQoYLjBON6sYaaOhhNfNW
ABnOvexXKhAioZAW7Uj/ONbasPpccxYJJfHeXH8lgwwv9avu0ApZeHdOQd7k
IUv/Ww47bbivjBzXTNy+2UyGhpzymjORykicH373fCSDWkCf58ttqshW9nCi
F5MM6so+yi+uqyHlg58qcxbIQI96Qs2kKaKQ90ck3EVxSHi06rgtBwkdPBP9
YrUqDtHZO13lQuRRu2165mYDHI5+7nv9nV0etRx+mtO7HYdM9sN77WSkkent
bSarD+LwgMtw3352ItpLMKpzPsV6/eN4DpP7kmigitO9JwYHq/TsW6sGJJFI
klop5w0cuh/2nw4OkUINNxzWNDzAwej6Qs7gGik08wE3U2rEQeFS3h2qohSq
N8ENvLpw2B8R2iWSLIeEqFX2bHQcvAz5bUKSSIhe3SezZQ6H25cFaP5lysi6
UUlQSJgCwjS9F488SGjzzITtV6WlvIeqow114/oUSPcv1tgQwvJTHFl2OeYU
OBrQF3aZxcfW799dGj/w9/yVPBITmPlaGUUB05SU1d+XE5Gx/6sa2rX/5v8G
Ct2VISA24cft+QUUSNMZeVOtJ4JMv+nqeNSx/MA2dp7it4JI6tudCv+3LL44
06NjGs2NTgtpeYvhFLBXc3sgNMONDvrxt+yfosDlefctx87xond8vy10+Knw
lvi1IEGJB3V0xahzKyzl+9u941DV0KHCxLeRwihLFj6ype7+bkIFwk0LObs+
McR3OFRh434qjPFccv9CICK9yU+N4cepcHzb8E6fU0REq+VLFYpYmueyoiKZ
x+wKFQpCso/PVxPQ8M81RaL3lvr5tyHn+5+rqZDBZv7hBE5Aqu9imgdfUUFK
mLg1Yy8BJV1tErzaS4X7a7VNq90kUEyCzXTfGIs/Arwjrkuz/FDZ/ippHhrE
FTx9NDxGQGJC+gUZsjSwy06ccy9g8UnGUaNnWrT/5qW9ixEnoPYDBQvnttLg
Sw1Tv6tHFPlbb3Om29LgcGrG15uloqjQz/baOk8aiEu1EUS1xJH3y42Lr8No
0Flh8OK3ggSqsQ3gFk6mgXuUgqxVAhGliD1FfXk0iMF2XsQ7pNAke8Hb0koa
9NQ86zt5TBodCPJzDu+hwYq9Zw9lqAiig4uVPR9G/ubBsaFfVSf1JLj+9t/M
Y1x32GqypZfq/QUt+I/O1XRwmXL/uCpmBvtE6FmfhuggrpWvdQeNYSlpx3GH
PXQ4t13vRZFmP/bRerjEw40O1VvXr/icOYjdNYgv5guhg5Eju2kc2y+MbU+g
5d6LdKjYm7T1vfsYRs8Jkda+Rf9Tr5nDbLpyIrXa6GDD1jQS4s+NPlUbT1K+
0KHy+xmPem8BRH9nxGf6iw5iN26nOdmLomi5/LGLHH/PU4mjBzf6hZQkGbD/
jlnQsixx5GQR9cJRgwHfAqVtlSwIKH2V9mPNzSw8z7KMykwRR4fRqamJnQzQ
nS95pntCGJWfz98veIQBbVP23MqjvCiJfZJZcZoB67rehygETmAzRdfleBMY
ME9WjVUIWcD6LxSrGGcx4LHBdPtx8XuYZ1a64/NHDKgPsNJ6+uYpxmWvu6Xi
EwNOhYu/80H3MFUOhSy/ftbfb62uNTnQinV8/y0X9nsJ/5cNjL+SEmOCYYpV
+gqpZqx5NZJzUmOCnIhQWd1oJSaQk5Opt4EJXFZNPv7eyRhSiPRQd2aCrpKj
hG1wObZaIzLp86mles8tt492+rFLeH/7Y87o6XQWfkueIr6424BpBaPG5cVM
kAkKPkDa9gALKcyY8mhaqu8v34O+UPaR4Yu6cEiIzirUkK4eNOpFho1NrrEX
H6giTgnVZNmzZIj62Fqoa0BCH5sep9Qnk2H1xI5MnWXKSPvWpu67d8j/zRvm
7mcoI6myT9cKq8iQJTVft9tVGcVNvSjseMW6Hr4zkEtOFcX4aJ/q7SXD112H
v01KqCEBqeOfGsfI8OKQwPuOCSWkMD5/pYEbB/evKgrwSAnVcuS2f5HBoSCa
82KushzCjXsYJ9bgcMTc7usgRR5drxTasR1wUD202XzTrBz64LRXA/biYGox
uZJPXRplrh86YOeOg6a25bz8Owk0DIuYQygOkxqST4tMiajjLN6y+jIL3+8d
rSijSyLDYYWb8rn/nQ8mZpoKyqHVV3xGNCtwSFQkz0eGEFGhu3iGXTsOboo/
NpY9lEEVvmsmfXtw6LN9Qfz6WR5tL5QbsR/BQU4wZ1xvoxLylHIBF04KnE2K
75+oUUKSVTUCMVIUiJ1trxYXICHLhPxG5VUU2Huy9E4FSRHxX75YyYlRoObI
ivh7lxSR3bNYDU4bCghY0p7eOaOAVmt/GFZ2o8CuHK/rfd9k0KVXaR5rQ/7u
z0qikAydc3wXKTCwcUCKOimBRjIVh5fdosCRdXhqQb0wGn+r/Fm6/O/8dyEU
YfCkIP8ZBaC99UKeKEuvvzVvCP9CgUsL5HXV1/nQxsx+a99Byv/w+1g6WS+C
nQqDW1qbpvt4kOLL4SsPCFToWNCNMc7lRYe1rnyzUafC1fHOFaIWAki7VdN9
ixEVTLg87q9ZJoYSLnT7mFpTAc2+bRMSkUQ+5z+3Hz9MhWs9DzN3FrPcfPmu
T5GnqSApLP1tZbQk6ibcjHGNp8KZe0lPgtQkkeO9LXHHblIhZ0jt0CVVAvI8
PsEZW0KFWre8vu1TBMR5FI4rtFDBNtPbNuYiAWleOicx/5HlJz7MBMwfJaAv
zE8bJhlU8NugWBaiQUASIdFlQr+pYNHEzt63lYC+Gd3pkRCjwfCi12mebgLS
0s7I71elAfVN3NTvPALi2Ud98cOQBrzvzHJ/Swoj3xJT12FL2p/5JmLo0KZ5
W8VDNDCaTOwEbzH0fXbF9CZ/GpQKD3ffiRdHeP+KjRrnaZCT2r94wE4SnRYO
faeXQYP9Jqlpd1h+7aorlexQTPtTD5BCm35ReuYaaVAWunrDG2MJtOY6/gGn
sfhoRHClmhc/Ol1pjHPOs/yJtvslbrc5bDufVJ6ECB24O6SVP7vMY/cvNy0b
V6aD3czRLRs+z2IpZo1Vw+vpYBJuUBdJH8U4dbvovNvp4LX8epdyNWu9M4z9
5j/5/ZeyZJ0CfOnQe2sdf5zsIJZHeqPnGbVU7zf50O0cdp0Oty6mBcQ/nMJ8
aye4igrof/5f2JGr8m6Pbe/o0HP1py9hhI+FF0KVu3A6hHdlqDPERFCsjZJD
yDQd8hN7LNbGiCH39fnFKQIMWGBbSFI6RkBdO7hygxUZ8K4pbnyA9fu9TK0a
CNdjgHlqA2Uza20tGvEox3Sp3u/Q8O3gJnsGmJTFxCUZC6PRbK2d8t5/++/Z
EaEstUYmgsUXwzraDzaxoebp3WfWX2XAWvZrQ7IjODbnGzWI7jPgDTY5/zH1
PVYvm7Ao/YQBuTLHE44XtmECMxQ30TcM8Bg9uzFU9BFG5dlnoda31N+/3dKJ
UPZPfv+Gxv3KsTxL9f2yYx6FAbJMwL6nGXhcb8Gq4E181NolPDa13k4u2rpU
73e56KBm8888X65F5wIjDyYcWb0++01WBbY+N6QAQlnr1h2WfXI12Egwc9E1
ieUnUmfu7jtfihlGveEKzluqF/E1xBc5VDKhMSp4VNOlCNMSI0W9/ie//+P7
sAu6O8jA2xl5I05SE819jTIwdibDLfmbCosiK1GBpGKksR8Z9J/b3+WSUUB4
1Jt5pVgy3PQ1vvlxmyK6rxJgLXSDDKXH413OXiGh6YmHW5gPyPBcs7xVaEoZ
dc42HBJtJENMuNzZyyXKyEB3262DXazrbonnnp9TRSszFQ0l6WRYHP5Yz6G+
AuUZvmGTnmPxjYZNcMYVRVTATXDnF8Yh+JtoK68OCW3i9WH/psTS6831r9Jc
5dG+zXW+Nfo44MNPkkPuyaPF3FvhceY4ZKxNAK0WKaS9+UD9rQM4bB+9rpWY
TkQDPAlyP0/g0Dhr1S24ThLpcwu9S4jC4W0DwXmgQhJxGR6rPHuNpfdX5Lzq
5pNCRzJsNx0tYPFB4Ce5yU4i2qEjPXaljsUHk8ya5yeIqH78x1g+BQfdAqKm
EUu/mysb7348jUNaZ8q1nxosv3POyKpEgAJ6ujMqZiy/MkuwOBOvSIGZty3l
U+tJSOWL5VlfXQp0KRv6bmUqok/vyEpmphR4tne58AlZEpKa3zXpbk+BHvOp
4BlcHvXt12OUeFNg7ZsAzVOOUsiQ7ql7JJIClZu79o3NSiJiQWDRoaus9YOm
VfviCCgqS7rN6j7lz/MihIKevhWTfkIB9UMbMwTXCqFZhTD90dcs/zF7LUY8
nAstL6wfr/lJAZ6ClY93ruBBmR4fqB3jFKA5TaYzY3lQnUNkYCcPFR4lSzQE
L+dBHuFbN5bLUqH+CzdJZTUPyuma7szVogIXMzj7hYMoOuxkwhe1lQpqF1f+
8q0RQyVSrn5FtlQwv64aHlQqieK45mYXPKhw3cwvIu8yEfWvoH6qCqPChcUb
DtQ+CfQ5+C69PokKw9FGtdRVBGSzOHetPI+l7+2qyykHCci20i0wrpIK6asd
B0rLCAi/9WyNZzvr/ufLft9YTkAL9U/OGfVQIX9mopgiIoFuCcXy7h+hQtiE
T/RXXgn0NulpcTonC1+z+ChtohIoYZtDgZk0C1/tLm7pYun9t6tbu7HVNECT
zx0tWf4hx7QlVx3R4Ob1w8FqcmJoNuX6LYc9S+d5f4j+rCs7RgOrQ6u9Mm+K
oV0tZ7UDz9CAbC2yw4D1/jvujXXFXGLxh/n2OO9zRNRZN0+Mvv13HpcUwrlk
Lx56TIPQ/3v+pdE97e4m1W9/zxfwo/2itt8thmiwUSpeRj2RHV1TNSemLlua
3+vomXRvO5EOofdyfJ2d57CSviIPS006tMcqqZI6Z7CLFw+1G22hQ3+uy8KJ
Z6PYhOdKJ77ddPC5mlZ4u3oYo4dQnlKP0GH5lLbtA9NfmHudwevSwKW8N19d
Z672BDp4VpvyaZ4dxri+yPa8zaLDk7EZn7Fzc9jrxvK2+610sHb5+Mp1igtx
sImaJn6iQ8Inhy4uMj9qPrl1sqqfDgw1YlGEqAgSkGS0CrAxwPElw0TEWBz1
DeCMdnEG1EXyfI5g8TNMPkZdK5by+tfoyq1/vZEBI4c6HuX2i6O8nOtOeVas
9Zvsppv2IigPeA7EH2KA/qg7lvicB2lLCE05+TPgraHTuvm3k5ipLKM17DwD
Pvlv+bTj2SxG27PhUUsGA359Iy7s5HqEERp6xvweMuDYRc6sHt127JWjvfuJ
ZgYEx13NsORvw4TWeJxx+MgA7X7xNeqfc7Fvay81qjBY/DI36krKa8X0Xe9/
nZ1jgB5yL0n3b8GIr/elNv2T3x9z7FvEe2UmjJsshKHlzVi4/iTfh/VM+L0z
gJ3nWAYm4mZhf9uRCYIlwFFNqcXy2zkSzvoy4ZnA7ZCYnzXYa5fkgXtRTIiU
Zd+yrr8aC12V6j15nQmfHxbEpq4swyrUf5k8LGRCJeX1Edcfd7HXyTWEd/VM
kPhAJQ1cvYG5cJW1X7IlA73odrl76irUeCZevS6UDEG/f4UY1ZDQlnN7hY5f
JoPV8vCOeGElZP6EMKSUS4aerOcadt+VUc8Kz6rdFSy8FlMlOBsoo4XWqx5b
28lw/GzpgrOACspP1Zc41EMG4/79O3Y2qqKeNI0YrxHyf/2G+6odVVBOx9g3
A04cXj9OepB8SAkx1++RD5fCIeLukVxtKXnU/K5NSXEVDq4dFndvvZJHKtk6
pLYt//XbP3yrWyuPRLK1uRm7cVCIXBbk3S2DYt8t//jSFYfxuy+ke/sIKG69
dfbXYBxucuHuFAEikuwYWP35Ag72o6uaW9yISCvt0O3rOTh8NTu40V5UFr27
6sH2tgyH3L2Xh7ZMEtFii5npizbW51FVMFB6Ko2q1DJih77isIL8wkj2jjya
rzZOXDaEQ+rKIavaeRJqj2gK/MRBAWM2gS4VfiWkGtK1Q12SAuFbjUeyiSTE
fXee8nYlBe70sA3qGSmiwOUywZGbWHq7ruX9SwUS8k19NV64kwLbs8cLW/QU
0eT+vfuvH6HAivRB+3sysohr5+6Kh4EsfX/jC+f0eSLKCcz99DiBAqYhFz4u
L5BAzzrb+0KzKJDHW6wSxSWKAg+d/1D3iAJav8025ioKoVKS/QX71r/5DXwo
SJy0eb6bAoSoxn31uXzouWHoR6l+CtxbjJ5+xNL7eUlF+yZ/U6Cs9VJpvR4v
4pf1b7ISowJ3RsPEtR28aKF759CiKhXib1XdMXwmgELaSMRqQxZez/NXRpwS
RecYseoDllTQCFic82HpacktzYq9zlQwDD9kc6qWiPSenhJj96dCk8t83nCq
JPoaHvRC+DwVnCNM2Y8nSiAhrz3uP9KpEOzbkyzzWRy9im8ZWllMhVtyKq/l
cZZ+/2pu9LqRCpyhLTXrUwiIfrAlIqhrqf5jLvG++CaNCqun+U1rgYB0fle2
Rs2xrjPr+fRdCeiutNiHa8IsPR7i9mbiI2t9rCn/ujINojuqG7bnEJA2fZub
/XoazJ5V7dt2TwyZZjjzp1rQYNxsj4RtkSiiRFinJTvRwPhEcaFOtBgSvVGq
+OQkDVx3fNuaMyyGnpG9vDqj/5vvUpE/3yyBeFxmswrSaH/2o6RQp4jCk/lC
Gjw0P5Ck+V0KaY7ZZeTX08Du5NjtM2eJKHinuWEihQbLJz8UusryI98XvX3B
Myw/ovnNNkN8DhsN+HU+VZAO48nsFyeT5rDfe3ePZJHoMJEf+H4FzyyW5ha/
1UP/b/1lDKsusAstMqNDmh5Fnq49irkrbQjZ4UCHOu8azqGRX1hOu8ipUW86
NOpHBl8YHsSO3g2zEYukw4/DORePH2X5gYlrL63u06HGd+B2zgQb+ink+rCh
gw7vtpfnd3rzIgfaV67Jn3T4tjyi/FynMDo0qm46OEGHp/kZlO9uYmh4LeOs
KB8DBvm3m86oExBfzmKYijwDeiyfShqdIaCSrf1HJrUZsHmo9Bm1gYB+Eo/r
GpswoLgM/6lRK4YyFTmeMu0YQMIWHj46JIJw+4u7b3gyoJ42j9Mc2VH5s6Jn
TWEMyPg/vbvAws9clcJkBqjTvT48uc7EpgyEzjTdYYB/ysFawZk3mMemjmtP
qxjwjE09vzDpGebmdyQ94RUDZBpuPaPteIL9+nYx9sUPxv/6cdiCX68/MrpU
z8ky4/i5jGupf7/N/JWfgjQLb8NyFU0KGrGQUK9fM6uZcKdDsT722X2sqi97
907EhMB2mQ6XtQlY5BlG0KINE465bN1AuRiOdZmuTK9wY0LxQkJn5LVyrNxk
PpcWzARPdg3y55/VmHzAndTPF5fqP2KfWiKn/8nrT/E20OV8zISDI69nT8zd
wyKnt+Tov1jqJ5L1Tivs3UUGwXAZdsqUBiI3rVKwO0oG6dTjbnmHViF9i717
2YLIwFdisi3ruCISW5bC2ZbA0v9nP7+cGSehoKFWBaksMigeKc7zXqeMPIUu
zt18RIZBRqj//gElRHPWpGg8JUOGi6e1YrwyGiZvOuD8mQwW69/Bg5Oq6Fx6
Xk/jABnMhTuPupuqodtRP31WsuGwadr5gvQlRbQ9u6y5VRyH69rEbb0V8ih8
MD05bAUOHLOI+0adPNrsE/i8cQMO+ozVyRYP5dF5JUazoRX+px4shRy5tdsr
DuHwCa++eCFEAtUoDjj1+LPW/Y8s499KojzPhd86cTjUDsqqQL8kkklzVpB5
iEPDNyP/X1pS6E5ISWZxMw4Fzp6iouNEVHv59L2BjzgI1s5XpW6RR47dyQ12
TNZadO9Fch8Jxe0+hz9bwGHh2nc6h7oyQr+5X3uJUuCq1HJHTVMSivx+W3uN
KgV2zK+WalJSRFZDuvNBBhTYwxTKdNMjoTy9/Ykz21l4nt51m99EEcUW2KhH
HGThb8ztfdYK8mhg7fkYgVgKnPTFXx9g8deJLUrPfW78zWsTR2Fnd3VwFlHg
ymJLRI6fCJIcu7qzuoECpcOnlCdP8SHDGx2GU51/8Z4HUU/epHhQKfCzMMRs
Cy8PIoVBdt8M5b9+6xTZvbwIrwmRSxKkAv//vT8v0lv1guBAooKEQm7paDIf
EuoQCCjWY+Gp3M0zwmMi6FQuJc3AjIXvBVofHbUJ6HDhlRfPHFj4/dO9y47l
j3ooFbGLPlTw/Lnom3JBEpFt1u4+eo4KI7qmGYIPJZD/aOjKN6lUOGhV63wy
jIAutTq3+ORToU0/4/THSgJa92LfZ81aKoRPb5rp1pBAbmzb9p18Q4Wdx1Ik
qPcISNmzLW2gjwpz5adI51h878GlSPOepMKmtCMFyykEtOlDf1MaHw1sCj3y
dV0lUNpHwYIheRrICaVzrccIKIKPM3uHDg3M9I6e/G5MQKO+yft6TGiQvz/q
/rnlYmiId0zu9H4avPFbNbjaUxQFfXjhU3mc9r/vP+H9xGvVCBaep8S/Dz4u
gTSXT21Iu0KDe7bXhPfuJSKbYxc90D0asFHODFzmkUZcC4YEzhoahH9IVZX7
JIVEGoUXunv/7icLoKODMr0u4zSolNLYcVNsETOxytiZykOH/5OLvgtY8Q/f
V+OyS/X7vDxZO4e1dIjbW25oEDWGqWQeyB3fSgc+R3XByBsj2NpnJV6FtvQ/
8x37sVbluYwBdzpkHjsdNigzhFEffbl8OJQOsjq7XQ72/sJS/C4n9Vxm8ce5
63HD7BNY+7HPey/n0qHWfuhTccM81k27YFT+gg7kgdwvVSw/WOx3+i76Tof3
J/dc9GoVQL+VPZSFORmQFKL3+oadODptOqoXKLWUzxOcucuGsooBa4Z8KIcT
CIhbzUQ/DmPAx8NT34/fE0ek3h3JZjYMyOlpm/mhL4JaX2+3S3ZlgGUiVTJA
gg+NDn7vEQ5mwN6Gcrugk9PYA2Tqf/UC43/fx9BTlWvNOQx491FEezyjGmsI
s3sqV86Apz9lzN2PNmJS7gfZw9qW6jO/o+fYxL6y/MWrT2uf6ZZhPl1FZ1r+
yeP3sLM9uMi2lMcwxJey3JfABI23+imuWs0Y22huJVWdCT8/Ba1Isy/D0vkt
tVKMlvZbT32sCn7gwoS+cQkbne2VWPH5xWt6AUvXA7xkmxrjmP/lx04shldh
zyMfBE79k8ef155i5FDChMR+q4ee3vcw9aehXzhambA3pCmqb+Aedjf7NWOT
AxkcOg8bKMlqorKLZ/rP+JBBtYaLzaZRAW0vrp8NjiSDI/nE8jgTEjrOTiSK
XiWDLVW8axOXEpI6f7Rh1X0yxLZ3RLINq6BdmFkA5xMyxFB/rR27rIzENRcH
Hd6Q/+gHVeRitvrNITIZKHI+vLxv1dDG68WrJCfJYOZ8zIrnghLKkuayNOPD
4en6zvC2NUroQsdooIE8DiUVLofn2uURV8X4o8a1+J/6oDzie9sf+NoYh7vB
3DFmmrLohlyQ5Q07HKIe2xMfWUmh0ozPP3s9cTjMHCWxR0ug/VYlvZ/CWXob
fd83VC+JYnW+OUQk4zDDXFCdYBLRVvPv13Pv4OCRLHg+uFECnU/264upwuGA
WPOxpotEtF/wxxD51X/1ocIKgUQZVP6kwXW097/7xbc4vFRA6ZkTdiVjOJDF
gntsypWQQAkbP5ObArf83fl9ekiIZzLnVZ8MBRRHwskv7BXRJR+7DP81LPzu
MCf1dimiHGn2yXigQNuB9IJkPhLaNIUOHtxLgQsc5h1yZxTQUW67+GL3v/2X
Ukhye6/cw1AKGFWEJrdbSKK9DQ2rnC9TIKP5+DctkEDyx/wXEnL/9vcLo5NQ
/y2gggKxK98XpVQLImtr+Rczz5fO5xYsOrS1DVFAuEkh60kXF9LMkxbhW06F
ggvXNwxc4EF6Z7zd+IlUUOpqMePo4kHPoz++uKPB0utqDZJRMoKI3qhf3bKZ
+ud+Yihl7cqKnF1UqOsLkWhplUTP3w4HzBylwvHji/PZeUQUl6eVxRFMhetj
EvsNfCTR+4ImeJLIWicNHS7jlET5ZI37Q9lUeLWgfH9DOEvv7VSXI5dSwcGy
8Fs/lwSaGNhw88RTKtCduI4J3SGg43VQcPYzFWRJfke1WXrcu7Gn1XqACj2Y
TEHYCwKandh1+wYbDaTbW3KcqAQkdtCQfpVAA2eNwoMFnBKofNo/H1OngYDa
4TvHdhBQ79PYNW5GNPBtz1E/NyiM0p6uabC0psGFhOAjehvF0NepfPGiwzS4
eYxabdwlhvIdM97Wn6b9ef4IiGP8J09EPA1EYkWnjAskEbVuYVndTRqctJPh
cq0gor01xQLVJTQ42x3/2GxeClkz/JWtW2jQJrX5+/QIAfX1RPhtYdJYn9/z
vSFwoNA7dynJv2kwQj2waX/yLJaTBY2pYnRwUB1QcBuYw3a160haqNH/8Msc
lrBySitoAx3WeT5u8Ns7hu2q3m3rtoMO0zzvW1zzR7BboU1xgwfpoEzSKgpv
GcJCT60wnz5FB6uAo6QVpgMYnk6SaI5h6f8yPartx19Y18RQHnc6Hdx6Gc7f
hqcwm6i9WwWK6LBNyerEqSfsiLlus8rL9yw/cWLbdb11AojrABwrpC7lLRSX
yvhwz7HwnueE24UUMdS7yeO7uDADjlPOO8T5EVDWjMDzN0oMGBh98fmCDgHR
6DEB3OsZsO+KcIaRCQE94buq/ducAT/3hY0VfRJHMs6V0xcPMMAvwqw6aDs/
4qC+2XHrBMsPGL4XDXWZxE5nhxX7nWNAoVF+qBXfb8w/ke190zUGKBBVjcqE
erDf+dPOjQUM2FYfOxzw5B0mPrfN3aeOAef0H3mtefYcKw1310t7x7rOlzJd
+bQU69EnCUTiS/X6FPnBEY4pBjjOSaSKnK7HugwfHuHhZ8LOnH4BWbwBy47l
Ir+SX8L/CS49NUFdJqzVfn4UW7yHfawe9xfYxgShqit59vsvY5D98l3evqXz
s4aV12sa/8njr2afKckIZ8IGj6r7eZ5PsGfhaz1HU5b0+UGtr4kzd5mQo7re
afTnHSxC5NvKkmom3NueOuh3Ow37tordza2DCcsEZg6qvXmAWRsYiruakyFb
++SVWLuVSOuk7DeVA2QoiXNomduviW58j5LwPEGG3htRFo7aSuhy6CPKgXNk
WOZ8L/uLAwkJW+vbTrL4YLvX9XUe3SQkY7NpnVT+3zweFVQSpxEwyOKDjbyH
otnqlFHnyCo+67dkSDAe//hgQgWFX3yfZImTIVf69mOzKjVUfuBQ4DyLDxpT
9YQagpVQkOOpDn1+HKYaS1wxDiXUetmiVkoBh8RX2E9Jln7PnAiwuKONw6gy
u4nifgXEdkndrNoEh9JAPj6GuCwa3F+fF7EPh8azI+6JG6SQq53nvvdeOOxS
8Si+pS+J3GOfzDWf/ZP/7EtEk/SRRdcUHEiMflK8FRGJhBf5J93FIXAyk/6y
WBKVb7O28KnGoXeDpQ37JiLqw5b7db/GIVR7R7o6nyzKPO586ftPHGJ02LYS
yxRQ38ts3uvjOAjzPrr3NFMJlTq5TnTzUKC95badLev7ElAeDmyVXcrbH5V6
e8NeiwLHFIu1dWRI6PDWdatPb6XAxPQwrY7FD05ZZxVMbSmQ3qbjcdhSAZFX
/3C95UGBnGNHJgOKpdH4IDnrRhgFpoN5Lpocl0RJP18bbEuiwJz/ka0DLH1Z
xb0ZgvIo8LJ1U+7CjBDyPHTyp10lBbS27TK7eVgQ3e2fJfW8oPw5386LfPJ5
3w18p0C9gLvHmCMvaryx0Fs8TAFL9RXObKncKLP2tMs0ix9qT2UvP1fBg5aL
PQ4aZPGDlq0fTViPF03fMF+bqEmFNw+MOXmUBNHpvS52JVuooLbadEWxtBg6
C87f43ZTYaBh8UTPHBGJu5yqHnClgs84W+mNE0SkW6Z5fpDFD04dBiMN5v/l
yz0vv3WBCt7NIsoi0pJIZIhp8z2HChE76K4imQT05lPn+dYy6p/nTQLJTAg7
7n3G4q8yYu36xwT0y7gzx+sLFbobTgxETBKQ9dPgbesHqSDGXSP4hMUvG4PX
YxfY/+YjS6AS5zTNsxI0SLKpuet0joAeBf0IUFtJg2y72EM6N1n+oLVQZ8+m
/+ZzGV8d3C6KbLY6WenvpEG7tm/e2kAxND6qUp9zhAYLD7JDqtRZ+vTjZVJB
IA3CmqPcFiII6GN/b59bAg32dNXqTi6w/KR+pURhFg3OlyxzT7clImqxzY/0
RzT4eWbFQTeCNFLeVK205xMNxmXv389m/V5J1oQDK/ppoFHe9T1bdBmKuxLN
iF6kgbDaoWXTD+cwfv50jwhxOpAe1LT4689j0o+vWqxdQQexR1UnjojOYaXJ
hHTXjXSwfFhZpDkwin3MsY80s6LD7Io7r3TPjmCxfWPcnc50yKu5Yh+ycwhr
tBNfJPvRYbnNimdr2gax2AWiXX4sHfqOvjfIvjSEffx4S36SxQ85IeerRTqm
MUml1ODLjfQ//URciCulnlbZRYfXa7JfURUEUOS614+v0OigML5wYUpSBJ3n
H/k0y+KHuzZBUzyNYkiKUDP4m8UPUmEHz3eeIiD9ne6HK5QZ4LLZLo60ioC+
1WaYTaxfyuMXcrra8sOC8ed+BNS+tq/nlCMDditFU8Sp/Ehs3WPPi74M2KLa
5JPaNYrhx73tDkQxwOjkc6Z21wK2tXvj9fLrDLjt+dNegLML0/QvelFQyIBZ
W0l154BX2E1jTse99QwQv6JyXTPkBZaxre9gTCcD6pmayR8TCjHVkOhpFwrj
f/00hj/P6NBY/MDm17+43aUU+xQy/WWMxQ/jlB6lwFeNGIeZA16mwATNPVvf
bhdvwSq2wcE53aX91sYvvxQS9jPhas66PbmK9zHCyQCs6PhS/WZ8w8+GqLNM
YLs5o7D9Yg12aN3hVMoVJvhKPJqYoFZgdkfiHPF7TKg/k68avv8WRngukJf2
Tx7/Jw/v3U27yf//eSnTQL83eeVbuJIhI4T5/scDTfRw668n5CAyCNm4VuZc
ICFmyPqpO4lkSP24eTyBtX5IeT/Bm00GmxMF39fzKyO2qMnis6VkuPnDZFOw
pTL6ZvM7TOEZGdrH3RuMmcpoq61s+M4vZPj6vjrf5I4q0k/4/j1nkAwTfNtx
J0U1VDISvUeWnYXXDxdW08NIqCrxUdQ9Ag73tVf5c32TRzv25347oI7DMI/9
+V+88sh9H3P60UYcxl5EhM3kyiOR+Io30tY4vNPd8vignDQyGTxWW+CCQ1ag
NN5zUgKxR2t9eR2As/iuqcVbUxJtt0rfJxqPQ89TWs1lWSKSt+hnhmXicIXb
gLswRhqFBjYZzj/EobLIeeR7JRG5fQrNzG1hfb7nF8eurZJCX7ysdL534+B1
oG/A1VABfdFpUTPox6Fjb8eiWy0JuWkqaNf8/pMXGqCEQmx/j1uLUeCZt8k2
t3gWX5bl9vGrUSD07XtX+zpFZGKcdcXTkAIBnUXciqIkNMepsPjFkgJT/6f3
FZDR3LkIf2cKvO6+6X1YRB5xqyzo5vhRQKNvPEunjIicwuS2DcRSoNtv/MEC
GxEhPiVvl3QKzC5fSf2VKYYevCjYSS+iwA/5IsqLAhF0+8mMw/VGCiS5bWtb
tZsPqfbe1KC/p0Cay3epsSIepGvQVrqdRoEViS1n5bRYer/xw+6Psyz+cWgp
r+PjRQOhHoV+QlQIHiuqJrHxojSv5jUblP72x/Ohzgu+fjn/5fGbpv9iHxZB
qb25ftLmVNjQECzCpkxAuFtt/JMDVJDnK+md7yWiekXm26ETVDgZferRzKQk
UuavCzSJosKRn64kWyIL7zUC9Juvsa6v6KBl3yWghODSwt0FLD7YnjBrX0pA
l+fLLXnrqGDo/mvBhYX/CqUCDw+/pUIQv8niAzcWvqczXr0mU+HLBt+mPSx/
0FNeyHZ4igovJpYdeV5AQCIcUa5x/DTg+nXbrIZMQC8jFzXeKNDADN5PfNtF
QKL6LssxXRrcvfth7nqlOOqTMr/RuI0GOtbnvNuMxdAWbYKJlz0NAqNOySi0
iiLVkAnF+94s/S+YD1mvxNG1yTMHOCNpUO/1jHc2TBKl3KE9SLxKg9UUe3q4
KRHJnP9UpXKfBvzOe4fjidJIK+PSILmGBlst67L320qhcQfNtOqfNJi416x4
KVIA3ePKOWQ3wbp/WskexZhFjIJrOsTw0uFb3fVH1R3zWNGEQ1mX3FIeM/sG
X2UrbTr0HIh3dS4cw3qL+XZ0G9OhWvtmyybbUWz7Ps+seLu/9aJBbIuuYvl3
j6V+nnrMPto4jA4a9V9J9R2/sOdngzw7k+jA9qKW94vaBHZwVI7fL48Ov1f0
LRtqXsBWntjmcredDqkcINaszoOcg+PvK/fQgVfhW+O9VYJIsaKU8/nIUh6/
l9rIlUVOxh89Jo6grStynzQDRqzO7HCOEUd5GTdjPq1mwOXgG6upFwgo6Xa/
sRdiwK+nB27kXBZHPN9+a67Yw/IDw80SQ3oiiM/82IdzbgzQjLf0S7DmRdeo
ezeOBDPg8NVbso+j5rDiSvXHcRdZ/qN51yEVll/a9UTYpfQWA1LCgFcrtREL
H8k8Pl/OgOez3NurL7RhBg7Cl048X8pXPjPB5Tn+lQFayp8LjafKsNyWD+uH
2ZlQamk2JuPQgsVNHq/eJcHC8481odmLTdjkAcbuLyuZ4BpKj6+5m48NjzHz
AjYt4XFA/SPShp1MWGlFzWdkpmLRT147Zx1eOm9F6vexl/gnf9/EasL9cTwT
ZEj6jnFeVdjkz6R82k0mXKryDUv4XYbp5L+z2PhP/v5zreS1861MaL2w7FTs
hRIs5a2NrrgVGSR/Rpq7aK9BkvtamtcfIsOP9U8T9meuRKoi1fQV/mQIkzec
XsGliOrm/H6xnSfD0/ufe129SeiHdLQaWzoZAnKXJd+jkNBFT+nRl0VkOEvK
ur5sQBk9G7wyw9lEBvFFrtyHwcooIVel1foDGZLWjvUrJKqiT4n7DSbpZHjV
J1TmLboCld49ReGfJwPZsaFk0oiEpMZFNX4J47A1+MOhE3IkxON/ekeNMv6n
f0wenVuhfatwHQ75hhkuK2bkUBz/iUQPCxxczG7O3F0rhaRVrpSkOuLwiP/T
TKYXEel5v0p764sDZ3XenE6CJPrMKNDwjMZBnN1oD6NMEvHe8Jk4eR0H++TP
1iZC0uhZSKWdaSEOkk/Z/SYlJJHAZcpoXD3Lf/AdONQRSkQ9H1bafOlk8cmQ
+hfH23Jo005RhwQqDiV3lDXfXyEh1bmezPszOGikfRw/ekEZXfusE3BF8G89
hoSuMi3WuJMooHqN00ubpf9ltColD+tRoPpl8qSMKgmtzctPXWlGAYvRfWu2
zCiiVzsidzo5UGBPecDgmQB5lL+ObXTrOQpw1N5xcBuSRPSAQJs9qRTgOpi9
zKuOgErpfuba+RTAEwxkHzkKI65L6xSmnlD+5I8KIdx1hxq5gwJPT0fmO97h
RLt86U0ZfRTY1Nhk9ukHNzIp8rjRPMF6fWCu38VlvKhVzpergpcKk99Ema7f
uFFHvdGeK3JU4FjVPdhrxYNcrzi+S137Nx9ZBMWkc1COGlPBdcGmmPZZDOl0
XdS7bUeFNd37z2CnicgdaW375UmF+z7bLLvXEZHmD7/FtHAqGO37rdjSL4FO
l2SNP0qmAiGuT8D+AAHtKLc+e/0OFczddQ+GRxLQQ2YLw62KCqnWD/DcWgLK
3HMp5sBLKuyNlPbMZOEzYeh7hdwPKrRHr/YiGkkgyToxlR2jVPA8upMkpCmB
7tQ52iRw0aCPInclabUEqhu21FSXoYHb/LFWU2cCcrEjbdZdQ/tfHvDlX8EU
XmDp9zj2a8v0xZB5ddXznXv/nrcSQxcqBE7kudNA/aq12cUSMeRA5azfF0qD
g2mC15JEJVC5OW4WfJnFB0f1E99fIKL072bHjuXSoP9tT/HDW1KI746vG1ZB
A/t2m3SvB9Io4eWII9d3GqDeZ82bzQRRhuYXpy3Df/tF2ZFBbbdSzHL6n/72
ecwxIuSSphQdkksO3Pv0fA4TDORYv2UVHZTlf7OvqZ/FtucI+ylgdHgvbxf3
fXQUE5n/eZm+mw7HyeLvr10Ywg4n8PZ0H13qz9xiWdF0JYgOEccEGDExg9jd
Lea9dYl0uPOz1ProxhEs/ajz1fJslr+wvjt/6+4cpmDuPZj+lMUXJ91vqnBx
ozJOVXPvz3SQ3jHtnD3Aj95ONHwvGqADnvez8mGDCAqWOrl+gY0Bsqe+ypid
EEdF3m0GhQQGKH6N7rbhJqDjExz+beoM+DbiteIXHwFVPGzZVmLEgH1jZr+P
1YijhEyLqXPWDNDfoVKbIsWPmE9Uv4S4MGC6I3tb+DJu1CUYY4MFMMDpKd+x
pgcsfktp5zwVx4COzpVuOmazmLmFWmhZJgOsT2yTn/bKwLp01TL2lDCg2kkm
xHzmBca05ptwaWEAH/5pg4F9G5Z40x/f1M0ANScBo5UZOVilQl4ZO5MBZon5
MgXJLZhP58ry/vklfiip0t1+W2SpXyf0nZJsmwoTuiVuZzR51mKdctciqwyY
8Ki9iM3LKgFTtjyIXXViAqdVk3nhh3JMRuvUDpd/8vczjb2uZkYv9esXJgZn
U9OY0BajSd4g+QTzmevwaG9Y8g8Ky+J8T9iRIWXT499z9asQVVk8ydGTDCRN
Lr6i26poY4DK5ZwwMizbs1LW8SgJEWenF7cnkcErr8Mk7owSOvtI5Zl4HhlO
3dLk0CGqIL+M9156lWSwPpOzsBFTRqOV7hwGL8kg29u3lRapgua5xA13/SAD
h6MV+9CUKkqKOxxtOUqGb92RUmklyqh40/UmTS4cbvD1BrRxKiMHld09h6Rx
0JvY19aRKIcubXp7fGEVDl0/NvZKNMkj67i8XVXYUt5+Otdv8XYbHOyYc12R
Y9LoROWm5w1u+J9+RJb/T0+SfRmCw8Ah9s3pJ4noSUl8TNVFHOifN1lMRBKR
zsyx3vhbOHDdKn52LkAW6fu/lCktx+EF78nkADkp1KhEMK1/jsPFxc+SD0Jl
0Ef2UyK933DoTz3pPSmvgIIIASPkIRweqql2bhFRQnftnVpeLqNAb0Quf/N2
JXTwXbs/H5ECXVbKm6sOK6KcMwvXH2pQIFo3ZKLWUhH57I8R8dtMgZsu95+t
FyShtmMp7hd3UeCcwg/tVwwFVJAf/SjxKAUkv9BHOLJlkLTChRvZQRTI4jEc
/39MnXk8lO/3/1G27MwYZBn7UkmFVHKfI0lSSbRIsieFktCGpJKkVNKCJEsk
IRVa7FKRkoqUpdmH7JUs+c3n+6u3/rwfzX1PZubxOq/Xuc71vMiKFJCpNbuS
eIaBA6+er9j4mgyXU1+eCrzBwEfKG+rPzZaCrNzuTWlFjD/zCxIAnKdJi2sZ
WOAhqObAEQUv5/5531oZ6Gi/SP2tnBiQfmfe+tUzvb67rgVncacY2LSVWr/a
XhRkv3jYL5Bj4r0qFYZajih4KqwW6dRm/tFDCSBORpPvLGFiNd5vfagqC5k6
KwVe2zFxnbvOx/1nyJD0i9vZ4sZEl37bhO/NFJCbynQZDGbiptn7tcJ05UFp
sdBA/yne6xUdO/awyZB3c01w83UmGpnkkockSFBvId8qdo+JG6wONxb2kCBQ
MuvunUomMj0zO8l3SZAufaZ113smHnEfwgNpJHBd+f1rOJuJ7eHpWmqWJMjK
s+oInWDinLSTM4SQBIetc8JOSrPw1XPn2pobJGiTva8fqsnC3maPxtc2JKiU
SX+1ZjELZ59YVyAyTxZMVsivDbVlYdqFo0q7z8mAcXZg+UnXv/M3svBseceb
O0Es7F+8m12qLgfNQkOjRSdYGHF+9ejNufKwV6BHJvUqCzUXnugZ/0WBZKNd
s7ryWOj45OTgYz8FsE/IC44pZ+H+FT4bd6lQwIXr8W4Pk1dfmg7anj8nBve/
ensGjLHQe0fBmdCxceKiRPiFE5Js3HL7gFiB+gTx229Za7g6G4f1t2brj/wi
vo99kXQxmZ7XCXkqqH3ehuf3Pa9bKy4YJqKKhvIMtrExN2pDnWV5H6H0yTiW
FjCt9+bGE9bDx9j4PV62vjGmj+BW3B5hJvLqQ/QBdjn8JDQiPx1bkMPGxcsE
XJ568MPCyyrvC5vYaJO2YPnFfFEQ+9Yn0vqVjUcaaxc41ElBQEjmvK8//vI9
ZWH7wn2D/GIc5H/C2OMoR4L31K+vZqjy9HXlmfZkNxJ8QrMkzgIOju1z0km6
RQK/RDlLnZUcPJV5/JMZyEH07GLXF5s5OJAQ3ZArLAN6LTlvYndzcJNJwyW+
dQKwpVxL41Y4BwOGQx7IDk4Ssl+ivW5c4OBacpzFCJVDbJk3trIwi4MLs3Y4
1Wo0E3oFJIvMUg7GvX81nvq8goj2JukebeRgl8q8Z6XlFcTutVf773RNz++0
76Tp4/D0+m5rcVTpiBAXw8NfWtWpVBNuxtl6U4pcXG71svJdZRURxCyI+TaP
i+/Ou1tSaVcIyVdE/cJ/ePsmXy8e7NjIxUesKMVI/VMEe87yyNs7p/2+1u3d
Pi8OTet/76aI5a/jufh6wzmDpANZBJrdvs9On+7/q9mFAOMBFw8qKMxeZJZL
aHhs/D7vH97+wPFajSe2NDQvUFFYyTcHNLwC19/dTsO1QsdJj5j60BGiGlG/
j4YvVtbv37WNCjpPZP3yo2lYQz2f221IhZ+LXJYfTqJhwhOLOUbFVNjYkSsX
dIeGYDYzY/42TVj22PXRwWc0TErQdMlN5+n9S92dr5tpqOU9ZRovoQV54vL0
NCYNL6t2pZVXaoPxsV2G0b947ye6YZPrDSrY6FUdTpCgY2ffoR4rRyow+d2i
d1HpuDtikUphigpIS248oLeIjsc0Nw7pV6lAjd2aXTKr6Hj51YTjuLISzHh2
20DMmf7f+X4N7rNHNwTQsWHOnOUeGvKgbnb/gnwUHX9dmrAaVKDAFBSM9Vyi
45INGqkVw/Lgd6TIu+c2HbN6Zbf93qUAblzF1PHHdCwrziRfT6dA73azkUV0
OtKdXzmt3KAG0Z7EO7WfdJx5vdv/52d1Xj5d88BEjIHujL1hPZ5UsBdKcZBX
ZeBOqfb9of5qcPLWitYvRgysf2r9QahDDVbv73drsmLgtRT3flaJGiQe4Hv0
djMDG7Xztr/ZrQJ7cnUU1fcwcLnDrzXnNRWgSSbIpi+Cgbuua33t7ZOHJ3c0
VjZcYGDwl8Dm5HwSGIe1WrVkMdDqW8mwYq4UmIW+m8oqZaCvScVyia2SUHdb
85Zbw18evzB0iB9cbdXFwJimN8c5hAhE3Vr01GyYgXWp17pUbghDwZ7hRZuF
mdh3WyC1YZ4I+PmOeoMSE91MTs4NXikK9y47RErPY2J2ueCbM01ScPRnYcos
5PnvrU09DypkoTU2JIbsyES6mWR91zF5eGZvH+Hvy0QrgQqVrcspYLh6/YoV
R5gYvro93+OQPOgF32/RP8f8M59Ohvy3yruW3mLiUvOljxbNJkG5+6sS8kNe
Xqg73LS5lgTOWk0DH+t5ecOLtqr7IgmiFFvn1Hxm4pWLEp1795NhIVobV/Yz
kRYpbS7+gVc/rr+wEZvJwu5rysc7Z5FhsV6QwTsK7/pYQ7nsQxKcZkW03TFg
4b7Zd4PZvPrg3XbhTL4FC6+acD4aMmSgcXKWWNUGFmZVbzf7GSELFY5XLmv4
sPD1XK9rlBZZsOiw7ec7xMJRc1ZocA0JrK95kAfiWP+dj/kpJsJC9CYLJdUf
+ftUUGA0p1vj230WxhlFBh/bpQgfjjuV5/3D2080D3Up+sb6M2/CD526+YKC
Ajz/HrTuQwxtnLi/ctaR92Sevl4wSBLi1QO5y6/KH+qx0WoRS/Gs3i/it8IF
oSrzaR5D8OsUkSvr2ejqZr8jxH+QCH74e8jRg43RuTZxxSf7CL63Xl3L/uHt
y6saXV90mo3nZm2xO647SJSk8G11SmHjHSVmy2K3MeKa8bFF5Go2vprZcP/A
ImH4smYwSfYjGylrXJMXeohDTmLdCyqX97x8xVjnTCngky0UPvIPb59WUSHr
JMtBiake/vMBJLBPN+mx0ObgQYkrOe21cmDz8F6dwxIOVhwyLCbLkKBhImD7
Ajuevi+M21pwSw4+HTj++YcrBw9FPF96zlgEgtVTXJlBHHR08B0/4P6duDw1
O595goMv1XXbpvaOElbSBaLG1ziooSj/OrMwl4jYuGvh1N2//foGYsWLU3rt
FdP8zYv77qh3t3DQu+t2zV6Ze4S/HelDIYuD2wRV5hsr1hDvtjYH7Rrj4BSp
vrGFv4aouZoou0aSiy813NX0IisJC/FnEcvVuXjIVyzj7YrHhFVhT/9WEy6m
e4oIdlleJwYu6MyX2jat91eahlcKB3JRTfNGUcXGB0S9hY6BdBQXr/gae335
WkKc6PJX8rk8reeNxZ8+Lsmd7u9UdH87ueApFwve35u7edVF4sjDMTcFRxqu
Kq2UE/5sACPtMdqWh2noY1D+4kcjFY6VJR0ePUvDXb0V+oyLVEh6Nf4l/iYN
Lz3UfYAaGrBEyvtsW/FfPrIG+JxYVJFbT0P7/KXJM0ETqIaU9qbPNGRPeNrO
3KAFHqLUBT/6adj5XinBeUoTjCjxs27NoCN/s7Bo8QAVYjbzL5hJoeMQse1t
1ZQy7HlZmpGn/3f+Uhk+Bz7XMllOx1MOIDTzlzK0rPo0uM+ejly7TZOXfRVh
q4ODpYkXHVfcFWUYnyCD77nOQ3ZhdCT/+khWXy8PM6YS+rzO8PKBpMrBd/EU
0L2Zw5hxg/6n/6kErQfq9DcX0dH3taSj5V0KyB61GTSqo2OR2+slX/oVofVh
Z5rrJzrqqDw1ThRSBQPN5DNnv9FRnh64q0VBHYSqnv6y5GegaaNYw2CeOuy5
SC/OI/H098GDuf62VHBNsn+6XZeBeSojsoNWavCpUaa5bykDM7bslB1SpUK3
aesi43UMFBZY15z2UBX2N89Q5PNgIDMg6/AGAWU4n2bFVAth4IVsyfKZn+Vh
8c3cPjjNwB6DF27PjORhT8uBQ+zkvzwHnv9Zar3RqoCB6vfMpN5dlYag5m0H
WVUMHDIaKhfjioJVSt0dvw8MFItUoE59FIX0a6Zz0jkMpAjKTu4KEIHYl2KG
bpMM1JUdVxNsEIHfc5lHm6WZOBQmW/ZpuSj8rhScHafJ0+Os8rn9puJw+vSh
Gu3FzD/9BxlIOT5Stt+WiROKqo7l5SRYXvDO2MaViQ0upTeTUyjgK1V/eW8Q
87/zblRvdi+6doKJlFZHY4v/8ZK83Rxtr/5dL5ADPRd6ZX4eE7UeDzTf0CZD
xIm7R5zLmRin9Oz5+Z0kcOt+tYLZzMQcuTe/l/H0vyGwf7POP7z9KqOw/t5f
vP+P888nj5VJsFJLPlBYkvWn3pHAwbZNX1OdhV/fXZJbXU8CTjq/b60xC5tj
o28Jb5UDMcP5w7NtWLh37qT0r2EZKOmp5P+1jYXi0eVXavxkYah916j+XhZ2
HigyaCbkoPi3qYHLcRbeaPOeldNKBgHHXZ2kJF6+CLrfnc37fX1qT+s+lstC
z9yodb6rFMHissoC06csZLm4nOLGUOB2ep2JHJ2FffW22s48v393RMDj608W
/op+0fDr9xhhftAxRFCcjRcmtA9H+40TTkavavXVePoaNnFwl+sYMa6YfaVl
IRvnpMqmj2UPEwamMSWLrNl/1q+HCGZ0vvanLdO8/blCBjfc9vxznlZprvf1
f3j7zmnn77lc5OnzxlspPZTvBJQetm7OYqNDdepEyRY+yI9aMHtuIxu3z/eb
yNIVBZNFT7Yc7eK9X+hMyQayFKySz1N0GmHjVMiTyjFjWaDPKayKFOH8qee8
zze4PevuP7z9ij4/Sff5HLz+IPR4ZiEJJq5PVdVbcjCq0KMmc1gW6g631YQ6
cZCqXJcmkiwFSvEi74R2cfDZ5pIbahECMNpsbmh7hIPuzFlg0TtJuNl+ECed
5+Djz7+3fL4+TDiORL9bkMHBdaeWke58KSNa3mx5b/+Ig+SaGAPf3ufEl84E
5x//8Hf2q7+Za9/BQeO9cl46SdnEhcSNdoMDHJR8LCDy2L+WsDCfGxY0k4tu
UtSK1JNVRDB51mA2hYv1pb8FIySrCGP1td8853DR8Hya0c/P94jwHYmmLRbT
+3Gd3mg0nvmHt/9wv+BeTW8u9geZOYmGFBHpq7/tCAzjYtWswQOFZ0oIBYel
7zCOi3mx6o8KLB8Qs88mG/qmcf+3v+dT9IFi4vaYZu25f3j7wTZBsonPuZhR
FOX807SYMFXpQr/1NHynlx1yXtYQZtlSTCs8aFi/zdYqt0UfduVsdDgRwtP7
Nxghc00VNi57H7TxNA2NDAqHd/Opw/OpOxInkmlYtGxbtxiXd/3j1BvtAhqu
aDae9DLSAHvqi2UXqmlYvrlENvAKrz4cUVNv+kjD2LNCef3dmiAkdj12TQ+v
HgS19G7eqA0LGw4nX/xNw7F33Um3RtWAXe7+wVaWjsovGG+WPufpLTOOJKbN
8+MvY0dd36vADwuJRkMzOor5RnUaSKiA3csLdyvX0NFPXyAMlBXBMOaoKXUH
Hdu1Ld+4NJHhWtjRJev307F6s+Bba7Y8JFxPr3h6ko6FKw3K5/D8p9zg3IGf
V+n4oXmFRe1tBdA4+GTVzbt0lBAstVVdqwBliwpXyVfSsVTVW37eFwX4TH1c
ue09HS8e3z5VzlGGWOCWd7HpGBLuljN8mgo1F8J9FkzQ0UC2bX3wGg2IoSiY
DEox/vQH1ODD6x/CZRoMjKRc/RI6Xw0KSgycmCYMfP3G2HtTKBXI7z1fHlvN
wJsC+nWMYDWYoSXAZrsw/lvfOL41/npSNC8fUI+FHeSjAE/xdnxKYuDjtvX2
RSfkwHCrlF3cnb/vJw0tGUnmq54xcGWQOXG6SgJmah7I9n7LQL3YUwODGiJQ
8W7z0mE6AwvHrrIlR4RB6NGNA3ajDHyvrqpk+0MEWht6W0niTLTclJp6I14E
jMkRwFRlolD9chG/kyIw+7yPxuyFTCza/W7vThMZOLt849zylUzUW+nltTNb
Ds6oZHYYbmXiOrYEd/UtCsgZiYsF+v89X4UCOgeuPO6LZOL9TbqifNfIUNN7
mrT0Eu/+UclXNndI0Hs5MnEkm4l1Oe1fDl8lwY39T5RKypgodW32wElrMnRE
rVXqbOTljxO/XqknkiCrhoYHupnYNpG/XMyWDGNmnTIfR3j1o6B/WbgoGT51
9m8TFWX9mRcmg1WptsFhZRZ+2RAtFGtDgiW1FWkl83n+OvXb4p1UEpTOcCe8
V7AwdSypY/mUDFQF+5z8somF2dVfxjRuysAWhWOrdHazcNVjso5bsxyE9VXE
5Yfz6sO7sJFD3STQ+ul9SOACC6MHTG41RlLAeaH0+dpMFl7aXNL9i08RlNOm
chL+4e1byMWP7ehk4YBay/1tEhJwU2H5jpdDLOy/Vim9Yu0kEW/PbyEozEaN
lW2JdZsnCcHH3LQIJTYyDZQPpV0dJ4S3LMmrnffX3/8gLume7TyEf/lnw0Se
vg5liSMbE3797PO7zyXsXUkvnHeyUUTi3kfLoW9EeK3wrZ5DbAxjz32anPiN
MNvhpm0Tz8Y9obC548MIcWTOsya5dF79EdZFR9dxImPb1mxqPRtbC7y7M6qF
4XT5ptHn7WxcJaSTKdEtBj+dSgeX9v/t98jAkOoC7/AZHKx5P+V/1EkOQpVe
u/BTOMj9qSpoUyMHMTZvJtYbcHB7VfL3BjcSaOR8rJGw4CB/+rZ31oFyYGuu
ldBiz8E5jw/tK30oA2P8dR9/e3LwpmqS6VWaKJiO7bG+EsrBt37LY0zavxMT
Wge3T8ZysLC8N8Nj8zhhF3Wtb+ENDu4ZFCib6xVDGMh2z7hdNK33CS1xleza
ab9//MXy7CttHAzKn5KPWZdG8A0uStjQy8GGc70znmysI0TWRHz3n5ru7yd/
bDr2S3aaz1B2+cRDex2ePosL7FdwLiU8YkCOspSL2o7ljrAtiXCccXm9otu0
30+OG3B4vJ+LDUIVUcW9D4i9NgW/9U5xUTeVnKK8v4J4Y3pCa+c/vP2yzRGv
6flczFm/mBlamUlUrCdH1m2hYVVYibJrmwF8Iu+cwdxDwwSfTO19qAERks9G
f0fQkGH4PKr2CBXylzhHp1ygYY/LWdZUrzrsTFqTfyWLhsVSEdbhFppwV9fS
9mwpDRds35h7cq0GHOGmWFU30vBHuurJ2xZa0Nopmfimm4YCVj+j9m7XhmfC
mR/TRmg4d818ztY36mDokRZWJELHG+5J6kXp6mDQn3bm6Ww6LtsbYHbPSAUK
8pnG6wzpGGjvuvN2hQpUpR07ssySjg/UKdpJH5TBtVbdVMOJ/mf/kCKcUNZd
Z7uLjrFWkiVWSby8noVPVh+l//EP8rDf45iy+Hn6n/UvCizboNMulUHHc81K
NoKByhAf9EZM4hEda6M+W2kaUmBPXee1Nf/w9VvsZka6d9Ix9VmlheM8VagX
XLd56RAdhY45/Vbcpg42gxNxjkIMFJKTNAqYow72UoXGvoo8P66/Y9zMggr0
HblB/HMZuHH028/N4lQQoI2u+0kwcOa6hrqHwlS4e8UuhenAywMxEqKbLqlC
d6SgLWUnAzNVi+3NzBXh5vV3dmqHGYjdRnuupcpDL7sOuWcZePanUNCOATJU
+aol/rjJwJAZl276HpMCjdlHnSeK//IzJUGSj/rw1HPGn9+jKES7k5U39PHy
RZMcd26sMEh3hDL3CzDRqMz/0excEdA526lxnsz8oz+iUB8Q932BHhOtHm9Z
05knDt+j4n2MzJkYbvWc/426LNx9kbhabz0Te1/5JfDLy8OApcAZd08m1j7z
VJx1gQLP+o5rBIX+fZ48yDca5K2MZeLZIy8F75rJw+gX00vOqUy8aP59Dvsk
CXzUbfp8C5lI7kbFRx5k2JGU2jFRPb3f9ith6//tI3P6/BKlcf+PXCY+nfnx
xcKVJIjVk2kUmGKi5ze+ZYLJJCjwNY8SlGNh7qhfz0YWLx+0x+m/0mbh5t75
2+/eIMHVSMv5zUtYaOA6/OODljTs2DKZ1WzHwojPe/ii5GQh30PlKMmdhXN0
U69mR8hC7A2HnHkHWKiexBVP2yMHA5J3n4vGsPDyPFF2NE0eugr2WOkm8/KD
u9fmux4UcDmxYJHFPdYf/6UAHnHLSj5VsvD1CXrLzzAySC+c2lvHZuGRhlgh
cflZUPKm3mtsgoVm25cfaF4zRnBvZucLyrDxcvdkkm/MBJGdeYf7TvN/55t3
lbHNxoj+dtIJ2uK/+7WGiSqr4wm9tmwcfb1jPW3NEEHtMjU+vH3av4vkEwd8
9rExLaNlMC+mlziSv1ZvTTQb9T9s+On0/RtxqLtiyb4rbPx5TcyLf/VPYuaq
JU/P32Hjjddenp87+OFhjui5xc1stPcxe/djiRh0Z6mXLmSwsXC/bAJZUBoS
P6Ri4C82ys51mrR4IgvvzRZQj0tw/vweSZDWyB7Y+g9f/8clQWqQMQdDnjd4
aMwnwYd43crjq3h6zVy0RaRTDiwfx48qOXPw95UNn40eSoGZ0prXkgEcvPj7
6mH2zt9E2R1x+YnIv3o9SdQELnpikMhBAfuip3uCBggXn8ASoxxePfCMlYGb
b4nwc2+yfj3mYH1sw/M5vbXEnJ7LwzPecP7rl3ge9CgSpnFwbaMvjZr3hNBe
ul844R++/v55bWMh//D18++QtEKNuOhwWf13vFE+QR6ZqbNgExcvb/+eZb39
AqFADz4/z4+LEw/2ZKVvKiVuC3H3aB7lovGNk1XKraVExbaabOcELi7hazFf
JppN+NDum+3K5OLd1D0xdjPvEpdT6h8vLeGijgy/Si2mEalffl87v5qG5uv2
BdOc9eG2X22irwsNCd+Da/xkDMDcYIPt1b00dK2BiEZHddim/FX3xHEa/vbd
fqf1EBVmoM0Ls394+Yuv7NdamUvDnAN7LFNma8IPdavLi57S0F3ipcy9SQ2A
jhyz+Lc0XLborto2Oy0gNQYvDWHQcNJDtD1yizYE99EdYJSGvc0L95muVgc3
SyVtT3E6zhrY+LX7KRU+1DtSUY2OF7YrZGnqqMKHY16dzAV0TF513rixTQU8
/JdsYayko/bi7DNrA5Qg7Mx9Vu0WOsaJS73TeEgBxc9V2bL+dDxF0dQpMZeH
lTsWP++NpKOtTen6Sp5/HydtmLx9kY468UMdm5UpsHxy/ren2fQ/eZICsxSK
h4vL6Cgp6v4ij0wBD+9GA4UmOh6e90OeLj0brBhrKkVodFyUFqlk5qUKRUmB
Ae3f6bhl/84llSx1yDuy5b3QLAYGlX1qM+f9PYaXrL2/KTNw99phuQer1cC8
Q7T0+nwG0keGQ7kiVHjvfKEufQUDj4tubrgyrAa/RCu4ZzYxsD/bJ0TokApk
90QR3X4MvLJ58RmFawrwdSp3uDqc5+/vOdX84KdAlnXYs5gExp/+CRl+lM9a
kZXJwFHxI7nhflLwZnf6QHgJA+0LRTa+nycBprZSHmqvGFjzf/ldGHS24VmF
Tt7zen+oBAqIQlqqQtPw4F/+sjBkkR681BVi4jnxzyMtfCKw+OmmfnnF6f24
G680fmyc89ePS8KvTNFDXwgmtm+zE/B8LgtzmNyFTQ5MzNP7fi/3GQXYW9yV
5+1kot+MSa91ChQw+m3urXCYidtjU+ekesuDwIenNYyzTKxIv/1Zi0sG164Z
HWLpvPsXhYSGpJBglcp66rdiJkZ8bDu2z5sMZXGBOpefM/8737bE0ImZ1M5E
kqrVj8J0MsCMrieH+5j4rIVTbtlFAsdZfDWvBHj+fLyWEU0hw/CKEwY58ix8
lTabaR5AApWCe9m++iwc+pJaVbKJBG/X3eiIXM5C/0XM1rwAWZCmGs89bM/C
N40zpQreyMInTdfcbi8W6kn7n3lRKwuGzt9OvQ9joWDPyKdhXj2RrFY/cufM
33kfChxynW3w6QYL9yo613vtoMDeuUr8NUWsP/VWESZ2nBqIaGPhW5F9g+v4
JeBCbe22Pb0svH4hsthSXwDub7/6s4aPjWP+DQL5yyaIHXrNQ7kkNjYLyJ5T
WTtBXNYumLlfl41Kv0jJzWfGiC1OG99cXMbG7x/z62anDRFZj8ZrAtexMSk1
PPhg4QBxxO7gUbl/ePldck/6pQ7w/H/kUNxwWw/xWiIjrO8UG4VJMQUFrH7C
eumGx9rJbPw4u9zHvP4X0WpwZlNzJRuXijl6+1kJw2DfR4Lxno0CskkC95XE
IZHxgvjE5tWL37mddcukoFpyw95lk2yMmuvzoPSdLIT7LeczkOEgrcn26Sjv
868afZ01pjnN07lQqi2sZcbB4yn3H7w14OW5vGPnRdZw/uQvOWhuLvpSvJ2D
TzW9fuXwfr+Wc3Lopfs4+Pmx5zKV1VzC4qGVwM1oDrasubvKefMoUbX/gP3I
FQ6eMvuwJPltFdHiKfa7JY+DZofkZzzpbCD2nrSuSir/y/esJ5LareH+Ow7S
xd4o/fDPI1Z72rFOM6f5+CdVdB30fnEQGGw3IfYzYt2s5yFqEly8P7Xs4smb
lUSavnjRqBoXnQIEX1cuKyeOHJbPNviHl9/6cFZ2w1YuqjY21oVq5RGb0oot
P/lzsVJ93rsk0YeE65MZ319ETvv1oVnsj9r/8PJl4hYoSeVw0aNENqhiYTbB
dTxKZjzmItVHucDK+jxhIG3c1utAQ99zvzb3OxiAw7nHA7KHaFgasSrUWp4K
D5R2LmmK4/n34Kb9cfOocKuVtcsujZeBm5JoNjkaoPJiXmrefRruiKB7rrmn
Duq9Cje8nv+tBxpQhFfzzrXT0OL2C51P6Vrw8kX4qVd9NIwS7Px54LYW7I0W
nb9DgI4vncYDDg9TIW3f1k/vyTw/nCnE53ZXGVwS8iFaj46tql+0XpQqQzqt
NX54GR2bU2UMNr1WhiDf+q6V6+m4wfrcu9d5ivBabftUvwcdBz3nRpyVIcMD
0VMGEqF0XKd4pOx0Jxl0deQ1l8XScWLH7LStPH+lccCWXZFCx3emdb20m0qQ
+2NFoX4hHY8vuf7cyVkBnuR+tebW0HF4vGu8b4kiOCfIc1Ta6KgVpLV0/jsV
iMq9t8Wjl1ef6p2dKvnVwfTHt0u/p+joe11rp9QVdQgOHmw5KsfAcs+N5Sev
UMFce6zJWIeBfTMXsASOq8E5kdaivCUMVInsxusSVAhQPXxVeC1P/4uMmsvc
VeGjT7VdmRsD13CLHwUPKcOr7jTxrmAGWi3un3XwOAVsz9Guyscw8JvNHDvi
jTxsCnw1nHGdgZ0tex+xxGSBeyxsg/w9Bj47MXDELkUaZj038CuvZGC6dcE+
2m9RKLYo8tN/z8COqU8SX8xEgcv+HRDC5uWFec9U7IJFILd2gJg9wXv/083f
qq+IwEhLNumWFBONJUUOn9EXhVfyXhkeGkx8OHXFBfXEYN6Z77NpJkxszLCs
9pktA4oL7ZKsVzMRDsrncuRIkCBm08m/nYljm9tPV7MpcJHStshoHxPHTetX
+p2RB+qmJqfA6GlestlzPyuhK0x0ctC9E/FLDj75vTKNvMPEz2muYqI0Egjj
AvqCZ0wcaXgteeIhCSpW7zmY8ZaJ1UfSrl++SwKBE3tkx+hMjNSKJ8+fTYY3
QzJh2aNMLNR7S/rmTAKDi3bc5+IsPBTss2gn734pn179X2qs//LB0d0LTKMW
sTC855F5d6IchN5aZt1nzcKiwoTU1/0yMC7Ro1HkzEJlXy/Jkq2yIH5nvjgn
gOffgwepKu/kIONQW5VRFAsdLs1zuP6GDC+P6Fm/SWThzo+HBzLm8/S+0LzR
IYeFGi7fLSKMFOGhwiYpiSd/94MpwOvwUR/m1+n12dyjG9yTf7D+4yPL3CN8
a2ex0WDNfNeSAxMEv9xF8ymVad5CeM6ZL+cXsPG6u9JXxYJh4kTQ6ijBlWzc
wS1WvfNsiFAIEP9auJmNORGaJbpe3wjj5Ax9td1sTFheaDQo0E90TPAfCAzn
Pb9I7av9qj5C+vzMs5QLbGSebIjf/nuEeOPUcDs9k+f/27dMTDJ/Ez1hyyw4
r9gYkpj3vIksArYf0vnsO9norfhVg+4rCYt87p2THGZj1bznfoX6spCtt2EO
CHNwPtFNV74gB1kqWy5FKXEwWWyBtPewHCxcOfOlsiEHbQv9N/+vP2d948CM
a8jz6x8P2s41kwPmnN6f6xw5eFDp7KD8HkmQ7VncUrOTg6YjL8ViJmdA3Web
YpXDHBSdCl/Rt26SEOGfcnsdz0GFFJ147dPDRPNmW6WhdA6OV28z8Yl5Ruh3
j6XpPJzW99Azu9dofOFgxfZL+TlDhYR/3pntL/qn/fvAVOTmBTO4KPumzm4w
uZr4fWKZ0xF5LhpWxHWsO11BXLa4rqb2Dx+/RL/iW8Zy3jV5g4q/xXXCexU3
xMOei4H73Ix6DC8SqUkcVpfn9OvdlPJdLEO5uD9YXP37ujIiv4mSOh47vT83
5pF8r+4NLirntk3EDd0nvr09JOxdxEV5VcvJI9QbROpj/ps2dVxcf3UjXVLo
IUEPUSyzWEfD4Kk5Gaz2eXDe3v/IYXcaKq338erbrQ91LidVNh2goWGrQ+LH
WirEXM8wMoihIZ+HXZ5/LBXeiV+5anmdlw8kjsrUnVGH3AL77tF8GhYKCRrO
zNQAsVP5SnZVNN73eZCv3EQDRs/dHIr/QMMHUfVKFVt4ev/qVxeVS0PFsXU2
MtHaELTkZ8X6Sdoff0oFvk+lEcoydKxpYVw+pEMFpbvHCr5q0vGrl8MdCS8V
eFKkuvibKR3nG+j75xqqAJcbmZxoS8eQnaTkcw4KkOEUM/xpO8+/J7jV3h6R
B9aQFkcqiI7620U3xxtR4EGVzveLJ+jY8FGlymWYApK1jUPFV+h4dehXuvs6
BRj5taRpfx4dT5b5zfv0gQJe7mtSmsp59cd3/4PsVxRwHR8Und1Cx441jMsH
DikD/flk3AMWHaNPLcjdYEqFkbp8/m9jdMyoe71R5KsGnB/VcqqSZGCG3rYa
oZtUKHZJU0pQZ6DEzB0Tqflq4D08YJJh/Hc+hgrpT4SMnGwYaP3oC9eYSoWd
JZWzb/3Dx7+86rm1/3EGJugamfR/k4ffn9TbLl9m4HqyLbPLnQQDaWjrmsv4
4yelYc9Vn3lqTxn40f0u36prEhBc4+aj9YaBYfSanJerhUFEgxr+nMZA/8Kg
OZWtPL9fFH1K+CcD2x7ydzrw/Pvr4PxAxiwm8qHtq30DwsDv9+XFExUmnuwr
N68WFYGKhO6DrUZMlH5eVlwnLQOivbkiF6yYyC9fGOzPloWOMMXT7M1MvFqm
TF4tRQELM5XbhnuY+JW/19s2igJ6Bie/VEcwMXvTedt7E2RIXndp5o8LTJQy
/R0aW0GC5Myds+qypvs1uvMh6lwpr57U80lmvSaBec+39SkNvHywImTGaSoJ
OtrcJmy6mEjWOrbexJwMIuNh1xKGmXimPNYkagsZKtbpfHwhzPPnx5ZyV/Pq
B/97M4MNs1nY/61m8EAGCRrPDgQcMGSh95sTNucpJNA66H9hsSULM+QS94v0
yIBg0rnsy04sdJbguznzgwwEsay3MXaxsPTuWp2l7nLg5+epffwoCw86LW2F
ADL0qml3Pz3PwqqmGRemUigwJpx3+HIGC3vtLvWVPFaASxpmMb6PWBiSVGE6
fkQRvPrL5yzqYKFETo6tFFUCUm+ecY0e5NWfM+Woq8sHnid759cKsnHoU9qI
Z+sEUZhSRHH6h48fy1IZPDaXjbbrwUdDZIzo91yXYwdstDr6JOXq8mGiQzb6
nfRGNgZT7+2Yk9BLbBmJ36jow8ZHEFX9/sA3wlVkR1H5QTb6+BNGU03fiL51
LQIzzv71/0OEeL3kQnraNB+/e4Pnyy91bNz8XKv4kowwpHosT7v2iY2vNplw
F4uLAy3zyc6Rb2w8X90Uug9k4MHst43LBTi4pZr7tT5QDmRrbG0/kDn/rceP
pe4qEdPnoHboppnBJiTYk7dWsNOcgw3uxR4+l3ifb69pzZ31HNQN3ZQ386cM
DLl+b33iwdP3dKfIlVYiMHPmwYbdIRw0urpbPeDcdyK9/Wbho9McDLAMHOHX
/E28ZOwwGU7hIGVm0miidwoRoXG86WjhdD/+1KK2Wr9WDj7wnn8/Zdtdol14
T7p+DwcljW29Nn+oIh5LtrTM/YePr2PDz2yU4eJLStrBybIqQqn4HVtMm4t9
W147jEmWENccdr9kmXGRSPv5M9Ijhliqe+j5B1defXBcImyhUUq4bC9cH/8/
Pn68sDPp0SNCqO7si68nuGjSdU4r9l4pYeE+1a1zjYsp28zp99IriCnDD9Jl
d6fzgVUM0S5fyUV7l0HVXewHxN6cdaPXNtPQ35g6kxM6B9yUn66+uZuGiSfe
pH/t04LPlQPVTeE0lBvw3/Aokwq0q/qWwQk0rJZfMTGfTwP2ZyxeuimThl2P
A3M8u3j61T1rm1sJDd+uvHCrxl4DFm84rnm0gYZfPnRcX9CuCX7D533Od9Fw
XDZ7fY+RNujUzzAMGaZh/a3k1/O/qUNA0+yUAGE6Htx/dx+RqQ6Wor+MzynR
0V09xpvupwxpB9rfaM+jo2iZGHnomwrEkC4yfwEdYy7GXl72RRkmGFLaPzbS
/+yvVoQxzgIxQV86opvgI7MCMhyncnbPOkLHla29phv2UCDptOCGr/E8vT/2
0v/dNXkw1X7+pSGdjttXVUg9HJoN7sNrL3Y+oGNRSJdA2jEKyI8cHJj5ko55
D71D6m4owSbdZfXUDjpOrclL8ZlSAepZdy2pQTpeyHI8LgzqEKI9T09akIH2
Rc4HFuapw5aBp45LFBi41K3nWfpcKlR923ii1YCBlm+vBWipqEGJSvn8BxYM
9Dg5eFozRg2WRvYLlG1gYIHgY93NJ1VhJbn26FtvBs4c8ciW5irBl8/z93ce
/Lu+ytP3D1O95XEM5A+8mSL3ggx5Mw5I3k9jYIy2gMSlQimge9zb8vr+9P6q
rJG+rB11DOzmvF8VeFQURkpmBBp+YqDqbY2zud6zoOHelx3a36b7O4ZtLqOG
/Mz/+vnKJjdL3UhMNJVetnP9BVG4XM0NF9FlYtGzorFD0hJwLVr02belTHwR
qlAgVyAD+mHftMfXMrEtpfB6fRUZVqSGmMz2YP7XL2P/uFS+IISJpzeWvjX3
kweFKIXXSqeZmBnh8/OIsjw0Exgtn8LE0dtL+d+rkEDeaL7n0gImam6Z9ZGq
SgaWg4Z1SxUTdz36as65SQLL29z0Ox+Y+CC4dB9rNwn0jML07nCYuNF56UiX
DAmucHOdnk4yMTzSIuKLNQkufwyarJVhIbHok3lZFwlUft7Qv6nFQrGBi5G7
U0gwb3XQZLwZz//32D6i5krDy0bRsYw1PH33kc5w5JeFwWjr1MYdLFyhvC2J
y8/z8wEKT3v3s/CzcH6kxFs56Ipd79ZxkoWGYik190EebrfNufP1GgvHzSbW
fPakwIRzo6pUPut/84LV1rcU4JNk8OXCChaGnt0a0cfLp6aSC9Kvsli4+JDI
KQ9HMXi4leJVPM7CsqbV+/uejBPlHy+k1Urx/Hj44bGA9RPExpj97jkabAwy
CBnr6hwjgnb/enHDlI26y48Hu74bIpSPWW17tnp6/tLhxaUBBxc2ztsYYRC+
m+ffrcqmtPayMfvZYffI+G+Ey2DGYrXjbLRoz1jCh33EwrfGlLlJbPypdu7D
jXs/iUu002ruuWx8ljDnaH01P4zckCsaecPGK6GdmQL+s+DHahF3Qfr/+Gpy
wnOmpOCYTvojvVE2iiU/lAnYLwtXTd7GWIpzcOq2lekD3vexNNS7w1CNg/fP
fzrnvIUEvj2p7fMW8fT73WONjXtIQL2Qwu9kzUEr+/IFbS/kwGP3zTlDWziY
rfEkvaxdCoxCDzU17OGg/hyO74dP/BDzQCG5KYKDtNXz4u6u5oM9Oi7SjIsc
FBBMv504/y3x6YXx1EA2B1c9aVoodLeZeHcjKKipjIPCb15fMQ2oJzbfdjpb
8ZqDixft9f3p85DYSZt809bNyx+Cu+M8Vz8i+DbcUdj1Dx9fZ3DeJxMR7n/X
H6oP1BjMnubtSL/w2LRwPheb9tz3uV+ZTrTwkWU8LLk412Seo8Pi84T27oYm
4X/4+HwiW0V6fLlY98Ntq9OPEsLnY+6uH4en+zmb2m4Gkc5Pz9u3B6v9lnrE
8/tqo/7F23IJS4O4XNYaGj7zE5e0eWQAydsVRYdcaf//+WO6cKy65/7PIBqa
LP94creHGgxuW5H38QQNA6///vlssxr06OwtfHqF5+8nfTdm1VNhr9ZXgRt5
NLwEX/KsDDUh0vFga3k5DZfMTepPvqMByo8yEyVbaGhdSZJwUdECS7tHZ1+x
aDgxsk8obJ4OjMj1idaP0XBr0/u05jI1MJL0ay6XpGPf8/VrBWSoMLp0NztB
nY6vFlqduxmuAjbXUMzPmI72LeVTsW9UQGfu9kPLbXj+vMGOkpKoCPEDKf72
2+iYWNJTPLOKAhGs/TYJgbz7H3fWGFnIw6T0fFc4Tse9BwcnomZRYKa/1Kjh
ZV79+CDiqvyFAlfGjTsUcul4R6LwuTmLAg+fRNhYPqXjhkdaA8NUClz6oKW7
g8G7P8Rzbc0+KjjOlzLzGqVjlYe89wctDUgts0j0Emfgglnnze6LUCEobJgg
1Bh4eOnGA4t/qsEb36M/1RYyUJ2av9C4UQ2enLEbH1/JQF1z0Q38SlRY0A3H
KVt5/tzY1ya7RwUW7Ho55ObP0/9F+8+vOK4ATzSXpCgcY2Cc1on7rwQp0Czd
+ErqEgNzguRvEGdJEGyUZS1wm4ERRarjzzIkITVqplRTGS8vHH3pmbRLEjYJ
m9FvNjKQes7ognibEFx+ViC4t5uBYzsD6IuMRcDr9ro7R0cYWOH7nrsdRKCs
ZkHKSREmej//9aNcWgSS5a593jWbiU/7z7VvChaBWYkf9TYaMnEto1Pv/Ulp
4F/tXLnYkonVm89y1hbKwon5Ah3bnJjYa+ge1lgrDxdtiK93dzEx6LCXkEcS
BeZeclcPOMrEN7X7xft7yGAvm0P3P8/ESe7YZLsRCX5XmYz4ZvD8entcQeRC
EizOWrXB4hETFY60LDxbQIKJx4aPFV/y3u+u0BUJXRLYzty2b+ALE7/8huWq
mmTQisi7IzT4d78vCWLnXmy0FWThL2WLgZxREhwS32EwqcDCjq3FW25Xk+C7
qr1Y/xyeP796c32hLQnGPE+afSb+zufIQGx7N0dkIwufksZLcoxkIetEc5Tn
ThZKiXa/eVokC3YetzfNPczCHzMKO69qkCF8361843gWCio9b+PbQIGl92kO
ZuksLNzW2+1qqwBRujlW8g9YuGn/KibzuCIUZGvGt7Xz8sN2A/PH6WJw5b7e
9tE+Ft7T3JtonccPYkNVcitnsPHdCzMfLbEJQtjTUpCPwsbG2vuff70aJ84L
sQ6N6bP/Ox894/Mb84Hl037ckkHYVdizcT02ivrEDxJ+1Gjfy57T+6uo8RJv
d/7Dv3c1fPI0LJaNERv5lpBfDxAG/AU/olPZCKPmmWqq44SLRaj0lhr2//p7
YY9pQlB/e9YA0crG0t2itLQCMXi6snrjzh42GsbHjTY3SMFyssyNJ1NsbLkr
umvYUA5sKFbakXIcDHm/bdtcX14eW5M8/7gOBys3lF541CkHfPeXnDy2lIMi
I79dqwflIM/OxcB5LQd9kw3NF5XLwlcFx3YzN14+aGB+v10mAhmUhFbZYA6K
nQq83/nlOzFgM7x17ikOuh4aa/f2Gifq8rhV+69zcPnHJ6ApmEEYrHjuo3+P
g6rJuqHx/rUERfxFvGrVdD/nnLD0DKkPHLxMbblf6ZZIXDD5XNPG5uC5eHWX
3QK1BPXy0Yu54xw80zaivN29lujoC1wbpcFFGsexq3BLFSHOqjA7bcrl+YVr
pOMbrxKzAi0fbXDhYnQfv0Pn28dE6++Fq433TvdnFlba7Nh0nIsajbMu9Oo+
JhQeDrtkJU33d2K+HE/0usPFzHvNkSXbs4grAa6jR59N14cGl0r2CicaLpYQ
M6h+YABJepuc9x2hIVlwhf/Feepg51z/VP3c//hn9/oSVNXhzDMph7fpNFwb
dXota0ADNjklHxF6SMOSM1G7KFnqkKe6rnvgBQ0z5eSOBwtoQrxSoqh0Bw1P
RfjriFpowahN5SfqIA2PHL8neXGtJgzkyDKZM+nIaso2XLNdHfYuzzm1UIGO
TZcr5x5RV4bwGbUi7w3o+Cg62f3UUxUgTTwoC7Hg6W15Efk973qxbq9A6gY6
xndW0F1OKAE9etWJQ95/52fIMJts9urMQTr+qLzO97/+QOdHibL4ODqK25w2
airg6UmjCM06jY7P/MuUD1QpgdB3m/To+3Q035emG8XzU37r86+HPqfjnnKP
m+YnFWHL59tbbrTT8eT/5WEVaL4e86ykj47Pt56cn01Shw9nz7qeEmCguDun
v4SqDj5FHy+1k3l6vPDXWjlDKoSLZuee1GNgnRnzmfQ1NdC6uGbQyJyBI4Nt
i6PVefVhvclrt/UM9NruwnzloAZSFlaMlZ4MlJ87lDRDbjY47WCX7whl4Jnh
8P7rlyigdX/fit2xDFx3Y3DBZBMZji2h8s9N/ctDlgHfITmnoMK//DMpaP0S
FyP1D+++ZfxT752PDExVdXaoPDILnO0CWI1cBgrwH/x0mV8E9jTpKGf+ZqDf
93k2DfyiIHJCi8UvOz1vY+SfnfBAi4lds9rGT46KA/3U1B5fMyaa6w5VDuXK
gPr75I60NUy8l29vcvIxCbiOO2LjdzDxt8fp0JzHFLAQfvSrYD8TT62+WFK0
Tx6Ue4dlak8y//QbyBA9Y5NX/DWeXhNEbnuXHIStnbT7cpeJv+YHKafw9Pfn
C33y8Qrmf+fP8h2cI6nXwqs/HuHza3h+77JzUIoDi4kvm77cq5EiQXFAh8/C
cSbKPwkROsvzi24POoetpXj++/uaszNfkyDRsE5/rQZPf2cuiT1VRQKnT2+v
ipiycKDvd7qFtRyklWikrV7N0/ee5napxzIQ8uJKF7GdhVaRYlMRb2WhVTyD
7rePhecqH0+WPJWFqqhLCaeiWRg/Hr+htYgMS+fkhm39h3e/VEjwR8Ed1n/5
s16O4bDjGQt9RZ/cpplSIKru0kxgsNA8bm5YhaUYFOwu9tD7xXvenNnLTNeO
EztX7IpeKcHGyeUdpe2540TO2hnrHalstBtIC66dO0aExVZtVPiHd//mV12f
+yo2/pbu0hC6O0QUX7ffJeDMxuVXu5Mik/sJjb33SOn+bNxTHZt8x7ePUA7d
uOl5JBtFgjtCaYv6iCLlOXT+22z8oDJiHVHDB3vjdEcDXrNR/dy9nweKRIF6
/n1BbjcbTw0MZ8QnSsG2utu3rn//u/9KFtTnyzhXiv7th5Bg70vX0lZlDs5b
fHPP5yMkWHvlrUOmEQc70dBUsZz3fV05HfVzBQcDm1bcnX1YFjJe1SWkbeL5
e2Pu7KtLpUFjQdtbGz8OJsiy2dL7+UHvhdHtkKMcPL8uoS2rd5Iou3i3ZGsC
B43PhBV/HvtGfDhfHrcvk4MeHT/XmMY1EuEVD0UPl0z3Zwo13lUsaZjmnQU+
MpYM/4d3/yh89jLFIQ72htAumRyrJs6EfbxyX3Cad8/NaI17p/DXTz8jmmdM
ld2ey8Wc1L1vE49mEtaJfhEzYHpefuXWbZoPHLh44cgpisLkVuL1evVRbx8u
EkpLfUTNHhL0sLmeyQen/XpUi4tIzD+8+3wPjX23b3LR8YlQxu6jBYSnZmNU
WTEXS+PsQn59zyDs3n893l3PRYHioNrS43nEyeqsF4n2NPTizzu37IY+RK+o
7J/pRcOw6mM658YNQPwH9VRxKA0j5zfRV+irgVq74IMjsTScf1H+3rU2Kjwe
Kj/2PIWGb90sZLO3aQDNvLzcoZCG3VpnDsYKaMDlUppLaw2vnrTbLimM1oAW
35T1Um00FCsx8TjsrgXJtubGIb00VChZM/bWUBuGXPnCPk7R8GySYdGCZJ7f
zRSdd1COjiTH+IWms1VhqdqVsEU6dAyoU7DTea8Chq/GPfYuoWNyHneD4VoV
yM/JePbNjo43k6YioE8BSsuCDnq70fFw4dRyFTsyrP39/nR8MB1/r3lwksZP
Af9g1TjWKTr618x0ySynwPpRi4rX+XQ02bMrY9JdAaSFKEMuVXR0PH1nu/Ec
BXCxjj6Y/IGOrj8KLtBlVWBh6YchMS4db4R5Llz+kQqXXNe9OjDJywvE1dNL
+DUgylSMTJVhYJZ6Vdt7P14egbXfv2ry/HwWc9LEUQ3GjnoF6y1m4GnTwFgT
JyrEfKvwyrdl4HLpkCNLhdXgxjnLYkNXBn7JpduTN6jA3t1OA5UnGNgrohy/
T48CBpkhTJWrvPqQ7O7UIyMHATJf1pblMdBGyNo/drc0mBfUrwksZ2DUfuua
zklxuHTsNDurmYE/GvL0+zVFIOzEuR+qTAaGh4TZl8wQAfbjMs+EXwwse7Bj
5Sk1UfiqNcfSSoKJKqObt95/IwI+FdRHUlQm5lbqPNwYNQtC43tebl/ExGvz
dBKav0uDzLnx9b3WPD1tlzMmX5GDxVVGxgecmbhzT/WV/kcUYOuO+98LYP5Z
X+DVq4rcq4pRTJTQf8mi7ScDNzZCKzyRV0/CfnwgH+Pl95irVM0cJnKHyRe2
3CYBpcTsftfjv+eh8/yx0l06tWl63mbvPZ9TN78y0bYkoyW7jwS9IStPK/9g
YrtKxY2WYZ4/31vaZTOL9YenQYZTKbIGmSqsP/6ABJkT55vHjVjos2koUUme
pz/xjr0XrFgoyte2a92oDEQ6LPfW2sLCMw5HK4ddZMBi9eNFO/ewsMQgzTtw
rRycDFIdaYv4q+dkcHmdJbfqIgu3R8UtmRNGgTKX4IyRLBY+CfG16ZNThAyV
56/KSlnYv/6Yer2sIigudnkR18Xz78amtsc8xSHjXN8O6REW9h22MnqnPkWU
KsnbrRRho87FS0baByaJra0aBrn/8O6j6x13is6fnqdc2vOKnGPJxvzYrub+
oEHiCNQ7uzux8W3J+EWpM72Edf1Vi2RfNi65rqBb2tVHpEYVXKQcYeNVLzFq
9bo+IjKwd9XZc2xc47VqLPz6CNEX7++/4hYbo2IF9rdbTRA+3uujPV+w0bzX
an6OoggEK++1//6ZjTfjOu5aHxaH+RoJE89m/p2XlIPPezcEzlXgoBW9d5J5
Sg7kh0zx0hwOmiR2BPSeJsGnTPdoc4KDxYdCe2oPyIFenIzr5Aae/w6Y6oqz
kAaBzMsfwJvnz9+eqD5FFwWfAbeKmjAOeu/95nFab5TYFGAvuuIf3v1r1ffZ
QWkcNHrSDbeXPyJa+Amz5vs8/51F2e1yvpzworzWnfsP7z5iR3pM3SeeX392
SrzO/C6x6ZSB/L1/+PayO1NVtEnT85NbDi6OTtSd9t96z8gu1su4aCx95GVe
5X1iT2fhx23uXCSvCzQB6YdEx+P5m9jB06//9LJ5UWDM9LWnuNjO7H/49gci
9eKkCrjY7ss3bJWUQQzdpD67V83FS/neMw3OZxCyP9qFh7bS/v/5Z2P64Cgl
89QggIZLP0TPsp1UBY1tZ+YZHqPhB4kuyWIzKhxsi62ru0jDmtO1JGdzddgW
u0OjPZuGxfsumjDrNeGF/8ElZWU0NN8ffT76uAZUHS/xFm2iYbi1XfKwkhZY
N8RVS9NoWBZas8m6XBscV1kfe/Wdhu3pF2vnR6pD34iW4w9ROvLlOD5m7FQH
2fc2X3uU6XgoKtFlUbIKVLEGr4TMp6OqQdis+M8qMDF3r+zRFfQ/ejAbKjIW
rVq3iY6aVav9LhXz9He9csI5PzpG+nPPPPAhQ8+ca+Knw+nonntrUUeVPKxf
NskySeD9u6ZXjTVZAeDoiVaHTDr2rzwk/ew9GZ4MOkQvLaHjha/bAvkbKFB1
ZeXKCw10Xn6OM+twVALHoMbF6V103FVq/bnaVxX2hi+N9R6m48CI7aHuC+qg
8LRh8IowA132HmDo9VPB1jCDlKTEwNCsF40gSwWhZj43g3kM7D92c1l3tRqs
vb0wYAky0CzTf6pLmArUwpzFco4MvETcWrX9mCoc7V0pv/0fvr23c6jOjiOM
/503QDa+Iw9tY2cvk84xUG/rzbKriWRobXwxe+k/fHuPd7YuBg8ZqPT07rHv
6RIQLLah9t4/fHtzubWtR/oZaOJSt750UgiGvl5oKZnBREvFo2FRASJgxFCJ
K5f/288QgXFFwz3b9Jl46MxXiSrq/2PqyuOpar8vMpPxcpF5ypRUSJOzd4oG
IUmpqAxRJEmiQVGmZEgqGYsSomROkjlpohTRgDtfEinK+Lvv7/P29frv+Vz3
3OGcu9ba+6xnbTHYGiotfmwNHevqHCY09aRgyQLzw9vt6Oj6qPoXB9UhnRHb
e9f9rx4nwxW6f3hxEB0P92R+kNovCyS5NRf9Yjj6/khVwwlpWVA9bXA7I5OO
n17wR8QfIkG51P7g68V01Hds4z9lIAOdPQontJrm8PtCZ97yxR/pqPxU+bo+
lQRVfCEl8wbpWOn754DZZxKcOXBi3QYujh5v8/Mp4/z/iz98AutJDMzuKX83
vkgGsp8G6/7SZmDt/PrVeSdIwFcptV9mFQfPB/JW0r6Kw2j/8DYuGwbKtAQb
iy6RAh/4uXu3KwO7tj4rPJskBX5tl676BjJQYPy+x7yjJJhJFF5sEs3Ay2K9
ZySfyYJcVOFn73QG5jFeLet4QIbqB1etDhcxcDJnnsPdCTkYFJrXPa+BgX+E
rRI6xDnX6/ZXxCiLgZFOFd5lj3nhsdVJD5hhoM2FWAHZ0T+EjE919XopJq4M
CFphaj1FTNZTjs1oMvHjqOvLYeYE4W1tBAtXcPD+0pMja1eOEp6C9c8UrJlo
Sn5rI/x+hBga6zqR7cLE9XuZsbm6w8QMuYl915+J936tfBSgMEikeY/JnQhn
4msbVc+13kNE/Yj1nvIbTLTcv+dtTOM4EZjP3FVbwNH7+ymigT+4Ibhk1vvk
OyYmPnWfWF4vAi/nrZLcR+fUE2O/fAIfi0NeROqLsgmOfm+t4M86KgWSqy9X
NIhx9PBFQb3zTpzvW9NnXrgaC49+xi8brTnn09zHvdyEhQtZ9DYnDr/GxTw8
V7yBhetLibI8mjSoi5xustjNwlMt2QsmxcUAnix4ZXeEhY8OXj3+tHOMYN/i
StAJY+HJ3NTo+0bThPIjYS+/ayxMt1yWM+bUTXzhyT/ql8/C61oV9Wmr2wmd
s4Y9Gk849YB8Dm649JyYWdTlZNXOQuWwJz52mg+IveLPrpj8J99+o8aqscox
FraNS20NH3hK1B68sKBSmI0SRPSqJ4tqifp+qanQ/+Tb28Q1jzxewkb1maKe
vu+FhLvP06zadWy0zKzIvbzuHMF3Zs3pXf/Jt19amyDn581GK6eNT6tMKgmm
ia6fXcicftf/Qv90M3GuP/OncsWpvJy5vIOtzUeDPR6xMXP/jtI7eulEjuCd
jdKv2ai8p8twc+NDIvDigs6JDRR0NNdtkzuoAwOHh82ad1PQLfNt+yp+fWCf
Zz/g9qNgwsnHxakc/Dr+8nnEcBgF6UsZ9W8cVCHayjz++lUK1u42a2phqoLu
r86C+3kUXLQ4TvajqwZse18enlBNweb682bGN9VBkHlIbaiNgmuKJR1tV2nC
pkW3ab1UCmZ+Mn5qW6sFpDvqHhnjFAxespFnOlkNfGyb/7wQ+bf/0q4K1ga2
QwXKVES6uud6bmWoWnWYZLmEis5XQ/ZueqMED88U2dqup+KKB9cOTJxVgKU/
zCw1dlKx9HNIs1AVGYgb12b9faj/ng9Z6PQP7ttxjorWWbd2dS8lw5+QWyEC
V6h49JFPhZo7GXKeDBktvEtF1fbtdY/6ZeGLYWiGZBUViy2OZ82XI0PWW+br
E6+p6FFouCxedgEM575feKyf+u/3rwytDwVWr/jFeX3pF4FxMWpg+M3F44gQ
DWvfhfgdr1EF5d2pQzsVaVhw70Lpk2FluD7pkzdhSMMgB2bGcn1VSH3tFixq
MZd/r9+RycvaTvv3+EqwXvShPR6iIe9s/R62izwMBFo9NwyhoZ7XRu7pUVlY
QNKYpCfQ8KmLUU5YkAx8oGisFb9Dw8vne3/E/hQDZboQi13B4Z/iZ4K+7vNh
SCG8LqSVhlkTfFcX1QnApjCtB2FfaKiuYqwW7S4ERooiO7eO0LBnB+Xn02oB
yGLKyCbw/fXLC0IGg884TG7OT68lH3PeQJ+Oj7ZJ70l8Nh+WnzFhWhJ0tLgV
F7lzRAreS2sJGtjTMTvizQr3LWSY+cRiXzpAR5+9F89I7yLDw65lY2En6Ti+
J8Hc2VoWKj1PJAfcouPWH5fbiAwSiExKdOwspePKJY+W/+DgN7uWwF/NdHx5
hOp54h4JHB5daeDuof/bn5KBDVQD7o/f6JiUOXklPJkEzzCV24CHgQ7J65nL
LWSgvT1OjyTLwCKxoHuNHDzyTHom9kyHgcWpGl7rNpMgMlpLkL2agR0qCtIW
ahx+e9hS3WnL0d9Pdl49HSkFB0TQGN0ZSD5phJ+8Ofoz2byDCGJghMT0onX+
JPDfEbpYKIaBITr7b49JkGHTRlbm2kwGPo3KWF9qSob8w6Z+i4sZuG58r5jF
WzkQt1GNZnUxMMmnzq5uVhQkhQ/vfj7AQFVre0/rpfMg/XfcsCYXEx8VTeep
vJwkyuRN78uQmBiXs6PBijlJ7DysvrBdm4me/7//aIIIH11WNrWSiXvUTu32
ev+DMC/Qy+7Zwvy3nhkmwq6X1/vvY6Kd871beW+HCLsyz/HgAOa/frdvRD6f
C2Nz5N/5Kd+JuKjgwdhUTr1g+24M8v4Q41oSTKM6JrqzPhhN2PPDKXhxxeb9
3/xNUYiJfTFhyuTUBwE2RZJ3xUFr/i3N1CkmsucdklrRIgWbn04GJklw8Fex
NEvXjAST2akXdmqwcE1LyU0vBRKYPt5399JyFlaH1Zewl3P4lVdEL2ATC2sK
8/a5HJIGm9BNX6SdWf/mmYiAntGDuxpHWZik4+nWbf2dSJB0Mpg5z0KFoXdD
ddkTRJhW1zGHZBa+ktXg1WhqI2a9P1GIAha+cfQ/1vrjJcFP0xIfq2HhsEBm
cPWuZuJGQpKt4rv/9G98md9/0VhYlr35k8+CWmLv2fa6yN+sf/JevKc8K4nE
+q+50aJsjC8/eSMwq56wM1u22VGFjeyvguGHLjQQKb33eK4sm/PHvGyZctV3
msPvckGZOovDc/0ZvVP+3drn2Dj2vhImLz0mdFXvlIcnzfnnS8b3PA7OZaPB
5gffd5zMI0LEmj6ZP57rz/M8sZPZYc/B9+fiT4RP6EL1CuAf9KCgXughFbcY
PeBiOTieCqagR8XVUFOO3n/TapO88hIFN38TlP7mzMH3r58X38uk4LzdbMam
MHUQ107Uli2h4HD3zdGjouoQkhkTV9f87zyrT+pwcvOuq9+7Kf/64TSBS+/+
UtMhCr5bwLN4j7AWSKyywifc/84XGVaFghC+B+YyVNwnE9LotUgJOn7mig0v
pKKO9LFv5w4pQkR6X4P9qn/yz6qspvQ49UAQ0fXAhorrDvQqrkyWh+iIfuct
rlQMmR1dxDKXgZ7mXWGHAzl6vubH6HMxWXi0YueanGgqVvaV+JNEyaD6NeWg
SjoVjZUHdtx1VQDpCp5fiUVUNBVSWfgrkgwJdQ9GLBupeGZBo3tElhykzCyJ
PdPFwXepFL5Xxspg6Lvi6csBKqZWfL9zuU4VbCQiXPfMUvH3ytGcmGE1GKOO
u9OlaNjp8uqhmq0qGAzaON3UouFF27gdk2EqwNZalS2ygoaFqv5ZAYqqYJxo
bX3UmoZXeiOuicgqg9CS7APkfTRkTysqiU8pwkGeNyoQQEPJZTVWd1rJ4MB/
7khoJA11s03p+bxkaF0daDQv9e9+VylovXPZ7ux9GmZEKr3KvS0Bjpjoql9H
+/f3KAw+4jqtUR001KRs7qwUEQIxCUpCL4OGtNdDy2/QBMDMgtISNEnDzH3p
CpceCnL4TXCfiDgdj9G497/TE4KlKM16pUbHZQMSt+b3CsOsSMkzNKGjqt82
66A+CdghFMRXtIGOLhuNM2QCSLBqRVipyx463hPZMt7fRIbc1P08CX50lDEz
7FeblIWbRs30j+fpyPhjkrv5iwxo/j6y2v06HdM2fbm/RITE4XPzEWb+XJ7N
C+XR6+lP6Lj9YJjiF30ZGDqzOmleO4dvzl2+xXOLBBni9767UelIGXdPF20n
Qdc7l2re33Q8dGpg5n4wCdJbGQt1RBlYyCzxLufg+7fRX7ruKgy0utn3gwji
8IPtxvTepQzceOFc41i2NCz6UndkhyUDl/MIu8ntlALFzLMlYrsYuES6kBIn
IAXJiVLXNvgyUEllOTNlQhoyKvXEU0MZ/9sfYCgZ9WfRVY6+d/ONWqPHwf80
YYvHuXP9+h9O/iFBjxl4/9HDztVOctDnc3nWtv+vv14UdOp/7/vzi4FDpwm3
7lGO3t9osl9LmPkv/04RO3jHxw8qMdEr6MxVIalJAkamZ4eMmPhtg7eEZeYo
USyh5+m7jolJS4eaPMt/EEWuq2qVdjCx8F7/DiJ2kFjJ6PMNOTS3f8omo/D0
xzNzeD8YWTMZcJmJ4vnqF/xe/CJkb//8KHyHie/4uETLr88QwgG1b6xeMPH4
M58lq8YEoGPhNYdHX5iY0OzMvf75fNAVe7jJ+wfneC4vbG2nJUFo4a2vmfws
5H2gTCikSUOAv6zIN3kWaoys0tn/TBoODbfdPbmIhe8udUrtjSAB+2ZRNg+y
8MBP05lysjT8Pn/8ctU2Fv6UzGrkmpwPcTfedGh4sjCmNLpfJ0oQ7vfZnIg8
yULxWOEdCgbTxK490jH6cZzj01eeMfeZIBKFCtfYZ7Fw+5WjBcLN5YQD60XE
5TIWWhQ8cHBWfUbcnFyMks9ZuMLWpn4+UU8Ew6NdMZ9YGG2a6dnFLiFa9+s/
S+BhY/Bbdubh2CZirblDJF2Gjf66UzUPG+oJyy31lad12Ui+JNRmeiqX6Ijb
vnH+Gg7ePxE29lyRTXzjef3ilS0bedvsKKk/rxIJeT3ZhBsbF0/+vmfDKidq
w8R67gWyseUJfW362UriZFzE+Z0X2Sjg0Nm/rKqUePryXWtkxpz+j1+Tk/vm
IRvffvI5F3HhFrH0+EavrKY5fqjWMB3L3UJB5sIt3y0eL4KObckqH/dRkDfd
8eQvG104Xq5yviaAgiNBt9sDVVUga/Ol+KuRFNzWcvnB5wpVcJKO23srhcMH
X0drskZVIW1+2UHX+xT8dc0i8E+7OnitVBPOq6Nguo6arvM1dai94doz9J6C
/jsCTqx6qgm39XUvxbAoGGm/j/KmXAukho3fFU5RcKH2+I6GhaogyvBwCJeg
4vzlwTa1f1QgQeJ0iI0GFT8S35reL1aCmz4LfaxNqdi5Iye2ykwJVk6OX5nd
SMWbF4UNghbKgUv1fHszZyqSuwWz107Jwvyi3+B3lIrfpMKs5JNlweqDl/js
BSqKVky4D7vJgehi5QDpZOq/9ZQc7Kn6LfX5HhWXjrp9PLhYFsyC5DYYPKWi
gOjxF7PZZMjwmn//5Dsqmkw4qf25pwgJMZGjKgwqfk6+xyV8lfP++yzfbJrg
8MOLrQ15VeogdVCfpidGw94lN+Sim1Xhtsav7ClVGl5fPF0xyYHyWgkH7XnG
c3n3XkZd/TVWNCTtt3DTHFGBG2G3TLh209D1VnPKjoOcz1/jptgVRkNZt7IA
3iFZ8M99KfPrKg0Fv3yKnc/Ru22NuzY+y+PUB3YyoueFJaBK+rVWTPXf+7Ni
YHD1Q9P5NzSMlP14rPgFPxhs5L25hEJDfsnuyT62AJQuPiHhMUbD097yjnpk
IWjdIP54izAd16+7cCKzXgC8ki6J6SjR/8UrQUiUytRabkTHdnJV4/EVkmDV
8CFw0oKOJqUDS/d3S0FUzjaX9Tv+mXc16vzP/Mht1XcC47zpGHp1lK/vEAf/
ec/4Gp6lox1J3IlDeHDx7I2pbYkcflizJcO7mQQ/DXoaDXPoWN6Z2b//OAkG
RHlMJys59cPn4y87Mkngo1JzaOoFHQcNtryJ/ykNQe6ZH4u/0pE/rjXV1UwG
JD41fRn6QcczRpsLXUxlYGlEHUlPgIGZarmBcW9I8NV1rV61AgNnJxkf/NaS
gOwv+OHdIgZKrTep8QwhQXfJ6OObyMBkt63d81WkQFtH02zU4W9epRTMvNal
rTvIwD0l0uO5/VLgmlt69NtpBu7dIxP9YrEM2JVeSFqQwMCAVe+S9R9w+PlH
8MhM9lwewms3h/F35Qxs5m8SuHRWHoI+72xM+8xA1uplWgpr5oMifalL3zAD
ez5pPaA+4oItav06WnxMLJl3u1t35xQhEC/77qnc3PwS68UJ0r36TBRpa9V4
JzZJKPIsjisjmFix9Epv5LcfRKBAycPT9kw8NnJ6/EPMAOFCvEwO8uDwAav9
bNOLb8TrPOEq3eA5P06rZdzRfZeY2PjbNCS5Y4Swl13uZn2TifGv/W6xSicJ
ri3M3aubmZi/9V7eQXEB0Ck1+jmvm4lWbnbeol9F4OOWGvWt3zj8sjd3/k6G
BJAV1MLSuVnoknRhdcMmaeiVE6oDGRZqHz4SnvJJGpZuMr12UIeFK7s9TEsJ
Ekjcj7pjtZqF5G2SoYs4/HtyXa0z2ZaF5m+iy/S5JcF3fuzHBa4sPFbSt/nY
UUEYFDwb//44C7dFD+rdyR0hxkzLe0jRHH64OdAeOjNFXLxev3NbOgu/rJ66
K9FzjsjXcyhjFs3dr902rJc7r5GFH/xFbHZotRDRTO337zrn9P5GacF7V9lz
+ThJfiHrLk2zsE011686r5E4xKUgZybJRr2trwMsI+uIl/UToQc15/C3vIJL
285srr9juMLnvIkLG/9872NSxaqIqibJ1+NH2XhyUab/JaFK4u2FqftE+Fw/
PyCwujbiBhtLxGiR8yueEF0YmeVXy8bJ02Mt7rmPCEtHb2O+HRQs4g/njUzS
h9sqzMGZQxR8zM32O75eE2IWXNQ1C6GgwW6FRimO3p7eKHnrawIFF2gGlN2t
VYM/+Yu4ym5TUPVd3bsAijqEmR+hPK+goKzGxgPxZuqQxDsm1f2Cgk+fbfN4
naABS6e32g5/peCNGx9t26s0YY/Oso+9PyhYuzyTLTuiBmIRTg9e8lMxJaXB
w1RcHWxk7wj9lqeiuqCZyO7tiiD78X3GZQMq9p7gJ6VWK4HP69QFTkDFXbjO
+KukEmwei1Dct42Kk0cv/CG5ykOpXcVBV08qyg9+bX0mLgN5n6sbDp2ios2v
YjJPJhl00628t8RR8R59ZEbxKBmM48l79bOo+K44zWakcAG0loh2biijYsPS
1opzG8jAFrZK3f+civsreQZv5CrAtSRHn3OfOfywfsC+QUkZXtoNXAwepqLS
c49Ho3JqEEc0/TrMS8PBsJBUGyM16N7XSL1FpmEqdSNdarsKFJfmiq3To/3L
JypAWqWuSjKnYdsd4e3zlFSB62dtmcZWGjrOnn80HaEMJ77evm7owcF3iTbV
iIsKcGraOYIIpqGCxeRi2whZELRJq9e7REOIzWZHb5IFtXaVzZI3aaj/Y3Gu
zSJxaIxo2bG8hIa1Z9tXZEmIwU9fx8wXTTTcXJXMEMkWgoLo4NexH2lYJXje
q6teGIY/1IXGD9JQeGKX9HS+ANQ42oZe4qKjcDuf19Z5QiAnxMP3XJqO00Ti
W5PTQjD17UbDMW06tv14EK+ZJgo+fM8OWq+kY5ZaE/1zvCR42sonuW/h4O2E
s8laXxn49qJIOGg/Ha3Fbf08XpNh5qRS3OXjdHwvHHZaZJUsJO8R3xseRcfv
fxb37qXJQI2f5emANDp213F3XBcigV9FllL2AzpaWvk/CKglwT0j6h+inqP/
D/8iMjh47P+p6onwBzr+Jhvs7vQlQWNVOZ8Mi45Ht730SGFJw80X4zcUpulo
fFvnQ+8FEgiKi63SlmSgrvNz9ZnPJJi8kKcrqsnAVHJpCf0kCU4suuj+bTkD
192xDD9CkYBzggkaYpsZ//jHh1d9kQQp2R5Dvb0MvHvz/mnPSikwcpy0tD7G
wLcVeMjbSxq6W24WbIjg4D/PYTMbqgyI+sa4QAoDYyiTJpmDZHi5PjXpROGc
P4dkl8CnVMvAj/4brY9fIcGmqecr5zEYOE/T16q9XxiMM2rcJCcZWPr00O3Y
skkizz/qhpb43PySvOBORZI6E5/turmv4uQEYVziPThtwkTRRcZyAYqjxAYV
LVj4Hz89+0nD65rdc3peNn583YUjnLV/v/LgtW/Ey0Q7IjqMibbfjuy8cnyI
EHs+FB59jYkq9+zwGTFOdC8ptnuex8Sz32cV3vpxAyk12WJbGxP9mk2ryvSF
4VzqZKkvhYl7k9xrpr6Iw4nX2f7h40wUWlHneDZICiaXqa3JEmEhj71swzsT
zvl4qbH9hjILWVYBRRk7SXDrmvejmKUsvPOZdUHtn/N5pevWk/UsDAWD258N
OPVAg16T804Wzt/+OtePVxwKtKTa9H1Y2KL6at15Gjf4VSnvXXGWhTJ9+0u7
AmeJmlC/lWuvsLBq1kR0jXg7kXLquvrWuyy8wX/X4I1RBzFz12LnyioWXr03
ZkANbSC+8Zt0K79m4dJeSaFIwUriYPLm3rV9rP/hte8eK7X3o3P3d2ftuzZe
FZi7f6twOm4sSYGNxnp0r+GFDURtZ/T3eEM2Ost7yZ6xSid+eOT7tP4nz75Q
u0jzmAMbr76zPXBi+grxU35z40avuf5OMyHC3HuKjepNlWXKfVWEerLEzqPx
bBR9a8669jiPENYY6IjKnusXnendlHmyfM5vH5crYtjxnzx7uc5c+tbNFLS3
O553slgfevetK7B1oaBA/8KOaDVdMFIKl9/nT8F9mRoMtrsqiIjqi1iEU3BY
iXtvUIcKHF104IRiMgVTikzaf2WrgmuoZYzgP377Tz6RkaABXwQGnyk+peAj
w98rPiWrA7X2QIjvOwouG/FdMLlIEwIL6GamDA4/tD7oD9fXhqRWfUXtCQrG
vB5938KnCqsXyN7VEaNit1dfm56oKvhmeJRPq3L0+uVIpzhHJTBw2ATPl1Fx
ivGyq/mzEgSu7jh614qKIrUCdg/r5WHDDo2Xhbuo6CYp9f4uyMGd21Y3R3w5
fPMh/+4hPVmI1zwadC+MihdmNBOGOXjP07k3OPYqB9+PdDVVqpOBu3pULSyP
ihvJlMSo62S4+M56NKOaiuVGBD/fOTJAyv3Y51Qqph/3sJP/pQI+G+/y1Y9T
scanl9ulWw1U9ddrvRKh4bLy+oNlgyrgSmx4nq9Mw+k0b6oIvyoYRPQyQpbQ
MOdl67KznM8XNqt032M9De1GIpe8klQFt3uq6QE7aTiqcNPILlkJ3kT/5qvz
oeHzfbUjddvloDnlvf/5czS8sIWwvCZHBssvJwR9r9Bwslg5bdF9Ejg4PF3v
fZeGC8Xacw4oi8PglLfAqioartq5U8HjiBiIdRVacL+i4ZlPvv0CrQJQRUta
2N1LQxms6uAqEIQfWmjcM0rD479ut953E4Ty5ETmkAAdj1FeBbt6CMI8841q
7xXoKJaicrm9VBA+yVzteLiIjsOOO0RUzCWAUI1YfAvpmG48SDd4LwWLnVeX
VDrQcdNNetyOZlnIffmsaP5BOnbqMRc6+ZChwHdncddpOm47UKayU1QWVlvc
//Qino5bg+Lbf2yRAcdNeffbs+ko+uXjbfp7aZg8L8SXX07HoLAN1eQ0EugN
z7wPek7Hb/snz9/aQwJ63A2bXZ85r2e0LNPPSgYM9v357jY857efcjMUucfL
wO3py7fYLpCBnSleel5yDEyat5qu8IwExDwv/y36DDzPFyfAOkOCogxR1/UE
Ay2evXO5xiUFBT6BJz3sGZginVYFnlKw9HCZaMMBBm5M09a+9FUK1t38k3Xt
JIc//mw7vu0LCfr55rkmxjIw4vsfyrOdZBDOeNhy8xYDua/yt42PkaHaq6kk
tJSj7y9HH4rzlYfGq9XaFj0MdJt43//hpwjI/n6zZ/vQ33lZPPDrUqXoHR4m
SuwT/WMsPEU4O+TUHpJl4sWDfyQ0PScJexun9J26TFR8co8IEpog2k4+VHNa
w0Qfo+TcqS8/iO6PvnoGdkzcL2J6u7V1hPDzriv85fo3f3KISFj8qKv9P3n2
K7UDDT5EM/HH9ZvTCo3fCT/broXf0pn/8tcEcXrF1K3yBiYqp35rWG0jAPYT
0xZ5nXP9/ZJvjWKN7H/qEW8mF1scMqX3b1OcZf6rh6RB1ocnjS01l38mO+41
v0+LhbbxBjEizdJwuzRAm72ChfrajWnreUlQfZvW0GTNwmX102HxG6TA5dlA
z/W9LDSM80ktyheES4rXU08fY2HxqR887vvHiHW3BS5ER7Dw4prlxRYjk0SE
yxb6uxQW5vKU2PGQHhIOm5Otk+6zUIWLqdue00QUHsrtOV3Heb3t5an975uJ
y9XOUkHvWXgpk7vENb2I4MKgV+uZLGS7ixbKTzUQE+ML5wlPzvFBSN/p3l4x
No4s8fFy0q0l4qav0b+qsfHm2bw/zxSeEjrWjkkjJnP4P3XO+FjR7jm8N/O8
8iz9yNx65mzFupKwubXNi6JV/NfZGHFtZaC83ENCb+MD0zf5bNQ5LZfjqJ5H
GOjkPO18wsbOSrPvH2SjiNtCXzTvO1BwmwQvM69cDyzDvj/9eIqCXlSJXJuj
anBAuEgxNo6CVNLhvAJZNZBs4pMzyqJgg9b3H1H56rChmIvPr4yCImZj+yRf
qIHQ29q2Lc8p+EfeLpshrwGOmo4/jnym4J2jnsNXQjXBMG84PGaYU1/cPDG1
oE0DEvbZ/V7HS8XHGwu0awZU4fSm7XtSyVTEFyHWYl8XwM8DTz+AHhW3ly9c
dsxFCX6X1Xx/v4aKbzwWfLT8oggRy90mBLZSsf6QTmIdrwJkDLykdLpTcYEG
j5VUsgzgWxGNwSCOHr+ulbEwVBaODth2/ImhYlVsMZ2HRAa95U7udzKp6H3I
u2S6QQF8ywTo34qp/+5HkQPzA6csO5qpeGciLCQvWh6SNzZOzXRTcbhrsMb0
shKE7JXS0hj62w9Sg6G7WgY0bhpWBrUtnbquBkz1L5rrZGgYsed6VM9aDl+1
TS77sZCGztqHL4X0qMDZovt98atoiFwz/uenVEChgT+01YaGZQc2EcEsZUBB
zdksVxrW2V/J8tJQhNGznPo9kIYjskzLQ0OyYKgnJv8hmvYvf8vAGP+LNRfT
aWhjxmNTZSQJG2QXOfQU0fDxPGW3x8slQHvnz3OnGmhYc8bZ8dC4EFx6aWct
0knDYCdXPyF/YQg5Zi9kxqZhgkQAO0tPEKas5e/wzND+d7+W1yl86SFJOtK4
bDdonhOC69cdP6hq0nH+083Cwb9EoVzwidyz5XR86Dn+u9VGEvYWtFgLb6aj
/22daJ/zJEgKu7F3wGXOz7MthmiROEbHU6ryAZVkWUhrZmctjqCj+qYpUYUK
GfA33r1n8AYdr41I/um+LQ1tHX4CloV0pCsEmzd/I8HjuwMtQ0/p2PrBpKZb
gQRGhZM6ke/omNg5sTbxKmdNKzpZ/Z88+2pb/XvxE3T8+GZJcM8zaXg7eHLJ
XTEG1sHuCwbvSHCs+o1upRoD1xxX9W0ZIUFmDYvL04SBYR064TfKpcBxNPd5
8QYGhlam7OYUnHB916KjaXsYeDmm9qi2lxS4/4zwbfVjYFCnmPqQoTRU19I+
j5xn4LHJhuKCSBnIeCpkUHGdgfc0jkVxacqB8Mhbb/l7jH/ypJuO68gDz3bu
+tYnDKxKlMvyuikD10oXpedRGaiX9uUga5EIGBbtdg3/zcDJTy9jfIsnia1f
XM7cEWXi1bEIM7e8SWLW3FP4qQoTq2gv1mQJTBAr3xoHBi5j4lBtxYD0iVFi
+vrdd62Wf/PrRwjrhLNWvk5MZBb4ia0Y/EboPB504j7MxI5cWU8npSHiktys
85JzTHQMbg7m0h4iQnI/wOwVJkqtu5e4NOEX8fvQNplDd//eT+CC+MiC6Fev
OHhfmn6h21QI8vtaeEl9TAzUIchbtorDVt98l98/mdgaKRLp5iIF5xftF1MT
4uA1Y+eln7IkMFdRMrJQZKFYvItT3V4SRFhkGM37x49v46acXkTi8HGj+j4L
Fu47dmtnwQ0pKNew0xd1ZOELtqTxZV4JyPjq9/buQRbaH9q7KuQbF0i8NvXu
Pc1C8/8HyBlC9Htdf3kCC3l5HgprO7OIa2vVi9pvs1DOfOOwP28dkdcS+Z1W
wULV5p8myqtaCKvQ4vnJL1i4+8+t4MHkcuKoT5gS4wsLZSvakzNOFBJaFyss
wkdY+GgoeVEvu4Zw7w4VlOZjY9/L6VY79TrC0HmkZo0cB38dl3nqn2giLkhp
O/AbzOlt14nZbm+CjUrZXPXXLaOIVyQiSNV+zp9fv1+6tNFjDt/X9l3q4wtm
Y9054Xt3qioJmysvvlEvzfV7qCe+2gremjs+X/xvDa1SNj4ssrgfszCb6I3T
27yqhY26L1u7HO89IFz8Gvi47CgoT7MKd+HWhxbLwURXNwrqbqg/8jRGD6ps
qwYVT1BQmOebTvqYMqyI+SbNjKbg4bqQZYoiaoB/yqy00ymoeKtjF+9rNXh/
Q2NDdREFx+0lXevV1WHUx9HapJGCcmmitx/FqUOav4vZkS6O/l+3NuWFnia8
zff+2jtAwZzOyRyZI1qQKGN+0WSWghukT7lG/1SBT8Vl3P1SVHwfAL8SrJSh
OCzRMlOLg7fPT3fu/6MEUuG8yW/MqP/mAyjBzKMF5TusqShXpZJ52loeAtR+
d9bvpSKXxvgrUp0MHHuc1zd0jIrBoaLlEqvJMBu5L8c+korbLIeG17eTQTby
k++NFCoubkj5OrhaHiorp+eZ3af+c3/E6XSAHFAVqWmP6qgYT126TqSXDGkl
mUpT76k4+/9/ivDl9D6nQBYVzQ65ndi1XRUKgujJ76aoeMXfhbZwtTrw3pW8
EyVBw5NWm/YJWqsCUyArxEaDhuuPHzrcH68C21OfuUea0tA1gyz6fbMq2OxP
JMttmusPtTupv45xpuHhJJ2281ZKcLJ/pMkgnIZSYfSFUcOykOGvpnE6mYbE
eP93n3nSYGMyZq1RMJdnH6VntK6nhoPnsbJPo0/OB2v7WSv+tzRcHeOfm9Ut
AGkFx+SiaTSU1P44/9IjAQhcUTg49JuGhddluVaMC8KX3zGxBaIc/b7wbpVj
lyC8Yr+ZPKlCx9iGpa3EemHYKJ4XWL2Us96cJO+hIwm2BxbWbLekY4x9IRoy
pKDv+yGht04cfLe4+o2fTYaZe+dXi/vS8WfZyjGBHWS4nXJL70IoHQ8zVtVy
BcjAh8cXFD8l0fFd9fmkzzEc/hCf3xOTS8e0gnyu/gQS9FydOGD9mI5DrEtH
vlvLwH2bM7NnX3Oen/G0avYVCURX3nEX6aejZrmNVqy5DPzckfgq+Bf9f3mh
XrkOynlCDAyZgIfrvGTAQ19RT0KJ8T+9+b03d8UuIwZuYvDP9AAJ5j3vlpmy
YPxbL0jCLUr7r3M7/uZbSkKrUcaTZm8GrppRkk6ZkYJzRUdg3VkGnmMYtJA4
9UStK/+z24kMPMnubf3mz6kfrdYqOOcw8JvmynrFYTnodaGs1H7EQJNnX2/U
ecmDgdav/WNfGdhXV71/aIcoqHdc3Xt4lIGujfP1+rKmiewykfV3BJjIf7V/
U1jvNPHgeQSNtICJNq5tywr2TBKWEs+iPQ2ZuGpHxirtrFHCM7pgQnLtXL+H
ZDJu9sqBiaSbO3VoQwOEtXTn+UlPJpawj4mEHBoixDT3pIae4uh7lbcKiU5D
xB7PnHJ2HBOplmu6BqLGCOPPVzPuZTGxer2a5aLzk0T4vg6Z+haO/i8Oo7xj
C8DMYbfbLp+Y6FTgfGDrdxHgvl9h+uU7ExmqJuX7L0rCZdW+IuX/+PXzm8Tp
18gslPGc5ZN+yLl+0+ep/NBjYcWGsjK7IBKE3E3TvGPOQpvwSPMHktKwkpoy
7rWVhSMy95XbUAJCthl2ZrqzkO+d+SBtkTDY/Dpw3jCIhVu7UwvCFo4Tuc/d
l92MYeExjc/L8rMnibi25S/eZnLw26tn2cdDGcSskITymhIWFoTkbOMpfkxM
HC8MuNg81+8PJQ1fX9zNWaeu7mwbyCWu0K5H0Qbn9P1iVke4GBcbd5QNXtAM
aCQcVSps46XZ6Lk1Q9Tct5kQjHJRGtVmo+tkm+STu5WEpca9ivsr5/oz+0ay
r1Ttm8N7c82Ejq0BbASzVw/NysqInGiUfxnJxtKg831OypVEilrLeoE0jp4/
E3Nk6nw5QR7ctujkA049wVt4NM4pi2Bn/bbY40RBfv/dbYGKepAstXpf1GEK
jsbcWd36UhnaSjWvXDtHwZFVS5O7YlThSrS/1tIrFPy0zqooukwN+hK2M1fc
pWAVd7/3x1INeNz6uU6jioIdtrGjFQfVQWW5/vYDrymYbVmZ80ZTE8Q+bCnw
66eg/aZxRbNALYi6e9zA9Ndff48axN1zPeAgRMULR14slrmiBsr9P8sdFKm4
l3aZb0JVCcw2Dx7oN/w7b1AJeulBVp/WcvR/cDNfftcCkCjLN6/cTkV2R9Q1
wRI5aC279X3w4N/8ehmQZB12Z52h/luvykKfDcFzK4GKRFIas+oAGcwZ750e
3qYiv5SxcwYHv7WKJVuyKzh632AelD8iw7UHUsNDLzjH07D1L9ZUgKSvzB7u
Xip+PK9dPGOuDIprG4ff/KCiwTsItc9WA6NO96dj/DR8/rT7XMpbVXiZkX97
Vp6G8gtGNkXuVIWx5O2sqwY05HIdvC4ypgK5TVddkoGG829+Cb/3UAXomqfY
p7dx6oH1A5mfXJXhQbmWUZUnDbUvS5TspsjBvFN3Vjw9xeGH0HAuzy2y0H9U
z+dsHA1P87IVG5pkwDo1YGdyFg1LL8WL/EoQg7XjbruvlNFwat1yunfVfKgP
r3yyoIXDJ0xz16UXhGDfyiUT9KG/fh8BOLcv3Fl2Hh0N0TP24XNBMHgU0rlQ
lo5Q8CNFiE8IXNd9LmrWoWNhmO/lp6rzQYOnvap9NR2Teb5GabdKwpEfB3tq
bOlINTiVtLpZBqxkWsp43Tn6WuT5r72byJB7aHKbVBAdV0z6VZ86IgtJP5Yt
6LlIx+hUheguQVkQLVySNpVBx8U8beV5j0ggltKxjKuYjj5hda0pSjKQ+uiT
3uVGOrY029evKiZBschJ+7guOj56++iewi8SOCZUJxweoP8z30Z/0J8EF6wa
o+7McvjE+Ea6hidHTy65te6ONAP/XE+xKFgoA6Fbzuvu02bgoRjfzTNPSWCb
ptdybCUDX8JbY1aZGOQpnThzcAsD+TaNGqUOSEJse9RgxX4GbldP2f+LVxqm
Ko6ovD7OwCMqlWthWBrG2nafyoxioJeN+IRViSycVpx/+XkaA21/rVXe/oMM
l1Lcnrx/wEBz74PG7CE50N6ssvFIPQNvb7Bw+MmpL2YsDnTtYTHw5v5Oz9Yc
Plh5Sc0jfZqB6UsMc712/SFm+YvL7kgysdOtj3ZXcIrYWmq1+KAmE09+/Rr7
PW+CWJSU5RpuxkQyd67JEc1RIiknq+D8Zia2DXTFLqSPEBEDAo7iLkzUd372
ojD+O8HrxmMk4M/ESFO1PWaPBgnR+VmqfRfm+jsZLP4X0jeYKPh9V+T2E+NE
9W+JSzoFzH9/j9yQfP/CdNdbJsquV390rlQEHLcbejynMf/FL3HINEyPkJpg
Yj06XKu6KAXHVvZ5a4ix0HBSvqHjKAneBumd/K7KwvSpadDk8Gs1y2wtyYT1
r1+JBEtjB1UXbGD9y0+c+sm75NUDXxaWHtCraXaaJN7m8G9LDGVhr+183S/n
pgh/kkriq6ssvMmKUh3YOkBklIpebctj4cH89DrjknfEtsjZ2rhqFkrsXKFN
O/mMSLpUkXOnjYVTIub9Qx9KiP2NpOwMytx+2wrDzhnNMQ7/4Eqf48friZQX
hjFkYTa2mbLOVBxsIGbSvl2UXzKH17Fmau1NjnP9Gs23YR2vD83p8Q0Z0UOP
zrAxLizHTI6D92Np2+unL7PxNlMk3GVFCWH0esxJKIeNEh+lByrG7xCjS9IV
2irZuNLcV0BrMJdoMep30d7EwW/3J47vlfTggGfKD2FnCh4Yyz99blQXYtsq
qEZHOfq5NVa4xkINwGeiRf4CBf+cKbIO260KZ1baz+u+RsE1E1fWVneowvpV
4mk9+RTMWkqxk5bTgGTf9pwPTyh4rFNqxb7P6hDYwbQ1fEvBl2GJYRFKmtDr
sz5ehE7BZwMuzNIyLehYfhf6f1NQwPAt6uuogYOJr92EKBWze2S/md9TBReP
XfbvVagoyZsW9EBKGX48250fuZSKU8Hru1cUKgHJuX7fKUsq/n85rqwATzQN
o72cqGiyvrsoPJYMP5S/2xYfpuKzrxpHJqRkoWTzr4LQUCrKWC5K/PNVFqbz
uU5vSuLo9QVNztpKZOhYfTTPIZeKNk1jb3m+kMGYm7Fh52Mq2pHib8pfJoP6
74cRlW+oWP92hNi4agEkq9XvyqBQ0b2sX2VjrzKknOm8eWaMipNq574eFFQH
HVH79RnCNFyxCpb8OacK8GqkJ1SJhmONqTq/N6tAf21Oy2ojGv7eMXAs1EUF
xBm10ivW0TBpTWZgb6UKPCN62wx30PDP0VeMlENKIPzCwSDUm4Y6lU/PD+2X
g64oMWWnszR8vTpK34mbDEbBr0L1EmmYzBJb+4NfBmTTRizW5NDwlQHt3MZj
4nBhZOVvqUc0fDBDVWDuFoOQ4Bs8tS84/BA2PluZIQA8xs7e97/SMEiwvDch
VhCk1LQtr/2gYXN7meSuQAEoAIezT/npqOxcvMFcWhDaEu/m35OnI39O7Y3a
44IQSpYwOGLA0fO6KSIMBXF4/PqzSADQceLzBr3HTVIQVlnk7L+NjuGNI18C
P8rCu46uLa886djcaBsta0SG+xqWHYWn/jOv5E7ly8g4Or7JWPa8t18G+J0S
NLKz6Li1s9ChbAcJzhOxPqFldCz/yrXA7gMJLu7MFFneMtefUbwtK2T4iY5x
MaMlK2pkYKX6lSDl73RUdWeuKWWToP+te4T3PAa+ijAnaa+RAZnyU3rmZAY+
dXd+qvKQBO9eXAdhPQau7SWJkixJsIAkX0Y2Z+D8XUZSmnZSMBSXmaq8lYGO
ok4NvOekwHr1KdUwDwYGg//42/dSYKqYtso7mIFm1T36xl4kyDesb9lyiYGF
vA3h8YZkyD+2pfToTQ6faHs88QTO9TYwfXlnCQMrPQ4nK1nIA/vo0A7ZbgbK
+KuaVR0WBVKo8h7xbwwMl1Da9TuBG57XZ8+4czORe9mu1bZtk4TQct/lIMPE
D/+/X2OSeP95TT9Jh4kL1bSkvgf+IfQq/Af0/jNvVrThJX2eLROtKu82hG4c
IYK4V5uV/ie/3s9fgnnn+Fx//ocMW+hyFBN/Wxoulz4+THAN6lx8ksbBf5LH
gOP5CaJqMX/TsXrm/+YdeKZTB059YP7PP5q5puXCGdbfx8XBVYK7umeaiY/X
jFR+6JeCIpmz0U8lWdgRavqMz4kEUVt4nqdpsrAohOK68Y00DFWwDzw2Y+GD
JbML+tVJ8Mnh91jaZs6adVpphac0OGou+LzdhYXtsSVqFw8JwS7tbDU7fxZq
i2RnEiE/CfYuoy6LcBa+t79gahY9TvDWSy1KusHCyuMSN1pTnhD5u1fKHSpk
4d2CvqJx61bi40LP4yv+M2/2qvYfo00dc/NKenYUfVFizPlxCh6f7m/5M5dn
L2h/f13ZfDZiwCgX06OOGFagyaWqstG5fL/WjHgtsU82dHO9MRvVdCen1Eyz
CeptuYHDu9i4Gy+UB0k8JMaWOzT6+bKxcubMBavEYiJpOkn8cOjc/qvqX3p/
mq6ycd2HJ/oqUEIcUeUPvp3HxmCeTosF23MJx1QTm5jquf6PvRs5PWwbB28f
GjnvZ+hBtol6TP5JCrJegddiUIXUQ2e73WIp2GMSlzEbqApKb0eyv92kYNOH
4E6XenXQ93kuY1FKQYcc3pknfWrQaJbzQKCFgumSn89c49cA5vKuhsWfKKiS
f83pw21NuHbQ9tO+7xS05fWpiGrWhLZXLxS551FRV/LpDS1uNUhyL+Q7LEvF
BRZ64w/fKQF1Uam/nC4VT7x8rX1GUglqdNucklZT0T/r9vjII0XQ3LmV1WNL
xZ9df1zsj8gD6VHnzUS3v/OiZCDOuuRtwQkqVrh9LJR+LQNXpToE2y5ScWLH
wGr2WTnQEpk44JpBxdX/f0IVAEzDD9c+pOLJ4v1wUUwOmFdk0mKbqNiXeU5Z
5pc8KGhOrqv5yNHn7plP4sjK8IGu9WN8kIqm+yydvrxQBeVP25/d5KJh6BXl
HexaNRieN7BOhkRDgdSzLyVOq4K1yx3L59o0nG2Lo1p6qXB+3wH1W1bS0CE1
hraEXxXu5ufR07dw8P0iv0DLZWW4k0ZZ6ryfhtUPG4ssdymCYZ3/n7PH//Zr
yIByVo33omj4g7gnYpwlC723VCss02jorhc6ovBbEoRd9toXPqBhxZTuz6Mn
JKDGuuHotnoaqssywuePC8HU4dUire9p6Bi64/aibULQXKewRZRFw0Wk/J+/
LQVBYcNM+ZOpv/NrBWGCy+r5Sgk6Dr9ckn8XhcB9sHTvuPrffrsI7BY287tg
Ssfbjw9nqJMloWeXqu7njXR8mLJ1Q7UJCRif5wvfceboefU9i3k9yRByxc6j
7SgdUcASai7KQsaprkbecDpOy8deGXopA5uueVjnJs/Nmw2j7DhNLqDjefXx
/sQeEli4HTFqrqHj76nlm6LNSJAgk+ay/i0dTWIHv2flksBrYpFJAo2OxI4e
10zOulWyadmmP/T/zT+q3P2wwHM+A3HqworQf/r5Xf26caoMdBWjvjhWQIJl
kfJvNIwZ2BSrVHB/rTTUeZUphlsxUG8q4tovpiR0n3ZM3L6bgfv3Fa7KOC4F
IQ3WYdFHGNi9QDPwVZQ0FKyOCmwO4+jtZgftWxw+OcBsSfS/xkCHY3q5Gds4
eN/su4Odx0C/CtFvhYvl4WTnipu3qhn4M2DD2pkZMlQn7H19msJ5PG6FX2CJ
COivyN9PjDOw4u3K10W+k4Q2adMRDxEmXuduDhvjniLuqS0OTVJm4sarhQ4q
chPEk/3yj5cuZeKjCyerbseOEjs7vNLT1jP/8W/XtIb/IEKCP8+z3MnE0Jrr
zVuXfiOMtnpSn3pz8L6l5O4QDBG+ux0P8/1n3qxx8iblqkQmenl1d0w3/iSi
BG6fWJnDRJmV+2dLA2aJl2fKCy6+5Bzv0lhNcIQgPL3woID+lYldKs8Ct3aI
wZqawo6Ho8z/7Qex1OM+0SvAQub1qKUOOdLwseWGktwCFvbf3Li8bDkJft9Y
PlhjyEKrQu3Q+FQSZKWvdFuy9u88P2n48M7VheLAwhDFJ6ZwSwyurb75zsOL
hbzd11kPknngS+fakZJTf/sn00TpHbbp0XgWdlce95ufVk+Qchhjl7M5/JJC
dzrX/pSY6dJ9/LichbIqa6aXn2okjn9QWv3oMwtF7lZoX3QtIrhufXdwHubU
B0UqTec8mghyxgdG+7w5/03lK3UNKTIbjW+C+y0OvlMXB0TU6bHRsqLw6+/X
D4m0Rr3E1eZzev5zDL/6uN0cHueHj+uHuc/5M3mKt3zpOjGH71SJvMqMmDn9
b5/lNL8lk40leYfaswSKiU0HbA9MFLNxKrAz3so/lRDmqfo41MzB/7bA2sn4
YkK0depMhw0F0+reEoqphmCzZe1HJVcKjunyPz5M1gW5ed8qvh2nYLXN65Py
SSpweKC6vSaKgtY5PMknG1VhC3/WO0oqBaO8lRtkstXg0bbBnfEPKDjTeKkl
ykkd7r9bpf+9noKfE6K1Zy6pg2FEr9DiTgrq3Ui47GOvCSu9W03K2RSMF6q5
+y5dC96GPbo/Mk3BB9eCL5XyqcLPl/PvlUhSUcFK2tD+hwpkbYzsD9SkIm/D
tiWZPkrQ9VuGJ245FSPWnFxvUqkIad1Cd/Q3U1F/8eVPfFbywBriuXrGhYrP
qbTm3CBZqDXZevmBPxVnPb0Vm8tlQeMBtVsngoqB93u1i4ZlQXL3maOON6i4
4YVOgscVObi44lSMcCEVlXats37mIwdxm0J++NdS0cLPy+zKZzlQjvvg8biD
ijn2zJrEAEUw4w3Q3sykYrrCQ72mbFX4VCBrHD/J4RP9Xc5ZkerQfHXzZS31
v/ipAsIfYtevN6Ghhe/PLUYeqtCzweTMwAYangh49HL4mAqYDPVxW+75mz+v
xKm/9I7yXKCh6+GRoAN8ZIiafyLN7DoNO3svn1nQKQ0SZ3Q2/8qn4dv9ftPq
ahKgqjJrXPKEhj3Jg6plv+ZD9Sibv6mNhmG7ZK+uZAgAdWLVHmcqDbt3UMat
JgXgmnHiTN447d/rSQg6bm7RPCNCxx9J/i72HoKQQhiGb1Xm4HWsx0JdzvO/
SWi+Dl5Cx4sf+CP0LSXhBelsis56Om7fflzYfos0mGz+WhKzk46thwsD5x0k
g05p0sfXPnS8YmWq2H+KDDm28dZO5+i4y2/s3Nc3MlCkFC+afIWOQgfuyz+t
JsE65Z+2znfp/5v/7bY15LVGFR3p+br1kfoyIFqhZGL+io4FrL2JJ5xJsNZW
XeVrLx1v3K+bdQmQAR4FA0fjn3T0lnyZRv5Bgi3kmBsHBRn4oNy+sENSBtSt
FuvRFzCw7BypzWYVp17I6xIgL2bg0pUve05YkeCIOcPr9VoGJpwmT+s3SAKV
b1J2pSMDCTdZhZYMznrWrT38EANtRsUc2pWkwc9A6qNcCON/+3mjYpoW7bvM
wNGW5t0e0WTQU/rCZ3iHgU4i1Z9j2+RgZ98C+ekKBtabjh7v85IHe+6FV55/
YeAnkgY1Il8UVJypLgt/MNBEatjp4KEZImhgzNSDn4njd15Cstw0sbvAZg/7
P3n1zzPvvdZY9NfP8puobzrcSIG5PDRL5e2/bm/j4O2xBhHBDDbhkLdVrOrA
3HzxoQMl+dtPMlFRt+ZyucsQIbVDIelOLBNfDm08WlMxSjQG07lO35rLq693
/GJ29hkTxQPFqjweCoC05CbrJT1MvMF75XZxhyh8m64quD7ExCUrvuxS95cE
B6VQ+S88LFQ4HmNpbS0N649ceucty0KzEL+KvtfSUDua1l2oy8LoW2Yml+1J
0JIv5RG4hoP3vMXLJ85Lw66kQj2w46w7tr8/LScBgUXOXc5uLBQz29a3L1kY
FGf9hXhOsLAn2oJwXf+TsDsXG7nrIguh15JXSn+aEDWelrySweGLTUcEm46d
IxwUillSxSwkB495f3GsI8JDYsq5P7JQ8qFZ+JefGYTv1JsbTwbm8un7C3Q9
Xv0nr743nlniJsXGg+2r+Ujd9cShOwW297XYGO4kr3E7tpgI+fbe9+yKOXy3
lIkSCdrLxgO6EWWKJcXE1E+7ds1jbNQkPcyRWFhJrBZQoYZHsFGFOeJ/KbCG
ELBeO+9ZChvN08TDI33qiD0N+Uds78/5KYtej0s/qZvbj5s8taTaaCcFrRbM
fBcZ0ANl+cQcCx8K5/zdMK810gRDrx0unmcp6Hl9T40HR8+3sJAimEhBUxFy
lM5vNfiWjgHjdyi47NFO6T9T6pB5IeftWCUFN45eTvltrQ7d6RLGqq8oGCSy
7vpGd024yXpzxqiPgoe1L5NSjLXgh2dHmMhPCnbz/rYMFFWH13JfLkoIUpFU
X8awEFcH0ynrfdoLqBgtsavXJUQRdKT6eKoWUTEhf3ap8UclyNl18WEKUvFr
tcKea0uV4P775EWXHKho276Vx05LHojzBQV3vaho3/g8ak2nDDi7yZDyT1Px
VRrXumUussAX2GB6Ip6KfOyT7ZEcPbziceAe32wO/vKeLf+zQBF+L423DSyn
ovkJara1ORngc8H63FYq8usJr+y5qgCyVSqadV+oaDV++u4VeWUIeN755PYI
Ffd0au6RN1QDF5Gru4r5aBgXe1cm/70adJytaGyTo+Fu912Uf/IsO7RnJ330
afi1P55h5a4CLlx7CEeChrmPHD3MilXgmKiynZ09R78/vjf5+IoySG+muQUc
oKG+o1GW0jkFIKq59509+Rd/ZeHXXjfy9lhOPTD8dsvorAyYmra2O9yay7fk
Ja45eZTS8JpdbekbczHYdTLy/mgzDf+vqXMPp2r7+jgpJMK2t2vYSEIKieSy
xpDcu6GSkApFKRGVI6mUEl2QUpREJEVSRBFRKFEolU61L2tfQnLLvXf/3ud0
nD/ns/aaa6/nWfM7P2PMOb/jA7t/9L7+TLDkJko3f2Rj5/J2rkOaBOSdHLGq
6GbjzopykeFCMcjcFLTnjfCf+lDioLkFdg9Tp/wuF6VZLMvQ+VMvRBJeiLhQ
zlqQeLCsZbRangLfM6tLz68i8erMaUfiZ8vD5RBL38qtJHIt0nbyShSgNVTy
55sIEh1WqqHxBnlIzdWwKjpF4gtGcaOomzyQsy0TyjJIbGhUqZj0oEJlXkXe
myISTz/T3OqxhAZa4b5JO56R2NGSfsA8jQqUfconXd6TGBj3fFdCEhUScsyd
kS+YPyInclwXUiFppo+s7ySJm2YcWlrlTAWtzPdV/hQOxr6aKFzfRAXrwFRd
U20OHtqzpZ/cSwWmn2eqoTkHM527H4u5SQMt+ViLhQsHZzFKGKL9stDSf09q
ry8Ho2fY7BTaSQH5uCWLE/dxUJ9Xc/rKejngukzK7Yvj4GnWksqA6/Jgu+LV
r9grHCw+FyntEaIAC0J+5928y8GHn+Ja7bMV4WrTBh27ag5SxlLP3dhMg7n0
SzMNuRzMGd26gHFZAsxoIX4bxjmYlPY37cT4KNFmmZHrL8NF48aWd1ZG48RE
qvRNay0uLnMxeNDTNUrc04rLxf/Ul+1hbItY58TFVn223Vu7PqKsTfD2XgJ9
r7/NuxXaQ0iORJXXhXAxfuBy3DFOF9G1emTRg2NcdBHLaF/i20Os/xCZ9/oi
F8d2z5gbuPkX4XJhS89w/p/5QRjeZZ+hp77hov50sfB2+1mwc5gqlc7iYv/l
yh/XhGTgdHTm+MthLnY5Hr9ikEYBM7MjbQxJHs6npK1UjqZCsGbu9lp1Ht4q
MmfF+1NhIbydaF7MQ19+a+NdwfwddW7rli473j9+D3LgKqeYdGIjD4v1Y9a+
r5CGknrG6+DgP/42wpBZRPngH8PDZr8tbdyGSULxpT0Zl8LDwXRhM7+IXmKO
4ttP5/J46KFfl9ER3kbkXbye4Fcx5V9c7RgBW5un8jX+C4uqQxg8bNHQKOgU
e0Qkr5CWmfiPX73L2WNB78T5qDF07UWQ8zPi3CzvpKcqfMx2eWX/aX4t4Vtu
8aRt0VS+vuzK4QcjNlM8n1HIjUz/j1+95FCAS0IgHy98jR3Lzn1IiO5x+p4Q
xcfBriUhZ7IqiATlxYml5/hYcb7n5iqlB8TSmQNeOaV8rM+qubkvK5sIOrRn
9yEXgd630SzyJ/TB07PHP2UzE4+ensOyUJoPbwNdV50NY2Ln8bS7yVvU4f3t
TSt3nWDiKpnSokV71MGfHvndJ42JfKEB9y2FdDj84lDkkjtMbHQy3sYX1QKt
66K8rU+ZSB1eF3Xhria43mEV3G0T9Le1BvVuzIXZXXEMXy4T9+U+X6VpPg/c
vYt+BY4xsdLDWLmyUh3mCldOrJdm4aRur7ziQjrEvA9RnqfJwvk5+hpL96hC
wNel7ySWCPR1RDiMYyrgeRXyaKsDC3XSNSYLzilC6ylF6f5NLIyd5WyoGKUA
G/Uyew1DWHi0/ejQvGB52DnRtbz9GAunbb1d2J0rD2IiVREtqSzcNlKx+723
Iiy0iLhcmM9CvyPBX3IF45GRU5zBfsLC0KL+72V3FIBLufJ0gM1CpdZFykoH
6WBJ2x8kOsLCDRtVE6PGNEDZaemMcUk2KuXuuuS+hA5H71192KrORn+7FuFR
gg4Rzspi1cZs7NNV6ryoQodBhb8ckuz+nGelw6T8lsDyjWzUcT+8gtusCskO
6V+EdrORUVaowz+hCPcL0l/cOfLn9wrgtVzz7L0UNsZ1PCnzEYyXJMlE+7Q8
NtL/f4BLg6t4hvy2Cjbevb+PxTGeDVdNa2JtXv/xSxCF0IuvmDMYbEywf+zn
0igGbXpemvRBNqpNhpUz+8ThaW/LWrWZ5D9+7WJgyuNfnFQR8Dr3RdRpQ3Ew
oyofGlhIomubd/j8h7LwbO9Ct9c2JGrrnmwLe0yBT8L14r/XkYLx4F5mracA
0bUP5VYFkfjAa9veV9oKkP8o6JxINPmv/+TWbze6pM+TuOt8je0bQyrctKgx
F8oh8fMn3ufco1QIqz+e8bb0f/UGzxw2LKfCqzifzPJG8t96o0UH56Sc+JvE
8IF8+p1JKqhd3bz91k8S3TW9TMc1aaAw+OssfwYHfa6FK36YRYMr0ev0kpQ4
+DTwR/vCUCrcXrY0+9wCDhbd3ZMTbEeFFbpC0mEg4O8T4t9qAigQ6LRyY4Gb
gL//Kg3KkaKA4tUfwyI7OOiy4sB1uj8F3OdukKj5i/OPPlBB+fPysXdnOGiQ
ZqD67IwCBNXTPjdncVDuaq2xT5Ei2JEJ7fkPOMgKi4z8nKgEVx/FD+7p5GBo
oTl1mqokKO054n3lBweZRY9zS4uFQWNDkzJb5A+vjxPFe/92vKDAxf1FhleH
E8aI5sp9Hul6XLQ4yRo7nzpKRFj3boiz5mKKkcn68k99RF6vzG73tVwcuviZ
KH7eSwS022mZ+XGxaG2A14O7PURR15aGif1cFPeoOnhRpps4ajpttcppLh78
qnz4RW4vwSiOq5tzjYu2DS+mUXPGCOvlfdEjtVzkb3ONzNYXA6sNCunvOrio
d7zvL4aSJDzPqL4k0cVF7ex9MtrbZeB/xZK8hHho9kni5WGQg79qjt+lUQX8
XTzPdLcxFbIzm9dq60zVl/W8N8lWtOBhZbokVjHlIH3g7bmelTwsH/xxLGRS
CgKCHn/84MvDHWHKB7yCxeEx5TTt1j4eCps6mK6IGCLSu/9e1BzHw11VWbmK
emOE+FjcNbl03r96+nvZUExl4Z/11VdEzB0ePq3hYeP4skXXOl8Qia41/Tnv
eP/qs7YePA7m8TBqf8kQX6iWsDdp1XIen+L7BV8dSuZq8f/N1/ce0f9MN5vS
b3nvNWN9Xnzc5GlirylcRkSmvm1sDPnf+dpEa/GuUmLHtI8HR45N5We+ZZpG
210S3D9eyq3xf0iw93oMjNyemi+mPZA3mls1df52qDC74MM6Jmb6Fpxq0FoA
3NePB8QPMdFv7Kzhngt0MMr/6vPwLBNf82pNjWQ0YEaZUkLoDSZm6Jf+vjVN
C/yHzQbSHzL/yR9owqqdn34mNzIxOlwq96yOFtTKtNGL/mbiBTgU4d0wF2q5
5xc9/MlEEocNS0AL1vS3tZ6cwcI1oWEGJwM0wM9worhBkYVRs89X7ZyrCqKZ
jcsC9Vlokdw9PoepCsY2d44rECw8HhWiE7hXFbjy4bNMXFkYXVjY90VeGXTV
auapBgj0tuk87Ww9FQY3+IXpR7LQzF/mbxM1BVhZ+/KaViILFy77wnVKUoBF
28q2cDNZeKKn546IsQqkm8T7qJSw/tFLRUhZ+q1XuZ6FmXHjDf0dSqC4J7GE
6GShbZHCSb9iVZjXMblh1Q8WDuczLGniGlAZNnhOV4SN5g8YC17P1gAGvpke
Js/GRIYPe86wOpyzcdVQ0WXjwJlk31IHdWgM5wq9tWTjmsAAnXXWdEj8tE3l
12o2RsjW9ohOqkFnmN9L7jY2Hr8mpqfarwyl1uUFv/ezcTrZ17LWQgFULNuD
hU6zcbHfqbqY1TSQ3BVe23SVjSWztT88/C0DJ16PrptZzMawFHedX++lIGGb
9rkb//Grn6Pvn+jSwUb1hBpeHksCTLXj67Z9Z+O8jvqAVy/EoHOtSbL9bzbe
EpP/VeA0E2bfe3YljULiJSmhp/u2zYRGm2EXJ20S63TERLryJEFWzKZ6pjmJ
wS2H3xSpUIA5ERJi5kLirbD6jCc/qYA62g+MfElsXxt5ze6WAsw/tlB/7b4/
+XYB38tOxHjGkdiaZU4Vy6XBpbdrdhleITHeJOjLAVIO6M9PJe27S/6zHkaD
xV3btyhUk1ju7r03KJ4KLbab+uvbSOS0STS0CHh+tHnxUy6HRIt5S9VSBfx3
N/G8ZvsYiYXNSRdm0anQfcj2ISnNwcGqHcGLp9OgNPOxLkOTg2vo/K+ijlSY
NfTION+Ugys0vHlbaIJ45FB6xFdHgf4e82mySpQF96XT1zC9Of/EMxRw0q72
nBXKwQf08SOBZnLQaLt8hepxDs70Hyd9smnwLtWpbuwSB3dzPio3NCpCkIpZ
jEMBB/181t+bnqUICW/rmf2VHJSOlA9YE68AIR1jO9+xOZgif+5Er+EsMNKR
2vZyRHD9rPWjvUFjxKG8sNNsKS5KJvNMGAVjhLvXtWQeXaD3Kidk9cRHiVKb
NUblJlxcuTH2y4FT/UTWJnLmiD0X6zSzGWNhfcScXI3TqZ5crCSFsyOiegg1
7dBmm91cVMvlknbd3URBe+4q7yNcXOz2eBqjr5sIej3tfloeF5dUJVwLmy0M
ruezAmSaubhhuUXTJ5+ZcMGa4YUMLoZHzWl2T5YGP0FH1kNTfvVVhtU5WyQE
+nzl49ynLlS4EZ5ps1uVhzrN+pddw6hA7Z4ebm/Ew1MfHlI8H1Nh9sVVjDO2
PAxyUboz+YYCKWFWwyYbeOhEO2Oh0yEDN4/iG14QD3tcjRJ+iU8DqNVjS0bz
cPmmGEeX0AkiYGnamfHzPDwRduyMtdtXQvGLV6DsTR7a3tia2mf8hnAvY2vJ
PBL0v3G3048Zzwjl2v6wT694aBpvmV3c8ogInsaZpH7l4WFz+c9Ws/MJx7DD
xnf6pvS7WN5A1110yq8+u6vKM1CJjyst9vpK9tYQmoPvNZwNpvRWz7Bd6wrw
cemg2wztZcnEk4z9rx3dpvj9o9UiS7HtfPxpabD+5IFiIlbmFcs4ko/juhTx
E9sriDJaj6b+GT42+NRfiii/T+xf6Z/kkDWVr6kuvf5t9QM++vgd4BZvyyEe
qlx5HNfAR5Oywa/vUwuJIvn4RP21TGSMPPJZX6kLNpDqkuvHxJDX83uuFOmD
d3qchssBJh7TWuuzelwdpuurrZc9zUT3QJFL6nM0YElXQ8WOq0xUbbZRaKJr
Qt8XTzPePSY69m1WMf2tAUtF9wb/VcdEWgB7ltYTTZDc3BlQ+IGJRxzTYt46
zoUdfMlTs7qZWDekwQ910QbXvBr/g0IsfJOYYnDquTrUXvL2kKGy0H7+4lJ2
uSrUVGTkv5jHQu/Y6i6R+6rgIttvILuMhWqb7feKtKmCb5rBi2MrWSi2dMQm
aEARJt26lcW3sHAHc/3XsD000MFpxgvDWfglbPfTyXfy0OnbuTfqJAtnXAv6
ch0VgDSLifIvZGGW6/2NZXcVYNkPR3uhZ1P6P+fDjnbL9yyU29zcfMdVFU4M
uiRc57PQSld7vKOLDlG2DycUJlkoI9TmG9ChAZN104+XyrLxdAzVMf4wHSQi
h3funyvg58EvmTU66pDpKxzbYCbQb8XFk010OlQf/HHP1pmNZstvnAmSU4fg
uq2X3/iw0TJc6FvBNFXYPlCmvOHEn/ojClDy/uWtqjQ2nhyuzdD6SoGE7mer
1t5hY9J9Jyv/bBnoXbLFTeQpG3ftXCHy21cCOovkTtm3Cu63NbIdNBIHd5/b
bSUkG099XXlglaY4eFjXf1w8ykbPeLpQ8O6ZQK5pHPokReLbdeFFAyxxEErd
G5pNJzHn//lEArKlFqr/Xkxi26W+/Z8/y0BrafO3o/bkv/vLz6QM+ShuIvH0
TJxAPUF8dSP02uo9JOpPSMcLHZKHLPZ98cKjJO7fnsIUu06DyY2RC+ipU/VG
GELzAspvTe2fcfsY8XvfYxKrbmJ2UTsVVpGdDdXNJKYMFP/SSaFC29z5+WZM
Eq9ExhcafKYCeWHYtmqIRFkRG1tspsJRc7UbXAkOHul0XtloToNb0jP1lqkJ
+Hpf3/xReSpsUjy4M8OIg++XHNyp6kqFS26va3RXcDBYut06TogCPtV5bS88
OOhmeyCdHysLxVs6bokFczBtct+doDNycMakKXdPDAe1HpjM3lFIg2Fze19e
MgfFdsqJBAm+L/7emwsTcv/k65VgR2e+1+pyDi72scxf264Ioo7PDLW+/akP
Lgnazva+9wc4KFq8ycpn42+i+TDdjS3OxfZzXy2uxU0QIpzK3cQcLt560JVz
2XOMeBbDsL29iCsY72VZd4/1E5IrvxvCci4mp69Uc/74k2A4p0UNruPijXUf
cs57dxE2h7xGLAOn1lcXfpuecCeKi/U7mp/tGughsvcbf1h0jos/m27PljUY
JG7CCstPN/74X04QDkGNfdMb/8QT4sBrjBo//ZmLt1McRruFpaBJCx02z+Bh
6KMqpRx7OZCekzxcrchDXPTl6r2jctBpF7TNdAEPm5HvfuEUFUyy57FaiT/7
VeRA0eRk7XlXHuZrHjzqJyfgl6HJ9m/+PJyIJK64vJ0J0d89JzwP8vDsXBtG
xe5RYpqc5Rf2//zqrQdfvjs4RsgEh8ZSrvPwt2nd/L82lBL5I8Gu20t4+NK4
Nqfav5poKuv52PSCh9/GedmhUEscync/6P2Jh+uNWD6DT+4TUdoxN1cLT/kV
v7p7/Hs5VcDf0nMnXAV6nhck891sPh+rtde3SccWEZIbY4T+tpji7wNNVSoT
W/gYJlvHLvteRkS7Nb+PDp+6LiPpt4pyio9tLMt3Tg1lxIJfK0/aZ/BRMV6u
I0a2lGilTvCzi/jYET7cWCOVS3hxO4bW1U7x+zLHqpdxnkwMmjewIW+tHlAk
SaWm3UxkrWF1lHPUIUy470XdESZOHsiSSLOnw2bdG9s3pTDx8fxABxikw7tj
gV5ReUw83vppjc5bLeiQod1bU8FEc30v98kkTfBrWRFR0MzEnjcRh6oWzYWo
mpcfi5hMfKZ0ub2Xpw10jvw73yEmPnp1JTE6QgNWWXPwkgQLzxkGt5z/QQfR
+nSpY6os9Pth8rluUBWcYn81Shiy/om3VUExbPtnVVvW//SGYaSlAqEpj1ez
1rOQdvhB6V8WirCOm2psvJOF80YHm4ozaFC7+3nJ/MN/zq8qQKVORVPjeRYu
hyg9bqECLJdbsmEgh4XOOna/o0Rp4GqUAm/KWGhkVllhukcBeo4cuLykiYVv
TxbW8hjKQJ1RnGzzjYV7PsQ7mH9Qg9ryIq2xfha6fb0Yu7FUA4RumMy1EGej
yeEJ+aA6Ojx/khG7UIWN62soWzeFq4P8rIJ3lQZsTMgw+MyfVIe++OZDH5GN
bsNS8/1n0GGjVUfsLXc2OnZ8znq8Vw2cNQPGf+9g4xWG9utNNkpQb+4o9zuK
jbaHrG7Lu8hDy7GfT2+dZWO+wTI7RzcabBVS//LpBhtDjU8lShDSEFNo5F39
kI3bDEK7hdqlYP553qvlDVN+9YpdOx5Setm4vdhwX6+MGGz1z3TeNJ1Ecb9R
0fwUcTCVfQIbFEhU/uZzJP+ZOKT8iNbp1RXwbyjXwcFcCqKF1m+jWpNYc9Li
8VIXCvQvp/z+vkbA3zayBsc65KH/kdssZ38SL44Xz51dogDRW/kPXQ+S+NG5
/uz4JnlIsrIbmZFAouj3EiNGDw2MnXUKIJNEInO/ldVZKvic7q5ceJ/EYonJ
u7HqNJCb9Hj2qG5K391vfJjT8oHELoMXLF41Feh/Ee/Sukjsx2bG9dtUiDiu
J/RdiIND9o2LHcRo4FET1MCicrDAA9fRa6hQZxSiG6/DwdjOMp/TFCo8bh0d
eWjBQcrLrTMvGsmAdV6Q3sVVAn334q6UlRfweeHml5NbOfi8XCnXdZACDO6t
WdL7OXirqyV0cRIVRNc9YjSe4uD+xo9qF27KQ0n/Sr3ZVwXPA+cSccH31FX7
4s30exycKFjtTxtRhKJ6MujSM4F+jy4f80qlQsd2k9xTfA4asZZdWPhFGCxF
Wv2Zkxy8Ya+39/KiMUL/zfNnbMrU/sicN4fLkrW52PqrecEstTEif3qlaoM5
F5Nuto1VKPYTy4K+Me65cHFF6e7bS6t/Eu7T8tPMNv9ZH/1BjL6Ky3EIE/R3
ZqfdDs1uYkGjk6zUCcH8EBCmEJv6gyBHkro9LnPxy+l9Hn77homFXk91Pe4I
+HzdxIReljB4lkV+VGnjYm+ISI/raknAYvsnQ6Sg7brHuCVLGu7/nSazcYyL
8y0dvv4qoECRFYr4SfNwhdzVB707qbC0+U6CsiYP11ZGbXDQpYJT8rUTHqY8
9Am5vzloDRW4pwThkqNAz2m1BecZckC536ffsYmHFUq98yoFfFI7O/bVzz0C
/fb7KCJ/YoiYljH6qvIoD2MO+tO1nSaIRu8hK7mLPNTVTLdhO30h1Nbar5K5
zcPRyKNW1HfNxGSE92DZE8H/yZsuHalYT2xvHpbkveEhdfhv9c07Sggvz4Ox
r/7jV9+pcK3b5ddUmyP28bbHLD6qtt1cPz+niojSG21QUJvS//TD1zx8jPl4
ZLpoeSMjm3AQ07P3WMFHhpTYyqzD54hD1Rt1fvzHr9767lUv2V18XCUR/66q
sYSIb6r/SUbz8aBF87Fh1iPCV/3Ar+XJfJT0sPI2m1NM1NyISnfM5SMZsLxK
Xf0WUehp1zH6aCr/Q1ntffTRaz7Kkc9fCmVlE48S7YyUHZj/8ISQkH3oo6uS
zfx/2/8HcxBozg==
                "], {{{}, {
                   EdgeForm[], 
                   Directive[
                    Opacity[0.05], 
                    Hue[0.67, 0.6, 0.6]], 
                   GraphicsGroupBox[{
                    PolygonBox[CompressedData["
1:eJwl3HO0Hna+9uEdNmxs27Zt27Zt27Zt27Ztu22ctkmbpOlcT+ePec+c/X0+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                    "]]}]}, {}, {}}, {{}, {}, {
                   Hue[0.67, 0.6, 0.6], 
                   Directive[
                    RGBColor[0.24720000000000014`, 0.24, 0.6]], 
                   LineBox[CompressedData["
1:eJwd3AO0Hfi99+ET27Zt27Zt27Zt27Zt205mwpk4M8EEM8lM+uyu9fZte377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                    "]]}}}], {GridLines -> Dynamic[
                  Join[{{{2524521600, 
                    GrayLevel[0.9]}, {2840140800, 
                    GrayLevel[0.9]}, {3155673600, 
                    GrayLevel[0.9]}, {3471292800, 
                    GrayLevel[0.9]}, {3786825600, 
                    GrayLevel[0.9]}}, {0, 5, 10, 15, 20}}, 
                   Replace[
                    MousePosition[{"Graphics", Graphics}, None], {
                    None -> {{}, {}}, {
                    Pattern[CalculateUtilities`GraphicsUtilities`Private`x$, 
                    Blank[]], 
                    Pattern[CalculateUtilities`GraphicsUtilities`Private`y$, 
                    Blank[]]} :> {{{
                    CalculateUtilities`GraphicsUtilities`Private`x$, 
                    GrayLevel[0.7]}}, {{
                    CalculateUtilities`GraphicsUtilities`Private`y$, 
                    GrayLevel[0.7]}}}}], 2]], Epilog -> {
                  DynamicBox[
                   Typeset`ToBoxes[
                    
                    DynamicModule[{
                    CalculateUtilities`GraphicsUtilities`Private`pt = (
                    NearestFunction[1, {6105, 1}, 3, CompressedData["
1:eJwU12c4l28bB3CR7R8hWdkkSUgIldsOWUmyiUJWVipkJyUhJbukIaFIkuwy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                    "], CompressedData["
1:eJwU12c8lm8bB3CR7R8hWdkkSUgIlcsOWUmyiUJWVipkJyUhJbukIaFIkuwy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                    "], CompressedData["
1:eJxM23k4VH37AHAJRVG2mbEMs9mzJFki3QdFFJIo2aMia4siSUKWslQiUaIo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                    "], Automatic, 
                    Hold[
                    Nearest[CompressedData["
1:eJwU12c8lm8bB3CR7R8hWdkkSUgIlcsOWUmyiUJWVipkJyUhJbukIaFIkuwy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                    "] -> CompressedData["
1:eJxM23k4VH37AHAJRVG2mbEMs9mzJFki3QdFFJIo2aMia4siSUKWslQiUaIo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                    "]]]][
                    Part[#, 1]]& )[
                    MousePosition[{"Graphics", Graphics}, {0, 0}]], 
                    CalculateUtilities`GraphicsUtilities`Private`scaled = 
                    MousePosition[{"GraphicsScaled", Graphics}, None]}, 
                    If[
                    CalculateUtilities`GraphicsUtilities`Private`scaled === 
                    None, {}, {
                    Text[
                    Style[
                    Row[{
                    (DateString[#, {"Year"}]& )[
                    Part[
                    CalculateUtilities`GraphicsUtilities`Private`pt, 1, 1]], 
                    (
                    Function[{
                    CalculateUtilities`GraphicsUtilities`Private`a, 
                    CalculateUtilities`GraphicsUtilities`Private`acc}, 
                    Quiet[
                    RawBoxes[
                    ToBoxes[
                    NumberForm[CalculateUtilities`GraphicsUtilities`Private`a, 
                    Max[1, 
                    Ceiling[
                    RealExponent[
                    CalculateUtilities`GraphicsUtilities`Private`a] + 
                    CalculateUtilities`GraphicsUtilities`Private`acc]], 
                    ExponentFunction -> (Null& ), 
                    NumberFormat -> (StringReplace[#, StringExpression[
                    Pattern[CalculateUtilities`GraphicsUtilities`Private`s, 
                    BlankSequence[]], ".", EndOfString] -> 
                    CalculateUtilities`GraphicsUtilities`Private`s]& )]]]]][#,
                     1]& )[
                    Part[
                    CalculateUtilities`GraphicsUtilities`Private`pt, 1, 2]]}, 
                    ","], 12], 
                    Part[
                    CalculateUtilities`GraphicsUtilities`Private`pt, 1], {
                    1.5 Sign[
                    Part[CalculateUtilities`GraphicsUtilities`Private`scaled, 
                    1] - 0.5], 0}, Background -> White], 
                    AbsolutePointSize[7], 
                    Point[CalculateUtilities`GraphicsUtilities`Private`pt], 
                    White, 
                    AbsolutePointSize[5], 
                    Point[CalculateUtilities`GraphicsUtilities`Private`pt]}]],
                     TraditionalForm, Graphics]]}, FrameTicks -> {{{{0., 
                    FormBox[
                    TagBox["0", #& ], TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {2.5, 
                    FormBox[
                    TagBox["2.5", 
                    $CellContext`TagBoxWrapper["StringBoxes" -> "2.5"]], 
                    TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {5., 
                    FormBox[
                    TagBox["5", #& ], TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {7.5, 
                    FormBox[
                    TagBox["7.5", 
                    $CellContext`TagBoxWrapper["StringBoxes" -> "7.5"]], 
                    TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {10., 
                    FormBox[
                    TagBox["10", #& ], TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {12.5, 
                    FormBox[
                    TagBox["12.5", 
                    $CellContext`TagBoxWrapper["StringBoxes" -> "12.5"]], 
                    TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {15., 
                    FormBox[
                    TagBox["15", #& ], TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {17.5, 
                    FormBox[
                    TagBox["17.5", 
                    $CellContext`TagBoxWrapper["StringBoxes" -> "17.5"]], 
                    TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {0.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {1., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {1.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {2., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {3., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {3.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {4., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {4.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {5.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {6., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {6.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {7., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {8., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {8.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {9., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {9.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {10.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {11., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {11.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {12., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {13., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {13.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {14., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {14.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {15.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {16., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {16.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {17., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}}, {{0., 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {2.5, 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {5., 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {7.5, 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {10., 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {12.5, 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {15., 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {17.5, 
                    FormBox["\"\"", TraditionalForm], {0.00625, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.25]}}, {0.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {1., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {1.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {2., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {3., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {3.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {4., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {4.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {5.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {6., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {6.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {7., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {8., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {8.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {9., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {9.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {10.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {11., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {11.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {12., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {13., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {13.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {14., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {14.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {15.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {16., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {16.5, 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}, {17., 
                    FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
                    GrayLevel[0.], 
                    AbsoluteThickness[0.125]}}}}, {{{2524521600, 
                    FormBox["\"1980\"", TraditionalForm]}, {2840140800, 
                    FormBox["\"1990\"", TraditionalForm]}, {3155673600, 
                    FormBox["\"2000\"", TraditionalForm]}, {3471292800, 
                    FormBox["\"2010\"", TraditionalForm]}, {3786825600, 
                    FormBox["\"2020\"", TraditionalForm]}, {2587680000, 
                    FormBox["\"\"", TraditionalForm]}, {2650752000, 
                    FormBox["\"\"", TraditionalForm]}, {2713910400, 
                    FormBox["\"\"", TraditionalForm]}, {2776982400, 
                    FormBox["\"\"", TraditionalForm]}, {2903212800, 
                    FormBox["\"\"", TraditionalForm]}, {2966371200, 
                    FormBox["\"\"", TraditionalForm]}, {3029443200, 
                    FormBox["\"\"", TraditionalForm]}, {3092601600, 
                    FormBox["\"\"", TraditionalForm]}, {3218832000, 
                    FormBox["\"\"", TraditionalForm]}, {3281904000, 
                    FormBox["\"\"", TraditionalForm]}, {3345062400, 
                    FormBox["\"\"", TraditionalForm]}, {3408134400, 
                    FormBox["\"\"", TraditionalForm]}, {3534364800, 
                    FormBox["\"\"", TraditionalForm]}, {3597523200, 
                    FormBox["\"\"", TraditionalForm]}}, {{2524521600, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {2840140800, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3155673600, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3471292800, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3786825600, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {2587680000, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {2650752000, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {2713910400, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {2776982400, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {2903212800, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {2966371200, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3029443200, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3092601600, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3218832000, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3281904000, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3345062400, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3408134400, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3534364800, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}, {3597523200, 
                    FormBox[
                    StyleBox["\"\"", 0, StripOnInput -> False], 
                    TraditionalForm]}}}}, ImagePadding -> All, 
                GridLines -> {{{2524521600, 
                    GrayLevel[0.9]}, {2840140800, 
                    GrayLevel[0.9]}, {3155673600, 
                    GrayLevel[0.9]}, {3471292800, 
                    GrayLevel[0.9]}, {3786825600, 
                    GrayLevel[0.9]}}, Automatic}, PlotRangePadding -> None, 
                AspectRatio -> NCache[
                  Rational[1, 3], 0.3333333333333333], 
                AxesOrigin -> {2.6*^9, 0}, AxesStyle -> Directive[
                  GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], 
                  FontOpacity -> 1], BaseStyle -> AbsoluteThickness[1], Frame -> 
                True, FrameLabel -> {None, None}, FrameStyle -> Directive[
                  GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], 
                  FontOpacity -> 1], FrameTicksStyle -> 
                Directive[FontFamily -> "Times", FontSize -> 10], 
                GridLines -> {{{2524521600, 
                    GrayLevel[0.9]}, {2840140800, 
                    GrayLevel[0.9]}, {3155673600, 
                    GrayLevel[0.9]}, {3471292800, 
                    GrayLevel[0.9]}, {3786825600, 
                    GrayLevel[0.9]}}, Automatic}, GridLinesStyle -> 
                GrayLevel[0.9], ImageSize -> Full, 
                LabelStyle -> {FontFamily -> "Verdana", FontSize -> 10}, 
                Method -> {"AxesInFront" -> True}, 
                PlotRange -> {{2587939200, 3598214400}, {
                  0, 17.773746682529158`}}, PlotRangeClipping -> True, 
                PlotRangePadding -> None, Prolog -> {
                  Opacity[0], 
                  TagBox[
                   RectangleBox[
                    Scaled[{0, 0}], 
                    Scaled[{1, 1}]], Annotation[#, "DatePlot", "Frame"]& ]}, 
                TicksStyle -> 
                Directive[FontFamily -> "Times", FontSize -> 10]}], 
              TagBox[
               GridBox[{{
                  TagBox[
                   GridBox[{{
                    StyleBox[
                    RowBox[{"\"(\"", "\[NoBreak]", 
                    FormBox[
                    TagBox[
                    FormBox[
                    TemplateBox[{"\"from \"", 
                    FormBox[
                    TagBox["\"Jan 4, 1982\"", Identity], TraditionalForm], 
                    "\" to \"", 
                    FormBox[
                    TagBox["\"Jan 9, 2014\"", Identity], TraditionalForm]}, 
                    "RowDefault"], TraditionalForm], 
                    Format[#, TraditionalForm]& ], TraditionalForm], 
                    "\[NoBreak]", "\")\""}], {
                    FontFamily -> "Verdana", FontSize -> 10, 
                    GrayLevel[0.5], 
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                    0}, StripOnInput -> False]}}, 
                    GridBoxAlignment -> {"Columns" -> {{Left}}}, 
                    DefaultBaseStyle -> "Column", 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                   "Column"], 
                  TagBox[
                   GridBox[{{
                    StyleBox[
                    RowBox[{"\"(\"", "\[NoBreak]", 
                    TemplateBox[{"\"in \"", "\"percent\""}, "RowDefault"], 
                    "\[NoBreak]", "\")\""}], {
                    FontFamily -> "Verdana", FontSize -> 10, 
                    GrayLevel[0.5], 
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 0\
}, StripOnInput -> False]}}, GridBoxAlignment -> {"Columns" -> {{Left}}}, 
                    DefaultBaseStyle -> "Column", 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                   "Column"]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Baseline}}}, 
                AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                GridBoxSpacings -> {"Columns" -> {{0.5}}}], "Grid"]}, 
             "Labeled", DisplayFunction -> (FormBox[
               GridBox[{{
                  TagBox[
                   ItemBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], DefaultBaseStyle -> "Labeled"], 
                   "SkipImageSizeLevel"]}, {
                  
                  ItemBox[#2, Alignment -> {Left, Inherited}, 
                   DefaultBaseStyle -> "LabeledLabel"]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Center}}, "Rows" -> {{Center}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], TraditionalForm]& ), 
             InterpretationFunction -> (RowBox[{
                StyleBox[
                "Labeled", FontFamily -> "Bitstream Vera Sans", 
                 FontSize -> -1 + Inherited], "[", 
                RowBox[{#, ",", 
                  RowBox[{"{", #2, "}"}], ",", 
                  RowBox[{"(", "\[NoBreak]", 
                    GridBox[{{
                    StyleBox[
                    "Bottom", FontFamily -> "Bitstream Vera Sans", 
                    FontSize -> -1 + Inherited], 
                    StyleBox[
                    "Left", FontFamily -> "Bitstream Vera Sans", 
                    FontSize -> -1 + Inherited]}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}]}], 
                "]"}]& )], TraditionalForm]], "Output"]}], 
       XMLElement[
       "dataformats", {}, {"computabledata,formatteddata,timeseriesdata"}]}], 
     XMLElement["states", {"count" -> "2"}, {
       XMLElement[
       "state", {
        "name" -> "Log scale", "input" -> 
         "History:Treasury:EconomicData__Log scale"}, {}], 
       XMLElement[
       "statelist", {
        "count" -> "5", "value" -> "All years", "delimiters" -> ""}, {
         XMLElement[
         "state", {
          "name" -> "Last year", "input" -> 
           "History:Treasury:EconomicData__Last year"}, {}], 
         XMLElement[
         "state", {
          "name" -> "Last 2 years", "input" -> 
           "History:Treasury:EconomicData__Last 2 years"}, {}], 
         XMLElement[
         "state", {
          "name" -> "Last 5 years", "input" -> 
           "History:Treasury:EconomicData__Last 5 years"}, {}], 
         XMLElement[
         "state", {
          "name" -> "Last 10 years", "input" -> 
           "History:Treasury:EconomicData__Last 10 years"}, {}], 
         XMLElement[
         "state", {
          "name" -> "All years", "input" -> 
           "History:Treasury:EconomicData__All years"}, {}]}]}]}], 
   Typeset`pod4$$ = XMLElement[
   "pod", {"title" -> "Treasury security percent change", "scanner" -> "Data",
      "id" -> "TSOperator:ChangeRate:Treasury:EconomicData", "position" -> 
     "400", "error" -> "false", "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            StyleBox[
             TemplateBox[{
               StyleBox[
                TagBox[
                 TagBox[
                  TagBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox["20", 
                    $CellContext`TagBoxWrapper["StringBoxes" -> "20"]]}], 
                    "\[NoBreak]", 
                    StyleBox[
                    RowBox[{}], FontFamily -> "Helvetica", FontSize -> 
                    Smaller], "\[InvisibleSpace]", "\[ThickSpace]", 
                    "\[InvisibleSpace]", 
                    StyleBox[
                    
                    RowBox[{
                    "\"%\"", "\[InvisibleSpace]", "\"/\"", 
                    "\[InvisibleSpace]", "\"day\""}], FontFamily -> 
                    "Helvetica", FontSize -> Smaller]}], Identity], #& , 
                  SyntaxForm -> Dot], "Unit", SyntaxForm -> Dot], 
                LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 0, 
                ZeroWidthTimes -> False], "\"  \"", 
               StyleBox[
                RowBox[{"\"(\"", "\[NoBreak]", 
                  FormBox[
                   TagBox["\"January 9, 2014\"", Identity], TraditionalForm], 
                  "\[NoBreak]", "\")\""}], {
                FontFamily -> "Verdana", FontSize -> 10, 
                 GrayLevel[0.5], LinebreakAdjustments -> {1, 100, 1, 0, 100}, 
                 LineIndent -> 0}, StripOnInput -> False]}, "RowDefault"], 
             LineIndent -> 0], TraditionalForm]], "Output"]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,computabledata,formatteddata,numberdata,quantitydata"}]}], 
     XMLElement["states", {"count" -> "1"}, {
       XMLElement[
       "state", {
        "name" -> "Show history", "input" -> 
         "TSOperator:ChangeRate:Treasury:EconomicData__Show history"}, {}]}], 
     XMLElement["definitions", {"count" -> "1"}, {
       XMLElement[
       "definition", {
        "word" -> "Treasury security percent change", "desc" -> 
         "Fraction of change over the reported frequency relative to the \
previous reported value."}, {}]}]}], Typeset`pod5$$ = XMLElement[
   "pod", {"title" -> "Treasury security year over year percent change", 
     "scanner" -> "Data", "id" -> 
     "TSOperator:YearOverYearChangeRate:Treasury:EconomicData", "position" -> 
     "500", "error" -> "false", "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            StyleBox[
             TemplateBox[{
               StyleBox[
                TagBox[
                 TagBox[
                  TagBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox["33.3", 
                    $CellContext`TagBoxWrapper["StringBoxes" -> "33.3"]]}], 
                    "\[NoBreak]", 
                    StyleBox[
                    RowBox[{}], FontFamily -> "Helvetica", FontSize -> 
                    Smaller], "\[InvisibleSpace]", "\[ThickSpace]", 
                    "\[InvisibleSpace]", 
                    StyleBox[
                    
                    RowBox[{
                    "\"%\"", "\[InvisibleSpace]", "\"/\"", 
                    "\[InvisibleSpace]", "\"yr\""}], FontFamily -> 
                    "Helvetica", FontSize -> Smaller]}], Identity], #& , 
                  SyntaxForm -> Dot], "Unit", SyntaxForm -> Dot], 
                LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 0, 
                ZeroWidthTimes -> False], "\"  \"", 
               StyleBox[
                RowBox[{"\"(\"", "\[NoBreak]", 
                  FormBox[
                   TagBox["\"January 9, 2014\"", Identity], TraditionalForm], 
                  "\[NoBreak]", "\")\""}], {
                FontFamily -> "Verdana", FontSize -> 10, 
                 GrayLevel[0.5], LinebreakAdjustments -> {1, 100, 1, 0, 100}, 
                 LineIndent -> 0}, StripOnInput -> False]}, "RowDefault"], 
             LineIndent -> 0], TraditionalForm]], "Output"]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,computabledata,formatteddata,numberdata,quantitydata"}]}], 
     XMLElement["states", {"count" -> "1"}, {
       XMLElement[
       "state", {
        "name" -> "Show history", "input" -> 
         "TSOperator:YearOverYearChangeRate:Treasury:EconomicData__Show \
history"}, {}]}], 
     XMLElement["definitions", {"count" -> "1"}, {
       XMLElement[
       "definition", {
        "word" -> "Treasury security year over year percent change", "desc" -> 
         "Fraction of change over the past year relative to its value one \
year ago."}, {}]}]}], Typeset`aux1$$ = {True, False, {False}, True}, 
   Typeset`aux2$$ = {True, False, {False}, True}, Typeset`aux3$$ = {
   False, False, {False}, True}, Typeset`aux4$$ = {
   False, False, {False}, True}, Typeset`aux5$$ = {
   False, False, {False}, True}, Typeset`asyncpods$$ = {}, 
   Typeset`nonpods$$ = {
    XMLElement["sources", {"count" -> "1"}, {
      XMLElement[
      "source", {
       "url" -> 
        "http://www.wolframalpha.com/sources/\
EconomicDataSourceInformationNotes.html", "text" -> "Economic data"}, {}]}]}, 
   Typeset`initdone$$ = True, Typeset`queryinfo$$ = {
   "success" -> "true", "error" -> "false", "numpods" -> "3", "datatypes" -> 
    "Economic", "timedout" -> 
    "Data,Percent,Unit,AtmosphericProperties,UnitInformation,Music,Geometry", 
    "timedoutpods" -> "", "timing" -> "5.551", "parsetiming" -> "0.758", 
    "parsetimedout" -> "false", "recalculated" -> 
    "http://www5a.wolframalpha.com/api/v2/recalc.jsp?id=\
MSPa1881d6607a13cage03500001ai0cd1i4f42442c&s=53", "id" -> 
    "MSPa1891d6607a13cage035000011h8418b2d333fi1", "host" -> 
    "http://www5a.wolframalpha.com", "server" -> "53", "related" -> 
    "http://www5a.wolframalpha.com/api/v2/relatedQueries.jsp?id=\
MSPa1901d6607a13cage03500004ga81ffe1ga2ce0h&s=53", "version" -> "2.6"}, 
   Typeset`sessioninfo$$ = {
   "TimeZone" -> 1., 
    "Date" -> {2014, 1, 13, 18, 52, 48.398582`8.437407613774274}, "Line" -> 
    16, "SessionID" -> 27143232596724861421}, Typeset`showpods$$ = {1, 2, 3, 
   4, 5}, Typeset`failedpods$$ = {}, Typeset`chosen$$ = {}, Typeset`open$$ = 
   False, Typeset`newq$$ = 
   "United States treasury bill 3-month on January 9,2014"}, 
   DynamicBox[ToBoxes[
     AlphaIntegration`FormatAlphaResults[
      Dynamic[{
       1, {Typeset`pod1$$, Typeset`pod2$$, Typeset`pod3$$, Typeset`pod4$$, 
         Typeset`pod5$$}, {
        Typeset`aux1$$, Typeset`aux2$$, Typeset`aux3$$, Typeset`aux4$$, 
         Typeset`aux5$$}, Typeset`chosen$$, Typeset`open$$, 
        Typeset`elements$$, Typeset`q$$, Typeset`opts$$, Typeset`nonpods$$, 
        Typeset`queryinfo$$, Typeset`sessioninfo$$, Typeset`showpods$$, 
        Typeset`failedpods$$, Typeset`newq$$}]], StandardForm],
    ImageSizeCache->{1112., {147., 154.}},
    TrackedSymbols:>{Typeset`showpods$$, Typeset`failedpods$$}],
   DynamicModuleValues:>{},
   Initialization:>If[
     Not[Typeset`initdone$$], Null; WolframAlphaClient`Private`doAsyncUpdates[
       Hold[{
        Typeset`pod1$$, Typeset`pod2$$, Typeset`pod3$$, Typeset`pod4$$, 
         Typeset`pod5$$}], Typeset`asyncpods$$, 
       Dynamic[Typeset`failedpods$$]]; Typeset`asyncpods$$ = {}; 
     Typeset`initdone$$ = True],
   SynchronousInitialization->False],
  BaseStyle->{Deployed -> True},
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.598623684381694*^9, 3.598623783153514*^9, 3.59862389511843*^9, 
   3.5986241095307703`*^9, 3.598624146806231*^9, {3.598624246729321*^9, 
   3.598624272442083*^9}, 3.598624368589682*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"DayDiff", "=", 
   RowBox[{
    RowBox[{"DateDifference", "[", 
     RowBox[{
     "\"\<Jan. 9, 2014\>\"", ",", "\"\<April. 9, 2014\>\"", ",", 
      "\"\<Day\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.598973274618553*^9, 3.5989732839185658`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r", "=", 
  RowBox[{"rx", "/.", 
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{
        FractionBox["0.04", "100"], " ", "*", 
        FractionBox["DayDiff", "360"]}]}], "\[Equal]", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "rx"}], " ", 
        FractionBox["DayDiff", "365"]}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"rx", ",", "0"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.598973246538514*^9, 3.5989733027685924`*^9}, 
   3.598973334778637*^9, {3.5989733900487146`*^9, 3.598973415808751*^9}, {
   3.5989742481521235`*^9, 3.598974251702128*^9}}],

Cell[BoxData["0.00040557583468514113`"], "Output",
 CellChangeTimes->{{3.5989733919187174`*^9, 3.5989734286087685`*^9}, 
   3.598974252192129*^9, 3.599759813979416*^9, 3.5997600103926506`*^9, 
   3.599845748798917*^9, {3.6000298207792397`*^9, 3.600029827234521*^9}, 
   3.6000302262871385`*^9, 3.6000709063537664`*^9, 3.6000732714102387`*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["Zmienno\:015b\[CAcute].",
  FontWeight->"Bold"],
 " Istnieje kilka metod wyliczania tego parametru z danych rzeczywistych. \
Przedstawimy tutaj jeden z najprostszych - liczenie tzw. zmienno\:015bci \
historycznej, polegaj\:0105cej na estymacji \[Sigma] z danych z przesz\
\[LSlash]o\:015bci. W modelu Blacka-Scholesa cena akcji ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["S", "t"], TraditionalForm]]],
 " ma rozk\[LSlash]ad log-normalny, sk\:0105d mo\:017cna \[LSlash]atwo \
wyliczy\[CAcute] wariancj\:0119 logarytmicznej stopy zwrotu dla \
okres\[OAcute]w ",
 StyleBox["t",
  FontSlant->"Italic"],
 " oraz ",
 StyleBox["t",
  FontSlant->"Italic"],
 " + ",
 StyleBox["h",
  FontSlant->"Italic"],
 ":"
}], "Text",
 CellChangeTimes->{{3.5989743276322346`*^9, 3.598974379312307*^9}, {
  3.5989744100723495`*^9, 3.5989744448723984`*^9}, {3.5989746759900813`*^9, 
  3.5989747213786774`*^9}, {3.5989747903246207`*^9, 3.598974815803078*^9}},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expectation", "[", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Log", "[", "x", "]"}], "-", 
      RowBox[{"Expectation", "[", 
       RowBox[{
        RowBox[{"Log", "[", "x", "]"}], ",", 
        RowBox[{"x", "\[Distributed]", 
         RowBox[{"LogNormalDistribution", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"r", "-", 
              FractionBox[
               SuperscriptBox["\[Sigma]", "2"], "2"]}], ")"}], "h"}], ",", 
           RowBox[{"\[Sigma]", " ", 
            SqrtBox["h"]}]}], "]"}]}]}], "]"}]}], ")"}], "2"], ",", 
   RowBox[{"x", "\[Distributed]", 
    RowBox[{"LogNormalDistribution", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r", "-", 
         FractionBox[
          SuperscriptBox["\[Sigma]", "2"], "2"]}], ")"}], "h"}], ",", 
      RowBox[{"\[Sigma]", " ", 
       SqrtBox["h"]}]}], "]"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"h", " ", 
  SuperscriptBox["\[Sigma]", "2"]}]], "Output",
 CellChangeTimes->{3.598974836671272*^9, 3.5997598280662217`*^9, 
  3.5997600249294815`*^9, 3.5998457911489763`*^9}]
}, Open  ]],

Cell[TextData[{
 "St\:0105d historyczn\:0105 zmienno\:015b\[CAcute] mo\:017cna otrzyma\
\[CAcute] wyliczaj\:0105c wariancj\:0119 historycznych logarytmicznych st\
\[OAcute]p zwrotu i dziel\:0105c j\:0105 przez ",
 StyleBox["h",
  FontSlant->"Italic"],
 " (liczone w latach, czyli dla danych finansowych jest to \
najcz\:0119\:015bciej ",
 Cell[BoxData[
  FormBox[
   FractionBox["1", "252"], TraditionalForm]]],
 ")."
}], "Text",
 CellChangeTimes->{{3.5989750526736264`*^9, 3.5989751033059*^9}, 
   3.598975529826497*^9, {3.5989758757679815`*^9, 3.5989759002580156`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"FinancialData", "[", 
    RowBox[{"Firm", ",", "\"\<Jul. 1, 2012\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.59975961666413*^9, 3.5997596170871544`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Funkcja", " ", "licz\:0105ca", " ", "zmienno\:015b\[CAcute]", " ", "przy",
     " ", "wzi\:0119ciu", " ", "pod", " ", "uwag\:0119", " ", "ostatnich", 
    " ", "N", " ", "dni"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"Sig", "[", 
    RowBox[{"Data_List", ",", "N_Integer"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ShortenData", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"Data", ",", 
         RowBox[{"-", "N"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"252", 
       RowBox[{"Variance", "[", 
        RowBox[{"Differences", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"ShortenData", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "]"}]}], 
      "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5989760164581785`*^9, 3.598976083118272*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Rysowanie", " ", "zmienno\:015bci", " ", "w", " ", 
     "zale\:017cno\:015bci", " ", "od", " ", "tego"}], ",", " ", 
    RowBox[{"jak", " ", "wiele", " ", "danych", " ", "we\:017amiemy"}]}], " ",
    "*)"}], 
  RowBox[{
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Sig", "[", 
        RowBox[{"Data", ",", "n"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "20", ",", "300"}], "}"}]}], "]"}], ",", 
     RowBox[{"DataRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"20", ",", "300"}], "}"}]}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"20", ",", "0.15"}], "}"}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Liczba dni wstecz\>\"", ",", 
        "\"\<\!\(\*SuperscriptBox[\(\[InvisiblePrefixScriptBase]\), \
\(\[Sigma]\)]\)hist\>\""}], "}"}]}]}], "]"}], ",", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Zaznaczenie", " ", "wybranej", " ", "zmienno\:015bci", " ", 
      RowBox[{"<<", "metod\:0105"}], " ", "eksperck\:0105"}], ">>", 
     "\"\< \>"}], "*)"}], 
   RowBox[{"Plot", "[", 
    RowBox[{"0.235", ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "20", ",", "300"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.59897642467875*^9, 3.598976466188808*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {GrayLevel[0], LineBox[CompressedData["
1:eJw9lnlYjWkfx4spVGJIZX2PJUsRqWylvkibon1fzumcztLZT7ZSOi0U0TJG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      "]]}}, {{}, {}, 
    {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQPW31vXggz0FknfvDKpFz9l/Ox3yo3W8G5wd/udXw
u84Szr9jw7PAv8Qezt/b7d3s3uQE5yeEJCnn27jC+S/nTHY6bOgB59euK2Tt
/eIF53+3z3Jv/uQL5yeJSe12KAyA8/0KQ5f8Oh8I5+vyyJ318gmG8ydy7z0e
uj4Ezp+/48iOFO4wOH/B0siXnK3hcL7a9yOvM59GINR37NVNSI6C8w8dl0uL
uhUN52dlhxXwW8TC+Wz+0ruiNsfB+VO8b2dt4EqA8+f158+oO4Xg12pZHDzX
loiw7/vroBqzJDh/d0oay9cvCL4kyxm508uS4XyfX6kmyqEpcH7lhGOZbkKp
cP6LCCGO44cQ/MCDKseEmtLg/P6G7PoHtulwPn/R3IXcbxH8TuZpjxlXZ8D5
bscr+0JjMuH8Gw8nmmhzZcH5yXMKfp0+huAbdlppnirLhvN/iJ4un2yaA+cz
XXXT3/UcwX/46tvDpGm5cP7OBblbrgXnwflXOs6/X86Sj0g/Aj+8XI4g8ctX
BRg6FMD59Q1+Bu+nI/hCN6/OF/qO4B87denwE/9COP/p88yn35ch+AyhT6YV
sBbB+bbRV/5Mj0XwnSyyf5/uQ/DdRZl+/d+P4AMAcYR5FQ==
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["\"Liczba dni wstecz\"", TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*SuperscriptBox[\\(\[InvisiblePrefixScriptBase]\\), \
\\(\[Sigma]\\)]\\)hist\"", TraditionalForm]},
  AxesOrigin->{20, 0.15},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.598976347418642*^9, {3.5997598393868694`*^9, 3.599759849140427*^9}, 
   3.5997600346310368`*^9, 3.5998458393990436`*^9}]
}, Open  ]],

Cell["\<\
Znajdujemy zmienno\:015b\[CAcute] dla podanej przez nas liczby dni:\
\>", "Text",
 CellChangeTimes->{{3.5989750526736264`*^9, 3.5989751033059*^9}, 
   3.598975529826497*^9, {3.5989758757679815`*^9, 3.5989759002580156`*^9}, {
   3.5997596541702757`*^9, 3.599759665281911*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Sigma]", "=", 
  RowBox[{"Sig", "[", 
   RowBox[{"Data", ",", "DaysN"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599759704727167*^9, 3.599759725702367*^9}}],

Cell[BoxData["0.4713278925198055`"], "Output",
 CellChangeTimes->{
  3.600029805007781*^9, 3.600030241607297*^9, {3.6000709110883703`*^9, 
   3.600070919979419*^9}, 3.600073349929615*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Kalibracja do modelu Blacka-Scholesa", "Section",
 CellChangeTimes->{{3.5997588860428514`*^9, 3.599758915321526*^9}}],

Cell[CellGroupData[{

Cell["\<\
Parametry u i d w modelu dwumianowym s\:0105 pewnymi idealizacjami, nie mog\
\:0105 by\[CAcute] odczytane bezpo\:015brednio z notowa\:0144 na rynkach \
finansowych.\
\>", "Item",
 CellChangeTimes->{{3.599758926945191*^9, 3.599758937492794*^9}, {
  3.599758969218609*^9, 3.5997589881506915`*^9}, {3.599759117938115*^9, 
  3.5997591220933523`*^9}, {3.6000224257320027`*^9, 3.6000225515714445`*^9}}],

Cell["\<\
Zak\[LSlash]ada si\:0119, \:017ce warto\:015b\[CAcute] oczekiwana i wariancja \
w jednym okresie w modelu dwumianowym i w modelu Blacka-Scholesa \
skalibrowanego do rynku s\:0105 sobie r\[OAcute]wne.\
\>", "Item",
 CellChangeTimes->{{3.599758926945191*^9, 3.599758937492794*^9}, {
  3.599758969218609*^9, 3.5997589881506915`*^9}, {3.599759117938115*^9, 
  3.5997591220933523`*^9}, {3.6000224257320027`*^9, 3.60002261766127*^9}, {
  3.600022681286474*^9, 3.6000227034711866`*^9}, {3.6000227461094465`*^9, 
  3.6000228016632833`*^9}}],

Cell["St\:0105d otrzymuje si\:0119 warunki:", "Item",
 CellChangeTimes->{{3.599758926945191*^9, 3.599758937492794*^9}, {
  3.599758969218609*^9, 3.5997589881506915`*^9}, {3.599759117938115*^9, 
  3.5997591220933523`*^9}, {3.6000224257320027`*^9, 3.60002261766127*^9}, {
  3.600022681286474*^9, 3.6000227034711866`*^9}, {3.6000227461094465`*^9, 
  3.600022813672263*^9}}]
}, Open  ]],

Cell[BoxData[{
 StyleBox[
  RowBox[{
   RowBox[{"Warto\:015b\[CAcute]", " ", 
    RowBox[{"oczekiwana", ":", "\[IndentingNewLine]", 
     RowBox[{
      SubscriptBox["S", "t"], 
      RowBox[{"(", 
       RowBox[{"pu", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "p"}], ")"}], "d"}]}], ")"}]}]}]}], "=", 
   RowBox[{
    SubscriptBox["S", "t"], 
    SuperscriptBox["e", "r\[CapitalDelta]t"]}]}],
  FontSize->18], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   RowBox[{"Wariancja", ":", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["S", "t"], "u"}], ")"}], "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "p"}], ")"}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["S", "t"], "d"}], ")"}], "2"]}], "-", 
     RowBox[{
      SuperscriptBox[
       SubscriptBox["S", "t"], "2"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"pu", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "p"}], ")"}], "d"}]}], ")"}], "2"]}]}]}], "=", 
   RowBox[{
    SuperscriptBox[
     SubscriptBox["S", "t"], "2"], 
    SuperscriptBox["e", 
     RowBox[{"2", "r\[CapitalDelta]t"}]], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["e", 
       RowBox[{
        SuperscriptBox["\[Sigma]", "2"], "\[CapitalDelta]t"}]], "-", "1"}], 
     ")"}]}]}],
  FontSize->18]}], "DisplayFormula",
 CellChangeTimes->{{3.6000229012102942`*^9, 3.600023168462514*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Rozwi\:0105zanie wymaga dodatkowych za\[LSlash]o\:017ce\:0144:\
\[LineSeparator]W modelu Coxa-Rossa-Rubinsteina:\[LineSeparator]\tu\[Times]d \
= 1\[LineSeparator]W modelu Jarrowa-Rudda:\[LineSeparator]\t",
 Cell[BoxData[
  FormBox[
   RowBox[{"p", "=", 
    RowBox[{
     RowBox[{"1", "-", "p"}], "=", 
     FractionBox["1", "2"]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Item",
 CellChangeTimes->{{3.6000232035417757`*^9, 3.600023326172095*^9}, {
  3.600023785452652*^9, 3.6000237945907154`*^9}}],

Cell[TextData[{
 "Rozwi\:0105zanie:\[LineSeparator]\t",
 Cell[BoxData[
  FormBox[
   RowBox[{"p", "=", 
    FractionBox[
     RowBox[{
      SuperscriptBox["e", "r\[CapitalDelta]t"], "-", "d"}], 
     RowBox[{"u", "-", "d"}]]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "\[LineSeparator]CRR:\[LineSeparator]\t",
 Cell[BoxData[{
  FormBox[
   RowBox[{"u", "\[TildeTilde]", 
    SuperscriptBox["e", 
     RowBox[{"\[Sigma]", 
      SqrtBox["\[CapitalDelta]t"]}]]}], 
   TraditionalForm], "\[IndentingNewLine]", 
  FormBox[
   RowBox[{"d", "\[TildeTilde]", 
    SuperscriptBox["e", 
     RowBox[{
      RowBox[{"-", "\[Sigma]"}], 
      SqrtBox["\[CapitalDelta]t"]}]]}], TraditionalForm]}],
  FormatType->"TraditionalForm"],
 "\[LineSeparator]JR:\[LineSeparator]\t",
 Cell[BoxData[{
  FormBox[
   RowBox[{"u", "\[TildeTilde]", 
    SuperscriptBox["e", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r", "-", 
         FractionBox[
          SuperscriptBox["\[Sigma]", "2"], "2"]}], ")"}], 
       "\[CapitalDelta]t"}], "+", 
      RowBox[{"\[Sigma]", 
       SqrtBox["\[CapitalDelta]t"]}]}]]}], 
   TraditionalForm], "\[IndentingNewLine]", 
  FormBox[
   RowBox[{"p", "\[TildeTilde]", 
    SuperscriptBox["e", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r", "-", 
         FractionBox[
          SuperscriptBox["\[Sigma]", "2"], "2"]}], ")"}], 
       "\[CapitalDelta]t"}], "-", 
      RowBox[{"\[Sigma]", 
       SqrtBox["\[CapitalDelta]t"]}]}]]}], TraditionalForm]}],
  FormatType->"TraditionalForm"]
}], "Item",
 CellChangeTimes->{{3.6000232035417757`*^9, 3.6000233436877213`*^9}, {
  3.6000234799910955`*^9, 3.600023506474661*^9}, {3.600023808081667*^9, 
  3.6000240386775675`*^9}, {3.600024124771658*^9, 3.6000241949201765`*^9}}],

Cell["Funkcja wyznaczaj\:0105ca u i d:", "Item",
 CellChangeTimes->{{3.6000242234150724`*^9, 3.600024231492428*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"KalibracjaBS", "[", 
   RowBox[{
   "r_Real", ",", " ", "\[Sigma]_Real", ",", "n_Integer", ",", 
    "\"\<CRR\>\""}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Nu]", "=", "0"}], ",", 
      RowBox[{"\[Micro]", "=", 
       RowBox[{"r", "-", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], "/", "2"}]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Sigma]", " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"d", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Sigma]"}], " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"p", "\[Rule]", 
       RowBox[{
        RowBox[{"1", "/", "2"}], "+", 
        RowBox[{
         RowBox[{"1", "/", "2"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Micro]", "-", "\[Nu]"}], ")"}], "/", "\[Sigma]"}], " ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "/", "n"}], "]"}]}]}]}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599644491895947*^9, 3.5996444987594957`*^9}, {
   3.5996445442096343`*^9, 3.599644544770006*^9}, {3.599644578500376*^9, 
   3.599644584800556*^9}, 3.5996447024105406`*^9, {3.5996449469837236`*^9, 
   3.5996449814926033`*^9}, {3.5996453190334325`*^9, 
   3.5996454248756175`*^9}, {3.599645467382806*^9, 3.5996455650155478`*^9}, {
   3.599645815116399*^9, 3.599645920953576*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"KalibracjaBS", "[", 
   RowBox[{
   "r_Real", ",", " ", "\[Sigma]_Real", ",", "n_Integer", ",", "\"\<JR\>\""}],
    "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Nu]", "=", 
       RowBox[{"r", "-", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], "/", "2"}]}]}], ",", 
      RowBox[{"\[Micro]", "=", 
       RowBox[{"r", "-", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], "/", "2"}]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Sigma]", " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"d", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Sigma]"}], " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"p", "\[Rule]", 
       RowBox[{
        RowBox[{"1", "/", "2"}], "+", 
        RowBox[{
         RowBox[{"1", "/", "2"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Micro]", "-", "\[Nu]"}], ")"}], "/", "\[Sigma]"}], " ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "/", "n"}], "]"}]}]}]}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.599645578596553*^9, 3.599645596043128*^9}, {
   3.599645854376427*^9, 3.5996458548137226`*^9}, {3.5996458849607134`*^9, 
   3.5996458882048626`*^9}, 3.5996459452747087`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Wycena opcji europejskich", "Section",
 CellChangeTimes->{{3.599759027147922*^9, 3.599759035387393*^9}}],

Cell[CellGroupData[{

Cell["\<\
Opcja europejska: instrument pochodny, kt\[OAcute]rego posiadacz (opcja call) \
ma prawo w okre\:015blonym czasie (czas wyga\:015bni\:0119cia) kupi\[CAcute] \
za okre\:015blon\:0105 cen\:0119 (cen\:0119 wykonania) instument bazowy, \
natomiast jego wystawca (opcja put) jest zobowi\:0105zany w czasie \
wyga\:015bni\:0119cia sprzeda\[CAcute] instrument bazowy za cen\:0119 \
wykoniania.\
\>", "Item",
 CellChangeTimes->{{3.599759048131122*^9, 3.5997590488461633`*^9}, {
  3.6000243205554914`*^9, 3.600024334293597*^9}, {3.6000244467591887`*^9, 
  3.6000244653755293`*^9}, {3.600024506770975*^9, 3.6000245265040536`*^9}, {
  3.6000245812123485`*^9, 3.6000246960474815`*^9}, {3.600024727017017*^9, 
  3.6000247270200186`*^9}, {3.6000250295336313`*^9, 3.600025108902253*^9}}],

Cell[TextData[{
 "Wycena: \[LineSeparator]Stosuj\:0105c drzewo dwumianowe skalibrowane do \
rynku mo\:017cemy prognozowa\[CAcute] zmiany cen instrumentu bazowego.\
\[LineSeparator]W ka\:017cdym z w\:0119z\[LSlash]\[OAcute]w ko\:0144cowych \
wyp\[LSlash]ata z opcji dana jest nast\:0119puj\:0105co:\[LineSeparator]\t\
call:",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"max", " ", 
     RowBox[{"(", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["S", "t"], "-", "K"}]}]}]}]}], TraditionalForm]]],
 "),0),\n\tput: ",
 Cell[BoxData[
  FormBox[
   RowBox[{"max", 
    RowBox[{"(", 
     RowBox[{"(", 
      RowBox[{"K", "-", 
       SubscriptBox["S", "t"]}]}]}]}], TraditionalForm]]],
 "),0),\ngdzie K to cena wykonania, a ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "t"], " "}], TraditionalForm]]],
 "to cena instrumentu bazowego w momencie wykonania t.\[LineSeparator]Nast\
\:0119pnie dyskontujemy uzyskane w czasie wyga\:015bni\:0119cia opcji wyp\
\[LSlash]aty na chwil\:0119 0."
}], "Item",
 CellChangeTimes->{{3.599759048131122*^9, 3.5997590488461633`*^9}, {
  3.6000243205554914`*^9, 3.600024334293597*^9}, {3.6000244467591887`*^9, 
  3.6000244653755293`*^9}, {3.600024506770975*^9, 3.6000245265040536`*^9}, {
  3.6000245812123485`*^9, 3.6000246960474815`*^9}, {3.600024727017017*^9, 
  3.600024730220152*^9}, {3.6000247910384703`*^9, 3.6000248891855555`*^9}, {
  3.600024927795158*^9, 3.6000250216614*^9}, {3.6000251181233654`*^9, 
  3.6000251181283693`*^9}, {3.600025192736843*^9, 3.6000252897681866`*^9}}],

Cell["Funkcje wyceniaj\:0105ce:", "Item",
 CellChangeTimes->{{3.599759048131122*^9, 3.5997590488461633`*^9}, {
  3.6000243205554914`*^9, 3.600024334293597*^9}, {3.6000244467591887`*^9, 
  3.6000244653755293`*^9}, {3.600024506770975*^9, 3.6000245265040536`*^9}, {
  3.6000245812123485`*^9, 3.6000246960474815`*^9}, {3.600024727017017*^9, 
  3.600024730220152*^9}, {3.6000247910384703`*^9, 3.6000248891855555`*^9}, {
  3.600024927795158*^9, 3.6000250216614*^9}, {3.6000251181233654`*^9, 
  3.600025125497257*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"EuroValueProcess", "[", 
   RowBox[{
   "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
    ",", "\"\<call\>\""}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t", "=", "T"}], ",", 
      RowBox[{"N", "=", "n"}], ",", 
      RowBox[{"D", "=", "d"}], ",", 
      RowBox[{"U", "=", "u"}], ",", 
      RowBox[{"R", "=", "r"}], ",", 
      RowBox[{"s", "=", "S0"}], ",", 
      RowBox[{"k", "=", "K"}], ",", 
      RowBox[{"p", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"E", "^", 
           RowBox[{"(", 
            RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
      RowBox[{"\[Nu]", "=", "1"}], ",", 
      RowBox[{"S", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"V", "=", 
       RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
      RowBox[{"Vtemp", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"S", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"s", " ", 
         SuperscriptBox["U", "j"], 
         SuperscriptBox["D", 
          RowBox[{"i", "-", "j"}]]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"N", " ", "t"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"V", "=", 
      RowBox[{"{", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{
           RowBox[{"\[Nu]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                 RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], ")"}]}],
            ",", "0"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", 
           RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"N", " ", "t"}]}], ",", 
       RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
       RowBox[{"i", "--"}], ",", 
       RowBox[{
        RowBox[{"Vtemp", "=", 
         RowBox[{"{", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"E", "^", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"p", " ", 
                RowBox[{"V", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", 
                   RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "-", "p"}], ")"}], 
                RowBox[{"V", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"V", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
     RowBox[{"V", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"V", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{
           RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "i", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5996605021972466`*^9, 3.599660518639149*^9}, {
   3.599660551916216*^9, 3.5996605558948555`*^9}, 3.600025171941053*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"EuroValueProcess", "[", 
   RowBox[{
   "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
    ",", "\"\<put\>\""}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t", "=", "T"}], ",", 
      RowBox[{"N", "=", "n"}], ",", 
      RowBox[{"D", "=", "d"}], ",", 
      RowBox[{"U", "=", "u"}], ",", 
      RowBox[{"R", "=", "r"}], ",", 
      RowBox[{"s", "=", "S0"}], ",", 
      RowBox[{"k", "=", "K"}], ",", 
      RowBox[{"p", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"E", "^", 
           RowBox[{"(", 
            RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
      RowBox[{"\[Nu]", "=", 
       RowBox[{"-", "1"}]}], ",", 
      RowBox[{"S", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"V", "=", 
       RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
      RowBox[{"Vtemp", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"S", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"s", " ", 
         SuperscriptBox["U", "j"], 
         SuperscriptBox["D", 
          RowBox[{"i", "-", "j"}]]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"N", " ", "t"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"V", "=", 
      RowBox[{"{", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{
           RowBox[{"\[Nu]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                 RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], ")"}]}],
            ",", "0"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", 
           RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"N", " ", "t"}]}], ",", 
       RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
       RowBox[{"i", "--"}], ",", 
       RowBox[{
        RowBox[{"Vtemp", "=", 
         RowBox[{"{", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"E", "^", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"p", " ", 
                RowBox[{"V", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", 
                   RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "-", "p"}], ")"}], 
                RowBox[{"V", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"V", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
     RowBox[{"V", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"V", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{
           RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "i", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5996605379169326`*^9, 3.599660562312109*^9}, 
   3.600025168957074*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Parametry greckie", "Section",
 CellChangeTimes->{{3.599759132120926*^9, 3.5997591396063547`*^9}}],

Cell[CellGroupData[{

Cell["\<\
okre\:015blaj\:0105 wra\:017cliwo\:015b\[CAcute] instrumentu pochodnego na \
zmiany r\[OAcute]\:017cnych czynnik\[OAcute]w, np. ceny instrumentu bazowego,\
\>", "Item",
 CellChangeTimes->{{3.5997591427495337`*^9, 3.5997591485618663`*^9}, {
   3.6000145298778515`*^9, 3.600014542689584*^9}, 3.6000145862330747`*^9, {
   3.6000146247312765`*^9, 3.6000146247982807`*^9}, 3.6000147144464083`*^9, {
   3.60001477987315*^9, 3.6000148226955996`*^9}, {3.600014917401016*^9, 
   3.6000149175010223`*^9}}],

Cell["\<\
s\[LSlash]u\:017c\:0105 do hedgowania, czyli minimalizowania ryzyka \
posiadania aktyw\[OAcute]w, np. instrument\[OAcute]w pochodnych.\
\>", "Item",
 CellChangeTimes->{{3.5997591427495337`*^9, 3.5997591485618663`*^9}, {
   3.6000145298778515`*^9, 3.600014542689584*^9}, 3.6000145862330747`*^9, {
   3.6000146247312765`*^9, 3.6000146247982807`*^9}, 3.6000147144464083`*^9, {
   3.60001477987315*^9, 3.6000148226955996`*^9}, {3.600014917401016*^9, 
   3.6000149337309504`*^9}, {3.6000150229190516`*^9, 3.6000150398560205`*^9}}]
}, Open  ]],

Cell["\<\

\
\>", "Text",
 CellChangeTimes->{3.600015177499893*^9}],

Cell["Podstawowe parametry greckie:", "Text",
 CellChangeTimes->{{3.6000150470124297`*^9, 3.6000150701937556`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Theta = \[CapitalTheta] = ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{"\[PartialD]", "V"}], 
    RowBox[{"\[PartialD]", "t"}]], TraditionalForm]]],
 ","
}], "Item",
 CellChangeTimes->{{3.6000151815781264`*^9, 3.60001518251518*^9}, {
  3.6000152562663984`*^9, 3.600015300479927*^9}, {3.6000153831196537`*^9, 
  3.60001539914057*^9}, {3.6000154471053133`*^9, 3.600015459560026*^9}, {
  3.600015491565857*^9, 3.600015492428906*^9}, {3.6000304748880014`*^9, 
  3.6000305366869707`*^9}, {3.6001445668147097`*^9, 3.6001445668147097`*^9}}],

Cell[TextData[{
 "Delta = \[CapitalDelta] = ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox[
     RowBox[{"\[PartialD]", "V"}], 
     RowBox[{"\[PartialD]", "S"}]], "\[TildeTilde]", " ", 
    FractionBox[
     RowBox[{
      SubscriptBox["V", "11"], "-", 
      SubscriptBox["V", "01"]}], 
     RowBox[{
      SubscriptBox["S", "11"], "-", 
      SubscriptBox["S", "01"]}]]}], TraditionalForm]]],
 ","
}], "Item",
 CellChangeTimes->{{3.6000151815781264`*^9, 3.60001518251518*^9}, {
  3.6000152562663984`*^9, 3.600015300479927*^9}, {3.6000153831196537`*^9, 
  3.60001539914057*^9}, {3.6000154471053133`*^9, 3.600015459560026*^9}, {
  3.600015491565857*^9, 3.600015504409591*^9}, {3.600015555884536*^9, 
  3.6000155871923265`*^9}, {3.600015647906799*^9, 3.6000156486378403`*^9}, {
  3.60014457506418*^9, 3.60014457506418*^9}}],

Cell[TextData[{
 "Vega = ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{"\[PartialD]", "V"}], 
    RowBox[{"\[PartialD]", "\[Sigma]"}]], TraditionalForm]]],
 ","
}], "Item",
 CellChangeTimes->{{3.6000151815781264`*^9, 3.60001518251518*^9}, {
  3.6000152562663984`*^9, 3.600015300479927*^9}, {3.6000153831196537`*^9, 
  3.60001539914057*^9}, {3.6000154471053133`*^9, 3.600015459560026*^9}, {
  3.600015491565857*^9, 3.600015504409591*^9}, {3.600015555884536*^9, 
  3.6000156068484507`*^9}, {3.600015640341366*^9, 3.600015656621297*^9}}],

Cell[TextData[{
 "Rho = \[Rho] = ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{"\[PartialD]", "V"}], 
    RowBox[{"\[PartialD]", "r"}]], TraditionalForm]]],
 ","
}], "Item",
 CellChangeTimes->{{3.6000151815781264`*^9, 3.60001518251518*^9}, {
  3.6000152562663984`*^9, 3.600015300479927*^9}, {3.6000153831196537`*^9, 
  3.60001539914057*^9}, {3.6000154471053133`*^9, 3.600015459560026*^9}, {
  3.600015491565857*^9, 3.600015504409591*^9}, {3.600015555884536*^9, 
  3.6000156068484507`*^9}, {3.600015640341366*^9, 3.6000156565972958`*^9}, {
  3.6000158701215086`*^9, 3.6000159274597883`*^9}}],

Cell[TextData[{
 "Gamma = \[CapitalGamma]= ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox[
     RowBox[{"\[PartialD]", "V"}], 
     RowBox[{"\[PartialD]", 
      SuperscriptBox["S", "2"]}]], "\[TildeTilde]", " ", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["V", "22"], "-", 
         SubscriptBox["V", "12"]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["S", "22"], "-", 
         SubscriptBox["S", "12"]}], ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["V", "12"], "-", 
         SubscriptBox["V", "02"]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["S", "12"], "-", 
         SubscriptBox["S", "02"]}], ")"}]}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["S", "22"], "-", 
        SubscriptBox["S", "02"]}], ")"}], "/", "2"}]]}], TraditionalForm]]],
 "."
}], "Item",
 CellChangeTimes->{{3.6000151815781264`*^9, 3.60001518251518*^9}, {
  3.6000152562663984`*^9, 3.600015300479927*^9}, {3.6000153831196537`*^9, 
  3.60001539914057*^9}, {3.6000154471053133`*^9, 3.600015459560026*^9}, {
  3.600015491565857*^9, 3.600015504409591*^9}, {3.600015555884536*^9, 
  3.6000156068484507`*^9}, {3.600015640341366*^9, 3.6000156565972958`*^9}, {
  3.6000158701215086`*^9, 3.6000159854691067`*^9}, {3.6000305632185645`*^9, 
  3.600030643935089*^9}}]
}, Open  ]],

Cell["", "Text",
 CellChangeTimes->{{3.600015133513377*^9, 3.6000151403757696`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Wycena opcji ameryka\:0144skich", "Section",
 CellChangeTimes->{{3.599759157233362*^9, 3.5997591637327347`*^9}}],

Cell[CellGroupData[{

Cell["\<\
Opcja ameryka\:0144ska: instrument pochodny, kt\[OAcute]rego posiadacz (opcja \
call) ma prawo w dowolnym momencie przed up\[LSlash]ywem okre\:015blonego \
czasu (czasu wyga\:015bni\:0119cia) kupi\[CAcute] za okre\:015blon\:0105 cen\
\:0119 (cen\:0119 wykonania) instument bazowy, natomiast jego wystawca (opcja \
put) jest zobowi\:0105zany przed up\[LSlash]ywem czasu wyga\:015bni\:0119cia \
sprzeda\[CAcute] instrument bazowy za cen\:0119 wykoniania.\
\>", "Item",
 CellChangeTimes->{{3.599759048131122*^9, 3.5997590488461633`*^9}, {
  3.6000243205554914`*^9, 3.600024334293597*^9}, {3.6000244467591887`*^9, 
  3.6000244653755293`*^9}, {3.600024506770975*^9, 3.6000245265040536`*^9}, {
  3.6000245812123485`*^9, 3.6000246960474815`*^9}, {3.600024727017017*^9, 
  3.6000247270200186`*^9}, {3.6000250295336313`*^9, 3.600025108902253*^9}, {
  3.600025352356698*^9, 3.60002539653999*^9}, {3.6000255428360014`*^9, 
  3.6000255822161255`*^9}}],

Cell[TextData[{
 "Wycena: \[LineSeparator]Stosuj\:0105c drzewo dwumianowe skalibrowane do \
rynku mo\:017cemy prognozowa\[CAcute] zmiany cen instrumentu bazowego.\
\[LineSeparator]W ka\:017cdym z w\:0119z\[LSlash]\[OAcute]w ko\:0144cowych \
wyp\[LSlash]ata ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{"h", "(", 
     SubscriptBox["S", "t"]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ")) z opcji dana jest nast\:0119puj\:0105co:\[LineSeparator]\tcall:",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"max", " ", 
     RowBox[{"(", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["S", "t"], "-", "K"}]}]}]}]}], TraditionalForm]]],
 "),0),\n\tput: ",
 Cell[BoxData[
  FormBox[
   RowBox[{"max", 
    RowBox[{"(", 
     RowBox[{"(", 
      RowBox[{"K", "-", 
       SubscriptBox["S", "t"]}]}]}]}], TraditionalForm]]],
 "),0),\ngdzie K to cena wykonania, a ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "t"], " "}], TraditionalForm]]],
 "to cena instrumentu bazowego w momencie wykonania t.\[LineSeparator]W w\
\:0119z\[LSlash]ach po\:015brednich warto\:015b\[CAcute] opcji ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    SubscriptBox["V", "t"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ") jest warto\:015bci\:0105 wi\:0119ksz\:0105 z aktualnej wyp\[LSlash]aty \
oraz przysz\[LSlash]ych zdyskontowanych wyp\[LSlash]at:\[LineSeparator]\t",
 Cell[BoxData[
  FormBox[
   RowBox[{"max", "(", 
    RowBox[{"h", "(", 
     SubscriptBox["S", "t"]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "), ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["e", 
      RowBox[{"-", "r\[CapitalDelta]t"}]], "(", 
     RowBox[{
      RowBox[{"p", " ", 
       SubscriptBox["V", 
        RowBox[{
         RowBox[{"t", "+", "1"}], ",", "u"}]]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "p"}], ")"}], 
       SubscriptBox["V", 
        RowBox[{
         RowBox[{"t", "+", "1"}], ",", "d"}]]}]}], ")"}], ")"}], 
   TraditionalForm]],
  FormatType->"TraditionalForm"],
 ".\[LineSeparator]Cofaj\:0105c si\:0119 od chwili wyga\:015bni\:0119cia po \
kolejnych okresach dochodzimy do warto\:015bci w chwili 0."
}], "Item",
 CellChangeTimes->{{3.599759048131122*^9, 3.5997590488461633`*^9}, {
  3.6000243205554914`*^9, 3.600024334293597*^9}, {3.6000244467591887`*^9, 
  3.6000244653755293`*^9}, {3.600024506770975*^9, 3.6000245265040536`*^9}, {
  3.6000245812123485`*^9, 3.6000246960474815`*^9}, {3.600024727017017*^9, 
  3.600024730220152*^9}, {3.6000247910384703`*^9, 3.6000248891855555`*^9}, {
  3.600024927795158*^9, 3.6000250216614*^9}, {3.6000251181233654`*^9, 
  3.6000251181283693`*^9}, {3.600025192736843*^9, 3.6000252897681866`*^9}, {
  3.6000254183114257`*^9, 3.6000254200986257`*^9}, {3.6000254522099037`*^9, 
  3.6000255035039196`*^9}, {3.600025588477267*^9, 3.6000256488953314`*^9}, {
  3.600025686354184*^9, 3.6000258021129465`*^9}, {3.6000258334156895`*^9, 
  3.6000258801246634`*^9}}],

Cell["Funkcje wyceniaj\:0105ce:", "Item",
 CellChangeTimes->{{3.599759048131122*^9, 3.5997590488461633`*^9}, {
  3.6000243205554914`*^9, 3.600024334293597*^9}, {3.6000244467591887`*^9, 
  3.6000244653755293`*^9}, {3.600024506770975*^9, 3.6000245265040536`*^9}, {
  3.6000245812123485`*^9, 3.6000246960474815`*^9}, {3.600024727017017*^9, 
  3.600024730220152*^9}, {3.6000247910384703`*^9, 3.6000248891855555`*^9}, {
  3.600024927795158*^9, 3.6000250216614*^9}, {3.6000251181233654`*^9, 
  3.600025125497257*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AmValueProcess", "[", 
    RowBox[{
    "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
     ",", "\"\<call\>\""}], "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"t", "=", "T"}], ",", 
       RowBox[{"N", "=", "n"}], ",", 
       RowBox[{"D", "=", "d"}], ",", 
       RowBox[{"U", "=", "u"}], ",", 
       RowBox[{"R", "=", "r"}], ",", 
       RowBox[{"s", "=", "S0"}], ",", 
       RowBox[{"k", "=", "K"}], ",", 
       RowBox[{"p", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"E", "^", 
            RowBox[{"(", 
             RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
       RowBox[{"\[Nu]", "=", "1"}], ",", 
       RowBox[{"S", "=", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"V", "=", 
        RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
       RowBox[{"Vtemp", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"S", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"s", " ", 
          SuperscriptBox["U", "j"], 
          SuperscriptBox["D", 
           RowBox[{"i", "-", "j"}]]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"N", " ", "t"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"V", "=", 
       RowBox[{"{", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Max", "[", 
           RowBox[{
            RowBox[{"\[Nu]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"S", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                  RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], 
              ")"}]}], ",", "0"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "0", ",", 
            RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"N", " ", "t"}]}], ",", 
        RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
        RowBox[{"i", "--"}], ",", 
        RowBox[{
         RowBox[{"Vtemp", "=", 
          RowBox[{"{", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Max", "[", 
              RowBox[{
               RowBox[{"Max", "[", 
                RowBox[{
                 RowBox[{"\[Nu]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"S", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "k"}], 
                   ")"}]}], ",", "0"}], "]"}], ",", 
               RowBox[{
                RowBox[{"E", "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"p", " ", 
                   RowBox[{"V", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "-", "p"}], ")"}], 
                   RowBox[{"V", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}]}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"V", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
      RowBox[{"V", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"V", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "i", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.599641480254881*^9, 3.599641586271182*^9}, {
   3.5996495059304447`*^9, 3.5996495634385767`*^9}, {3.599649727209181*^9, 
   3.5996498697286873`*^9}, {3.599649904386665*^9, 3.5996500837896347`*^9}, {
   3.599650115650758*^9, 3.59965030586189*^9}, {3.599650377643489*^9, 
   3.5996504700197506`*^9}, 3.5996505429711223`*^9, {3.599650579556386*^9, 
   3.5996506211739774`*^9}, {3.599650746837308*^9, 3.599650750462711*^9}, {
   3.5996507982564044`*^9, 3.5996508462922583`*^9}, {3.599651248228791*^9, 
   3.599651257141699*^9}, 3.599651320036405*^9, {3.59965142177087*^9, 
   3.599651488231938*^9}, {3.599651525697789*^9, 3.5996515815588255`*^9}, {
   3.5996516788933735`*^9, 3.599651697791901*^9}, {3.5996517516906424`*^9, 
   3.5996517576065655`*^9}, {3.5996519773552847`*^9, 3.59965197835995*^9}, {
   3.599652111511248*^9, 3.5996521138367925`*^9}, 3.599652202562623*^9, {
   3.5996527192162247`*^9, 3.5996527560106287`*^9}, {3.599652814945704*^9, 
   3.599652830114768*^9}, {3.5996528841375866`*^9, 3.59965289585236*^9}, {
   3.5996531989203267`*^9, 3.5996532676298866`*^9}, {3.5996533320165825`*^9, 
   3.599653475793923*^9}, {3.5996535849122815`*^9, 3.5996535850493755`*^9}, {
   3.599653619356127*^9, 3.5996536345061665`*^9}, {3.599653674432644*^9, 
   3.5996536903952284`*^9}, {3.5996537214558263`*^9, 3.599653726670286*^9}, {
   3.5996539374830766`*^9, 3.599653957896616*^9}, {3.599653988551942*^9, 
   3.599654112138894*^9}, {3.5996542153033085`*^9, 3.599654218611502*^9}, {
   3.5996542705119143`*^9, 3.5996542742373843`*^9}, {3.5996543304246426`*^9, 
   3.599654382816385*^9}, {3.59965441373989*^9, 3.5996544884084096`*^9}, {
   3.5996547980427275`*^9, 3.599654800128114*^9}, {3.599655524751621*^9, 
   3.599655567822181*^9}, {3.5996556548538933`*^9, 3.599655657490642*^9}, {
   3.599656093378686*^9, 3.5996560978916793`*^9}, {3.5996565983255253`*^9, 
   3.599656616577634*^9}, {3.599657124608512*^9, 3.5996571287672696`*^9}, {
   3.5996571636784196`*^9, 3.5996571652494617`*^9}, {3.599657219789628*^9, 
   3.599657255755478*^9}, {3.5996572964404564`*^9, 3.599657416428028*^9}, {
   3.5996575020658092`*^9, 3.5996575068169603`*^9}, {3.599657544642042*^9, 
   3.5996575895488214`*^9}, {3.5996576589908695`*^9, 3.599657669821051*^9}, {
   3.599658032491544*^9, 3.5996580428234005`*^9}, {3.5996584856480446`*^9, 
   3.599658486042302*^9}, 3.6000259122979975`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AmValueProcess", "[", 
    RowBox[{
    "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
     ",", "\"\<put\>\""}], "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"t", "=", "T"}], ",", 
       RowBox[{"N", "=", "n"}], ",", 
       RowBox[{"D", "=", "d"}], ",", 
       RowBox[{"U", "=", "u"}], ",", 
       RowBox[{"R", "=", "r"}], ",", 
       RowBox[{"s", "=", "S0"}], ",", 
       RowBox[{"k", "=", "K"}], ",", 
       RowBox[{"p", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"E", "^", 
            RowBox[{"(", 
             RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
       RowBox[{"\[Nu]", "=", 
        RowBox[{"-", "1"}]}], ",", 
       RowBox[{"S", "=", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"V", "=", 
        RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
       RowBox[{"Vtemp", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"S", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"s", " ", 
          SuperscriptBox["U", "j"], 
          SuperscriptBox["D", 
           RowBox[{"i", "-", "j"}]]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"N", " ", "t"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"V", "=", 
       RowBox[{"{", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Max", "[", 
           RowBox[{
            RowBox[{"\[Nu]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"S", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                  RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], 
              ")"}]}], ",", "0"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "0", ",", 
            RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"N", " ", "t"}]}], ",", 
        RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
        RowBox[{"i", "--"}], ",", 
        RowBox[{
         RowBox[{"Vtemp", "=", 
          RowBox[{"{", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Max", "[", 
              RowBox[{
               RowBox[{"Max", "[", 
                RowBox[{
                 RowBox[{"\[Nu]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"S", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "k"}], 
                   ")"}]}], ",", "0"}], "]"}], ",", 
               RowBox[{
                RowBox[{"E", "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"p", " ", 
                   RowBox[{"V", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "-", "p"}], ")"}], 
                   RowBox[{"V", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}]}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"V", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
      RowBox[{"V", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"V", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "i", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.599652213494872*^9, 3.599652219965168*^9}, {
   3.5996579315626163`*^9, 3.599657970815645*^9}, {3.599658123026579*^9, 
   3.599658131400132*^9}, {3.5996582114512177`*^9, 3.5996582260909233`*^9}, {
   3.5996584156416173`*^9, 3.5996584430628033`*^9}, 3.599658474246479*^9, {
   3.5996585660263395`*^9, 3.5996585703181906`*^9}, {3.5996612639403696`*^9, 
   3.599661265740567*^9}, 3.600025915855356*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Modu\[LSlash] do wyceny opcji", "Section",
 CellChangeTimes->{{3.5997592201389604`*^9, 3.599759226644333*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"noVertices", "[", "x_Integer", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"x", "+", "1"}], ")"}], 
    RowBox[{
     RowBox[{"(", "x", ")"}], "/", "2"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"edges", "[", "x_", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"noLayers", "=", "x"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"paths", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", " ", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"(", 
         RowBox[{"noLayers", "-", "1"}], ")"}]}], ",", 
       RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"enterVertices", "=", 
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"noVertices", "[", 
             RowBox[{"i", "-", "1"}], "]"}], "+", "1"}], ",", " ", 
           RowBox[{"noVertices", "[", "i", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"w", "=", 
           RowBox[{"enterVertices", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ",", " ", 
          RowBox[{"w", "\[LessEqual]", " ", 
           RowBox[{"enterVertices", "[", 
            RowBox[{"[", 
             RowBox[{"-", "1"}], "]"}], "]"}]}], ",", " ", 
          RowBox[{"w", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"paths", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"paths", ",", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"w", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"w", "+", "i"}], ")"}]}], ",", " ", "\"\<Up\>\""}], 
               "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"paths", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"paths", ",", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"w", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"w", "+", "i", "+", "1"}], ")"}]}], ",", " ", 
                "\"\<Down\>\""}], "}"}]}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
     ";", "\[IndentingNewLine]", "paths"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.599661008721761*^9, 3.5996610186043262`*^9}, {
  3.599662436596431*^9, 3.599662461867876*^9}, {3.600029532003749*^9, 
  3.6000295344833927`*^9}, {3.600070945793151*^9, 3.6000709467775745`*^9}}],

Cell["", "Text",
 CellChangeTimes->{{3.600073871423275*^9, 3.600073873954651*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"edges", "[", "3", "]"}]], "Input",
 CellChangeTimes->{{3.6000738593289423`*^9, 3.600073885845845*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "\[Rule]", "2"}], ",", "\<\"Up\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "\[Rule]", "3"}], ",", "\<\"Down\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"2", "\[Rule]", "4"}], ",", "\<\"Up\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"2", "\[Rule]", "5"}], ",", "\<\"Down\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"3", "\[Rule]", "5"}], ",", "\<\"Up\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"3", "\[Rule]", "6"}], ",", "\<\"Down\"\>"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.6000738868458805`*^9}]
}, Open  ]],

Cell["", "Text",
 CellChangeTimes->{{3.6000738544693427`*^9, 3.600073856719453*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"priceProcess", "[", 
    RowBox[{"noPeriods_", ",", "s0_", ",", " ", "u_", ",", " ", "d_"}], "]"}],
    ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"s0", " ", 
       SuperscriptBox["u", 
        RowBox[{"i", "-", "j"}]], " ", 
       SuperscriptBox["d", "j"]}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"i", ",", " ", "0", ",", " ", "noPeriods"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"j", ",", "0", ",", " ", "i"}], "}"}]}], "]"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5996632000570984`*^9, 3.5996632813157463`*^9}, {
  3.599666191381192*^9, 3.5996662379938583`*^9}, {3.5996662726658416`*^9, 
  3.5996662799382577`*^9}, {3.5996664192542257`*^9, 3.5996664421975384`*^9}, {
  3.599666980708339*^9, 3.599666984619563*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"KalibracjaBS", "[", 
   RowBox[{
   "r_Real", ",", " ", "\[Sigma]_Real", ",", "n_Integer", ",", 
    "\"\<CRR\>\""}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Nu]", "=", "0"}], ",", 
      RowBox[{"\[Micro]", "=", 
       RowBox[{"r", "-", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], "/", "2"}]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Sigma]", " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"d", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Sigma]"}], " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"p", "\[Rule]", 
       RowBox[{
        RowBox[{"1", "/", "2"}], "+", 
        RowBox[{
         RowBox[{"1", "/", "2"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Micro]", "-", "\[Nu]"}], ")"}], "/", "\[Sigma]"}], " ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "/", "n"}], "]"}]}]}]}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KalibracjaBS", "[", 
   RowBox[{
   "r_Real", ",", " ", "\[Sigma]_Real", ",", "n_Integer", ",", "\"\<JR\>\""}],
    "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Nu]", "=", 
       RowBox[{"r", "-", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], "/", "2"}]}]}], ",", 
      RowBox[{"\[Micro]", "=", 
       RowBox[{"r", "-", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], "/", "2"}]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Sigma]", " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"d", "\[Rule]", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Sigma]"}], " ", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "/", "n"}], "]"}]}], "+", 
          RowBox[{"\[Nu]", " ", 
           RowBox[{"1", "/", "n"}]}]}], ")"}]}]}], ",", 
      RowBox[{"p", "\[Rule]", 
       RowBox[{
        RowBox[{"1", "/", "2"}], "+", 
        RowBox[{
         RowBox[{"1", "/", "2"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Micro]", "-", "\[Nu]"}], ")"}], "/", "\[Sigma]"}], " ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "/", "n"}], "]"}]}]}]}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.599677277342273*^9, 3.5996772923371305`*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"EuroValueProcess", "[", 
     RowBox[{
     "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
      ",", "\"\<call\>\""}], "]"}], ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"t", "=", "T"}], ",", 
        RowBox[{"N", "=", "n"}], ",", 
        RowBox[{"D", "=", "d"}], ",", 
        RowBox[{"U", "=", "u"}], ",", 
        RowBox[{"R", "=", "r"}], ",", 
        RowBox[{"s", "=", "S0"}], ",", 
        RowBox[{"k", "=", "K"}], ",", 
        RowBox[{"p", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"E", "^", 
             RowBox[{"(", 
              RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
        RowBox[{"\[Nu]", "=", "1"}], ",", 
        RowBox[{"S", "=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"V", "=", 
         RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
        RowBox[{"Vtemp", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"S", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"s", " ", 
           SuperscriptBox["U", "j"], 
           SuperscriptBox["D", 
            RowBox[{"i", "-", "j"}]]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"N", " ", "t"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"V", "=", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Max", "[", 
            RowBox[{
             RowBox[{"\[Nu]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"S", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                   RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], 
               ")"}]}], ",", "0"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", 
             RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", 
          RowBox[{"N", " ", "t"}]}], ",", 
         RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
         RowBox[{"i", "--"}], ",", 
         RowBox[{
          RowBox[{"Vtemp", "=", 
           RowBox[{"{", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"E", "^", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"p", " ", 
                  RowBox[{"V", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"1", "-", "p"}], ")"}], 
                  RowBox[{"V", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"V", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
       RowBox[{"V", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"V", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{
             RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "i", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]",
      "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"EuroValueProcess", "[", 
     RowBox[{
     "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
      ",", "\"\<put\>\""}], "]"}], ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"t", "=", "T"}], ",", 
        RowBox[{"N", "=", "n"}], ",", 
        RowBox[{"D", "=", "d"}], ",", 
        RowBox[{"U", "=", "u"}], ",", 
        RowBox[{"R", "=", "r"}], ",", 
        RowBox[{"s", "=", "S0"}], ",", 
        RowBox[{"k", "=", "K"}], ",", 
        RowBox[{"p", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"E", "^", 
             RowBox[{"(", 
              RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
        RowBox[{"\[Nu]", "=", 
         RowBox[{"-", "1"}]}], ",", 
        RowBox[{"S", "=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"V", "=", 
         RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
        RowBox[{"Vtemp", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"S", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"s", " ", 
           SuperscriptBox["U", "j"], 
           SuperscriptBox["D", 
            RowBox[{"i", "-", "j"}]]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"N", " ", "t"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"V", "=", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Max", "[", 
            RowBox[{
             RowBox[{"\[Nu]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"S", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                   RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], 
               ")"}]}], ",", "0"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", 
             RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", 
          RowBox[{"N", " ", "t"}]}], ",", 
         RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
         RowBox[{"i", "--"}], ",", 
         RowBox[{
          RowBox[{"Vtemp", "=", 
           RowBox[{"{", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"E", "^", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"p", " ", 
                  RowBox[{"V", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"1", "-", "p"}], ")"}], 
                  RowBox[{"V", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"V", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
       RowBox[{"V", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"V", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{
             RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "i", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]",
      "]"}]}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.599673899316061*^9, 3.5996739038263187`*^9}, 
   3.5996768327928467`*^9, {3.599676931998521*^9, 3.599676933437603*^9}, {
   3.5996769635733266`*^9, 3.5996769641483593`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AmValueProcess", "[", 
    RowBox[{
    "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
     ",", "\"\<call\>\""}], "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"t", "=", "T"}], ",", 
       RowBox[{"N", "=", "n"}], ",", 
       RowBox[{"D", "=", "d"}], ",", 
       RowBox[{"U", "=", "u"}], ",", 
       RowBox[{"R", "=", "r"}], ",", 
       RowBox[{"s", "=", "S0"}], ",", 
       RowBox[{"k", "=", "K"}], ",", 
       RowBox[{"p", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"E", "^", 
            RowBox[{"(", 
             RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
       RowBox[{"\[Nu]", "=", "1"}], ",", 
       RowBox[{"S", "=", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"V", "=", 
        RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
       RowBox[{"Vtemp", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"S", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"s", " ", 
          SuperscriptBox["U", "j"], 
          SuperscriptBox["D", 
           RowBox[{"i", "-", "j"}]]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"N", " ", "t"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"V", "=", 
       RowBox[{"{", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Max", "[", 
           RowBox[{
            RowBox[{"\[Nu]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"S", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                  RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], 
              ")"}]}], ",", "0"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "0", ",", 
            RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"N", " ", "t"}]}], ",", 
        RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
        RowBox[{"i", "--"}], ",", 
        RowBox[{
         RowBox[{"Vtemp", "=", 
          RowBox[{"{", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Max", "[", 
              RowBox[{
               RowBox[{"Max", "[", 
                RowBox[{
                 RowBox[{"\[Nu]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"S", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "k"}], 
                   ")"}]}], ",", "0"}], "]"}], ",", 
               RowBox[{
                RowBox[{"E", "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"p", " ", 
                   RowBox[{"V", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "-", "p"}], ")"}], 
                   RowBox[{"V", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}]}], 
              "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"V", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
      RowBox[{"V", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"V", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "i", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AmValueProcess", "[", 
   RowBox[{
   "T_", ",", "n_", ",", "d_", ",", "u_", ",", "r_", ",", "S0_", ",", "K_", 
    ",", "\"\<put\>\""}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t", "=", "T"}], ",", 
      RowBox[{"N", "=", "n"}], ",", 
      RowBox[{"D", "=", "d"}], ",", 
      RowBox[{"U", "=", "u"}], ",", 
      RowBox[{"R", "=", "r"}], ",", 
      RowBox[{"s", "=", "S0"}], ",", 
      RowBox[{"k", "=", "K"}], ",", 
      RowBox[{"p", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"E", "^", 
           RowBox[{"(", 
            RowBox[{"r", "/", "n"}], ")"}]}], "-", "d"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"u", "-", "d"}], ")"}]}]}], ",", 
      RowBox[{"\[Nu]", "=", 
       RowBox[{"-", "1"}]}], ",", 
      RowBox[{"S", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"V", "=", 
       RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", 
      RowBox[{"Vtemp", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"S", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"s", " ", 
         SuperscriptBox["U", "j"], 
         SuperscriptBox["D", 
          RowBox[{"i", "-", "j"}]]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"N", " ", "t"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "0", ",", "i"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"V", "=", 
      RowBox[{"{", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{
           RowBox[{"\[Nu]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"S", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"N", " ", "t"}], "+", "1"}], ",", 
                 RowBox[{"j", "+", "1"}]}], "]"}], "]"}], "-", "k"}], ")"}]}],
            ",", "0"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", 
           RowBox[{"N", " ", "t"}]}], "}"}]}], "]"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"N", " ", "t"}]}], ",", 
       RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
       RowBox[{"i", "--"}], ",", 
       RowBox[{
        RowBox[{"Vtemp", "=", 
         RowBox[{"{", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Max", "[", 
             RowBox[{
              RowBox[{"Max", "[", 
               RowBox[{
                RowBox[{"\[Nu]", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"S", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], "-", "k"}], 
                  ")"}]}], ",", "0"}], "]"}], ",", 
              RowBox[{
               RowBox[{"E", "^", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "R"}], "/", "N"}], ")"}]}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"p", " ", 
                  RowBox[{"V", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"j", "+", "1"}]}], "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"1", "-", "p"}], ")"}], 
                  RowBox[{"V", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "j"}], "]"}], "]"}]}]}], ")"}]}]}], 
             "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"j", ",", "1", ",", "i"}], "}"}]}], "]"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"V", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"Vtemp", ",", "V"}], "]"}]}]}]}], "]"}], ";", 
     RowBox[{"V", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"V", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{
           RowBox[{"N", " ", "t"}], "+", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "i", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.59967696992969*^9, 3.599676981923376*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"r0", " ", "=", " ", "r"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sigma0", "=", "\[Sigma]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"s00", "=", 
     RowBox[{"Data", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.5996827463360815`*^9, 3.599682759898857*^9}, {
  3.6000277955658274`*^9, 3.6000278023872175`*^9}, {3.600027852386077*^9, 
  3.6000278631756945`*^9}, {3.6000298442598104`*^9, 3.6000298527194195`*^9}, {
  3.600029888363055*^9, 3.60002988853417*^9}, {3.6000299738187246`*^9, 
  3.6000299792963543`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"udCalibrated", "=", 
      RowBox[{"KalibracjaBS", "[", 
       RowBox[{
       "r", ",", " ", "sigma", ",", " ", "n", ",", " ", "kalibracja"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"uPred", "=", 
      RowBox[{
       RowBox[{"udCalibrated", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"dPred", "=", 
      RowBox[{
       RowBox[{"udCalibrated", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "paths", ",", " ", "prices", ",", " ", "i", ",", " ", "option", ",",
            "\[IndentingNewLine]", "priceTree", ",", " ", "optionTree", ",", 
           " ", "delta", ",", " ", "gamma", ",", " ", "napis"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"paths", "=", 
           RowBox[{"edges", "[", 
            RowBox[{
             RowBox[{"t", " ", "n"}], " ", "+", "1"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"prices", "=", " ", 
           RowBox[{"priceProcess", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"t", " ", "n"}], " ", "+", "1"}], ",", " ", "s0", ",", 
             "u", ",", "d"}], "]"}]}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"option", "=", 
           RowBox[{"Flatten", "[", 
            RowBox[{"optFun", "[", 
             RowBox[{
             "t", ",", "n", ",", "d", ",", "u", ",", "r", ",", "s0", ",", "k",
               ",", "callPut"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"delta", "=", 
           RowBox[{"Round", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"option", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", 
                RowBox[{"option", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"prices", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", 
                RowBox[{"prices", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}], ",", "0.0001"}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"gamma", "=", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"t", " ", "n"}], ">", "1"}], ",", 
             RowBox[{"Round", "[", 
              RowBox[{
               FractionBox[
                RowBox[{
                 FractionBox[
                  RowBox[{
                   RowBox[{"option", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "-", 
                   RowBox[{"option", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}], 
                  RowBox[{
                   RowBox[{"prices", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "-", 
                   RowBox[{"prices", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]], "-", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"option", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], "-", 
                   RowBox[{"option", "[", 
                    RowBox[{"[", "6", "]"}], "]"}]}], 
                  RowBox[{
                   RowBox[{"prices", "[", 
                    RowBox[{"[", "5", "]"}], "]"}], "-", 
                   RowBox[{"prices", "[", 
                    RowBox[{"[", "6", "]"}], "]"}]}]]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"prices", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "-", 
                   RowBox[{"prices", "[", 
                    RowBox[{"[", "6", "]"}], "]"}]}], ")"}], "/", "2"}]], ",",
                "0.0001"}], "]"}], ",", "\"\<brak\>\""}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"napis", "=", 
           RowBox[{"\"\<\[CapitalDelta] = \>\"", " ", "<>", " ", 
            RowBox[{"ToString", "[", "delta", "]"}], " ", "<>", " ", 
            "\"\<\\n\>\"", "<>", " ", "\"\<\[CapitalGamma] = \>\"", " ", "<>",
             " ", 
            RowBox[{"ToString", "[", "gamma", "]"}]}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"priceTree", "=", 
           RowBox[{"Labeled", "[", 
            RowBox[{
             RowBox[{"TreePlot", "[", 
              RowBox[{
               RowBox[{"paths", "/.", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Range", "[", 
                    RowBox[{"noVertices", "[", 
                    RowBox[{
                    RowBox[{"t", " ", "n"}], " ", "+", " ", "1"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", 
                    RowBox[{"noVertices", "[", 
                    RowBox[{
                    RowBox[{"t", " ", "n"}], " ", "+", " ", "1"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "<>", 
                    "\"\<.   \>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"prices", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"noVertices", "[", 
                    RowBox[{
                    RowBox[{"t", " ", "n"}], "+", "1"}], "]"}]}], "}"}]}], 
                 "]"}]}], ",", " ", "\[IndentingNewLine]", 
               RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"PlotLabel", "\[Rule]", "\"\<Proces cen akcji\>\""}], 
               ",", " ", 
               RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"napis", ",", "Medium"}], "]"}], ",", "Left"}], "]"}]}],
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"optionTree", " ", "=", " ", "\[IndentingNewLine]", 
           RowBox[{"TreePlot", "[", 
            RowBox[{
             RowBox[{"paths", "/.", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"Range", "[", 
                   RowBox[{"noVertices", "[", 
                    RowBox[{
                    RowBox[{"t", " ", "n"}], " ", "+", " ", "1"}], "]"}], 
                   "]"}], "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{
                    RowBox[{"Range", "[", 
                    RowBox[{"noVertices", "[", 
                    RowBox[{
                    RowBox[{"t", " ", "n"}], " ", "+", " ", "1"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "<>", 
                  "\"\<.   \>\"", "<>", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"option", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"noVertices", "[", 
                   RowBox[{
                    RowBox[{"t", " ", "n"}], "+", "1"}], "]"}]}], "}"}]}], 
               "]"}]}], ",", " ", "\[IndentingNewLine]", "Bottom", ",", 
             "\[IndentingNewLine]", 
             RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ImageSize", "\[Rule]", "Medium"}], " ", ",", " ", 
             RowBox[{
             "PlotLabel", "\[Rule]", 
              "\"\<Wycena instrumentu pochodnego\>\""}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"Grid", "[", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"priceTree", ",", " ", "optionTree"}], " ", "}"}], "}"}],
            "]"}]}]}], "]"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       ",", "\[IndentingNewLine]", 
       "\"\<W\[LSlash]asno\:015bci procesu cen akcji\>\"", ",", 
       "\[IndentingNewLine]", "Delimiter", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"u", ",", "uPred", ",", " ", "\"\<U\>\""}], "}"}], ",", 
         RowBox[{"0.1", "uPred"}], ",", 
         RowBox[{"2", "uPred"}], ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"u", ",", "uPred", ",", " ", "\"\<\>\""}], "}"}], ",", 
         RowBox[{"{", "uPred", "}"}], ",", " ", 
         RowBox[{"ControlType", "\[Rule]", "SetterBar"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"d", ",", "dPred", ",", " ", "\"\<D\>\""}], "}"}], " ", ",", 
         RowBox[{"0.1", "dPred"}], ",", 
         RowBox[{"2", "dPred"}], ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"d", ",", "dPred", ",", " ", "\"\<\>\""}], "}"}], ",", " ", 
         RowBox[{"{", "dPred", "}"}], ",", 
         RowBox[{"ControlType", "\[Rule]", "SetterBar"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "s0", ",", "s00", ",", " ", "\"\<Cena pocz\:0105tkowa\>\""}], "}"}],
          ",", " ", 
         RowBox[{"0.1", "s00"}], ",", " ", 
         RowBox[{"10", "s00"}], ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"k", ",", "s00", ",", "\"\<Strike\>\""}], "}"}], ",", 
         RowBox[{"0.1", "s00"}], ",", " ", 
         RowBox[{"10", "s00"}], ",", " ", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
       "\[IndentingNewLine]", "\"\<\\nOpcja\>\"", ",", "\[IndentingNewLine]", 
       "Delimiter", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"optFun", ",", "EuroValueProcess", ",", "\"\<\>\""}], "}"}],
          ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"EuroValueProcess", "\[Rule]", "\"\<Europejska\>\""}], ",",
            " ", 
           RowBox[{
           "AmValueProcess", "\[Rule]", "\"\<Ameryka\:0144ska\>\""}]}], "}"}],
          ",", " ", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"callPut", ",", "\"\<call\>\"", ",", " ", "\"\<\>\""}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<call\>\"", "\[Rule]", "\"\<Call\>\""}], ",", " ", 
           RowBox[{"\"\<put\>\"", "\[Rule]", "\"\<Put\>\""}]}], "}"}]}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ControlPlacement", "\[Rule]", "Left"}]}], 
      "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
    "\"\<Definicja modelu i kalibracji do modelu Blacka-Scholesa\>\"", ",", 
    "\[IndentingNewLine]", "Delimiter", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"t", ",", "1", ",", "\"\<Liczba lat\>\""}], "}"}], ",", "1", 
      ",", "4", ",", "1", ",", " ", 
      RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", ",", "1", ",", "\"\<Okresy w roku\>\""}], "}"}], ",", "1",
       ",", "4", ",", "1", ",", 
      RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r", ",", "r0", ",", " ", "\"\<Stopa procentowa\>\""}], "}"}], 
      ",", " ", 
      RowBox[{"0.01", "*", "r0"}], ",", " ", "1", ",", " ", 
      RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r", ",", "r0", ",", "\"\<\>\""}], "}"}], ",", 
      RowBox[{"{", "r0", "}"}], ",", " ", 
      RowBox[{"ControlType", "\[Rule]", "SetterBar"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "sigma", ",", "sigma0", ",", " ", "\"\<Zmienno\:015b\[CAcute]\>\""}], 
       "}"}], ",", " ", "0.001", ",", " ", "1", ",", " ", 
      RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"sigma", ",", "sigma0", ",", "\"\<\>\""}], "}"}], ",", 
      RowBox[{"{", "sigma0", "}"}], ",", " ", 
      RowBox[{"ControlType", "\[Rule]", "SetterBar"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "kalibracja", ",", "\"\<CRR\>\"", ",", 
        "\"\<Spos\[OAcute]b kalibracji\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\"\<CRR\>\"", ",", " ", "\"\<JR\>\""}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.599680260115878*^9, 3.599680292468728*^9}, {
   3.599680358819524*^9, 3.5996804754451942`*^9}, {3.5996805103551908`*^9, 
   3.59968054863838*^9}, {3.5996806834070888`*^9, 3.599680782625764*^9}, {
   3.5996808356667976`*^9, 3.5996809028036375`*^9}, {3.5996809334343896`*^9, 
   3.5996809439599915`*^9}, {3.5996809827892127`*^9, 
   3.5996810055825167`*^9}, {3.5996810407465277`*^9, 
   3.5996810568294477`*^9}, {3.599681101772018*^9, 3.5996811047641892`*^9}, {
   3.5996811567251616`*^9, 3.599681186307853*^9}, {3.5996812256351023`*^9, 
   3.599681249613474*^9}, {3.5996812868736053`*^9, 3.599681341192712*^9}, {
   3.599681405360382*^9, 3.599681410352668*^9}, {3.5996815450953746`*^9, 
   3.599681545610404*^9}, {3.599681691423744*^9, 3.5996817013973145`*^9}, {
   3.5996817505751276`*^9, 3.5996818490947623`*^9}, {3.599681997826269*^9, 
   3.5996820231927204`*^9}, {3.5996821778595667`*^9, 3.599682194477517*^9}, {
   3.599682336403635*^9, 3.599682426444785*^9}, {3.5996825679468784`*^9, 
   3.5996825742952414`*^9}, {3.5996826993223925`*^9, 
   3.5996827342823925`*^9}, {3.5996827729096017`*^9, 3.599682851402091*^9}, {
   3.5996828867391124`*^9, 3.5996829311716537`*^9}, {3.5996831113039565`*^9, 
   3.599683176420681*^9}, {3.599683207572463*^9, 3.599683267387884*^9}, 
   3.599683300745792*^9, {3.5996833737209663`*^9, 3.599683553073224*^9}, {
   3.599683590606371*^9, 3.599683619624031*^9}, {3.599683650833816*^9, 
   3.599683659773327*^9}, {3.599683694750328*^9, 3.59968376734848*^9}, {
   3.599846458125001*^9, 3.5998465032455816`*^9}, {3.5998465351164045`*^9, 
   3.5998465566786375`*^9}, {3.599846655866311*^9, 3.5998467197829666`*^9}, {
   3.599846760313285*^9, 3.5998467678027134`*^9}, {3.600024169483427*^9, 
   3.600024270631212*^9}, {3.6000251930429716`*^9, 3.600025228896022*^9}, {
   3.600025358163416*^9, 3.600025371758193*^9}, {3.6000254754881268`*^9, 
   3.6000255037957454`*^9}, {3.6000255443720665`*^9, 3.600025545031104*^9}, {
   3.60002557940307*^9, 3.6000256416606307`*^9}, {3.600025679532797*^9, 
   3.6000257236793222`*^9}, {3.6000257755082865`*^9, 
   3.6000257766483517`*^9}, {3.600025809174212*^9, 3.6000258109863157`*^9}, {
   3.600025986808372*^9, 3.600026100448872*^9}, {3.6000261359479027`*^9, 
   3.600026428801653*^9}, {3.6000265073191433`*^9, 3.600026523850089*^9}, {
   3.600026560495185*^9, 3.6000266126461678`*^9}, {3.600026676360812*^9, 
   3.6000266838332396`*^9}, {3.6000267632917843`*^9, 3.600026785487054*^9}, {
   3.600027192271321*^9, 3.600027230490507*^9}, {3.600027345752099*^9, 
   3.6000273971090364`*^9}, {3.600027467244048*^9, 3.6000276288692923`*^9}, {
   3.600027670209657*^9, 3.6000277575216513`*^9}, {3.6000278195621996`*^9, 
   3.6000278409064207`*^9}, {3.600027873745299*^9, 3.6000280790130396`*^9}, 
   3.6000281123839483`*^9, {3.6000283393439293`*^9, 3.6000284089979134`*^9}, {
   3.60002849495283*^9, 3.6000285128728547`*^9}, {3.6000286575431294`*^9, 
   3.600028684767687*^9}, {3.600030013287895*^9, 3.600030035925906*^9}, {
   3.6000303094292717`*^9, 3.6000303289041862`*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`kalibracja$$ = "CRR", $CellContext`n$$ = 
    2, $CellContext`r$$ = 0.316, $CellContext`sigma$$ = 
    0.4713278925198055, $CellContext`t$$ = 1, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold["Definicja modelu i kalibracji do modelu Blacka-Scholesa"], 
      Manipulate`Dump`ThisIsNotAControl}, {{
       Hold[$CellContext`t$$], 1, "Liczba lat"}, 1, 4, 1}, {{
       Hold[$CellContext`n$$], 1, "Okresy w roku"}, 1, 4, 1}, {{
       Hold[$CellContext`r$$], 0.00040557583468514113`, "Stopa procentowa"}, 
      4.055758346851412*^-6, 1}, {{
       Hold[$CellContext`r$$], 0.00040557583468514113`, ""}, {
      0.00040557583468514113`}}, {{
       Hold[$CellContext`sigma$$], 0.4713278925198055, 
       "Zmienno\:015b\[CAcute]"}, 0.001, 1}, {{
       Hold[$CellContext`sigma$$], 0.4713278925198055, ""}, {
      0.4713278925198055}}, {{
       Hold[$CellContext`kalibracja$$], "CRR", "Spos\[OAcute]b kalibracji"}, {
      "CRR", "JR"}}}, Typeset`size$$ = {1117., {200., 207.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`t$23633$$ = 0, $CellContext`n$23634$$ = 
    0, $CellContext`r$23635$$ = 0, $CellContext`sigma$23636$$ = 
    0, $CellContext`kalibracja$23637$$ = False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`kalibracja$$ = "CRR", $CellContext`n$$ = 
        1, $CellContext`r$$ = 0.00040557583468514113`, $CellContext`sigma$$ = 
        0.4713278925198055, $CellContext`t$$ = 1}, "ControllerVariables" :> {
        Hold[$CellContext`t$$, $CellContext`t$23633$$, 0], 
        Hold[$CellContext`n$$, $CellContext`n$23634$$, 0], 
        Hold[$CellContext`r$$, $CellContext`r$23635$$, 0], 
        Hold[$CellContext`sigma$$, $CellContext`sigma$23636$$, 0], 
        Hold[$CellContext`kalibracja$$, $CellContext`kalibracja$23637$$, 
         False]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, 
      "Body" :> ($CellContext`udCalibrated = \
$CellContext`KalibracjaBS[$CellContext`r$$, $CellContext`sigma$$, \
$CellContext`n$$, $CellContext`kalibracja$$]; $CellContext`uPred = Part[
          Part[$CellContext`udCalibrated, 1], 2]; $CellContext`dPred = Part[
          Part[$CellContext`udCalibrated, 2], 2]; Manipulate[
         Module[{$CellContext`paths$, $CellContext`prices$, $CellContext`i$, \
$CellContext`option$, $CellContext`priceTree$, $CellContext`optionTree$, \
$CellContext`delta$, $CellContext`gamma$, $CellContext`napis$}, \
$CellContext`paths$ = $CellContext`edges[$CellContext`t$$ $CellContext`n$$ + 
             1]; $CellContext`prices$ = \
$CellContext`priceProcess[$CellContext`t$$ $CellContext`n$$ + 
             1, $CellContext`s0, $CellContext`u, $CellContext`d]; \
$CellContext`option$ = Flatten[
             $CellContext`optFun[$CellContext`t$$, $CellContext`n$$, \
$CellContext`d, $CellContext`u, $CellContext`r$$, $CellContext`s0, \
$CellContext`k, $CellContext`callPut]]; $CellContext`delta$ = 
           Round[(Part[$CellContext`option$, 2] - 
              Part[$CellContext`option$, 3])/(Part[$CellContext`prices$, 2] - 
             Part[$CellContext`prices$, 3]), 0.0001]; $CellContext`gamma$ = 
           If[$CellContext`t$$ $CellContext`n$$ > 1, 
             
             Round[((Part[$CellContext`option$, 4] - 
                 Part[$CellContext`option$, 5])/(
                Part[$CellContext`prices$, 4] - 
                Part[$CellContext`prices$, 5]) - (
                Part[$CellContext`option$, 5] - 
                Part[$CellContext`option$, 6])/(Part[$CellContext`prices$, 5] - 
               Part[$CellContext`prices$, 6]))/((
               Part[$CellContext`prices$, 4] - Part[$CellContext`prices$, 6])/
              2), 0.0001], "brak"]; $CellContext`napis$ = 
           StringJoin["\[CapitalDelta] = ", 
             ToString[$CellContext`delta$], "\n", "\[CapitalGamma] = ", 
             ToString[$CellContext`gamma$]]; $CellContext`priceTree$ = Labeled[
             TreePlot[
              ReplaceAll[$CellContext`paths$, 
               Table[Part[
                  Range[
                   $CellContext`noVertices[$CellContext`t$$ $CellContext`n$$ + 
                    1]], $CellContext`i$] -> StringJoin[
                  ToString[
                   Part[
                    Range[
                    $CellContext`noVertices[$CellContext`t$$ $CellContext`n$$ + 
                    1]], $CellContext`i$]], ".   ", 
                  ToString[
                   
                   Part[$CellContext`prices$, $CellContext`i$]]], \
{$CellContext`i$, 1, 
                 $CellContext`noVertices[$CellContext`t$$ $CellContext`n$$ + 
                  1]}]], VertexLabeling -> True, DirectedEdges -> True, 
              PlotLabel -> "Proces cen akcji", ImageSize -> Medium], 
             Style[$CellContext`napis$, Medium], 
             Left]; $CellContext`optionTree$ = TreePlot[
             ReplaceAll[$CellContext`paths$, 
              Table[Part[
                 Range[
                  $CellContext`noVertices[$CellContext`t$$ $CellContext`n$$ + 
                   1]], $CellContext`i$] -> StringJoin[
                 ToString[
                  Part[
                   Range[
                    $CellContext`noVertices[$CellContext`t$$ $CellContext`n$$ + 
                    1]], $CellContext`i$]], ".   ", 
                 ToString[
                  
                  Part[$CellContext`option$, $CellContext`i$]]], \
{$CellContext`i$, 1, 
                $CellContext`noVertices[$CellContext`t$$ $CellContext`n$$ + 
                 1]}]], Bottom, VertexLabeling -> True, ImageSize -> Medium, 
             PlotLabel -> "Wycena instrumentu pochodnego"]; 
          Grid[{{$CellContext`priceTree$, $CellContext`optionTree$}}]], 
         "W\[LSlash]asno\:015bci procesu cen akcji", 
         Delimiter, {{$CellContext`u, $CellContext`uPred, "U"}, 
          0.1 $CellContext`uPred, 2 $CellContext`uPred, Appearance -> 
          "Labeled"}, {{$CellContext`u, $CellContext`uPred, 
           ""}, {$CellContext`uPred}, ControlType -> 
          SetterBar}, {{$CellContext`d, $CellContext`dPred, "D"}, 
          0.1 $CellContext`dPred, 2 $CellContext`dPred, Appearance -> 
          "Labeled"}, {{$CellContext`d, $CellContext`dPred, 
           ""}, {$CellContext`dPred}, ControlType -> 
          SetterBar}, {{$CellContext`s0, $CellContext`s00, 
           "Cena pocz\:0105tkowa"}, 0.1 $CellContext`s00, 10 $CellContext`s00,
           Appearance -> 
          "Labeled"}, {{$CellContext`k, $CellContext`s00, "Strike"}, 
          0.1 $CellContext`s00, 10 $CellContext`s00, Appearance -> "Labeled"},
          "\nOpcja", 
         Delimiter, {{$CellContext`optFun, $CellContext`EuroValueProcess, 
           ""}, {$CellContext`EuroValueProcess -> 
           "Europejska", $CellContext`AmValueProcess -> "Ameryka\:0144ska"}, 
          Appearance -> "Labeled"}, {{$CellContext`callPut, "call", ""}, {
          "call" -> "Call", "put" -> "Put"}}, ControlPlacement -> Left]), 
      "Specifications" :> {
       "Definicja modelu i kalibracji do modelu Blacka-Scholesa", 
        Delimiter, {{$CellContext`t$$, 1, "Liczba lat"}, 1, 4, 1, Appearance -> 
         "Labeled"}, {{$CellContext`n$$, 1, "Okresy w roku"}, 1, 4, 1, 
         Appearance -> 
         "Labeled"}, {{$CellContext`r$$, 0.00040557583468514113`, 
          "Stopa procentowa"}, 4.055758346851412*^-6, 1, Appearance -> 
         "Labeled"}, {{$CellContext`r$$, 0.00040557583468514113`, ""}, {
         0.00040557583468514113`}, ControlType -> 
         SetterBar}, {{$CellContext`sigma$$, 0.4713278925198055, 
          "Zmienno\:015b\[CAcute]"}, 0.001, 1, Appearance -> 
         "Labeled"}, {{$CellContext`sigma$$, 0.4713278925198055, ""}, {
         0.4713278925198055}, ControlType -> 
         SetterBar}, {{$CellContext`kalibracja$$, "CRR", 
          "Spos\[OAcute]b kalibracji"}, {"CRR", "JR"}}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{1431., {230., 237.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.6000241345274277`*^9, {3.6000242503500524`*^9, 3.6000242720162916`*^9}, 
   3.600025230538116*^9, 3.6000253726452436`*^9, {3.6000254838546047`*^9, 
   3.6000255046567945`*^9}, 3.6000255469862156`*^9, 3.600025724934394*^9, 
   3.600026432448861*^9, 3.6000265247491407`*^9, 3.600026561746257*^9, 
   3.6000266139472427`*^9, 3.600026787113147*^9, {3.600027210247349*^9, 
   3.6000272334236746`*^9}, {3.600027372444626*^9, 3.600027380596092*^9}, 
   3.600027472942374*^9, {3.6000275107305355`*^9, 3.600027585128791*^9}, 
   3.600027630411381*^9, {3.600027682025333*^9, 3.600027708458845*^9}, {
   3.600027908278274*^9, 3.6000279445843506`*^9}, 3.6000279841906157`*^9, 
   3.600028049280339*^9, 3.600028079859088*^9, {3.600028347306385*^9, 
   3.6000283629982824`*^9}, 3.6000284103099885`*^9, 3.600028514240933*^9, 
   3.600028686891808*^9, 3.6000302844607143`*^9, 3.600030341649638*^9, 
   3.6000710008838196`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Part", "::", "partd"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Part specification \[NoBreak]\\!\\(0.316` \
\[LeftDoubleBracket] 2 \[RightDoubleBracket]\\)\[NoBreak] is longer than \
depth of object. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\
\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/partd\\\", ButtonNote -> \
\\\"Part::partd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.6001446392757554`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Part", "::", "partd"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Part specification \[NoBreak]\\!\\(0.316` \
\[LeftDoubleBracket] 2 \[RightDoubleBracket]\\)\[NoBreak] is longer than \
depth of object. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\
\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/partd\\\", ButtonNote -> \
\\\"Part::partd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.600144639348804*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Part", "::", "partd"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Part specification \[NoBreak]\\!\\(0.4713278925198055` \
\[LeftDoubleBracket] 2 \[RightDoubleBracket]\\)\[NoBreak] is longer than \
depth of object. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\
\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/partd\\\", ButtonNote -> \
\\\"Part::partd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.6001446393538074`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Part :: \
partd\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.6001446393588095`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["\<\
Wycena opcji zale\:017cnych od trajektorii\
\>", "Section",
 CellChangeTimes->{{3.599759241303171*^9, 3.5997592511057315`*^9}}],

Cell[TextData[{
 StyleBox["(Wady modelu dwumianowego).",
  FontWeight->"Bold"],
 " Wyp\[LSlash]ata z takich opcji zale\:017cy nie tylko od ko\:0144cowej ceny \
instrumentu, ale tak\:017ce od ca\[LSlash]ej \:015bcie\:017cki, po \
kt\[OAcute]rej poruszali\:015bmy si\:0119 do ko\:0144cowej ceny."
}], "Text",
 CellChangeTimes->{{3.5986427786032586`*^9, 3.598642805833297*^9}, {
  3.5986430840636864`*^9, 3.598643085283688*^9}, {3.5986431893138337`*^9, 
  3.5986432103338633`*^9}, {3.598643268903945*^9, 3.5986432692139454`*^9}, {
  3.598966360122382*^9, 3.5989663652323895`*^9}, {3.599845894799121*^9, 
  3.5998458979091253`*^9}},
 TextJustification->1.],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Jeden", " ", "okres", " ", "wprz\[OAcute]d", " ", "w", " ", 
    "algorytmie"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"Step", "[", 
    RowBox[{"S_List", ",", "u_", ",", "d_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"#", "*", "u"}], ",", 
         RowBox[{"#", "*", "d"}]}], "}"}], "&"}], ",", "S"}], "]"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5985272154224596`*^9, 3.598527259183963*^9}, {
  3.598527974086853*^9, 3.5985279995153074`*^9}, {3.5985280368394423`*^9, 
  3.598528052655347*^9}, {3.59852809432473*^9, 3.5985280968518744`*^9}, {
  3.5985301141192555`*^9, 3.598530125581911*^9}, {3.5986430140935884`*^9, 
  3.598643047483635*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Drzewo", " ", "w", " ", "postaci", " ", "list", " ", "do", " ", "okresu", 
    " ", "M"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"ComputeFullTree", "[", 
    RowBox[{"S0_", ",", "u_", ",", "d_", ",", "M_Integer"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"S", "=", 
        RowBox[{"{", "S0", "}"}]}], ",", "FullTree", ",", "i"}], "}"}], ",", 
     RowBox[{
      RowBox[{"FullTree", "=", 
       RowBox[{"{", "S", "}"}]}], ";", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", " ", "M"}], ",", 
        RowBox[{"i", "++"}], ",", 
        RowBox[{
         RowBox[{"S", "=", 
          RowBox[{"Step", "[", 
           RowBox[{"S", ",", "u", ",", "d"}], "]"}]}], ";", 
         RowBox[{"FullTree", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"FullTree", ",", "S"}], "]"}]}]}]}], "]"}], ";", 
      "FullTree"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.598528357435779*^9, 3.5985283674603524`*^9}, {
   3.5985284047054825`*^9, 3.598528461350723*^9}, {3.5985285113865843`*^9, 
   3.5985285635265665`*^9}, {3.5985286029788237`*^9, 3.598528622466938*^9}, {
   3.598528676247014*^9, 3.5985287056286945`*^9}, {3.5985288311958766`*^9, 
   3.598528885366975*^9}, {3.5985289211630225`*^9, 3.5985289704318404`*^9}, {
   3.598529071814639*^9, 3.598529109011767*^9}, 3.5985291524172497`*^9, {
   3.5986430579736495`*^9, 3.5986430731536713`*^9}, {3.5987254212398643`*^9, 
   3.5987254225898657`*^9}, {3.5989626112737174`*^9, 3.598962612273719*^9}}],

Cell["\<\
Przyk\[LSlash]adowo, na poni\:017cszym obrazku dwuokresowego modelu \
dwumianowego dwa w\:0119z\[LSlash]y z cen\:0105 51.48 w ko\:0144cowym okresie \
nie mog\:0105 zosta\[CAcute] po\[LSlash]\:0105czone w jeden, poniewa\:017c r\
\[OAcute]\:017cni\:0105 si\:0119 dla nich ceny po pierwszym okresie.\
\>", "Text",
 CellChangeTimes->{{3.5987256599801984`*^9, 3.59872578968038*^9}},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Rysunek", " ", "przyk\[LSlash]adowego", " ", "drzewa", " ", 
    "dwuokresowego", " ", "dla", " ", "opcji", " ", "zale\:017cnych", " ", 
    "od", " ", "trajektorii"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"lvl", ",", 
       RowBox[{"lvl1", "=", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], "}"}]}], ",", 
       RowBox[{"lvl2", "=", 
        RowBox[{"Thread", "[", 
         RowBox[{"List", "[", 
          RowBox[{"2", ",", 
           RowBox[{"Table", "[", 
            RowBox[{"i", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "2", ",", 
               RowBox[{"-", "2"}], ",", 
               RowBox[{"-", "4"}]}], "}"}]}], "]"}]}], "]"}], "]"}]}], ",", 
       RowBox[{"lvl3", "=", 
        RowBox[{"Thread", "[", 
         RowBox[{"List", "[", 
          RowBox[{"4", ",", 
           RowBox[{"Table", "[", 
            RowBox[{"i", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "3", ",", 
               RowBox[{"-", "3"}], ",", 
               RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "]"}], "]"}]}], ",", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Wywo\[LSlash]ujemy", " ", "uprzednio", " ", "napisan\:0105", " ", 
         "funkcj\:0119", " ", "z", " ", "arbitralnymi", " ", "parametrami"}], 
        " ", "*)"}], 
       RowBox[{"FullTree", "=", 
        RowBox[{"ComputeFullTree", "[", 
         RowBox[{"50", ",", "1.04", ",", "0.99", ",", "2"}], "]"}]}], ",", 
       "j", ",", "k", ",", 
       RowBox[{"text", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"lvl", "=", 
       RowBox[{"{", 
        RowBox[{"lvl1", ",", "lvl2", ",", "lvl3"}], "}"}]}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"Dodanie", " ", "tekst\[OAcute]w"}], " ", "*)"}], 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "lvl", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"k", "=", "1"}], ",", 
          RowBox[{"k", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"FullTree", "[", 
             RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"k", "++"}], ",", 
          RowBox[{"text", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"text", ",", 
             RowBox[{"Text", "[", 
              RowBox[{
               RowBox[{"FullTree", "[", 
                RowBox[{"[", 
                 RowBox[{"j", ",", "k"}], "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"lvl", "[", 
                 RowBox[{"[", 
                  RowBox[{"j", ",", "k"}], "]"}], "]"}], "+", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "\[Epsilon]"}], "}"}]}]}], "]"}]}], 
            "]"}]}]}], "]"}]}], "]"}], ";", 
      RowBox[{"(*", " ", 
       RowBox[{"Dodanie", " ", "strza\[LSlash]ek"}], " ", "*)"}], 
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"text", ",", 
          RowBox[{"Arrowheads", "[", "Medium", "]"}], ",", 
          RowBox[{"Arrow", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lvl1", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"lvl2", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}], ",", 
          RowBox[{"Arrow", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lvl1", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"lvl2", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
          RowBox[{"Arrow", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lvl2", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"lvl3", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}], ",", 
          RowBox[{"Arrow", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lvl2", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"lvl3", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
          RowBox[{"Arrow", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lvl2", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"lvl3", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
          RowBox[{"Arrow", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"lvl2", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"lvl3", "[", 
              RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "Small"}]}], "]"}]}]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{"\[Epsilon]", "\[Rule]", "0.4"}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.5987254348798833`*^9, 3.598725521030004*^9}, {
  3.5989626438137627`*^9, 3.5989626591837845`*^9}, {3.5989629864792852`*^9, 
  3.5989630205993333`*^9}, {3.598963076859412*^9, 3.5989632124118867`*^9}}],

Cell[BoxData[
 GraphicsBox[{{InsetBox["50", {0, 0.4}], InsetBox["52.`", {2, 2.4}], 
    InsetBox["49.5`", {2, -1.6}], InsetBox["54.08`", {4, 3.4}], 
    InsetBox["51.48`", {4, 1.4}], InsetBox["51.480000000000004`", {4, -0.6}], 
    InsetBox["49.005`", {4, -2.6}]}, 
   {Arrowheads[Medium], ArrowBox[{{0, 0}, {2, 2}}], 
    ArrowBox[{{0, 0}, {2, -2}}], ArrowBox[{{2, 2}, {4, 3}}], 
    ArrowBox[{{2, 2}, {4, 1}}], ArrowBox[{{2, -2}, {4, -1}}], 
    ArrowBox[{{2, -2}, {4, -3}}]}},
  ImageSize->Small]], "Output",
 CellChangeTimes->{
  3.5986428753433943`*^9, 3.598643528411317*^9, 3.5987258686404905`*^9, 
   3.598729522480792*^9, {3.5989626441537633`*^9, 3.598962659493785*^9}, {
   3.598962987559287*^9, 3.5989630211393337`*^9}, {3.598963080639417*^9, 
   3.598963084159422*^9}, {3.598963135859494*^9, 3.5989632413819275`*^9}, 
   3.5989810689919662`*^9, 3.599845941099186*^9},
 TextAlignment->Center]
}, {2}]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Funkcja", " ", "pomocnicza", " ", "do", " ", "liczenia", " ", 
    "wyp\[LSlash]at", " ", "z", " ", "opcji"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"ComputeFullTable", "[", "FullTree_List", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"M", "=", 
        RowBox[{"Length", "[", "FullTree", "]"}]}], ",", 
       RowBox[{"FullTable", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", "M"}], ",", 
        RowBox[{"i", "++"}], ",", 
        RowBox[{"FullTable", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"FullTable", ",", 
           RowBox[{"Flatten", "[", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"{", 
                  SuperscriptBox["2", 
                   RowBox[{"M", "-", "i"}]], "}"}]}], "]"}], "&"}], ",", 
              RowBox[{"FullTree", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "]"}]}], "]"}]}]}], 
       "]"}], ";", "FullTable"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5985308486642694`*^9, 3.5985308511934137`*^9}, {
   3.598531006277284*^9, 3.5985310074363503`*^9}, {3.5985310483456907`*^9, 
   3.598531190056796*^9}, {3.5985312606428328`*^9, 3.598531319972226*^9}, 
   3.5987255408700314`*^9, {3.598725585390094*^9, 3.5987256001301146`*^9}, {
   3.598725884880513*^9, 3.5987258983405323`*^9}, {3.5987259408105917`*^9, 
   3.5987259421605935`*^9}, {3.598962691213829*^9, 3.59896269177383*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Kilka", " ", "typowych", " ", "wyp\[LSlash]at", " ", "zale\:017cnych", 
    " ", "od", " ", "trajektorii"}], " ", "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"Payoff", "[", 
     RowBox[{
     "\"\<Azjatycka arytmetyczna\>\"", ",", "\"\<Call\>\"", ",", 
      "FullTree_List", ",", "K_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Max", "[", 
        RowBox[{"#", ",", "0"}], "]"}], "&"}], ",", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Mean", ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"ComputeFullTable", "[", "FullTree", "]"}], "]"}]}], "]"}], 
       "-", "K"}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"Payoff", "[", 
     RowBox[{
     "\"\<Azjatycka arytmetyczna\>\"", ",", "\"\<Put\>\"", ",", 
      "FullTree_List", ",", "K_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Max", "[", 
        RowBox[{"#", ",", "0"}], "]"}], "&"}], ",", 
      RowBox[{"K", "-", 
       RowBox[{"Map", "[", 
        RowBox[{"Mean", ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"ComputeFullTable", "[", "FullTree", "]"}], "]"}]}], 
        "]"}]}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"Payoff", "[", 
     RowBox[{
     "\"\<Azjatycka geometryczna\>\"", ",", "\"\<Call\>\"", ",", 
      "FullTree_List", ",", "K_"}], "]"}], ":=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Max", "[", 
        RowBox[{"#", ",", "0"}], "]"}], "&"}], ",", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"GeometricMean", ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"ComputeFullTable", "[", "FullTree", "]"}], "]"}]}], "]"}], 
       "-", "K"}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"Payoff", "[", 
     RowBox[{
     "\"\<Down-and-out\>\"", ",", "\"\<Call\>\"", ",", "FullTree_List", ",", 
      "K_", ",", "B_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", ">", "B"}], " ", "&"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{"Min", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"ComputeFullTable", "[", "FullTree", "]"}], "]"}]}], 
          "]"}]}], "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"True", "\[Rule]", "1"}], ",", 
         RowBox[{"False", "\[Rule]", "0"}]}], "}"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{"#", ",", "0"}], "]"}], "&"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{"FullTree", ",", 
            RowBox[{"-", "1"}]}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "-", "K"}]}], "]"}], 
      ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.5989627073538523`*^9, 3.5989627127738595`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Funkcja", " ", "korzystaj\:0105ca", " ", "z", " ", "poprzednich", " ", 
    "i", " ", "licz\:0105ca", " ", "cen\:0119", " ", "opcji", " ", 
    "zale\:017cnej", " ", "od", " ", "trajektorii"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"PathDependantPrice", "[", 
    RowBox[{
    "S0_", ",", "u_", ",", "d_", ",", "p_", ",", "r_", ",", "T_", ",", 
     "M_Integer", ",", "type_String", ",", "payoff_String", ",", "K_", ",", 
     "B___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Take", "[", 
       RowBox[{
        RowBox[{"ComputeFullTree", "[", 
         RowBox[{"1", ",", "p", ",", 
          RowBox[{"1", "-", "p"}], ",", "M"}], "]"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ".", 
     RowBox[{"Payoff", "[", 
      RowBox[{"type", ",", "payoff", ",", 
       RowBox[{"ComputeFullTree", "[", 
        RowBox[{"S0", ",", "u", ",", "d", ",", "M"}], "]"}], ",", "K", ",", 
       "B"}], "]"}]}], " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "r"}], " ", "T"}]]}]}]}]], "Input",
 CellChangeTimes->{{3.5985339303875337`*^9, 3.598534072750676*^9}, {
  3.598534111066868*^9, 3.598534158956607*^9}, {3.598536266804169*^9, 
  3.5985362889784374`*^9}, {3.5987258233404274`*^9, 3.598725843130455*^9}, {
  3.598725909180547*^9, 3.5987259229805665`*^9}, {3.59896272747388*^9, 
  3.598962728523882*^9}, {3.5989627662839346`*^9, 3.598962773113944*^9}}],

Cell["\<\
Poniewa\:017c nie mo\:017cemy \[LSlash]\:0105czy\[CAcute] punkt\[OAcute]w o \
jednakowej cenie, ilo\:015b\[CAcute] punkt\[OAcute]w w ka\:017cdym kroku zwi\
\:0119ksza si\:0119 dwukrotnie. To powa\:017cna wada pokazuj\:0105ca, \:017ce \
model dwumianowy nie mo\:017ce by\[CAcute] stosowany w przypadku opcji zale\
\:017cnych od trajektorii. Na poni\:017cszym rysunku wida\[CAcute], jak czas \
oblicze\:0144 ro\:015bnie wraz z rozmiarem drzewa w tempie eksponencjalnym. \
Przy cho\[CAcute]by 100 okresach otrzymywaliby\:015bmy czas oblicze\:0144 id\
\:0105cy w lata (podczas, gdy zazwyczaj w zastosowaniach praktycznych \
u\:017cywa si\:0119 raczej ok. 100 000 okres\[OAcute]w).\
\>", "Text",
 CellChangeTimes->{{3.5987305941124697`*^9, 3.5987305993107667`*^9}, {
  3.5987306576831055`*^9, 3.598730870445275*^9}},
 TextJustification->1.],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListPathDependant", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"(*", " ", 
     RowBox[{
     "Liczymy", " ", "czas", " ", "wyliczania", " ", "ceny", " ", 
      "konkretnej", " ", "opcji", " ", "dla", " ", "r\[OAcute]\:017cnej", " ",
       "ilo\:015bci", " ", "okres\[OAcute]w"}], " ", "*)"}], 
    RowBox[{
     RowBox[{"Prepend", "[", 
      RowBox[{
       RowBox[{"Timing", "[", 
        RowBox[{"PathDependantPrice", "[", 
         RowBox[{"50", ",", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"0.0075", "/", "i"}], "+", 
            RowBox[{"0.3", 
             SqrtBox[
              FractionBox["0.5", "i"]]}]}]], ",", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{
            RowBox[{"0.0075", "/", "i"}], "-", 
            RowBox[{"0.3", 
             SqrtBox[
              FractionBox["0.5", "i"]]}]}]], ",", "0.5", ",", "0.06", ",", 
          "0.5", ",", "i", ",", "\"\<Down-and-out\>\"", ",", "\"\<Call\>\"", 
          ",", "51", ",", "49.8"}], "]"}], "]"}], ",", "i"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "10", ",", "20"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5987266380866065`*^9, 3.598726638506607*^9}, {
   3.59872674045675*^9, 3.5987268038768387`*^9}, {3.5987275869979353`*^9, 
   3.598727587867936*^9}, {3.598728510896345*^9, 3.5987285248563647`*^9}, {
   3.59872864279653*^9, 3.598728672426572*^9}, {3.598728718856636*^9, 
   3.598728718936637*^9}, {3.5987291159473763`*^9, 3.598729116072176*^9}, 
   3.598729166163864*^9, 3.5987295582468843`*^9, {3.5987300515075746`*^9, 
   3.5987300621775894`*^9}, {3.5989646798009815`*^9, 3.598964681710984*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Wykres", " ", "czas\[OAcute]w", " ", "wykonania", " ", "w", " ", 
    "zale\:017cno\:015bci", " ", "od", " ", "liczby", " ", 
    "okres\[OAcute]w"}], " ", "*)"}], 
  RowBox[{
   RowBox[{"MapThread", "[", 
    RowBox[{"List", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ListPathDependant", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"ListPathDependant", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", "0.03", "]"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Ilo\:015b\[CAcute] okres\[OAcute]w\>\"", ",", 
      "\"\<Czas (sekundy)\>\""}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5985365032736945`*^9, 3.598536515948419*^9}, 
   3.598536553129546*^9, {3.5985369579447002`*^9, 3.5985369918296385`*^9}, {
   3.5985375024608445`*^9, 3.598537504843981*^9}, {3.5986438168397284`*^9, 
   3.59864384655977*^9}, {3.5987295798169146`*^9, 3.5987296437070036`*^9}, {
   3.598729698757081*^9, 3.598729879807334*^9}, {3.59873010109227*^9, 
   3.5987301231765337`*^9}, {3.598730174189451*^9, 3.598730223858292*^9}, {
   3.5987303701506596`*^9, 3.5987303975482264`*^9}, {3.598962840344038*^9, 
   3.5989628576140623`*^9}, {3.5989634170831738`*^9, 
   3.5989634705632486`*^9}, {3.598965782271573*^9, 3.598965786601579*^9}, {
   3.598965818251623*^9, 3.5989658184216237`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointSize[0.03], 
   PointBox[{{10., 0.031000000000000583`}, {11., 0.031000000000000583`}, {12.,
     0.016000000000000014`}, {13., 0.04699999999999882}, {14., 
    0.10899999999999999`}, {15., 0.21799999999999997`}, {16., 
    0.4530000000000012}, {17., 0.9359999999999999}, {18., 
    1.7940000000000005`}, {19., 3.8369999999999997`}, {20., 7.878}}]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["\"Ilo\:015b\[CAcute] okres\[OAcute]w\"", TraditionalForm], 
    FormBox["\"Czas (sekundy)\"", TraditionalForm]},
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.5987298806673355`*^9, {3.5987300957139626`*^9, 3.598730123920576*^9}, 
   3.598730225209369*^9, {3.5987303769130464`*^9, 3.5987303978272424`*^9}, 
   3.5989634027121534`*^9, 3.598963471233249*^9, 3.598964724721044*^9, {
   3.598965814741618*^9, 3.5989658189516244`*^9}, 3.5998460278393073`*^9}]
}, {2}]],

Cell["\<\
Jak widzimy z poni\:017cszego por\[OAcute]wnania, przy takiej ilo\:015bci \
okres\[OAcute]w cena nawet nie zbli\:017ca si\:0119 do rzeczywistej ceny \
danej opcji barierowej (cena wyliczona za pomoc\:0105 symulacji Monte Carlo).\
\>", "Text",
 CellChangeTimes->{{3.5987305941124697`*^9, 3.5987305993107667`*^9}, {
  3.5987306576831055`*^9, 3.598730870445275*^9}, {3.5989662354922075`*^9, 
  3.5989662826222734`*^9}, {3.598966383692415*^9, 3.598966389972424*^9}},
 TextJustification->1.],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", 
    RowBox[{"(*", " ", 
     RowBox[{
     "Analogiczny", " ", "wykres", " ", "cen", " ", "w", " ", 
      "zale\:017cno\:015bci", " ", "od", " ", "liczby", " ", 
      "okres\[OAcute]w"}], " ", "*)"}], 
    RowBox[{
     RowBox[{"MapThread", "[", 
      RowBox[{"List", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPathDependant", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"ListPathDependant", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "3"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"PointSize", "[", "0.03", "]"}]}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Ilo\:015b\[CAcute] okres\[OAcute]w\>\"", ",", 
        "\"\<Cena opcji\>\""}], "}"}]}]}], "]"}], ",", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Dorzucenie", " ", "ceny", " ", "wyliczonej", " ", "na", " ", 
     "zewn\:0105trz"}], " ", "*)"}], 
   RowBox[{"Plot", "[", 
    RowBox[{"1.2090", ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "10", ",", "20"}], "}"}]}], "]"}], ",", 
   RowBox[{"Graphics", "[", 
    RowBox[{"Style", "[", 
     RowBox[{
      RowBox[{"Text", "[", 
       RowBox[{"\"\<Cena opcji z symulacji MC\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"16", ",", "1.3"}], "}"}]}], "]"}], ",", "\"\<Label\>\""}], 
     "]"}], "]"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"10", ",", "1"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5989656812414317`*^9, 3.5989657351915073`*^9}, {
  3.5989657905215845`*^9, 3.598965790711585*^9}, {3.598965821421628*^9, 
  3.5989658591716805`*^9}, {3.598965913401757*^9, 3.59896592290177*^9}, {
  3.5989659602618227`*^9, 3.598965997191874*^9}, {3.5989660287019176`*^9, 
  3.598966135662068*^9}, {3.598966189972144*^9, 3.5989662082121696`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointSize[0.03], 
    PointBox[{{10., 2.773722351219058}, {11., 2.6975936327233256`}, {12., 
     2.6032601327663647`}, {13., 2.5383340164572847`}, {14., 
     2.462343648899685}, {15., 2.4062352219860363`}, {16., 
     2.343232951402071}, {17., 2.2941503127401237`}, {18., 
     2.240757925359372}, {19., 2.1973578894825416`}, {20., 
     2.151320978234062}}]}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7cRzk42BQcXh0yXfJIGIz/bbjvrfsjdC8LXrj62t
T0Hw63zvpBVfRPC/C889qWeuCueHzzPyez0LwVds+fBEml0NzhdMilQVyUHw
s2e/Km+4ieCvnRHw5q2LOpwv2pfIpbwSwX9+b5bVGVENOP++er2IbTWCv8/E
QmD9PQSffa6k3FQvTTi/7O/Sq07rEfyAnVHzU2S0EO6zfNLV3o7g/9ggoVD0
GsH3bCk9fiFcG84/4F8r8X0Pgr+wbG31RC0dOD8rcROD7jQEP9IlSX/CLwR/
U5NVQXq6LpxvuHNvFNtZBH/6ZtH0ZQZ6cH4657TWXXMQ/Njwg77TGPXh/L0M
ohrP8hB81jxbFfNbCP6uTI6n6vIGcL6aF5tjXiiCv3TZzUKJDgRfInW68eGd
CL5DYOa/5e8R/OqdAvM+KBoi4tP/jFtxBIKflxh7JLIbwU+5euOSw14En788
41XiZwT/7JSz156pGiHse+B2ZmkMgr+8d1VQ6iQEX3H747UdRxD8AD5DoWe/
EPxJD4O9l+saw/knxBJFM+MR/M2VTS9SpiL4GyMqJxw5juB7ZLa5PXqM4N+v
nPzn/38EHwA9tIDC
      "]]}}, 
   StyleBox[InsetBox["\<\"Cena opcji z symulacji MC\"\>", {16, 1.3}], "Label",
    StripOnInput->False]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["\"Ilo\:015b\[CAcute] okres\[OAcute]w\"", TraditionalForm], 
    FormBox["\"Cena opcji\"", TraditionalForm]},
  AxesOrigin->{10, 1},
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.598965740231514*^9, 3.5989657910615854`*^9, 3.598965822021629*^9, 
   3.5989658689916945`*^9, {3.598965919861766*^9, 3.598965923431771*^9}, 
   3.5989659920918665`*^9, {3.598966056751957*^9, 3.5989660890620027`*^9}, {
   3.59896613007206*^9, 3.598966135892068*^9}, {3.598966197162154*^9, 
   3.5989662087921705`*^9}, 3.5998460628493567`*^9}]
}, {2}]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["\:0179r\[OAcute]d\[LSlash]a", "Section",
 CellChangeTimes->{{3.5997593094640694`*^9, 3.599759313367293*^9}}],

Cell[CellGroupData[{

Cell["\<\
W.Walu\:015b, M.Bary\[LSlash]o, 2011, In\:017cynieria Finansowa, UW\
\>", "Item",
 CellChangeTimes->{{3.5997593301552534`*^9, 3.599759330158253*^9}, {
  3.5997593699775305`*^9, 3.599759398827181*^9}}],

Cell["\<\
J.Jakubowski, 2011, Modele matematyczne rynk\[OAcute]w instrument\[OAcute]w \
pochodnych I, UW\
\>", "Item",
 CellChangeTimes->{{3.5997593301552534`*^9, 3.599759330567277*^9}, {
  3.599759420653429*^9, 3.59975947626361*^9}}],

Cell["\<\
J.Palczewski, A.Palczewski, notatki do wyk\[LSlash]adu Computational Finance \
(wyk\[LSlash]ad 1 i 2)\
\>", "Item",
 CellChangeTimes->{{3.5997593301552534`*^9, 3.599759330937298*^9}, {
  3.599759508284442*^9, 3.599759562551545*^9}}],

Cell["\<\
http://demonstrations.wolfram.com/AmericanCallAndPutOption/\
\>", "Item",
 CellChangeTimes->{{3.5997593301552534`*^9, 3.599759331255316*^9}, {
  3.599759636739789*^9, 3.5997596436091814`*^9}}],

Cell["\<\
http://demonstrations.wolfram.com/BinomialTree/\
\>", "Item",
 CellChangeTimes->{{3.5997593301552534`*^9, 3.599759331255316*^9}, {
  3.599759636739789*^9, 3.5997596443282228`*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
ScreenStyleEnvironment->"SlideShow",
WindowSize->{1350, 631},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
TaggingRules->{"SlideShow" -> True},
Magnification->0.75,
TooltipBoxOptions->{TooltipDelay->Automatic},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->FrontEnd`FileName[{"SlideShow"}, "Earth.nb", 
  CharacterEncoding -> "WindowsEastEurope"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "SlideShowHeader"->{
  Cell[579, 22, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[1288, 41, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[3110, 102, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[26178, 740, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[27356, 781, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[620084, 10830, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[629497, 11114, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[640688, 11428, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[646315, 11592, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[662960, 12014, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[718841, 13388, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[744767, 14038, 64, 1, 1, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"SlideShowHeader", 746643, 14098}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[646, 25, 248, 4, 270, "Title"],
Cell[897, 31, 354, 5, 169, "Subtitle"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1288, 41, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[1377, 46, 92, 1, 83, "Section"],
Cell[CellGroupData[{
Cell[1494, 51, 209, 4, 44, "Item"],
Cell[1706, 57, 263, 5, 44, "Item"],
Cell[1972, 64, 250, 5, 69, "Item"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2271, 75, 97, 1, 83, "Section"],
Cell[CellGroupData[{
Cell[2393, 80, 142, 2, 44, "Item"],
Cell[2538, 84, 90, 1, 44, "Item"],
Cell[2631, 87, 142, 2, 44, "Item"]
}, Open  ]],
Cell[2788, 92, 273, 4, 39, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3110, 102, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[3199, 107, 98, 1, 83, "Section"],
Cell[3300, 110, 1208, 20, 246, "Text"],
Cell[4511, 132, 2435, 82, 220, "Text"],
Cell[CellGroupData[{
Cell[6971, 218, 5050, 114, 154, "Input"],
Cell[12024, 334, 3365, 67, 340, "Output"]
}, {2}]],
Cell[15401, 404, 544, 20, 77, "Text"],
Cell[15948, 426, 827, 14, 105, "Text"],
Cell[CellGroupData[{
Cell[16800, 444, 2644, 71, 90, "Input"],
Cell[19447, 517, 1466, 33, 81, "Output"]
}, {2}]],
Cell[20925, 553, 729, 15, 105, "Text"],
Cell[21657, 570, 322, 8, 77, "Text"],
Cell[CellGroupData[{
Cell[22004, 582, 603, 20, 44, "ItemNumbered"],
Cell[22610, 604, 925, 29, 84, "ItemNumbered"],
Cell[23538, 635, 1690, 66, 92, "ItemNumbered"]
}, Open  ]],
Cell[25243, 704, 886, 30, 105, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26178, 740, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[26267, 745, 142, 3, 83, "Section"],
Cell[26412, 750, 425, 8, 48, "Text"],
Cell[26840, 760, 192, 6, 33, "Input"],
Cell[27035, 768, 272, 7, 33, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27356, 781, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[27445, 786, 119, 1, 83, "Section"],
Cell[27567, 789, 690, 11, 105, "Text"],
Cell[CellGroupData[{
Cell[28282, 804, 355, 7, 48, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[28640, 813, 591, 22, 45, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[29234, 837, 970, 28, 105, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[30219, 868, 380, 8, 77, "Text"],
Cell[CellGroupData[{
Cell[30624, 880, 212, 4, 33, "Input"],
Cell[30839, 886, 179, 3, 33, "Output"]
}, Open  ]],
Cell[31033, 892, 601, 12, 105, "Text"],
Cell[CellGroupData[{
Cell[31659, 908, 495, 8, 33, "Input"],
Cell[32157, 918, 575049, 9584, 319, "Output"]
}, Open  ]],
Cell[607221, 10505, 337, 9, 33, "Input"],
Cell[CellGroupData[{
Cell[607583, 10518, 673, 18, 51, "Input"],
Cell[608259, 10538, 342, 4, 33, "Output"]
}, Open  ]],
Cell[608616, 10545, 987, 26, 133, "Text"],
Cell[CellGroupData[{
Cell[609628, 10575, 973, 29, 99, "Input"],
Cell[610604, 10606, 198, 4, 33, "Output"]
}, Open  ]],
Cell[610817, 10613, 571, 14, 81, "Text"],
Cell[611391, 10629, 225, 5, 33, "Input"],
Cell[611619, 10636, 948, 26, 78, "Input"],
Cell[CellGroupData[{
Cell[612592, 10666, 1646, 43, 100, "Input"],
Cell[614241, 10711, 5084, 91, 159, "Output"]
}, Open  ]],
Cell[619340, 10805, 285, 5, 48, "Text"],
Cell[CellGroupData[{
Cell[619650, 10814, 183, 4, 33, "Input"],
Cell[619836, 10820, 187, 3, 33, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[620084, 10830, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[620173, 10835, 123, 1, 83, "Section"],
Cell[CellGroupData[{
Cell[620321, 10840, 406, 7, 69, "Item"],
Cell[620730, 10849, 542, 9, 69, "Item"],
Cell[621275, 10860, 370, 5, 44, "Item"]
}, Open  ]],
Cell[621660, 10868, 1562, 53, 140, "DisplayFormula"],
Cell[CellGroupData[{
Cell[623247, 10925, 535, 13, 146, "Item"],
Cell[623785, 10940, 1789, 56, 266, "Item"],
Cell[625577, 10998, 116, 1, 44, "Item"]
}, Open  ]],
Cell[625708, 11002, 1924, 52, 82, "Input"],
Cell[627635, 11056, 1813, 52, 82, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[629497, 11114, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[629586, 11119, 110, 1, 83, "Section"],
Cell[CellGroupData[{
Cell[629721, 11124, 782, 12, 93, "Item"],
Cell[630506, 11138, 1553, 37, 190, "Item"],
Cell[632062, 11177, 511, 7, 44, "Item"]
}, Open  ]],
Cell[632588, 11187, 4037, 116, 150, "Input"],
Cell[636628, 11305, 4011, 117, 150, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[640688, 11428, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[640777, 11433, 104, 1, 83, "Section"],
Cell[CellGroupData[{
Cell[640906, 11438, 505, 8, 44, "Item"],
Cell[641414, 11448, 535, 8, 44, "Item"]
}, Open  ]],
Cell[641964, 11459, 67, 4, 77, "Text"],
Cell[642034, 11465, 115, 1, 48, "Text"],
Cell[CellGroupData[{
Cell[642174, 11470, 563, 13, 50, "Item"],
Cell[642740, 11485, 833, 22, 55, "Item"],
Cell[643576, 11509, 545, 13, 50, "Item"],
Cell[644124, 11524, 601, 14, 50, "Item"],
Cell[644728, 11540, 1439, 42, 55, "Item"]
}, Open  ]],
Cell[646182, 11585, 84, 1, 48, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[646315, 11592, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[646404, 11597, 118, 1, 83, "Section"],
Cell[CellGroupData[{
Cell[646547, 11602, 949, 14, 117, "Item"],
Cell[647499, 11618, 3016, 81, 266, "Item"],
Cell[650518, 11701, 511, 7, 44, "Item"]
}, Open  ]],
Cell[651044, 11711, 6905, 160, 172, "Input"],
Cell[657952, 11873, 4959, 135, 172, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[662960, 12014, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[663049, 12019, 116, 1, 67, "Section"],
Cell[663168, 12022, 2698, 68, 223, "Input"],
Cell[665869, 12092, 82, 1, 36, "Text"],
Cell[CellGroupData[{
Cell[665976, 12097, 126, 2, 24, "Input"],
Cell[666105, 12101, 706, 22, 24, "Output"]
}, Open  ]],
Cell[666826, 12126, 84, 1, 36, "Text"],
Cell[666913, 12129, 869, 21, 43, "Input"],
Cell[667785, 12152, 3243, 98, 130, "Input"],
Cell[671031, 12252, 8621, 236, 298, "Input"],
Cell[679655, 12490, 9009, 257, 265, "Input"],
Cell[688667, 12749, 798, 19, 108, "Input"],
Cell[CellGroupData[{
Cell[689490, 12772, 17493, 382, 1086, "Input"],
Cell[706986, 13156, 9699, 173, 363, "Output"],
Cell[716688, 13331, 514, 11, 27, "Message"],
Cell[717205, 13344, 512, 11, 27, "Message"],
Cell[717720, 13357, 527, 11, 27, "Message"],
Cell[718250, 13370, 530, 11, 27, "Message"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[718841, 13388, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[718930, 13393, 137, 3, 67, "Section"],
Cell[719070, 13398, 652, 12, 57, "Text"],
Cell[719725, 13412, 826, 22, 24, "Input"],
Cell[720554, 13436, 1649, 38, 58, "Input"],
Cell[722206, 13476, 411, 7, 57, "Text"],
Cell[CellGroupData[{
Cell[722642, 13487, 5276, 136, 174, "Input"],
Cell[727921, 13625, 902, 16, 133, "Output"]
}, {2}]],
Cell[728835, 13644, 1751, 42, 78, "Input"],
Cell[730589, 13688, 2969, 89, 174, "Input"],
Cell[733561, 13779, 1508, 35, 59, "Input"],
Cell[735072, 13816, 845, 13, 120, "Text"],
Cell[735920, 13831, 1715, 37, 97, "Input"],
Cell[CellGroupData[{
Cell[737660, 13872, 1630, 35, 54, "Input"],
Cell[739293, 13909, 979, 18, 121, "Output"]
}, {2}]],
Cell[740284, 13930, 496, 8, 57, "Text"],
Cell[CellGroupData[{
Cell[740805, 13942, 2035, 51, 90, "Input"],
Cell[742843, 13995, 1866, 36, 124, "Output"]
}, {2}]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[744767, 14038, 64, 1, 1, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[744856, 14043, 114, 1, 67, "Section"],
Cell[CellGroupData[{
Cell[744995, 14048, 210, 4, 33, "Item"],
Cell[745208, 14054, 234, 5, 33, "Item"],
Cell[745445, 14061, 242, 5, 33, "Item"],
Cell[745690, 14068, 202, 4, 33, "Item"],
Cell[745895, 14074, 190, 4, 33, "Item"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
