(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     79170,       1721]
NotebookOptionsPosition[     77315,       1659]
NotebookOutlinePosition[     77738,       1675]
CellTagsIndexPosition[     77695,       1672]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Problem sterowania czasooptymalnego dla zlinearyzowanego r\[OAcute]wnania \
wahad\[LSlash]a matematycznego\
\>", "Title",
 CellChangeTimes->{
  3.6000190600187006`*^9, {3.6045999901683216`*^9, 3.6046000151887527`*^9}}],

Cell[CellGroupData[{

Cell["Autor:", "Section",
 CellChangeTimes->{{3.6000190762646294`*^9, 3.600019078279745*^9}, {
  3.60459103141191*^9, 3.6045910386353235`*^9}}],

Cell["\[CapitalLSlash]ukasz Skonieczny", "Subsection",
 CellChangeTimes->{{3.600019087752287*^9, 3.600019097023817*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["E-mail:", "Section",
 CellChangeTimes->{{3.600019277929164*^9, 3.6000192811853504`*^9}}],

Cell["ls292442@students.mimuw.edu.pl", "Subsection",
 CellChangeTimes->{{3.600019288736782*^9, 3.600019296192209*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Wst\:0119p:", "Section",
 CellChangeTimes->{{3.600019323591776*^9, 3.6000193278150177`*^9}, {
  3.6045910484348836`*^9, 3.6045910505150023`*^9}}],

Cell["\<\
Wyobra\:017amy sobie wahad\[LSlash]o kt\[OAcute]ry puszczamy w ruch z \
wybranego przez siebie po\[LSlash]o\:017cenia pocz\:0105tkowego oraz z wybran\
\:0105 pr\:0119dko\:015bci\:0105 pocz\:0105tkow\:0105 (za\[LSlash]\[OAcute]\
\:017cmy, \:017ce wahad\[LSlash]o porusza si\:0119 tylko w jednej \
p\[LSlash]aszczy\:017anie). Nastepnie mo\:017cemy \
\[OpenCurlyDoubleQuote]popycha\[CAcute]\[CloseCurlyDoubleQuote] \
wahad\[LSlash]o z dowoln\:0105 (ale ograniczon\:0105) si\[LSlash]\:0105,  mo\
\:017cemy r\[OAcute]wnie\:017c dowolnie wybiera\[CAcute] stron\:0119 w kt\
\[OAcute]r\:0105 pchamy. Naszym celem jest zatrzymanie wahad\[LSlash]a w \
punkcie po\[LSlash]o\:017cenia tj. chcemy, \:017ceby wisia\[LSlash]o \
swobodnie. Co wi\:0119cej chcemy tego dokona\[CAcute] w mo\:017cliwie najkr\
\[OAcute]tszym czasie\
\>", "Text",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, {
   3.6045887630041647`*^9, 3.6045888458979053`*^9}, {3.604588928390624*^9, 
   3.6045890967162514`*^9}, {3.6045894700126033`*^9, 3.6045895932096496`*^9}},
 FontSize->14],

Cell["\<\
Takie zagadnienie pomimo prostoty postawienia okazuje si\:0119 nie \
by\[CAcute] \[LSlash]atwym do rozwi\:0105zania. W zwi\:0105zku z tym \
poczynimy pewne uproszczenia - zamiast rozwa\:017ca\[CAcute] r\[OAcute]wnanie \
wahad\[LSlash]a matematycznego b\:0119dziemy rozwa\:017ca\[CAcute] jego \
zlinearyzowan\:0105 wersj\:0119, tzw. oscylator harmoniczny. Za\[LSlash]o\
\:017cymy r\[OAcute]wnie\:017c, \:017ce cz\:0119\:015bto\:015b\[CAcute] drga\
\:0144 tego oscylatora jest r\[OAcute]wna 1. Co takie za\[LSlash]o\:017cenia \
znacz\:0105 dla nieformalnego postawienia problemu? Aby zachowa\[CAcute] stoj\
\:0105c\:0105 za zagadnieniem intuicj\:0119 w postaci wahad\[LSlash]a powinni\
\:015bmy rozwa\:017ca\[CAcute] tylko ma\[LSlash]e wychylenia (a co za tym \
idzie ma\[LSlash]e pr\:0119dko\:015bci). Takie uproszczenia pozwalaj\:0105 \
nam jednak skorzysta\[CAcute] z pot\:0119\:017cnych narz\:0119dzi jakie \
oferuje nam teoria sterowania w przypadku gdy rozwa\:017cany uk\[LSlash]ad \
jest uk\[LSlash]adem liniowym. Jak si\:0119 p\[OAcute]\:017aniej oka\:017ce, \
mimo uproszcze\:0144 rozwi\:0105zania zagadnienia posiadaj\:0105 pewn\:0105 \
zaskakuj\:0105c\:0105 w\[LSlash]asno\:015b\[CAcute] - wspomnimy o niej na \
samym ko\:0144cu. \
\>", "Text",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, {
   3.6045887630041647`*^9, 3.6045888458979053`*^9}, {3.604588928390624*^9, 
   3.604589247275863*^9}, {3.604589291090369*^9, 3.604589457284875*^9}, {
   3.604591053634181*^9, 3.6045910553922815`*^9}, {3.6045987352055416`*^9, 
   3.6045987764899035`*^9}},
 FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Formalne postawienie problemu i jego kr\[OAcute]tka analiza\
\>", "Section",
 CellChangeTimes->{{3.6045910697071004`*^9, 3.60459108928122*^9}}],

Cell["\<\
Od strony formalnej problem mo\:017cemy sformu\[LSlash]owa\[CAcute] w nast\
\:0119puj\:0105cy spos\[OAcute]b:\
\>", "Text",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, 
   3.6045887630041647`*^9, {3.6045896062403946`*^9, 3.60458966489275*^9}, {
   3.604590694799657*^9, 3.604590707079359*^9}, {3.604591098129726*^9, 
   3.6045911033370237`*^9}},
 FontSize->14],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"\t", 
          RowBox[{
           RowBox[{"Znale\:017a\[CAcute]", " ", "funkcj\:0119", " ", 
            RowBox[{"u", " ", ":", " ", 
             RowBox[{"\[DoubleStruckCapitalR]", "\[RightArrow]", 
              RowBox[{
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "1"}], "]"}], 
               StyleBox[
                RowBox[{" ", 
                 StyleBox[" ", "Equation"]}]], 
               FormBox[
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"zwan\:0105", " ", "dalej", " ", "sterowaniem"}], 
                   ")"}], " ", "tak\:0105"}], ",", " ", 
                 RowBox[{
                 "\:017ce", " ", "dla", " ", "zadanego", " ", "wychylenia", 
                  " ", "pocz\:0105tkowego", " ", 
                  SubscriptBox["x", "0"]}]}],
                TraditionalForm], " ", "i", " ", "pocz\:0105tkowej", " ", 
               "pr\:0119dko\:015bci", " ", 
               FormBox[
                SubscriptBox["v", 
                 RowBox[{"0", " "}]],
                TraditionalForm], "rozwi\:0105zanie"}]}]}]}], " ", "\n", "\t", 
           RowBox[{"r\[OAcute]wnania", " ", "x"}]}], "\[CloseCurlyQuote]"}], 
         "\[CloseCurlyQuote]"}], 
        RowBox[{"(", "t", ")"}]}], " ", "=", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"x", "(", "t", ")"}]}], " ", "+", " ", 
        RowBox[{
         RowBox[{"u", "(", "t", ")"}], " ", "znajdzie", " ", "si\:0119", " ", 
         "w", " ", "po\[LSlash]o\:017ceniu", " ", "r\[OAcute]wnowagi", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"x", "=", "0"}], ",", " ", "x"}]}]}]}]}], 
      "\[CloseCurlyQuote]"}], "=", "0"}], ")"}], " ", "najszybciej", " ", 
   "jak", " ", "to", " ", "jest", " ", 
   RowBox[{"mo\:017cliwe", ".", "\t"}]}], TraditionalForm]], "Equation",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, 
   3.6045887630041647`*^9, {3.6045896062403946`*^9, 3.6045897842475767`*^9}, {
   3.6045905126032357`*^9, 3.6045905172174997`*^9}, 3.604590686034156*^9, {
   3.6045911093553677`*^9, 3.604591115352711*^9}, 3.6045926615831504`*^9},
 TextAlignment->Left,
 LineSpacing->{1, 3},
 FontSize->14],

Cell["\<\
Zauwa\:017cmy, \:017ce w istocie jest to pewne zagadnienie minimalizacyjne. \
Jednak\:017ce ograniczenia s\:0105 bardzo silne - funkcja x(t) musi by\
\[CAcute] rozwi\:0105zaniem r\[OAcute]wnania r\[OAcute]\:017cniczkowego. \
Warto r\[OAcute]wnie\:017c zwr\[OAcute]ci\[CAcute] uwag\:0119 na to, \:017ce \
pomimo tego, \:017ce poszukujemy sterowania o dziedzinie \
\[DoubleStruckCapitalR], to w rzeczywisto\:015bci interesuje nas ona do \
chwili osi\:0105gni\:0119cia punktu r\[OAcute]wnowagi (zale\:017cy ona od \
postaci sterowania - st\:0105d taka definicja dziedziny). Zapiszmy nasze r\
\[OAcute]wnanie w innej formie, niech\
\>", "Text",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, 
   3.6045887630041647`*^9, {3.6045896062403946`*^9, 3.6045899214224224`*^9}, {
   3.6045900287835627`*^9, 3.6045900606023827`*^9}, {3.604590150859545*^9, 
   3.604590188997727*^9}, {3.604592272535898*^9, 3.6045924026113377`*^9}, {
   3.604592455010335*^9, 3.604592479376729*^9}},
 FontSize->14],

Cell[BoxData[
 FormBox[
  RowBox[{"\t ", 
   RowBox[{
    RowBox[{
     StyleBox["A", "DisplayFormula"], 
     StyleBox["=", "DisplayFormula"], 
     FormBox[
      RowBox[{"(", GridBox[{
         {"0", "1"},
         {
          RowBox[{"-", "1"}], "0"}
        }], ")"}],
      TraditionalForm]}], ",", "  ", 
    RowBox[{"b", "=", 
     FormBox[
      RowBox[{"(", GridBox[{
         {"0"},
         {"1"}
        }], ")"}],
      TraditionalForm]}], ","}]}], TraditionalForm]], "Equation",
 CellChangeTimes->{{3.604590209352891*^9, 3.604590294725774*^9}},
 FontSize->14],

Cell[BoxData[
 FormBox[
  RowBox[{
  "w\[OAcute]wczas", " ", "nasze", " ", "r\[OAcute]wnanie", " ", 
   "mo\:017cemy", " ", "zapisa\[CAcute]", " ", 
   RowBox[{"jako", ":"}]}], TraditionalForm]], "Equation",
 CellChangeTimes->{{3.604590209352891*^9, 3.6045903029652452`*^9}},
 FontSize->14],

Cell[BoxData[
 FormBox[
  RowBox[{"\t", 
   RowBox[{
    RowBox[{
     RowBox[{"(", GridBox[{
        {
         RowBox[{"x", "'"}]},
        {
         RowBox[{"x", "''"}]}
       }], ")"}], "=", 
     RowBox[{
      RowBox[{"A", " ", 
       RowBox[{"(", GridBox[{
          {"x"},
          {
           RowBox[{"x", "'"}]}
         }], ")"}]}], "+", 
      RowBox[{"b", " ", "u"}]}]}], ","}]}], 
  TraditionalForm]], "EquationNumbered",
 CellChangeTimes->{{3.604590209352891*^9, 3.60459037805054*^9}, {
   3.604590465778558*^9, 3.604590466223583*^9}, 3.6045906674800944`*^9, 
   3.6045911291364994`*^9},
 FontSize->14],

Cell["\<\
zauwa\:017cmy, \:017ce u jest tutaj skalarem, pierwsze mno\:017cenie jest wi\
\:0119c mno\:017ceniem macierzy przez wektor a drugie mno\:017ceniem wektora \
przez skalar. Przyjmuj\:0105c za funkcjona\[LSlash] kosztu \
\>", "Text",
 CellChangeTimes->{{3.604590209352891*^9, 3.60459037805054*^9}, {
   3.604590465778558*^9, 3.604590466223583*^9}, 3.6045906674800944`*^9, {
   3.6045911291364994`*^9, 3.6045912044218054`*^9}},
 FontSize->14],

Cell[BoxData[
 FormBox[
  RowBox[{"\t", 
   RowBox[{
    RowBox[{
     RowBox[{"J", "(", "u", ")"}], "=", " ", "T"}], ",", " ", 
    RowBox[{
    "gdzie", " ", "T", " ", "jest", " ", "chwil\:0105", " ", 
     "osi\:0105gni\:0119cia", " ", "przez", " ", "uk\[LSlash]ad", " ", 
     RowBox[{"(", "1", ")"}], " ", "po\[LSlash]o\:017cenia", " ", 
     "r\[OAcute]wnowagi", " ", "przy", " ", "sterowaniu", " ", "u"}], ","}]}],
   TraditionalForm]], "Equation",
 CellChangeTimes->{{3.604590209352891*^9, 3.6045904033779883`*^9}, {
  3.6045904372599263`*^9, 3.604590528709157*^9}},
 FontSize->14],

Cell["\<\
otrzymujemy ju\:017c pe\[LSlash]ne sformu\[LSlash]owanie zagadnienia w \
j\:0119zyku teorii sterowania. Teraz mo\:017cemy zastosowa\[CAcute] kilka \
podstawowych twierdze\:0144 aby pokaza\[CAcute]\:017ce poszukiwane \
rozwi\:0105zania istniej\:0105 oraz dzi\:0119ki twierdzeniu 
bang - bang mo\:017cemy ograniczy\[CAcute] nasze poszukiwania do \
sterowa\:0144 przyjmuj\:0105cych tylko warto\:015bci ekstremalne(w naszym \
przypadku - 1 lub 1). Zauwa\:017cmy wi\:0119c \:017ce wystarczy znale\:017a\
\[CAcute] jedynie pocz\:0105tkow\:0105 warto\:015b\[CAcute] sterowania oraz \
chwilekt\[OAcute]rych sterowanie zmienia swoj\:0105 warto\:015b\[CAcute]. Dzi\
\:0119ki Zasadzie Maksimum Pontriagina oraz prostej analizie r\[OAcute]wnanie \
(przy pomocy \[OpenCurlyDoubleQuote]odwracania czasu\[CloseCurlyDoubleQuote]) \
mo\:017cemy obliczy\[CAcute] jaka jest warto\:015b\[CAcute] pierwszego \
sterowania oraz ile b\:0119dzie prze\[LSlash]\:0105cze\:0144 (traktuj\:0105c \
warto\:015bci pocz\:0105tkowe r\[OAcute]wnanie jako parametry). Wiemy \
ju\:017c wi\:0119c, \:017ce nasze zagadnienie jest dobrze postawione - mo\
\:017cemy wi\:0119c przej\:015b\[CAcute] do numerycznej strony zagadnienia.\
\>", "Text",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, 
   3.6045887630041647`*^9, {3.6045896062403946`*^9, 3.6045896591484213`*^9}, {
   3.6045897882238035`*^9, 3.6045897944561605`*^9}, {3.604591004165352*^9, 
   3.6045910069965134`*^9}},
 FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["Numeryczne podej\:015bcie", "Section",
 CellChangeTimes->{{3.604591223893919*^9, 3.6045912270280986`*^9}, {
  3.6045947851826134`*^9, 3.6045947879347706`*^9}, {3.6045958517926197`*^9, 
  3.6045958537527323`*^9}}],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Oznaczmy", " ", "przez", "  ", 
      SubscriptBox["t", "i"], "  ", "moment", " ", "i"}], "-", 
     RowBox[{
     "tego", " ", "prze\[LSlash]\:0105czenia", " ", "sterowania", " ", 
      "gdzie", " ", "i"}]}], " ", "=", " ", "1"}], ",", 
   RowBox[{"...", "r"}], ",", "  ", 
   RowBox[{"a", " ", "przez", " ", 
    SubscriptBox["t", "r"], " ", "rozumiemy", " ", "chwil\:0119", " ", 
    "wy\[LSlash]\:0105czenia", " ", "uk\[LSlash]adu", " ", 
    RowBox[{"tj", ".", " ", "chwil\:0119"}], " ", "osi\:0105gni\:0119cia", 
    " ", "przez", " ", "uk\[LSlash]ad", " ", "po\[LSlash]o\:017cenia", " ", 
    "r\[OAcute]wnowagi", " ", "oraz", " ", "jako", " ", 
    SubscriptBox["u", "0"], "pierwsz\:0105", " ", "warto\:015b\[CAcute]", " ", 
    RowBox[{"sterowania", ".", " ", "Przy"}], " ", "pomocy", " ", "tych", " ",
     "oznacze\:0144", " ", "mo\:017cemy", " ", "zapisa\[CAcute]", " ", "nasz",
     " ", "problem", " ", "jako", " ", "problem", " ", "minimalizacyjny", " ",
     "nastepuj\:0105cej", " ", "postaci"}]}], TraditionalForm]], "Text",
 CellChangeTimes->{{3.604595290759531*^9, 3.6045953286126957`*^9}, {
  3.6045954947511983`*^9, 3.6045956160071335`*^9}, {3.6045956529242454`*^9, 
  3.6045956605876837`*^9}},
 TextAlignment->Left,
 TextJustification->1,
 LineSpacing->{1, 3},
 FontSize->14],

Cell[BoxData[
 FormBox[
  RowBox[{"\t", 
   RowBox[{
    RowBox[{"min", " ", 
     FormBox[
      RowBox[{"g", "(", 
       RowBox[{
        SubscriptBox["t", "1"], ",", "...", ",", 
        SubscriptBox["t", "r"]}], ")"}],
      TraditionalForm]}], ",", " ", "\n", "\t", 
    RowBox[{
     RowBox[{"gdzie", " ", 
      FormBox[
       RowBox[{"g", "(", 
        RowBox[{
         SubscriptBox["t", "1"], ",", "...", ",", 
         SubscriptBox["t", "r"]}], ")"}],
       TraditionalForm]}], " ", "=", " ", 
     FormBox[
      SubscriptBox["t", "r"],
      TraditionalForm]}], ",", 
    RowBox[{"z", " ", "ograniczeniem", " ", 
     FormBox[
      RowBox[{
       RowBox[{"f", "(", 
        RowBox[{
         SubscriptBox["t", "1"], ",", "...", ",", 
         SubscriptBox["t", "r"]}], ")"}], "="}],
      TraditionalForm], " ", 
     RowBox[{
      FormBox[
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["u", "0"], "(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"-", "b"}], "+", 
             RowBox[{"2", 
              SuperscriptBox["e", 
               RowBox[{
                RowBox[{"-", "A"}], " ", 
                SubscriptBox["t", "1"]}]], "b"}], "-", 
             RowBox[{"2", 
              SuperscriptBox["e", 
               RowBox[{
                RowBox[{"-", "A"}], " ", 
                SubscriptBox["t", "2"]}]], "b"}], "+"}], "..."}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"r", "+", "1"}]], 
            SuperscriptBox["e", 
             RowBox[{
              RowBox[{"-", "A"}], " ", 
              SubscriptBox["t", "r"]}]], "b"}]}], ")"}], "-", 
         RowBox[{"A", " ", 
          SubscriptBox["x", "0"]}]}], "=", "0"}],
       TraditionalForm], "."}]}]}]}], TraditionalForm]], "EquationNumbered",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, 
   3.6045887630041647`*^9, {3.6045896062403946`*^9, 3.6045896591484213`*^9}, {
   3.6045897882238035`*^9, 3.6045897944561605`*^9}, {3.604591004165352*^9, 
   3.6045910069725122`*^9}, {3.6045912292942286`*^9, 
   3.6045912354845824`*^9}, {3.604594244393682*^9, 3.6045942444016824`*^9}, {
   3.60459527291751*^9, 3.6045952825730624`*^9}, {3.6045954595821867`*^9, 
   3.6045954731339617`*^9}, 3.6045957854878273`*^9, {3.6046003895391645`*^9, 
   3.604600401250834*^9}},
 FontSize->14],

Cell["\<\
Ograniczenia r\[OAcute]wno\:015bciowe pochodz\:0105 z og\[OAcute]lnej postaci \
rozwi\:0105za\:0144 dla liniowych uk\[LSlash]ad\[OAcute]w ze sterowaniem \
(podobnego do twierdzenia o postaci rozwi\:0105za\:0144 liniowych \
r\[OAcute]wna\:0144 r\[OAcute]\:017cniczkowych zwyczajnych. Rozwi\:0105zanie \
(2) daje nam ju\:017c pe\[LSlash]ne rozwi\:0105zanie zagadnienia - szczego\
\[LSlash]y w [2] z bibliografii. Jednak na potrzeby wizualizacji generujemy \
rozwi\:0105zanie w jawnej postaci - w tym celu dla ka\:017cdego ze sterowa\
\:0144 rozwi\:0105zujemy r\[OAcute]wnanie r\[OAcute]\:017cniczkowe zwyczajne \
(ze wzgl\:0119du na fakt, \:017ce prawa strona r\[OAcute]wnania jest tylko \
kawa\[LSlash]kami ci\:0105g\[LSlash]a). Warto zwr\[OAcute]ci\[CAcute] uwag\
\:0119 na fakt, \:017ce samo zagadnienie minimalizacji mo\:017ce by\[CAcute] \
zagadnieniem wielowymiarowym i w og\[OAcute]lno\:015bci jest trudne do rozwi\
\:0105zania. Poniewa\:017c szukamy rozwi\:0105za\:0144 na poziomicy pewnej \
funkcji, to mo\:017ce istnie\[CAcute] wiele punkt\[OAcute]w w kt\[OAcute]rych \
funkcja celu osi\:0105ga lokalne minimum. W zwi\:0105zku z tym zdecydowali\
\:015bmy si\:0119 na randomizacj\:0119 poszukiwa\:0144 globalnego minimum \
oraz danie u\:017cytkownikowu mo\:017cliwo\:015bci wyboru algorytmu poszukuj\
\:0105cego minimum (zdecydowali\:015bmy si\:0119 na symulowane \
wyrza\:017canie oraz algorytm typu Nelder-Mead ze wzgl\:0119du na to, \:017ce \
w przeprowadzanych testach dawa\[LSlash]y one najlepsze wyniki spo\:015br\
\[OAcute]d standardowych algorytm\[OAcute]w dost\:0119pnych w programie). W \
zwi\:0105zku z tym, je\:015bli u\:017cytkownik otrzyma wynik co do \
kt\[OAcute]rego ma podejrzenie, \:017ce nie jest poprawny (np. jest to \
lokalne minimum), powinien on uruchomia\[CAcute] procedur\:0119 (poprzez wci\
\:015bni\:0119cie przycisku \
\[OpenCurlyDoubleQuote]Go!\[CloseCurlyDoubleQuote]) a\:017c do uzyskania \
satysfakcjonuj\:0105cego wyniku. Nale\:017cy r\[OAcute]wnie\:017c z \
pewn\:0105 ostro\:017cno\:015bci\:0105 dobiera\[CAcute] warto\:015bci pocz\
\:0105tkowe dla uk\[LSlash]adu - jak ju\:017c wspomnieli\:015bmy wy\:017cej \
zadanie mo\:017ce by\[CAcute] wielowymiarowe, wynika to w\[LSlash]a\:015bnie \
z jakich warunk\[OAcute]w pocz\:0105tkowych startowa\[LSlash]o \
r\[OAcute]wnanie. U\:017cytkownik powinien wi\:0119c dobiera\[CAcute] \
stosunkowo niedu\:017ce warto\:015bci warunk\[OAcute]w pocz\:0105tkowych (rz\
\:0119du kilku, kilkunastu). Oczywi\:015bcie, w przypadku wprowadzania \
zdecydowanie wi\:0119kszych warto\:015bci procedura zbiegnie, zbie\:017cno\
\:015b\[CAcute] mo\:017ce by\[CAcute] jednak wolna a uzyskane \
rozwi\:0105zania w procedurze minimalizacyjnej zazwyczaj b\:0119d\:0105 \
jedynie punktami w kt\[OAcute]rych znajduje si\:0119 lokalne minimum.
\
\>", "Text",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, 
   3.6045887630041647`*^9, {3.6045896062403946`*^9, 3.6045896591484213`*^9}, {
   3.6045897882238035`*^9, 3.6045897944561605`*^9}, {3.604591004165352*^9, 
   3.6045910069725122`*^9}, {3.6045912292942286`*^9, 
   3.6045912354845824`*^9}, {3.604594244393682*^9, 3.6045942454977455`*^9}, {
   3.6045953619136004`*^9, 3.6045953760274076`*^9}, {3.6045957944603405`*^9, 
   3.60459584305912*^9}, {3.604599453610632*^9, 3.6045995450468616`*^9}},
 FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Kilka s\[LSlash]\[OAcute]w o uruchamianiu programu, wizualizacji oraz \
interpretacja wynik\[OAcute]w\
\>", "Section",
 CellChangeTimes->{{3.604595860953144*^9, 3.604595900503406*^9}, {
  3.6045974289058256`*^9, 3.6045974326730413`*^9}}],

Cell["\<\
Aby uruchomi\[CAcute] program mo\:017cemy albo zaznaczy\[CAcute] \
kom\[OAcute]rk\:0119 zawieraj\:0105ce wszystkie procedury i wcisn\:0105\
\[CAcute] Shift+Enter lub klikn\:0105\[CAcute] na g\[OAcute]rze strony wybra\
\[CAcute] Evaluation i nast\:0119pnie Evaluate Notebook. Po inicjalizacji uka\
\:017ce nam si\:0119 wizualizacja zawieraj\:0105ca trajektori\:0119 rozwi\
\:0105zania w przestrzeni fazowej, wykresy poszczeg\[OAcute]lnych \
wsp\[OAcute]\[LSlash]rz\:0119dnych oraz sterowania, prost\:0105 wizualizacj\
\:0119 wahad\[LSlash]a poruszaj\:0105cego si\:0119 zgodnie z optymalnym \
sterowaniem oraz okienko pozwalaj\:0105ce na ponowne uruchomienie procedur. \
Na g\[OAcute]rze okna z wizualizacj\:0105 znajduj\:0105 si\:0119 \
r\[OAcute]wnie\:017c przyciski pozwalaj\:0105ce na zobaczenie animacji ca\
\[LSlash]ej wizualizacji. Zwr\[OAcute]\[CAcute]my uwag\:0119, \:017ce \
uruchamianie animacji nie wymaga wciskania przycisku \
\[OpenCurlyDoubleQuote]Go!\[CloseCurlyDoubleQuote] - w istocie s\[LSlash]u\
\:017cy on do uzyskania innego rozwi\:0105zania (np. w wyniku zmiany warunk\
\[OAcute]w pocz\:0105tkowych b\:0105d\:017a podejrzenia, \:017ce \
rozwi\:0105zanie jest jedynie lokalnym minimum). Ka\:017cda z procedur \
znajduj\:0105cych si\:0119 na ko\:0144cu pliku zawiera r\[OAcute]wnie\:017c \
kr\[OAcute]tki opis. Warto zauwa\:017cy\[CAcute], \:017ce ca\[LSlash]y \
program mo\:017cna podda\[CAcute] prostej modyfikacji pozwalaj\:0105cej na \
rozszerzenie jego funkcjonalno\:015bci na uk\[LSlash]ady liniowe \
spe\[LSlash]niaj\:0105ce pewne za\[LSlash]o\:017cenia (trzeba w\[OAcute]wczas \
rozwa\:017cy\[CAcute] modyfikacj\:0119 wizualizacji - zaimplementowana przez \
autora jest dopasowana do konkretnego problemu). \
\>", "Text",
 CellChangeTimes->{{3.604595880067237*^9, 3.604595880070237*^9}, {
  3.6045974390564065`*^9, 3.604597584595731*^9}, {3.604597641369978*^9, 
  3.604598227181484*^9}, {3.6045993726690025`*^9, 3.604599445738182*^9}, {
  3.604599555431456*^9, 3.60459972300004*^9}, {3.60459987859594*^9, 
  3.6045999008672137`*^9}},
 FontSize->14],

Cell[TextData[{
 "Ze wzgl\:0119du na to w jaki spos\[OAcute]b dzia\[LSlash]a funkcja \
Manipulate, u\:017cytkownik kt\[OAcute]ry raz uruchomi\[LSlash] ca\[LSlash]\
\:0105 procedur\:0119 a nast\:0119pnie przy ponownym uruchomieniu programu \
Wolfram ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " ponownie otworzy plik .nb okno z wizualizacj\:0105 b\:0119dzie \
zakre\:015blone na czerwno i wy\:015bwietli kilka \
b\[LSlash]\:0119d\[OAcute]w. Wynika to z tego, \:017ce przy kolejnym \
uruchomieniu nie b\:0119d\:0105 zadeklarowane funkcje \
s\[LSlash]u\:017c\:0105ce do uzyskania rozwi\:0105zania. Je\:015bli \
u\:017cytkownikowi nie przeszkadzaj\:0105 te b\[LSlash]\:0119dy mo\:017ce je \
zignorowa\[CAcute] i uruchomia\[CAcute] procedur\:0119 ponownie w \
standardowy, opisany wy\:017cej spos\[OAcute]b. W przeciwnym przypadku mo\
\:017cna przed wy\[LSlash]\:0105czaniem pliku .nb usuna\[CAcute] r\:0119cznie \
kom\[OAcute]rk\:0119 zawieraj\:0105c\:0105 wynik wizualizacji, b\:0105d\:017a \
na g\[OAcute]rze strony wybra\[CAcute] Cell i Delete All Output (tutaj jednak \
nale\:017cy uwa\:017ca\[CAcute], je\:015bli robimy w programie jeszcze co\
\:015b innego to output ze wszystkich notebook\[OAcute]w zostanie \
usuni\:0119ty!)."
}], "Text",
 CellChangeTimes->{{3.6045982449344997`*^9, 3.6045986239991813`*^9}, {
  3.6045997267162533`*^9, 3.604599735463753*^9}, {3.6046001808672285`*^9, 
  3.604600189560726*^9}},
 FontSize->14],

Cell[TextData[{
 "Wykresem wymagaj\:0105cym kilku s\[LSlash]\[OAcute]w opisu jest wykres \
trajektorii w przestrzeni fazowej. Nie zosta\[LSlash]a na nim umieszczona \
legenda ze wzgl\:0119du na potrzeb\:0119 zachowania przejrzysto\:015bci \
wykresu.  Kolorem niebieskim jest oznaczona trajektoria, przerywane linie \
koloru zielonego i jasnoniebieskiego s\:0105 natomiast cz\:0119\:015bciami \
wykres\[OAcute]w fazowych ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"dla", " ", "u"}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], " ", "i", " ", "u"}], " ", "=", " ", 
     RowBox[{"1", " ", "odpowiednio"}]}]}], TraditionalForm]], "Equation",
  CellChangeTimes->{{3.604595880067237*^9, 3.604595880070237*^9}, {
   3.6045974390564065`*^9, 3.604597584595731*^9}, {3.604597641369978*^9, 
   3.6045979739760017`*^9}}],
 ". Co wi\:0119cej, je\:015bli uwa\:017cniej przygl\:0105dniemy si\:0119 \
sposobowi w jaki liczone jest liczba prze\[LSlash]\:0105cze\:0144 i warto\
\:015b\[CAcute] pocz\:0105tkowa sterowania, oka\:017ce si\:0119, \:017ce \
linie te odgrywaj\:0105 wa\:017cn\:0105 rol\:0119. Lini\:0105 czerwon\:0105 \
oznaczamy krzyw\:0105 na kt\[OAcute]rej nast\:0119puje \
prze\[LSlash]\:0105czenie sterowania - je\:015bli trajektoria uderza w \
t\:0105 lini\:0119, zmieniamy warto\:015b\[CAcute] sterowania. Zauwa\:017cmy, \
\:017ce powy\:017cej tej linii sterowanie jest r\[OAcute]wne -1, poni\:017cej \
jest natomiast r\[OAcute]wne 1."
}], "Text",
 CellChangeTimes->{{3.604595880067237*^9, 3.604595880070237*^9}, {
  3.6045974390564065`*^9, 3.604597584595731*^9}, {3.604597641369978*^9, 
  3.604598241672313*^9}, {3.6045986357338524`*^9, 3.604598635745853*^9}},
 FontSize->14],

Cell["\<\
Uzyskali\:015bmy zatem procedury pozwalaj\:0105ce nam na uzyskanie \
rozwi\:0105zania dla zadanych warunk\[OAcute]w pocz\:0105tkowych. Zaskakuj\
\:0105c\:0105 obserwacj\:0105 jest to, \:017ce rozwi\:0105zania cho\[CAcute] \
na pierwszy rzut oka wydaj\:0105 si\:0119 by\[CAcute] intuicyjne - zazwyczaj \
staramy si\:0119 za pomoc\:0105 sterowania \[OpenCurlyDoubleQuote]hamowa\
\[CAcute]\[CloseCurlyDoubleQuote] wahad\[LSlash]o, to s\:0105 kr\[OAcute]tkie \
okresy czasu w kt\[OAcute]rych \[OpenCurlyDoubleQuote]dopychamy\
\[CloseCurlyDoubleQuote] wahad\[LSlash]o na w\[LSlash]a\:015bciwe \
trajektorie. Mo\:017cemy to zaobserwowa\[CAcute] kiedy trajektoria w \
przestrzeni fazowej przekracza o\:015b x-\[OAcute]w ale nie trafia jeszcze na \
czerwon\:0105 krzyw\:0105 na kt\[OAcute]rej nast\:0119puje \
prze\[LSlash]\:0105czenie sterowania. W\[OAcute]wczas kierunek pr\:0119dko\
\:015bci (czyli kierunek w kt\[OAcute]rym porusza si\:0119 wahad\[LSlash]o) \
jest zgodny z kierunkiem sterowania. Zamiast wi\:0119c hamowa\[CAcute], \
przyspieszamy wahad\[LSlash]o, co jest wynikiem niezgodnym z intuicj\:0105. \
Musimy jednak pami\:0119ta\[CAcute], \:017ce samo wahad\[LSlash]o porusza si\
\:0119 wed\[LSlash]ug pewnych regu\[LSlash] - jego ruch jest przecie\:017c \
rozwi\:0105zaniem r\[OAcute]wnania r\[OAcute]\:017cniczkowego - to jest w\
\[LSlash]a\:015bnie powodem takiej postaci sterowania. \
\>", "Text",
 CellChangeTimes->{{3.604595880067237*^9, 3.604595880070237*^9}, {
  3.6045974390564065`*^9, 3.604597584595731*^9}, {3.604597641369978*^9, 
  3.604598241672313*^9}, {3.6045986357338524`*^9, 3.6045987260430174`*^9}, {
  3.604598785193401*^9, 3.6045988216634865`*^9}, {3.6045988835180244`*^9, 
  3.6045989613884788`*^9}, {3.604599028313307*^9, 3.6045991273259697`*^9}, {
  3.6045991743486595`*^9, 3.604599245377722*^9}, {3.604599840108739*^9, 
  3.6045998419078417`*^9}, {3.6046003448586087`*^9, 3.6046003451066227`*^9}},
 FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bibliografia", "Section",
 CellChangeTimes->{{3.6045953818977437`*^9, 3.6045953847209053`*^9}}],

Cell[TextData[StyleBox["1. Alberto Bressan, Benedetto Piccoli, \"Introduction \
to the Mathematical Theory of Control\", AIMS Series in Applied Mathematics, \
Springfield, 2007.\n2. Greg Knowles, \"An introduction to applied optimal \
control\", Academic Press, New York, 1981. \n3. Miros\[LSlash]aw Andrzej \
Lachowicz, \"Teoria sterowania\", Wydzia\[LSlash] Matematyki, Informatyki i \
Mechaniki Uniwersytetu Warszawskiego, 2010.",
 FontSize->14]], "Text",
 CellChangeTimes->{{3.600101257630853*^9, 3.6001013098058376`*^9}, {
   3.600101346829955*^9, 3.6001013926255746`*^9}, {3.6001014417513847`*^9, 
   3.6001017943075495`*^9}, {3.6001018619694195`*^9, 
   3.6001019483893623`*^9}, {3.600101984260414*^9, 3.600102029979029*^9}, {
   3.6001021306077847`*^9, 3.600103088773589*^9}, {3.600103120284391*^9, 
   3.6001032725190983`*^9}, {3.6001034077948356`*^9, 3.600103490287554*^9}, {
   3.600103561916651*^9, 3.6001036200609765`*^9}, 3.600105286216275*^9, 
   3.6045887630041647`*^9, {3.6045896062403946`*^9, 3.6045896591484213`*^9}, {
   3.6045897882238035`*^9, 3.6045897944561605`*^9}, {3.604591004165352*^9, 
   3.6045910069725122`*^9}, {3.6045912292942286`*^9, 
   3.6045912354845824`*^9}, {3.604594244393682*^9, 3.6045942454977455`*^9}, {
   3.6045953619136004`*^9, 3.604595388609127*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Procedury:", "Section",
 CellChangeTimes->{{3.600103522534398*^9, 3.600103525933593*^9}, {
  3.604595396208562*^9, 3.6045953964245744`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "function", " ", "computing", " ", "inital", " ", "conrol", " ", "and", 
    " ", "number", " ", "of", " ", "switches", " ", "for", " ", "any", " ", 
    "inital", " ", "point"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"initial", "[", "x0_", "]"}], ":=", "\[IndentingNewLine]", "\t", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "x", ",", "y", ",", "n", ",", "t", ",", "control", ",", "switches"}], 
       "}"}], ",", "\[IndentingNewLine]", "\t\t", 
      RowBox[{
       RowBox[{"x", "=", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"x0", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\t\t", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"x", "\[GreaterEqual]", "0"}], ",", "\[IndentingNewLine]", 
         "\t\t", 
         RowBox[{
          RowBox[{"y", "=", 
           RowBox[{"-", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"1", "-", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"x", "-", "1"}], ")"}], "2"]}], "]"}]}]}], ";", 
          "\[IndentingNewLine]", "\t\t", 
          RowBox[{"control", "=", 
           RowBox[{"Switch", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x0", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ">", "y"}], ",", "True", ",", 
             RowBox[{"-", "1"}], ",", "False", ",", "1"}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "\t\t", "]"}], ";", "\[IndentingNewLine]", 
       "\t\t", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"x", "<", "0"}], ",", "\[IndentingNewLine]", "\t\t", 
         RowBox[{
          RowBox[{"y", "=", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "-", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"x", "-", "1"}], ")"}], "2"]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\t\t", 
          RowBox[{"control", "=", 
           RowBox[{"Switch", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x0", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ">", "y"}], ",", "True", ",", 
             RowBox[{"-", "1"}], ",", "False", ",", "1"}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "\t\t", "]"}], ";", "\[IndentingNewLine]", 
       "\t\t", 
       RowBox[{"n", "=", 
        RowBox[{"Norm", "[", 
         RowBox[{"x0", "-", 
          RowBox[{"{", 
           RowBox[{"control", ",", "0"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\t\t", 
       RowBox[{"t", "=", 
        RowBox[{"Range", "[", 
         RowBox[{"1", ",", 
          RowBox[{
           RowBox[{"Ceiling", "[", "n", "]"}], "+", "5"}], ",", "2"}], 
         "]"}]}], ";", "\[IndentingNewLine]", "\t\t", 
       RowBox[{"switches", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"t", ",", 
            RowBox[{"First", "[", 
             RowBox[{"Select", "[", 
              RowBox[{"t", ",", 
               RowBox[{
                RowBox[{"n", "\[LessEqual]", "#"}], "&"}], ",", "1"}], "]"}], 
             "]"}]}], "]"}], "//", "Flatten"}], "//", "First"}]}], ";", 
       "\[IndentingNewLine]", "\t\t", 
       RowBox[{"Return", "[", 
        RowBox[{"{", 
         RowBox[{"control", ",", "switches"}], "}"}], "]"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "objective", " ", "to", " ", "minimization", " ", "procedure", " ", 
     RowBox[{"i", ".", "e", ".", " ", "function"}], " ", "g", " ", "stated", 
     " ", "above"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"objective", "[", "t_", "]"}], ":=", 
    RowBox[{"Last", "[", "t", "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"equality", " ", "constraints", " ", "function", " ", 
      RowBox[{"(", 
       RowBox[{"f", " ", "stated", " ", "above"}], ")"}]}], ",", " ", 
     RowBox[{
     "note", " ", "that", " ", "matrix", " ", "exponential", " ", "is", " ", 
      "available", " ", "in", " ", "a", " ", "form", " ", "that", " ", 
      "enables", " ", "to", " ", "multiply", " ", "it", " ", "by", " ", 
      "vector", " ", "b", " ", "at", " ", "once"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"equalityfun", "[", 
     RowBox[{"t_", ",", "x0_", ",", "u0_", ",", "r_"}], "]"}], ":=", 
    "\[IndentingNewLine]", "\t", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "x", ",", "v"}], "}"}], ",", 
      "\[IndentingNewLine]", "\t\t", 
      RowBox[{
       RowBox[{"a", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", "\t\t", 
       RowBox[{"b", "=", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], ";", "\[IndentingNewLine]", "\t\t", 
       RowBox[{"x", "=", 
        RowBox[{"Append", "[", 
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"2", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], 
                RowBox[{"i", "+", "1"}]]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"r", "-", "1"}]}], "}"}]}], "]"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], ",", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"r", "+", "1"}]]}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\t\t", 
       RowBox[{"v", "=", 
        RowBox[{
         RowBox[{"u0", " ", 
          RowBox[{"(", 
           RowBox[{"x", ".", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"MatrixExp", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "a"}], "#"}], ",", "b"}], "]"}], "&"}], ",", 
              RowBox[{"Prepend", "[", 
               RowBox[{"t", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "-", 
         RowBox[{"a", ".", "x0"}]}]}], ";", "\[IndentingNewLine]", "\t\t", 
       RowBox[{"Return", "[", "v", "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"inequality", " ", "constraints"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"inequalityfun", "[", 
     RowBox[{"t_", ",", "r_"}], "]"}], ":=", 
    RowBox[{"t", "-", 
     RowBox[{"Prepend", "[", 
      RowBox[{
       RowBox[{"Take", "[", 
        RowBox[{"t", ",", 
         RowBox[{"r", "-", "1"}]}], "]"}], ",", "0"}], "]"}]}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"optimization", " ", "procedure"}], " ", "-", " ", 
      "\[IndentingNewLine]", 
      RowBox[{
      "note", " ", "the", " ", "use", " ", "of", " ", "flag", " ", 
       "indicating", " ", "convergence", " ", 
       RowBox[{"(", 
        RowBox[{"flag", "=", 
         RowBox[{"0", " ", "means", " ", "convergence"}]}], ")"}]}]}], ",", 
     " ", 
     RowBox[{
     "NMinimize", " ", "is", " ", "used", " ", "to", " ", "the", " ", "fact", 
      " ", "that", " ", "it", " ", "will", " ", "more", " ", "likely", " ", 
      "find", " ", "a", " ", "global", " ", "minimum", " ", "than", " ", 
      "FindMinimum", " ", "and", " ", "methods", " ", "available", " ", "for",
       " ", "NMinimum", " ", "are", " ", "much", " ", "better", " ", "suited",
       " ", "to", " ", "our", " ", "need"}], ",", " ", 
     RowBox[{
     "we", " ", "use", " ", "Check", " ", "to", " ", "find", " ", "any", " ", 
      "messages", " ", "produced", " ", "by", " ", "NMinimize", " ", "and", 
      " ", "if", " ", "there", " ", "are", " ", "any", " ", "it", " ", 
      "means", " ", "there", " ", "was", " ", "no", " ", "convergence"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{
     "while", " ", "we", " ", "do", " ", "not", " ", "explicitly", " ", 
      "know", " ", "how", " ", "many", " ", "switches", " ", "there", " ", 
      "are", " ", "before", " ", "running", " ", "function", " ", "initial", 
      " ", 
      RowBox[{"(", 
       RowBox[{
       "and", " ", "we", " ", "want", " ", "the", " ", "initial", " ", 
        "values", " ", "to", " ", "be", " ", "changed", " ", "throughout", 
        " ", "visualization"}], ")"}], " ", "we", " ", "define", " ", 
      "variable", " ", "time", " ", "in", " ", "nice", " ", "way"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "nota", " ", "also", " ", "that", " ", "number", " ", "of", " ", 
       "iterations", " ", "is", " ", "limited"}], " ", "-", " ", 
      RowBox[{"we", " ", 
       RowBox[{"don", "'"}], "t", " ", "want", " ", "it", " ", "to", " ", 
       "last", " ", "really", " ", "long"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"optimize", "[", 
     RowBox[{"x0_", ",", "method_"}], "]"}], ":=", "\[IndentingNewLine]", 
    "\t", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "u0", ",", "r", ",", "flag", ",", "i", ",", " ", "time", ",", 
        "solution", ",", "message"}], "}"}], ",", "\[IndentingNewLine]", "\t", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"u0", ",", "r"}], "}"}], "=", 
        RowBox[{"initial", "[", "x0", "]"}]}], ";", "\[IndentingNewLine]", 
       "\t", 
       RowBox[{"time", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Unique", "[", "t", "]"}], ",", 
          RowBox[{"{", "r", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\t", 
       RowBox[{"i", "=", "1"}], ";", " ", 
       RowBox[{"flag", "=", "1"}], ";", "\[IndentingNewLine]", "\t", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"i", "\[LessEqual]", "3"}], " ", "&&", " ", 
          RowBox[{"flag", "\[Equal]", "1"}]}], ",", "\[IndentingNewLine]", 
         "\t", 
         RowBox[{
          RowBox[{"Check", "[", "\[IndentingNewLine]", "\t\t", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", "\t\t", 
             RowBox[{
              RowBox[{"solution", "=", 
               RowBox[{"NMinimize", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"objective", "[", "time", "]"}], ",", 
                   "\[IndentingNewLine]", "\t\t", 
                   RowBox[{
                    RowBox[{"equalityfun", "[", 
                    RowBox[{"time", ",", "x0", ",", "u0", ",", "r"}], "]"}], "==",
                     "0"}], ",", "\[IndentingNewLine]", "\t\t", 
                   RowBox[{"And", "@@", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Part", "[", 
                    RowBox[{
                    RowBox[{"inequalityfun", "[", 
                    RowBox[{"time", ",", "r"}], "]"}], ",", "i"}], "]"}], 
                    "\[GreaterEqual]", "0"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "r"}], "}"}]}], "]"}]}], ",", 
                   "\[IndentingNewLine]", "\t\t", 
                   RowBox[{"And", "@@", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Part", "[", 
                    RowBox[{"time", ",", "i"}], "]"}], "\[LessEqual]", 
                    RowBox[{"i", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "+", 
                    FractionBox["1", "2"]}], ")"}]}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "r"}], "}"}]}], "]"}]}]}], "}"}], ",", 
                 "\[IndentingNewLine]", "\t              ", "time", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Method", "\[Rule]", "method"}], ",", " ", 
                   RowBox[{"\"\<RandomSeed\>\"", "\[Rule]", 
                    RowBox[{"RandomInteger", "[", "50", "]"}]}]}], "}"}]}], 
                "]"}]}], ";", "\[IndentingNewLine]", "\t\t", 
              RowBox[{
              "message", "=", 
               "\"\<Optimization procedure converged successfully.\>\""}], 
              ";", 
              RowBox[{"flag", "=", "0"}], ";"}], "\[IndentingNewLine]", 
             "\t\t", "}"}], ",", "\[IndentingNewLine]", "\t\t", 
            RowBox[{
             RowBox[{
             "message", "=", 
              "\"\<Optimization procedure did not converge.\>\""}], ";", 
             RowBox[{"flag", "=", "1"}], ";"}]}], "\[IndentingNewLine]", 
           "\t\t", "]"}], ";"}]}], "\[IndentingNewLine]", "\t\t", "]"}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"Return", "[", 
        RowBox[{"{", 
         RowBox[{"u0", ",", "r", ",", 
          RowBox[{
           RowBox[{"solution", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "/.", 
           RowBox[{
            RowBox[{"Rule", "[", 
             RowBox[{"a_", ",", "b_"}], "]"}], ":>", "b"}]}], ",", 
          "message"}], "}"}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "we", " ", "generate", " ", "actual", " ", "solution", " ", "thanks", 
      " ", "to", " ", "the", " ", "minimizing", " ", "procedures", " ", "and",
       " ", "then", " ", "solving", " ", "systems", " ", "of", " ", "ODEs"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
     "we", " ", "suppress", " ", "any", " ", "messages", " ", "generated", 
      " ", "by", " ", "optimizing", " ", "procedure"}], ",", " ", 
     RowBox[{
     "if", " ", "there", " ", "was", " ", "no", " ", "convergence", " ", 
      "message", " ", "stating", " ", "it", " ", "will", " ", "be", " ", 
      "displayed", " ", "in", " ", "visualization", " ", "window"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
     "note", " ", "that", " ", "right", " ", "hand", " ", "sides", " ", "in", 
      " ", "systems", " ", "of", " ", "ODEs", " ", "generated", " ", "at", 
      " ", "one", " ", "by", " ", "a", " ", "piecewise", " ", "function"}], 
     ",", " ", 
     RowBox[{"we", " ", 
      RowBox[{"don", "'"}], "t", " ", "have", " ", "to", " ", "make", " ", 
      "loop", " ", "to", " ", "actually", " ", "solve", " ", "ODEs", " ", 
      "thanks", " ", "to", " ", "the", " ", "functionality", " ", "of", " ", 
      "NDSolve", " ", 
      RowBox[{"(", 
       RowBox[{
       "it", " ", "basically", " ", "does", " ", "it", " ", "for", " ", 
        "us"}], ")"}]}]}], "*)"}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"generatesolution", "[", 
     RowBox[{"x0_", ",", "method_"}], "]"}], ":=", "\[IndentingNewLine]", 
    "\t", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "u0", ",", "r", ",", "times", ",", "message", ",", "start", ",", "end",
         ",", "rhs", ",", "sol", ",", "u", ",", "x"}], "}"}], ",", 
      "\[IndentingNewLine]", "\t", 
      RowBox[{
       RowBox[{"Quiet", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"u0", ",", "r", ",", "times", ",", "message"}], "}"}], "=", 
         RowBox[{"optimize", "[", 
          RowBox[{"x0", ",", "method"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"start", "=", 
        RowBox[{"Prepend", "[", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{"times", ",", 
            RowBox[{"r", "-", "1"}]}], "]"}], ",", "0"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"end", "=", 
        RowBox[{"Part", "[", 
         RowBox[{"times", ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", "\t", 
       RowBox[{"u", "=", 
        RowBox[{"u0", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"i", "+", "1"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "r"}], "}"}]}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"rhs", "=", 
        RowBox[{"Piecewise", "[", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Part", "[", 
                RowBox[{"u", ",", "i"}], "]"}], ",", 
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"start", ",", "i"}], "]"}], "\[LessEqual]", "t", "<", 
                RowBox[{"Part", "[", 
                 RowBox[{"times", ",", "i"}], "]"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "r"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"t", "==", 
              RowBox[{"Part", "[", 
               RowBox[{"times", ",", 
                RowBox[{"-", "1"}]}], "]"}]}]}], "}"}]}], "]"}], "]"}]}], ";",
        "\[IndentingNewLine]", "\t", 
       RowBox[{"sol", "=", 
        RowBox[{"NDSolve", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"x", "''"}], "[", "t", "]"}], "\[Equal]", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"x", "[", "t", "]"}]}], "+", "rhs"}]}], ",", 
            RowBox[{
             RowBox[{"x", "[", "0", "]"}], "\[Equal]", 
             RowBox[{"x0", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "'"}], "[", "0", "]"}], "\[Equal]", 
             RowBox[{"x0", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], ",", "x", ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "0", ",", "end"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"Return", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{"times", ",", "0"}], "]"}], ",", 
          RowBox[{
           RowBox[{"x", "[", "t", "]"}], "/.", "sol"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"x", "'"}], "[", "t", "]"}], "/.", "sol"}], ",", "rhs", 
          ",", "message"}], "}"}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\n", "\[IndentingNewLine]", "\t", "\n", 
   RowBox[{"(*", 
    RowBox[{
    "here", " ", "we", " ", "generate", " ", "initial", " ", "parameters", 
     " ", "that", " ", "are", " ", "used", " ", "in", " ", "computation", " ",
      "and", " ", "visualization"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"x0", "=", 
     RowBox[{"{", 
      RowBox[{"6", ",", "5"}], "}"}]}], ";", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], "=", "x0"}], ";", " ", 
    RowBox[{"method", "=", "\"\<SimulatedAnnealing\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"times", ",", 
       RowBox[{"{", "position", "}"}], ",", 
       RowBox[{"{", "velocity", "}"}], ",", "control", ",", "message"}], 
      "}"}], "=", 
     RowBox[{"generatesolution", "[", 
      RowBox[{"x0", ",", "method"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"range", "=", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{
        SuperscriptBox["position", "2"], "+", 
        SuperscriptBox["velocity", "2"]}], "]"}], "/.", 
      RowBox[{"t", "\[Rule]", "0"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"visualization", " ", "procedure"}], " ", "-", " ", 
      RowBox[{
      "procedure", " ", "is", " ", "long", " ", "but", " ", "not", " ", 
       "that", " ", "complicated"}]}], ",", " ", 
     RowBox[{
     "the", " ", "most", " ", "important", " ", "part", " ", "is", " ", "use",
       " ", "of", " ", "dynamics"}], ",", " ", 
     RowBox[{
     "thanks", " ", "to", " ", "it", " ", "user", " ", "can", " ", "change", 
      " ", "initial", " ", "values", " ", 
      RowBox[{"(", 
       RowBox[{
       "and", " ", "used", " ", "method", " ", "by", " ", "optimizing", " ", 
        "procedure"}], ")"}], " ", "and", " ", "by", " ", 
      RowBox[{"clicking", " ", "'"}], 
      RowBox[{
       RowBox[{"Go", "!"}], "'"}], " ", "button", " ", "avoid", " ", 
      "reevaluating", " ", "whole", " ", "notebook", " ", "again"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "one", " ", "should", " ", "note", " ", "that", " ", "the", " ", "time",
        " ", "of", " ", "animation", " ", "is", " ", "equal", " ", "to", " ", 
       "the", " ", "time", " ", "generated", " ", "by", " ", "procedures"}], 
      " ", "-", " ", 
      RowBox[{
      "therefore", " ", "visualization", " ", "kind", " ", "of", " ", 
       "mimics", " ", "real", " ", "pendulum"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "there", " ", "is", " ", "one", " ", "disadvantage", " ", "of", " ", 
       "the", " ", 
       RowBox[{"Manipulate", "/", "Animate"}], " ", "though"}], " ", "-", " ", 
      RowBox[{"notebook", " ", "once", " ", "evaluated", " ", "contains", " ", 
       RowBox[{"Manipulate", "/", "Animate"}], " ", "enviroment", " ", 
       "which", " ", "with", " ", "another", " ", "opening", " ", "of", " ", 
       "notebook", " ", "will", " ", "try", " ", "to", " ", "plot", " ", 
       "again"}]}], ",", "  ", 
     RowBox[{
     "and", " ", "while", " ", "not", " ", "finding", " ", "function", " ", 
      "declarations", " ", "and", " ", "initialization", " ", "procedure", 
      " ", "it", " ", "will", " ", "generate", " ", "few", " ", "errors"}], 
     ",", " ", 
     RowBox[{
     "if", " ", "one", " ", "wants", " ", "to", " ", "avoid", " ", "those", 
      " ", "errors"}], ",", " ", 
     RowBox[{
      RowBox[{"he", " ", "should"}], " ", "-", " ", 
      RowBox[{"before", " ", "quitting", " ", "notebook"}], " ", "-", " ", 
      RowBox[{
      "delete", " ", "the", " ", "cell", " ", "with", " ", "plots"}]}], ",", 
     " ", 
     RowBox[{
     "otherwise", " ", "just", " ", "ignore", " ", "the", " ", "errors", " ", 
      "and", " ", "run", " ", "whole", " ", "notebook", " ", "again"}]}], " ",
     "*)"}], "\n", "\[IndentingNewLine]", " ", 
   RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
    RowBox[{"Animate", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Grid", "[", "\[IndentingNewLine]", "\t", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"Show", "\[IndentingNewLine]", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "ParametricPlot", "\[IndentingNewLine]", "[", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"position", ",", "velocity"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"t", ",", "0", ",", "\[Tau]"}], "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"PlotStyle", "\[Rule]", 
                 RowBox[{"{", "Thick", "}"}]}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "range"}], "-", "1"}], ",", 
                   RowBox[{"range", "+", "1"}]}], "}"}]}], ",", 
                RowBox[{"PlotLabel", "\[Rule]", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                  "\"\<Phase plane plot\>\"", ",", "Italic", ",", "Bold"}], 
                  "]"}]}], ",", " ", 
                RowBox[{"ImageSize", "\[Rule]", "500"}]}], 
               "\[IndentingNewLine]", " ", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"Red", ",", 
                   RowBox[{"Circle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "0"}], "}"}], ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{"Pi", ",", 
                    RowBox[{"2", "Pi"}]}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", "20", ",", "2"}], "}"}]}], 
                "]"}], "\[IndentingNewLine]", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"Red", ",", 
                   RowBox[{"Circle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "i"}], ",", "0"}], "}"}], ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "Pi"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", "20", ",", "2"}], "}"}]}], 
                "]"}], "\[IndentingNewLine]", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"Green", ",", "Dashed", ",", 
                   RowBox[{"Circle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", "i", ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "Pi"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "3", ",", "20", ",", "2"}], "}"}]}], 
                "]"}], "\[IndentingNewLine]", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"Cyan", ",", "Dashed", ",", 
                   RowBox[{"Circle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], ",", "i", ",", 
                    RowBox[{"{", 
                    RowBox[{"Pi", ",", 
                    RowBox[{"2", "Pi"}]}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "3", ",", "20", ",", "2"}], "}"}]}], 
                "]"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
             "]"}], "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
            RowBox[{
            "Graphics", "\[IndentingNewLine]", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"PointSize", "[", "Large", "]"}], ",", 
                RowBox[{"Point", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"position", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ",", 
                   RowBox[{"-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"1", "+", 
                    SuperscriptBox["range", "2"], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"position", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ")"}], "^", "2"}]}],
                     "]"}]}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"position", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ",", 
                    RowBox[{"-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"1", "+", 
                    SuperscriptBox["range", "2"], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"position", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ")"}], "^", "2"}]}],
                     "]"}]}]}], "}"}]}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Line", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "4"}], ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"4", ",", "0"}], "}"}]}], "}"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Arrow", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"position", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ",", 
                    RowBox[{"-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"1", "+", 
                    SuperscriptBox["range", "2"], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"position", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ")"}], "^", "2"}]}],
                     "]"}]}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"control", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ")"}]}], "+", 
                    "position"}], "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ",", 
                    RowBox[{"-", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"1", "+", 
                    SuperscriptBox["range", "2"], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"position", "/.", 
                    RowBox[{"t", "\[Rule]", "\[Tau]"}]}], ")"}], "^", "2"}]}],
                     "]"}]}]}], "}"}]}], "}"}], "]"}]}], 
               "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "range"}], "-", "2"}], ",", 
                   RowBox[{"range", "+", "2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "range"}], "-", "1"}], ",", "0"}], "}"}]}], 
                "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "400"}], ",", " ", 
              RowBox[{"PlotLabel", "\[Rule]", 
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Pendulum visualization \\n (arrow indicates direction of \
control) \\n\>\"", ",", "Italic", ",", " ", "Bold"}], "]"}]}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Plot", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"position", ",", "velocity", ",", "control"}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", "\[Tau]"}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"PlotStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Red", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", 
                   RowBox[{"Part", "[", 
                    RowBox[{"times", ",", 
                    RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "range"}], ",", "range"}], "}"}], "+", 
                  "1"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"AxesOrigin", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "500"}], ",", " ", 
              RowBox[{"PlotLegends", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<position\>\"", ",", "\"\<velocity\>\"", ",", 
                 "\"\<control\>\""}], "}"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"PlotLabel", "\[Rule]", 
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Plot of coordinates\>\"", ",", "Italic", ",", "Bold"}], 
                "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Grid", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"message", ",", " ", "SpanFromLeft"}], 
                 "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"\"\<Initial position:\>\"", ",", " ", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"Dynamic", "[", "a", "]"}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", "5"}]}], "]"}]}], 
                 "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"\"\<Initial velocity:\>\"", ",", " ", 
                  RowBox[{"InputField", "[", 
                   RowBox[{
                    RowBox[{"Dynamic", "[", "b", "]"}], ",", 
                    RowBox[{"FieldSize", "\[Rule]", "5"}]}], "]"}]}], 
                 "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"\"\<Method:\>\"", ",", 
                  RowBox[{"PopupMenu", "[", 
                   RowBox[{
                    RowBox[{"Dynamic", "[", "method", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<SimulatedAnnealing\>\"", ",", "\"\<NelderMead\>\""}],
                     "}"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Button", "[", 
                   RowBox[{"\"\<Go!\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"x0", "=", 
                    RowBox[{"{", 
                    RowBox[{"a", ",", "b"}], "}"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"times", ",", 
                    RowBox[{"{", "position", "}"}], ",", 
                    RowBox[{"{", "velocity", "}"}], ",", "control", ",", 
                    "message"}], "}"}], "=", 
                    RowBox[{"generatesolution", "[", 
                    RowBox[{"x0", ",", "method"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"range", "=", 
                    RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    SuperscriptBox["position", "2"], "+", 
                    SuperscriptBox["velocity", "2"]}], "]"}], "/.", 
                    RowBox[{"t", "\[Rule]", "0"}]}]}], ";"}]}], "]"}], ",", 
                  "SpanFromLeft"}], "\[IndentingNewLine]", "}"}]}], 
               "\[IndentingNewLine]", "}"}], ",", "  ", 
              RowBox[{"ItemStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Automatic", ",", " ", "Automatic", ",", " ", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "->", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"FontSize", "\[Rule]", "14"}], ",", "Red", ",", 
                    "Bold"}], "]"}]}], "}"}]}], "}"}]}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
         "\[IndentingNewLine]", "}"}], ",", 
        RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\[Tau]", ",", 
        SuperscriptBox["10", 
         RowBox[{"-", "20"}]], ",", 
        RowBox[{"Part", "[", 
         RowBox[{"times", ",", 
          RowBox[{"-", "1"}]}], "]"}]}], "}"}], ",", 
      RowBox[{"AnimationRunning", "\[Rule]", "False"}], ",", 
      RowBox[{"AnimationRepetitions", "\[Rule]", "1"}], ",", 
      RowBox[{"DefaultDuration", "\[Rule]", 
       RowBox[{"Part", "[", 
        RowBox[{"times", ",", 
         RowBox[{"-", "1"}]}], "]"}]}]}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.599594865758315*^9, 3.599594923123596*^9}, {
   3.599595013515766*^9, 3.5995950454185905`*^9}, {3.5995950953694477`*^9, 
   3.5995952098849983`*^9}, {3.5995952412607927`*^9, 
   3.5995953922324276`*^9}, {3.599596521934043*^9, 3.599596558127113*^9}, {
   3.599596755566406*^9, 3.5995967572725034`*^9}, {3.5995968721250725`*^9, 
   3.5995969518736343`*^9}, {3.5995969856615667`*^9, 
   3.5995969939440403`*^9}, {3.5995970325192466`*^9, 
   3.5995970506142817`*^9}, {3.599597262814419*^9, 3.5995973179165707`*^9}, {
   3.599597510126564*^9, 3.5995976369928207`*^9}, {3.5995977189325075`*^9, 
   3.599597732134262*^9}, {3.599597847856881*^9, 3.5995978677730207`*^9}, {
   3.5995979618514013`*^9, 3.599597993320201*^9}, {3.5995980515265303`*^9, 
   3.599598077341007*^9}, 3.5995983238291054`*^9, {3.5995984061778154`*^9, 
   3.5995984334003725`*^9}, {3.599598623141225*^9, 3.5995987526476326`*^9}, {
   3.599598785454509*^9, 3.5995988376204925`*^9}, {3.5995988813239923`*^9, 
   3.5995988848751955`*^9}, {3.5995995907225676`*^9, 3.599599684246917*^9}, {
   3.599599747580539*^9, 3.59959975511697*^9}, 3.599599788835899*^9, {
   3.599599970013262*^9, 3.5996000391792173`*^9}, {3.599600139694967*^9, 
   3.599600142567131*^9}, 3.599600683221055*^9, {3.5996007182990613`*^9, 
   3.599600780792636*^9}, {3.5996008414071026`*^9, 3.5996008544138465`*^9}, {
   3.5996010256246395`*^9, 3.5996010736143837`*^9}, {3.599601246216256*^9, 
   3.5996012710326757`*^9}, {3.599657511807277*^9, 3.5996575216378393`*^9}, {
   3.5996580602986493`*^9, 3.599658081177843*^9}, {3.5996581160668387`*^9, 
   3.599658253004671*^9}, {3.599658314410184*^9, 3.59965834896916*^9}, {
   3.5996583871923466`*^9, 3.5996584125457964`*^9}, {3.5996584801246614`*^9, 
   3.5996584805566864`*^9}, {3.599662385808054*^9, 3.5996624350688715`*^9}, {
   3.5996631123566103`*^9, 3.5996631249383297`*^9}, {3.5996631966554317`*^9, 
   3.5996632394548798`*^9}, {3.5996634334469757`*^9, 3.599663441541439*^9}, {
   3.599663489564185*^9, 3.5996634897391953`*^9}, {3.599664663440327*^9, 
   3.5996646847075434`*^9}, {3.5996663954313917`*^9, 3.599666509104893*^9}, {
   3.599666549872225*^9, 3.5996665740506077`*^9}, {3.5996666200452385`*^9, 
   3.5996667000748158`*^9}, {3.599667019264073*^9, 3.599667119821824*^9}, {
   3.5996671512756233`*^9, 3.599667178594186*^9}, {3.5996672185764728`*^9, 
   3.599667222303686*^9}, {3.5996672898145475`*^9, 3.599667289981557*^9}, {
   3.59966732010928*^9, 3.599667330833894*^9}, {3.599667407202262*^9, 
   3.5996674106814604`*^9}, {3.599667467967737*^9, 3.5996674826405764`*^9}, {
   3.59967319194713*^9, 3.599673274406846*^9}, {3.599673826506425*^9, 
   3.5996738687208395`*^9}, {3.5996742397960634`*^9, 3.599674240171085*^9}, {
   3.5996744119899125`*^9, 3.5996744205974045`*^9}, 3.59967916466275*^9, {
   3.599679765263102*^9, 3.5996797906735554`*^9}, {3.599680119228348*^9, 
   3.599680138013422*^9}, {3.5996818863424206`*^9, 3.5996818876304946`*^9}, {
   3.599686202866312*^9, 3.5996862053264527`*^9}, {3.599690540121389*^9, 
   3.599690658732173*^9}, {3.599690830069973*^9, 3.5996908363743334`*^9}, {
   3.5996912571103983`*^9, 3.5996913113094983`*^9}, {3.5996915343342543`*^9, 
   3.5996915383894863`*^9}, {3.599691612812743*^9, 3.5996916187950854`*^9}, {
   3.5996916872249994`*^9, 3.5996917066851125`*^9}, {3.599756865687313*^9, 
   3.5997569459729047`*^9}, {3.5997594242856565`*^9, 3.599759427692851*^9}, {
   3.5997652741792507`*^9, 3.5997653126884537`*^9}, {3.599765449373272*^9, 
   3.5997654564516764`*^9}, {3.5997655696951537`*^9, 3.599765584605006*^9}, {
   3.599765933701974*^9, 3.599766045898391*^9}, {3.599766165047206*^9, 
   3.5997661873324804`*^9}, {3.599766894987956*^9, 3.5997668968600636`*^9}, 
   3.600018804296074*^9, {3.6000229980849447`*^9, 3.6000230174200506`*^9}, 
   3.6000230747843323`*^9, {3.6000231164307137`*^9, 3.6000231396450415`*^9}, {
   3.600023216030411*^9, 3.60002322422888*^9}, {3.6000234883579865`*^9, 
   3.6000235099942245`*^9}, {3.6000235467793283`*^9, 3.6000235880506887`*^9}, 
   3.6000236424838023`*^9, {3.6000238385010138`*^9, 3.600023910826151*^9}, {
   3.600023955714718*^9, 3.6000239566457715`*^9}, {3.6000240524762526`*^9, 
   3.600024153570035*^9}, {3.600024278386174*^9, 3.600024328063015*^9}, {
   3.6000243592738004`*^9, 3.6000243605098715`*^9}, {3.6000244419755306`*^9, 
   3.600024445911756*^9}, {3.6000244885481944`*^9, 3.600024521939104*^9}, {
   3.6000245725740004`*^9, 3.600024598172465*^9}, {3.6000246678254485`*^9, 
   3.600024669280532*^9}, {3.6000248279826093`*^9, 3.6000248624175787`*^9}, {
   3.6000249438562365`*^9, 3.6000249665945373`*^9}, {3.6000250014095287`*^9, 
   3.6000250025945964`*^9}, {3.600025065698206*^9, 3.6000251097877274`*^9}, {
   3.600025145976797*^9, 3.600025205047176*^9}, 3.6000253439021177`*^9, {
   3.600025416096247*^9, 3.60002541648627*^9}, {3.600025544530593*^9, 
   3.6000255738342695`*^9}, 3.6000256572880425`*^9, 3.6000257233158193`*^9, 
   3.6000258207713933`*^9, {3.600026030467387*^9, 3.600026032250489*^9}, {
   3.600026079187174*^9, 3.6000260874496465`*^9}, {3.6000263458634267`*^9, 
   3.6000263526378145`*^9}, {3.6000265766726284`*^9, 3.600026594950674*^9}, {
   3.6000277295155673`*^9, 3.6000277329957666`*^9}, {3.6000278294992857`*^9, 
   3.6000279778937736`*^9}, {3.6000280202041936`*^9, 3.600028050291915*^9}, {
   3.600028104234*^9, 3.6000281064131246`*^9}, {3.6000282409788213`*^9, 
   3.6000282423629007`*^9}, {3.60002953036557*^9, 3.6000295565680685`*^9}, {
   3.600030098835085*^9, 3.6000301222814255`*^9}, {3.600030159912578*^9, 
   3.600030261972416*^9}, {3.6000302968034077`*^9, 3.6000302972424326`*^9}, {
   3.6000303766559753`*^9, 3.600030452109291*^9}, {3.6000305910982404`*^9, 
   3.6000306167877097`*^9}, {3.600030743578962*^9, 3.6000307481692247`*^9}, 
   3.6000307880655065`*^9, {3.6000308190472784`*^9, 3.6000308283038077`*^9}, {
   3.6000965070311346`*^9, 3.60009655223272*^9}, {3.6000966168344145`*^9, 
   3.600096643633948*^9}, 3.600097028555964*^9, {3.60009765579484*^9, 
   3.6000976808672743`*^9}, {3.6000978214953175`*^9, 
   3.6000978403013935`*^9}, {3.6000979235991573`*^9, 3.600097930966579*^9}, {
   3.6000980704085546`*^9, 3.600098071253603*^9}, {3.6000981192423477`*^9, 
   3.6000981539833345`*^9}, {3.6000982399292507`*^9, 3.600098254930109*^9}, {
   3.6000983183037333`*^9, 3.600098327119238*^9}, {3.600098526449639*^9, 
   3.60009855742141*^9}, {3.6000987785580587`*^9, 3.6000987826482925`*^9}, {
   3.600098814846134*^9, 3.6000988163972225`*^9}, {3.6000993391151204`*^9, 
   3.6000993420982914`*^9}, {3.600099558475667*^9, 3.6000995843351464`*^9}, {
   3.600100620274399*^9, 3.6001006336811657`*^9}, {3.600103644042348*^9, 
   3.6001036799634027`*^9}, {3.6001037428429995`*^9, 
   3.6001037809981813`*^9}, {3.6001038265807886`*^9, 3.600103955336153*^9}, {
   3.6001040172156925`*^9, 3.6001050490307093`*^9}, {3.6001054820274754`*^9, 
   3.600105487740802*^9}, {3.600105655797414*^9, 3.6001056656639786`*^9}, {
   3.604600043044346*^9, 3.604600044236414*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1268, 1002},
WindowMargins->{{Automatic, -5}, {Automatic, 3}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->FrontEnd`FileName[{"Article"}, "Preprint.nb", 
  CharacterEncoding -> "WindowsEastEurope"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 228, 5, 137, "Title"],
Cell[CellGroupData[{
Cell[832, 31, 143, 2, 70, "Section"],
Cell[978, 35, 120, 1, 36, "Subsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1135, 41, 94, 1, 70, "Section"],
Cell[1232, 44, 118, 1, 36, "Subsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1387, 50, 151, 2, 70, "Section"],
Cell[1541, 54, 1506, 23, 68, "Text"],
Cell[3050, 79, 2034, 30, 106, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5121, 114, 153, 3, 70, "Section"],
Cell[5277, 119, 825, 14, 30, "Text"],
Cell[6105, 135, 2827, 64, 45, "Equation"],
Cell[8935, 201, 1445, 22, 68, "Text"],
Cell[10383, 225, 574, 22, 42, "Equation"],
Cell[10960, 249, 290, 7, 24, "Equation"],
Cell[11253, 258, 622, 23, 42, "EquationNumbered"],
Cell[11878, 283, 448, 8, 30, "Text"],
Cell[12329, 293, 589, 14, 24, "Equation"],
Cell[12921, 309, 1913, 28, 125, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14871, 342, 218, 3, 70, "Section"],
Cell[15092, 347, 1373, 28, 50, "Text"],
Cell[16468, 377, 2885, 76, 49, "EquationNumbered"],
Cell[19356, 455, 3784, 54, 239, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23177, 514, 247, 5, 70, "Section"],
Cell[23427, 521, 2085, 31, 144, "Text"],
Cell[25515, 554, 1439, 25, 106, "Text"],
Cell[26957, 581, 1712, 31, 87, "Text"],
Cell[28672, 614, 1952, 28, 106, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30661, 647, 101, 1, 70, "Section"],
Cell[30765, 650, 1296, 18, 68, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32098, 673, 146, 2, 70, "Section"],
Cell[32247, 677, 45040, 978, 3405, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
