(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     39434,        829]
NotebookOptionsPosition[     38712,        800]
NotebookOutlinePosition[     39068,        816]
CellTagsIndexPosition[     39025,        813]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["MarkovPlotter", "Title",
 CellChangeTimes->{{3.605124643232402*^9, 3.60512465269063*^9}}],

Cell[CellGroupData[{

Cell[BoxData["markovPlotter"], "Input",
 CellChangeTimes->{{3.605120668242412*^9, 3.605120671142879*^9}, {
  3.605120741411079*^9, 3.605120748077743*^9}, {3.6051245614479*^9, 
  3.605124563390489*^9}}],

Cell[BoxData[
 DynamicModuleBox[{$CellContext`maxTrajectoryLength$$ = 
  100, $CellContext`initialDistribution$$ = {0.25, 0.25, 0.25, 
  0.25}, $CellContext`transitionMatrix$$ = {{0.25, 0.25, 0.25, 0.25}, {0.25, 
  0.25, 0.25, 0.25}, {0.25, 0.25, 0.25, 0.25}, {0.25, 0.25, 0.25, 
  0.25}}, $CellContext`addingNumber$$ = 2, $CellContext`autoOpacity$$ = True}, 
  TabViewBox[{{1,"\<\"Plot\"\>"->
   DynamicModuleBox[{$CellContext`list$$ = {{3, 2, 3, 2, 1, 4, 3, 4, 3, 
    4}}, $CellContext`trajectoryLength$$ = 10, $CellContext`opacity$$ = 
    1, $CellContext`maxlen$$ = $CellContext`maxTrajectoryLength$$}, 
    TagBox[GridBox[{
       {
        DynamicBox[ToBoxes[
          Panel[
           Show[
            
            ListLinePlot[$CellContext`list$$, Background -> White, 
             PlotRange -> {{0, $CellContext`trajectoryLength$$ + 1}, {0, 
                Length[$CellContext`initialDistribution$$]}}, PlotStyle -> 
             Directive[Blue, 
               Opacity[$CellContext`opacity$$]], 
             AxesLabel -> {"Step", "State"}, AxesOrigin -> {0, 0}]], 
           ButtonBar[{"Generate new trajectory" :> ($CellContext`list$$ = {
                 $CellContext`generateTrajectory[$CellContext`\
trajectoryLength$$, $CellContext`initialDistribution$$, \
$CellContext`transitionMatrix$$]}; $CellContext`opacity$$ = 1; Null), 
             "Add new trajectories" :> ($CellContext`list$$ = 
               Join[$CellContext`list$$, 
                 Table[
                  $CellContext`generateTrajectory[$CellContext`\
trajectoryLength$$, $CellContext`initialDistribution$$, \
$CellContext`transitionMatrix$$], {$CellContext`addingNumber$$}]]; 
              If[$CellContext`autoOpacity$$ == True, $CellContext`opacity$$ = 
                N[(1/Length[$CellContext`list$$])^(1/2), 3]]; Null)}, 
            ImageSize -> Full, Appearance -> Automatic], ImageSize -> 
           Automatic], StandardForm],
         ImageSizeCache->{380., {125., 159.}}]},
       {
        TagBox[GridBox[{
           {
            TemplateBox[{"\"Length: \"",InterpretationBox[
               StyleBox[
                GridBox[{{
                   SliderBox[
                    Dynamic[
                    
                    BoxForm`RemapVariable[$CellContext`trajectoryLength$$, {
                    1, $CellContext`maxTrajectoryLength$$}], 
                    BoxForm`RemapValue[#, $CellContext`trajectoryLength$$, {
                    1, $CellContext`maxTrajectoryLength$$}]& ], {0, 1}, 
                    Appearance -> Automatic, DefaultBaseStyle -> 
                    "LabeledSlider"], 
                   InputFieldBox[
                    Dynamic[$CellContext`trajectoryLength$$], Appearance -> 
                    "Frameless", ContinuousAction -> True, DefaultBaseStyle -> 
                    "LabeledSlider", FieldSize -> {{5, 10}, {1, 2}}, 
                    ImageMargins -> 0]}}, AutoDelete -> False, 
                 BaselinePosition -> {{1, 1}, Axis}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}], Deployed -> True, 
                StripOnInput -> False, FontFamily :> 
                CurrentValue["ControlsFontFamily"]], 
               LabeledSlider[
                Dynamic[
                 
                 BoxForm`RemapVariable[$CellContext`trajectoryLength$$, {
                  1, $CellContext`maxTrajectoryLength$$}], 
                 BoxForm`RemapValue[#, $CellContext`trajectoryLength$$, {
                  1, $CellContext`maxTrajectoryLength$$}]& ], {0, 1}]]},
             "RowDefault"]},
           {
            TemplateBox[{"\"Opacity:\"",InterpretationBox[
               StyleBox[
                GridBox[{{
                   SliderBox[
                    Dynamic[$CellContext`opacity$$], {0, 1}, Appearance -> 
                    Automatic, DefaultBaseStyle -> "LabeledSlider"], 
                   InputFieldBox[
                    Dynamic[$CellContext`opacity$$], Appearance -> 
                    "Frameless", ContinuousAction -> True, DefaultBaseStyle -> 
                    "LabeledSlider", FieldSize -> {{5, 10}, {1, 2}}, 
                    ImageMargins -> 0]}}, AutoDelete -> False, 
                 BaselinePosition -> {{1, 1}, Axis}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}], Deployed -> True, 
                StripOnInput -> False, FontFamily :> 
                CurrentValue["ControlsFontFamily"]], 
               LabeledSlider[
                Dynamic[$CellContext`opacity$$], {0, 1}]]},
             "RowDefault"]}
          },
          DefaultBaseStyle->"Column",
          GridBoxAlignment->{"Columns" -> {{Left}}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Column"]}
      },
      DefaultBaseStyle->"Column",
      GridBoxAlignment->{"Columns" -> {{Left}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Column"],
    DynamicModuleValues:>{},
    Initialization:>($CellContext`list$$ = {
        $CellContext`generateTrajectory[$CellContext`trajectoryLength$$, \
$CellContext`initialDistribution$$, $CellContext`transitionMatrix$$]}; 
     Null)]}, {2,"\<\"Configuration\"\>"->
   DynamicModuleBox[{$CellContext`showMatrix$$ = 
    True, $CellContext`showInitial$$ = True}, 
    TagBox[GridBox[{
       {
        TemplateBox[{InterpretationBox[
           GridBox[{{
              ButtonBox[
              "\"New transition matrix\"", Appearance -> {"FramedPalette"}, 
               ButtonFunction :> ($CellContext`transitionMatrix$$ = Evaluate[
                  Input["Specify new transition matrix:"]]), Evaluator -> 
               Automatic, ImageSize -> Automatic, Method -> "Queued"]}, {
              ButtonBox[
              "\"New initial distribution\"", Appearance -> {"FramedPalette"},
                ButtonFunction :> ($CellContext`initialDistribution$$ = 
                Evaluate[
                  Input["Specify new vector of initial probabilities:"]]), 
               Evaluator -> Automatic, ImageSize -> Automatic, Method -> 
               "Queued"]}}, DefaultBaseStyle -> "Column", 
            GridBoxAlignment -> {"Columns" -> {{Left}}}, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            GridBoxSpacings -> {"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], 
           
           ButtonBar[{
            "New transition matrix" :> ($CellContext`transitionMatrix$$ = 
              Evaluate[
                Input["Specify new transition matrix:"]]), 
             "New initial distribution" :> \
($CellContext`initialDistribution$$ = Evaluate[
                Input["Specify new vector of initial probabilities:"]])}, 
            Method -> "Queued", ImageSize -> Automatic, 
            Appearance -> {"Vertical"}]],TagBox[
           GridBox[{{"\"Show transition matrix:\"", 
              CheckboxBox[
               Dynamic[$CellContext`showMatrix$$]]}, {
             "\"Show initial distribution vector:\"", 
              CheckboxBox[
               Dynamic[$CellContext`showInitial$$]]}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"]},
         "RowDefault"]},
       {
        TemplateBox[{"\"Automatically adjust opacity:\"",CheckboxBox[
           Dynamic[$CellContext`autoOpacity$$]]},
         "RowDefault"]},
       {
        TagBox[GridBox[{
           {"\<\"Number of trajectories to add in each step:\"\>"},
           {
            InputFieldBox[Dynamic[$CellContext`addingNumber$$]]}
          },
          DefaultBaseStyle->"Column",
          GridBoxAlignment->{"Columns" -> {{Left}}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Column"]},
       {
        TagBox[GridBox[{
           {"\<\"Maximal length:\"\>"},
           {
            InputFieldBox[Dynamic[$CellContext`maxTrajectoryLength$$]]}
          },
          DefaultBaseStyle->"Column",
          GridBoxAlignment->{"Columns" -> {{Left}}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Column"]},
       {
        TemplateBox[{DynamicBox[
           ToBoxes[
            If[$CellContext`showMatrix$$, 
             Dynamic[
              MatrixForm[$CellContext`transitionMatrix$$]], ""], 
            StandardForm], ImageSizeCache -> {197., {26., 33.}}],DynamicBox[
           ToBoxes[
            If[$CellContext`showInitial$$, 
             Dynamic[
              MatrixForm[$CellContext`initialDistribution$$]], ""], 
            StandardForm], ImageSizeCache -> {62., {26., 33.}}]},
         "RowDefault"]}
      },
      DefaultBaseStyle->"Column",
      GridBoxAlignment->{"Columns" -> {{Left}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Column"],
    DynamicModuleValues:>{}]}, {3,"\<\"Help\"\>"->
   PanelBox[
    PaneBox["\<\"The MarkovPlotter program generates the trajectories of a \
homogeneous Markov chain with given transition matrix and initial state \
probability distribution. The transition matrix is of form \
\\!\\(\\*SubscriptBox[\\(p\\), \\(ij\\)]\\), where i and j are the row and \
column numbers respectively, and \\!\\(\\*SubscriptBox[\\(p\\), \\(ij\\)]\\) \
is the probability of going from the state i to the state j. The states are \
represented as natural numbers {1, 2, ..., n}. \\n The 'Plot' section: \\n \
This is the main window, containing the trajectory plot. The 'Length' slider \
controls the length of the trajectory, i.e. the number of steps generated; \
this is always a natural number, even if the value of the slider is not. The \
'Opacity' slider controls the opacity of the plot. Note that a new trajectory \
has to be generated after the length has been increased. The 'Generate new \
trajectory' button generates a trajectory, while 'Add new trajectories' adds \
a given number of trajectories to the plot; This helps to see the 'average' \
trajectory.\\n The 'Configuration' tab:\\n In this window, the user can \
specify the transition matrix and the initial distribution vector; Both are \
displayed in the window. Pressing a button opens a new window in which they \
can be specified using Mathematica commands, i.e. a uniform initial \
distribution for a 4-state Markov chain can be written both as {0.25, 0.25, \
0.25, 0.25} or Table[0.25, {4}]. For large number of states, the display of \
matrix and vector can be turned off. If the 'Automatically adjust opacity' \
checkbox is checked, the opacity of the plot diminishes automaticaly each \
time new trajectories are added to the plot.\\n In case of improper (e.g. \
non-stochastic) matrices or vectors, the results are unspecified and \
unpredictable.\"\>",
     ImageSize->{400, 200},
     ImageSizeAction->"Scrollable",
     ScrollPosition->{0., 0.},
     Scrollbars->{False, True}]]}}, 1,
   Alignment->Automatic,
   ImageSize->All],
  DynamicModuleValues:>{},
  Initialization:>{$CellContext`addingNumber$$ = 
    2, $CellContext`autoOpacity$$ = True, $CellContext`maxTrajectoryLength$$ = 
    100, $CellContext`initialDistribution$$ = 
    Table[0.25, {4}], $CellContext`transitionMatrix$$ = 
    ConstantArray[0.25, {4, 4}]}]], "Output",
 CellChangeTimes->{
  3.605120672715559*^9, 3.6051207492910967`*^9, 3.605120819077688*^9, 
   3.6051241734742613`*^9, 3.605124452040803*^9, 3.605124489236493*^9, 
   3.605124565331674*^9, 3.60512469338126*^9, {3.605124902664946*^9, 
   3.60512490366109*^9}, {3.605125993597658*^9, 3.6051259963443413`*^9}, {
   3.605126050807105*^9, 3.6051261749340754`*^9}, {3.605126247815941*^9, 
   3.6051262837910213`*^9}, {3.605126335432934*^9, 3.605126343440971*^9}, 
   3.6051263905944157`*^9, {3.6051264982614183`*^9, 3.605126543525222*^9}, {
   3.605126611602221*^9, 3.605126637203973*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Definitions", "Subtitle",
 CellChangeTimes->{{3.605120611535822*^9, 3.605120613821652*^9}, {
  3.605124603323242*^9, 3.6051246244953613`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"nextStep", "[", 
   RowBox[{"state_", ",", " ", "mat_"}], "]"}], " ", ":=", " ", 
  RowBox[{"RandomChoice", "[", 
   RowBox[{
    RowBox[{"mat", "[", 
     RowBox[{"[", " ", 
      RowBox[{"state", ",", " ", ";;"}], "]"}], "]"}], "\[Rule]", " ", 
    RowBox[{"Range", "[", 
     RowBox[{"Length", "[", "mat", "]"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.604770965426755*^9, 3.6047709804736567`*^9}, {
  3.6047710156296062`*^9, 3.604771017436379*^9}, {3.604771077411968*^9, 
  3.6047711622873783`*^9}, {3.6047712782014847`*^9, 3.6047712792685337`*^9}, {
  3.604772092174251*^9, 3.6047721452753897`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"generateTrajectory", "[", 
   RowBox[{"length_", ",", "startprob_", ",", "  ", "mat_"}], "]"}], " ", ":=",
   " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"retlist", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{"startprob", " ", "\[Rule]", " ", 
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", "mat", "]"}], "]"}]}], "]"}], "}"}]}], "}"}],
     ",", " ", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", " ", "=", " ", "1"}], ",", 
       RowBox[{"i", " ", "<", " ", "length"}], " ", ",", 
       RowBox[{"i", " ", "=", 
        RowBox[{"i", " ", "+", "1"}]}], ",", " ", 
       RowBox[{"retlist", " ", "=", " ", 
        RowBox[{"Append", "[", 
         RowBox[{"retlist", ",", " ", 
          RowBox[{"nextStep", "[", 
           RowBox[{
            RowBox[{"retlist", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", " ", "mat"}], "]"}]}], " ", 
         "]"}]}]}], " ", "]"}], ";", " ", 
     RowBox[{"Return", "[", "retlist", "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.604771381158928*^9, 3.604771454089884*^9}, {
  3.604771497515869*^9, 3.604771591101774*^9}, {3.604771639391967*^9, 
  3.604771744424761*^9}, {3.604771776996513*^9, 3.604771828229597*^9}, {
  3.604772038376535*^9, 3.604772053308468*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"plotter", "[", 
   RowBox[{
   "maxTrajectoryLength_", " ", ",", " ", "initialDistribution_", ",", " ", 
    "transitionMatrix_", ",", " ", "addingNumber_", ",", " ", 
    "autoOpacity_"}], "]"}], " ", ":=", " ", 
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"list", ",", " ", 
      RowBox[{"trajectoryLength", " ", "=", " ", "10"}], ",", " ", 
      RowBox[{"opacity", " ", "=", " ", "1"}], ",", " ", 
      RowBox[{"maxlen", " ", "=", " ", "maxTrajectoryLength"}]}], "}"}], ",", 
    " ", 
    RowBox[{"Column", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Dynamic", "[", 
        RowBox[{"Panel", "[", 
         RowBox[{
          RowBox[{"Show", "[", 
           RowBox[{"ListLinePlot", "[", 
            RowBox[{"list", ",", " ", 
             RowBox[{"Background", "\[Rule]", "White"}], ",", "  ", 
             RowBox[{"PlotRange", "\[Rule]", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", " ", 
                  RowBox[{"trajectoryLength", " ", "+", " ", "1"}]}], "}"}], 
                ",", " ", 
                RowBox[{"{", 
                 RowBox[{"0", ",", " ", 
                  RowBox[{"Length", "[", "initialDistribution", "]"}]}], 
                 "}"}]}], "}"}]}], ",", " ", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"Blue", ",", " ", 
                RowBox[{"Opacity", "[", "opacity", "]"}]}], "]"}]}], ",", 
             RowBox[{"AxesLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Step\>\"", ",", " ", "\"\<State\>\""}], "}"}]}], 
             ",", " ", 
             RowBox[{"AxesOrigin", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", " ", "0"}], "}"}]}]}], "]"}], "]"}], ",", 
          " ", 
          RowBox[{"ButtonBar", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<Generate new trajectory\>\"", " ", ":>", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"list", " ", "=", " ", 
                  RowBox[{"{", 
                   RowBox[{"generateTrajectory", "[", 
                    RowBox[{
                    "trajectoryLength", ",", " ", "initialDistribution", ",", 
                    " ", "transitionMatrix"}], "]"}], "}"}]}], ";", " ", 
                 RowBox[{"opacity", " ", "=", " ", "1"}], ";"}], ")"}]}], ",",
               " ", 
              RowBox[{
              "\"\<Add new trajectories\>\"", " ", "\[RuleDelayed]", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"list", " ", "=", " ", 
                  RowBox[{"Join", "[", 
                   RowBox[{"list", ",", " ", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"generateTrajectory", "[", 
                    RowBox[{
                    "trajectoryLength", ",", " ", "initialDistribution", ",", 
                    " ", "transitionMatrix"}], "]"}], ",", 
                    RowBox[{"{", "addingNumber", "}"}]}], "]"}]}], "]"}]}], 
                 ";", " ", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"autoOpacity", " ", "==", " ", "True"}], ",", " ", 
                   
                   RowBox[{"opacity", " ", "=", " ", 
                    RowBox[{"N", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "/", 
                    RowBox[{"Length", "[", "list", "]"}]}], ")"}], "^", 
                    RowBox[{"(", 
                    RowBox[{"1", "/", "2"}], ")"}]}], ",", " ", "3"}], 
                    "]"}]}]}], "]"}], ";"}], ")"}]}]}], "}"}], ",", " ", 
            RowBox[{"ImageSize", "\[Rule]", "Full"}], ",", " ", 
            RowBox[{"Appearance", "\[Rule]", "Automatic"}]}], "]"}], ",", " ", 
          RowBox[{"ImageSize", "\[Rule]", "Automatic"}]}], "]"}], "]"}], ",", 
       " ", 
       RowBox[{"Column", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", "\"\<Length: \>\"", "]"}], ",", 
             RowBox[{"Slider", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "trajectoryLength", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "maxTrajectoryLength"}], "}"}], ",", " ", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], 
              "]"}]}], "}"}], "]"}], ",", 
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", "\"\<Opacity:\>\"", "]"}], " ", ",", " ", 
             "\[IndentingNewLine]", 
             RowBox[{"Slider", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "opacity", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{"0", ",", " ", "1"}], "}"}], ",", " ", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], 
              "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], "}"}], "]"}]}], 
      "}"}], "]"}], ",", " ", 
    RowBox[{"Initialization", " ", "\[RuleDelayed]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"list", " ", "=", " ", 
        RowBox[{"{", 
         RowBox[{"generateTrajectory", "[", 
          RowBox[{
          "trajectoryLength", ",", " ", "initialDistribution", ",", " ", 
           "transitionMatrix"}], "]"}], "}"}]}], ";"}], ")"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.605035165866146*^9, 3.605035198011106*^9}, {
   3.605035232645665*^9, 3.605035253180903*^9}, {3.60503528959217*^9, 
   3.605035353178466*^9}, {3.605035493914832*^9, 3.605035502673172*^9}, {
   3.60503554397199*^9, 3.6050355467768507`*^9}, {3.605099609929079*^9, 
   3.605099615029063*^9}, {3.605099706168233*^9, 3.605099711511222*^9}, {
   3.6050997526817093`*^9, 3.605099760433158*^9}, {3.605099814026553*^9, 
   3.6050999002443533`*^9}, {3.60510030902162*^9, 3.6051003165365143`*^9}, {
   3.605100361970709*^9, 3.6051003908971357`*^9}, {3.605100438094635*^9, 
   3.605100502300847*^9}, {3.60510080953211*^9, 3.6051008490108423`*^9}, {
   3.605100879882391*^9, 3.6051008933716908`*^9}, {3.605100940465908*^9, 
   3.605100974380356*^9}, {3.6051010100527573`*^9, 3.6051011193525257`*^9}, {
   3.6051012096639442`*^9, 3.605101219574869*^9}, {3.605102112980702*^9, 
   3.605102117227704*^9}, {3.6051021868083067`*^9, 3.605102208259604*^9}, {
   3.605103171257551*^9, 3.605103176797226*^9}, {3.605103380722739*^9, 
   3.605103395903055*^9}, {3.605103457643409*^9, 3.605103552306128*^9}, {
   3.60510359039011*^9, 3.6051036741109467`*^9}, {3.6051037405061007`*^9, 
   3.605103779872759*^9}, {3.6051038492247963`*^9, 3.6051038528435097`*^9}, {
   3.60510394633349*^9, 3.6051039497421103`*^9}, {3.605103989145952*^9, 
   3.605103998253687*^9}, {3.605104031185522*^9, 3.605104032333449*^9}, {
   3.6051040696040077`*^9, 3.605104072182025*^9}, {3.605104127083672*^9, 
   3.6051041366729183`*^9}, {3.605104169413825*^9, 3.605104179352448*^9}, {
   3.605104236903735*^9, 3.605104258492332*^9}, {3.6051043028336678`*^9, 
   3.605104319223044*^9}, {3.605104397233225*^9, 3.605104456965789*^9}, {
   3.6051046313160677`*^9, 3.6051046359214277`*^9}, {3.605104993010401*^9, 
   3.605105023920883*^9}, {3.60510515802752*^9, 3.605105158806508*^9}, 
   3.605105291669746*^9, {3.605105336865933*^9, 3.605105391011673*^9}, {
   3.605107630784959*^9, 3.6051077021411953`*^9}, {3.605108156833082*^9, 
   3.605108208392762*^9}, {3.605108261083082*^9, 3.605108296479187*^9}, {
   3.605108350353747*^9, 3.605108363512932*^9}, {3.605108395622211*^9, 
   3.605108409284672*^9}, {3.605115561960599*^9, 3.605115562513173*^9}, {
   3.6051164014996357`*^9, 3.605116416036338*^9}, {3.605118007026497*^9, 
   3.6051180090962753`*^9}, {3.6051181272926073`*^9, 
   3.6051181493384666`*^9}, {3.605118185192832*^9, 3.605118217716106*^9}, {
   3.605118305048974*^9, 3.605118305734845*^9}, {3.6051183454245443`*^9, 
   3.605118346789442*^9}, 3.605118418296114*^9, {3.6051189129057913`*^9, 
   3.605118940386961*^9}, {3.605119161606421*^9, 3.605119201686736*^9}, {
   3.60512180544248*^9, 3.605121922671069*^9}, {3.605121956477551*^9, 
   3.605122028524014*^9}, {3.60512207099675*^9, 3.605122129770507*^9}, {
   3.605122161058709*^9, 3.6051221768876*^9}, {3.6051222149522877`*^9, 
   3.605122320285038*^9}, {3.605122618337551*^9, 3.605122630372765*^9}, {
   3.605122673361374*^9, 3.605122685401672*^9}, {3.60512274270615*^9, 
   3.605122769074683*^9}, {3.605122851495191*^9, 3.6051228518127832`*^9}, {
   3.605122899409185*^9, 3.605122922092791*^9}, {3.6051230552091722`*^9, 
   3.605123063685565*^9}, {3.605123160120075*^9, 3.605123209037184*^9}, 
   3.605123241849519*^9, {3.605123541978401*^9, 3.605123594642213*^9}, {
   3.605123629812099*^9, 3.6051236971083*^9}, {3.605123807609557*^9, 
   3.605123813508472*^9}, 3.6051239859163523`*^9, {3.605126064894252*^9, 
   3.605126076398452*^9}, {3.6051263205050097`*^9, 3.6051263311950903`*^9}}],

Cell[BoxData[
 RowBox[{"config", " ", ":=", " ", 
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"showMatrix", " ", "=", " ", "True"}], ",", " ", 
      RowBox[{"showInitial", " ", "=", " ", "True"}]}], "}"}], ",", 
    RowBox[{"Column", "[", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Row", "[", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ButtonBar", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
              "\"\<New transition matrix\>\"", "\[RuleDelayed]", " ", 
               RowBox[{"(", 
                RowBox[{"transitionMatrix", "=", " ", 
                 RowBox[{"Evaluate", "[", 
                  RowBox[{
                  "Input", "[", "\"\<Specify new transition matrix:\>\"", 
                   "]"}], "]"}]}], ")"}]}], ",", " ", 
              RowBox[{
              "\"\<New initial distribution\>\"", " ", "\[RuleDelayed]", " ", 
               
               RowBox[{"(", 
                RowBox[{"initialDistribution", " ", "=", " ", 
                 RowBox[{"Evaluate", "[", 
                  RowBox[{
                  "Input", "[", 
                   "\"\<Specify new vector of initial probabilities:\>\"", 
                   "]"}], "]"}]}], ")"}]}]}], "}"}], ",", " ", 
            RowBox[{"Method", " ", "\[Rule]", " ", "\"\<Queued\>\""}], ",", 
            " ", 
            RowBox[{"ImageSize", " ", "\[Rule]", " ", "Automatic"}], ",", " ", 
            RowBox[{"Appearance", "\[Rule]", "\"\<Vertical\>\""}]}], "]"}], 
          ",", 
          RowBox[{"Grid", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Style", "[", "\"\<Show transition matrix:\>\"", "]"}],
                ",", " ", 
               RowBox[{"Checkbox", "[", 
                RowBox[{"Dynamic", "[", "showMatrix", "]"}], "]"}]}], "}"}], 
             ",", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
               "Style", "[", "\"\<Show initial distribution vector:\>\"", 
                "]"}], ",", " ", 
               RowBox[{"Checkbox", "[", 
                RowBox[{"Dynamic", "[", "showInitial", "]"}], "]"}]}], 
              "}"}]}], "}"}], "]"}]}], "}"}], "]"}], ",", " ", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
          "Style", "[", "\"\<Automatically adjust opacity:\>\"", "]"}], ",", 
          " ", 
          RowBox[{"Checkbox", "[", 
           RowBox[{"Dynamic", "[", "autoOpacity", "]"}], "]"}]}], "}"}], 
        "]"}], "\[IndentingNewLine]", ",", " ", 
       RowBox[{"Column", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
          "Style", "[", "\"\<Number of trajectories to add in each step:\>\"",
            "]"}], ",", " ", 
          RowBox[{"InputField", "[", 
           RowBox[{"Dynamic", "[", "addingNumber", "]"}], "]"}]}], "}"}], 
        "]"}], ",", " ", 
       RowBox[{"Column", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Style", "[", "\"\<Maximal length:\>\"", "]"}], ",", " ", 
          RowBox[{"InputField", "[", 
           RowBox[{"Dynamic", "[", "maxTrajectoryLength", "]"}], "]"}]}], 
         "}"}], "]"}], ",", " ", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Dynamic", "[", 
           RowBox[{"If", "[", 
            RowBox[{"showMatrix", ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"MatrixForm", "[", "transitionMatrix", "]"}], "]"}], 
             ",", "\"\<\>\""}], "]"}], "]"}], ",", 
          RowBox[{"Dynamic", "[", 
           RowBox[{"If", "[", 
            RowBox[{"showInitial", ",", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"MatrixForm", "[", "initialDistribution", "]"}], "]"}], 
             ",", "\"\<\>\""}], "]"}], "]"}]}], "}"}], "]"}]}], "}"}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6051065233934183`*^9, 3.605106530362118*^9}, {
   3.60510659965976*^9, 3.605106635675047*^9}, {3.60510666585579*^9, 
   3.605106765816324*^9}, {3.605106860777122*^9, 3.605106890397979*^9}, {
   3.605106945086731*^9, 3.6051069561236467`*^9}, {3.605106988559431*^9, 
   3.605106994243556*^9}, {3.605107024400333*^9, 3.605107025296192*^9}, {
   3.605107066079259*^9, 3.6051071936251183`*^9}, {3.6051072753227987`*^9, 
   3.6051074430460052`*^9}, {3.605107477286138*^9, 3.605107504631036*^9}, {
   3.605107568274787*^9, 3.6051075892795267`*^9}, {3.60510775333144*^9, 
   3.605107759051317*^9}, {3.605107818491653*^9, 3.605107865851561*^9}, {
   3.605107907862338*^9, 3.605107938822259*^9}, {3.6051079724990396`*^9, 
   3.605108005989625*^9}, {3.605115291480077*^9, 3.605115329646278*^9}, {
   3.605115470269224*^9, 3.605115496657296*^9}, {3.605116259719638*^9, 
   3.6051162848752003`*^9}, {3.605118720163218*^9, 3.605118761321083*^9}, {
   3.605118862089343*^9, 3.605118900741459*^9}, {3.605118955193885*^9, 
   3.6051190446410303`*^9}, {3.605119135326055*^9, 3.605119140406616*^9}, {
   3.605119258105998*^9, 3.6051192969576607`*^9}, {3.605122357051516*^9, 
   3.605122431484997*^9}, 3.6051225802505827`*^9, 3.605122996976471*^9, {
   3.6051238373649817`*^9, 3.605123864850374*^9}, {3.6051238991615257`*^9, 
   3.6051239435215054`*^9}, {3.605124076695517*^9, 3.605124077799088*^9}, {
   3.605126224193881*^9, 3.605126243529933*^9}, {3.605126273631822*^9, 
   3.60512627464399*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"help", " ", "=", " ", 
   RowBox[{"Panel", "[", 
    RowBox[{"Pane", "[", 
     RowBox[{
      RowBox[{
      "Style", "[", 
       "\"\<The MarkovPlotter program generates the trajectories of a \
homogeneous Markov chain with given transition matrix and initial state \
probability distribution. The transition matrix is of form \
\!\(\*SubscriptBox[\(p\), \(ij\)]\), where i and j are the row and column \
numbers respectively, and \!\(\*SubscriptBox[\(p\), \(ij\)]\) is the \
probability of going from the state i to the state j. The states are \
represented as natural numbers {1, 2, ..., n}. \\n The 'Plot' section: \\n \
This is the main window, containing the trajectory plot. The 'Length' slider \
controls the length of the trajectory, i.e. the number of steps generated; \
this is always a natural number, even if the value of the slider is not. The \
'Opacity' slider controls the opacity of the plot. Note that a new trajectory \
has to be generated after the length has been increased. The 'Generate new \
trajectory' button generates a trajectory, while 'Add new trajectories' adds \
a given number of trajectories to the plot; This helps to see the 'average' \
trajectory.\\n The 'Configuration' tab:\\n In this window, the user can \
specify the transition matrix and the initial distribution vector; Both are \
displayed in the window. Pressing a button opens a new window in which they \
can be specified using Mathematica commands, i.e. a uniform initial \
distribution for a 4-state Markov chain can be written both as {0.25, 0.25, \
0.25, 0.25} or Table[0.25, {4}]. For large number of states, the display of \
matrix and vector can be turned off. If the 'Automatically adjust opacity' \
checkbox is checked, the opacity of the plot diminishes automaticaly each \
time new trajectories are added to the plot.\\n In case of improper (e.g. \
non-stochastic) matrices or vectors, the results are unspecified and \
unpredictable.\>\"", "]"}], ",", " ", 
      RowBox[{"Scrollbars", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"False", ",", " ", "True"}], "}"}]}], ",", " ", 
      RowBox[{"ImageSizeAction", "\[Rule]", "\"\<Scrollable\>\""}], " ", ",", 
      " ", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"400", ",", " ", "200"}], "}"}]}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6051162903067713`*^9, 3.605116311931259*^9}, {
   3.6051164787561274`*^9, 3.605116486320067*^9}, {3.605116520083847*^9, 
   3.605116528707121*^9}, {3.6051166490605383`*^9, 3.605116649489093*^9}, {
   3.6051167297909527`*^9, 3.6051167336462793`*^9}, {3.605116997273005*^9, 
   3.605117021832485*^9}, {3.6051171166992893`*^9, 3.605117125519306*^9}, {
   3.6051171645159187`*^9, 3.605117279895978*^9}, {3.60511733705616*^9, 
   3.605117372755959*^9}, {3.605117414719801*^9, 3.605117451344927*^9}, {
   3.605117547152055*^9, 3.605117583445966*^9}, {3.605117636652206*^9, 
   3.605117657539558*^9}, {3.60511777302623*^9, 3.60511792314564*^9}, {
   3.605117953813115*^9, 3.6051179544898252`*^9}, {3.605118401352708*^9, 
   3.6051184029892597`*^9}, {3.605118457522946*^9, 3.6051184616059*^9}, {
   3.6051185640926647`*^9, 3.6051185992091293`*^9}, {3.605119320474987*^9, 
   3.605119639702228*^9}, {3.605119678475507*^9, 3.6051200129876957`*^9}, 
   3.605120121320627*^9, {3.6051210433809977`*^9, 3.6051210436975393`*^9}, {
   3.605123278065948*^9, 3.605123463385503*^9}, {3.6051240973403807`*^9, 
   3.605124146795188*^9}, {3.605125313049745*^9, 3.605125360025139*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"markovPlotter", " ", "=", " ", 
   RowBox[{"DynamicModule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "maxTrajectoryLength", ",", " ", "initialDistribution", ",", " ", 
       "transitionMatrix", ",", " ", "addingNumber", ",", " ", 
       "autoOpacity"}], "}"}], ",", " ", 
     RowBox[{"TabView", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<Plot\>\"", " ", "\[Rule]", " ", 
          RowBox[{"plotter", "[", 
           RowBox[{
           "maxTrajectoryLength", ",", " ", "initialDistribution", ",", " ", 
            "transitionMatrix", ",", " ", "addingNumber", ",", " ", 
            "autoOpacity"}], "]"}]}], ",", " ", 
         RowBox[{"\"\<Configuration\>\"", " ", "\[Rule]", " ", "config"}], 
         ",", " ", 
         RowBox[{"\"\<Help\>\"", " ", "\[Rule]", " ", "help"}]}], " ", "}"}], 
       ",", "  ", 
       RowBox[{"ImageSize", "\[Rule]", "All"}], ",", " ", 
       RowBox[{"Alignment", "\[Rule]", "Automatic"}]}], "]"}], ",", " ", 
     RowBox[{"Initialization", "  ", "\[RuleDelayed]", "  ", 
      RowBox[{"(", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"addingNumber", " ", "=", " ", "2"}], ",", " ", 
         RowBox[{"autoOpacity", " ", "=", " ", "True"}], ",", " ", 
         RowBox[{"maxTrajectoryLength", " ", "=", " ", "100"}], ",", " ", 
         RowBox[{"initialDistribution", " ", "=", " ", 
          RowBox[{"Table", "[", 
           RowBox[{"0.25", ",", " ", 
            RowBox[{"{", "4", "}"}]}], "]"}]}], ",", " ", 
         RowBox[{"transitionMatrix", " ", "=", " ", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"0.25", ",", " ", 
            RowBox[{"{", 
             RowBox[{"4", ",", " ", "4"}], "}"}]}], "]"}]}]}], "}"}], 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605035276335696*^9, 3.605035278140622*^9}, {
   3.60503543082607*^9, 3.605035434184696*^9}, {3.6050996858244553`*^9, 
   3.605099716880478*^9}, {3.605099771430477*^9, 3.605099772976132*^9}, {
   3.605100007406142*^9, 3.605100059075301*^9}, {3.605100223142577*^9, 
   3.605100277917301*^9}, {3.605100455992406*^9, 3.60510045713061*^9}, {
   3.6051005067796593`*^9, 3.6051005121565237`*^9}, {3.605100650756374*^9, 
   3.6051007805664682`*^9}, {3.605101258542387*^9, 3.6051012655720453`*^9}, {
   3.6051014709936543`*^9, 3.605101489834278*^9}, {3.60510152077742*^9, 
   3.605101666337488*^9}, {3.605102035733059*^9, 3.605102059047882*^9}, {
   3.6051032869674063`*^9, 3.605103363328773*^9}, {3.605103406163011*^9, 
   3.6051034223863564`*^9}, {3.6051034663769817`*^9, 3.605103491087105*^9}, 
   3.6051036109081087`*^9, {3.60510365180678*^9, 3.605103664613833*^9}, 
   3.605103836209921*^9, {3.605105468293195*^9, 3.605105534113153*^9}, {
   3.605105579332391*^9, 3.6051055899208927`*^9}, {3.605105653079885*^9, 
   3.605105793625608*^9}, {3.605106410177841*^9, 3.605106434575787*^9}, {
   3.6051064844682198`*^9, 3.6051064981677017`*^9}, {3.60510653569982*^9, 
   3.6051065378496*^9}, {3.605106781265678*^9, 3.605106799234044*^9}, {
   3.605108069017907*^9, 3.605108071857332*^9}, {3.6051083200883617`*^9, 
   3.605108336606668*^9}, {3.6051084863378897`*^9, 3.60510855201301*^9}, {
   3.605115083906199*^9, 3.605115090474393*^9}, 3.60511517075117*^9, {
   3.605115714789307*^9, 3.6051158509259233`*^9}, {3.6051159017164373`*^9, 
   3.60511618986419*^9}, {3.605116305634364*^9, 3.6051163281594667`*^9}, {
   3.605117306245825*^9, 3.605117329203933*^9}, {3.6051174735958357`*^9, 
   3.6051175216003313`*^9}, {3.605117624542499*^9, 3.605117625815769*^9}, {
   3.605117674982465*^9, 3.605117720589505*^9}, {3.6051185201700573`*^9, 
   3.605118541668993*^9}, {3.605118657005641*^9, 3.6051186928055973`*^9}, {
   3.605119071815733*^9, 3.605119079908944*^9}, {3.605119110925693*^9, 
   3.605119114075754*^9}, 3.605120625014056*^9, {3.6051218354407177`*^9, 
   3.605121842700564*^9}, 3.605122183590407*^9, {3.605122809170353*^9, 
   3.605122815978627*^9}, {3.6051238795655203`*^9, 3.605123880823327*^9}, {
   3.6051240356016273`*^9, 3.6051240460311003`*^9}, {3.6051244812848377`*^9, 
   3.6051244847174263`*^9}, 3.605124686328248*^9, {3.605126042238201*^9, 
   3.60512604666807*^9}, 3.605126104588295*^9}]
}, Closed]]
}, Open  ]]
},
WindowSize->{740, 623},
WindowMargins->{{64, Automatic}, {Automatic, 5}},
ShowSelection->True,
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 95, 1, 92, "Title"],
Cell[CellGroupData[{
Cell[699, 27, 201, 3, 32, "Input"],
Cell[903, 32, 13042, 265, 399, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13982, 302, 148, 2, 50, "Subtitle"],
Cell[14133, 306, 649, 14, 55, "Input"],
Cell[14785, 322, 1379, 34, 121, "Input"],
Cell[16167, 358, 9185, 180, 693, "Input"],
Cell[25355, 540, 5520, 120, 649, "Input"],
Cell[30878, 662, 3556, 57, 969, "Input"],
Cell[34437, 721, 4247, 75, 297, "Input"]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
